/************************************************************************************/
/* Copyright (c) 2003, Outside Echo Ltd. & Hewlett-Packard.                         */
/* All rights reserved.                                                             */  
/*                                                                                  */
/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met:                    */
/*                                                                                  */
/*    * Redistributions of source code must retain the above copyright notice, this */
/*      list of conditions and the following disclaimer.                            */
/*    * Redistributions in binary form must reproduce the above copyright notice,   */
/*      this list of conditions and the following disclaimer in the documentation   */
/*      and/or other materials provided with the distribution.                      */
/*    * Neither the name of Outside Echo Ltd. & Hewlett-Packard                     */
/*      nor the names of its contributors may be used to endorse or promote products*/ 
/*      derived from this software without specific prior written permission.       */
/*                                                                                  */ 
/*                                                                                  */
/*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS NAMELY     */
/*   OUTSIDE ECHO LTD AND HEWLETT-PACKARD "AS IS" AND ANY                           */
/*   EXPRESS  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED     */
/*   WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/*   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE    */
/*   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL     */
/*   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR     */
/*   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER     */
/*   CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  */
/*   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE  */
/*   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH  DAMAGE.          */
/*                                                                                  */
/************************************************************************************/
/*                                                                                  */
/* This file contains the class which holds the character to phoneme mapping.       */
/*                                                                                  */
/*                                                                                  */
/* AUTHOR: Partha Pratim Talukdar, Hewlett-Packard Labs (India)                     */
/* Email: (ptpartha@india.hp.com)                                                   */
/* CREATED:  Aug 14, 2003                                                           */
/* MODIFIED: Jan 7, 2004                                                            */
/*                                                                                  */
/************************************************************************************/

#include "error.h"
#include "Mapping.h"

using namespace std;

/* Constructor */
MappingTable::MappingTable() 
{
   int i;

   for(i=0; i<MAXMAPNODES; i++)
   {
      mappingNode[i].used = false;
	    
      /******************************************/
      /* Added by Partha on 13th February, 2004 */

      strcpy(mappingNode[i].mappedStr, "");
      strcpy(mappingNode[i].className, "");

      /*****************************************/
   }

   entryCount = 0;
}

void MappingTable::LoadMappingFile(char * mappingFile)
{
   FILE *mapFP;
   unsigned int  tmpIdx=0;
   char tmpCh;
   char tmpType;                    /* Whether this is a Consonant(C) or Vowel(V) */
   char tmpClassName[MAXCLASSLEN];  /* Class of the character                     */
   char tmpMappedStr[MAXSTRLENGTH]; /* Mapping of the character                   */
	
   cout << mappingFile << endl; //Added by sameer 19/10/2004
   if((mapFP = fopen(mappingFile,"r")) == NULL)
      Error::PrintAndExit("Mapping file not found: Program Terminated");

   while(fscanf(mapFP,"%c %c %s %[^\n]\n", &tmpIdx, &tmpType, tmpClassName, tmpMappedStr) != EOF)
   {	   
      if(mappingNode[tmpIdx].used == true)
      {
	 printf("\n>> %c %s %s", tmpType, tmpClassName, tmpMappedStr); 
	 cout << ":\tMapping has already been defined\n\n";
	 continue;
      }
	    
      ++entryCount;

      mappingNode[tmpIdx].used = true;
      mappingNode[tmpIdx].type = tmpType;
      strcpy(mappingNode[tmpIdx].className, tmpClassName);
      strcpy(mappingNode[tmpIdx].mappedStr, tmpMappedStr);
   }

   fclose(mapFP);

   // cout << "\n\t** Mapping File Loaded **\n\n";
}
