/************************************************************************************/
/* Copyright (c) 2003, Outside Echo Ltd. & Hewlett-Packard.                         */
/* All rights reserved.                                                             */  
/*                                                                                  */
/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met:                    */
/*                                                                                  */
/*    * Redistributions of source code must retain the above copyright notice, this */
/*      list of conditions and the following disclaimer.                            */
/*    * Redistributions in binary form must reproduce the above copyright notice,   */
/*      this list of conditions and the following disclaimer in the documentation   */
/*      and/or other materials provided with the distribution.                      */
/*    * Neither the name of Outside Echo Ltd. & Hewlett-Packard                     */
/*      nor the names of its contributors may be used to endorse or promote products*/ 
/*      derived from this software without specific prior written permission.       */
/*                                                                                  */ 
/*                                                                                  */
/*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS NAMELY     */
/*   OUTSIDE ECHO LTD AND HEWLETT-PACKARD "AS IS" AND ANY                           */
/*   EXPRESS  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED     */
/*   WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/*   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE    */
/*   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL     */
/*   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR     */
/*   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER     */
/*   CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  */
/*   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE  */
/*   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH  DAMAGE.          */
/*                                                                                  */
/************************************************************************************/
/*                                                                                  */
/*                                                                                  */
/* AUTHOR: Panchapagesan. K., Hewlett-Packard Labs (India)                                 */
/* Email: sameer.badaskar@hp.com                                                      */
/* CREATED:  April 2, 2004                                                           */
/* MODIFIED: June 17, 2004                                                            */
/*                                                                                  */
/************************************************************************************/


#ifndef __TOKEN_TO_WORDS_H_
#define __TOKEN_TO_WORDS_H_

#include <string.h>
#include "festival.h"

int Number_to_Words(unsigned int val, EST_StrList& wordList);
int Convert_NUM_to_Words(const char *NumberString, int Iscii, int Model, EST_StrList& wordList);
void Convert_NDATE_to_Words(const char *Date, int Iscii, int Format, EST_StrList& wordList);
void Convert_NTEL_to_Words(const char *Tel, int Iscii,int Format, EST_StrList& wordList);
void Convert_NLITERAL_to_Words(const char *Literal, int Iscii,int begin, int end, EST_StrList& wordList);
char *RemoveCommas(const char *str);
char *SubString(const char *str, int begin, int end);
int Get_Number_Array(const char *NumberString, int Iscii,int *No_of_Digits, int Digit_Array_Size, unsigned int **Result_Array);
unsigned int StringtoInt(const char *str, int Iscii, int begin, int end);
void Init_Data_Structures();
int isNum(unsigned char val, int Iscii);
void Token_to_Words(const char *token, int isIscii, int tokenType, int tokenFormat, EST_StrList& wordList);
void Convert_NFLOAT_to_Words(const char *Float, int Iscii,int Format, EST_StrList& wordList);

enum {NUM,NORD,NFLOAT,NDATE,NYEAR,NTIME,NTEL,NFRAC,NPRCT,NRATIO,NSCORE,ALPHANUM,URL,EMAIL};

#endif
