%{
#include "lex.h"
#include "festival.h"
%}
DIGIT [0-9]
IDIGIT [-]
CHARACTER [a-z]|[A-Z]
ISCII_CHAR [-]|[]
NUM1 {DIGIT}+
NUM2 ({DIGIT}{1,2}",")?({DIGIT}{2}",")*({DIGIT}{3})
NUM3 ({DIGIT}{1,3}",")?({DIGIT}{3}",")*({DIGIT}{3})
NFLOAT1 {NUM1}"."{NUM1}
NFLOAT2 {NUM2}"."{NUM1}
NFLOAT3 {NUM3}"."{NUM1}
NUMORD {DIGIT}*(("1"{WHITESPACE}*[sS][tT])|("2"{WHITESPACE}*[nN][dD])|("3"{WHITESPACE}*[rR][dD])|([04-9]{WHITESPACE}*[tT][hH]))
NUMFRAC {DIGIT}{1,3}"/"{DIGIT}{1,5}
NUMROM "X"*(("I"("V"|"X"|("I"{0,2})))|("V"("I"{0,3})))
NUMRATIO {DIGIT}{1,5}{WHITESPACE}*":"{WHITESPACE}*{DIGIT}{1,5}
NUMRANGE ({NUM1}|{NUM2}{NUM3}){WHITESPACE}*"-"{WHITESPACE}*({NUM1}|{NUM2}{NUM3})
NUMPRCT ({NFLOAT1}|{NUM1}){WHITESPACE}*"%"
INUM1 {IDIGIT}+
INUM2 ({IDIGIT}{1,2}",")?({IDIGIT}{2}",")*({IDIGIT}{3})
INUM3 ({IDIGIT}{1,3}",")?({IDIGIT}{3}",")*({IDIGIT}{3})
INFLOAT1 {INUM1}"."{INUM1}
INFLOAT2 {INUM2}"."{INUM1}
INFLOAT3 {INUM3}"."{INUM1}
INUMORD (({IDIGIT}+)|({DIGIT}+)){WHITESPACE}*(("ڢ")|("ܢ")|("")|(""))
INUMFRAC {IDIGIT}{1,3}"/"{IDIGIT}{1,5}
INUMRATIO {IDIGIT}{1,5}{WHITESPACE}*":"{WHITESPACE}*{IDIGIT}{1,5}
INUMRANGE ({INUM1}|{INUM2}{INUM3}){WHITESPACE}*"-"{WHITESPACE}*({INUM1}|{INUM2}{INUM3})
INUMPRCT ({INFLOAT1}|{INUM1}){WHITESPACE}*"%"
MINUTE (([0]?[0-9])|([1-5][0-9]))
SECONDS (([0]?[0-9])|([1-5][0-9]))
HOUR_12 (([0]?[1-9])|([1][0-2]))
HOUR_24 (([0]?[0-9])|([1][0-9])|([2][0-3]))
TIME_HOUR_12 {HOUR_12}
TIME_HM_12 {HOUR_12}{WHITESPACE}*[:.]{WHITESPACE}*{MINUTE}
TIME_HM_24 {HOUR_24}{WHITESPACE}*([:.])?{WHITESPACE}*{MINUTE}
TIME_HMS1 {DIGIT}{1,5}":"{DIGIT}{2,2}":"{DIGIT}{2,2}
TIME_HMS2 {DIGIT}{1,5}":"{DIGIT}{2,2}"'"{DIGIT}{2,2}"\""
IMINUTE (([]?[-])|([-][-]))
ISECONDS (([]?[-])|([-][-]))
IHOUR_12 (([]?[-])|([][-]))
IHOUR_24 (([]?[-])|([][-])|([][-]))
ITIME_HOUR_12 {IHOUR_12}
ITIME_HM_12 {IHOUR_12}{WHITESPACE}*[:.]{WHITESPACE}*{IMINUTE}
ITIME_HM_24 {IHOUR_24}{WHITESPACE}*([:.])?{WHITESPACE}*{IMINUTE}
ITIME_HMS1 {IDIGIT}{1,5}":"{IDIGIT}{2,2}":"{IDIGIT}{2,2}
ITIME_HMS2 {IDIGIT}{1,5}":"{IDIGIT}{2,2}"'"{IDIGIT}{2,2}"\""
DAY (([0]?[1-9])|([1-2][0-9])|([3][01]))
MONTH (([0]?[1-9])|([1][0-2]))
YEAR ({DIGIT}{2,2}|{DIGIT}{4,4})
DATE_DMY {DAY}[/\-.]{MONTH}[/\-.]{YEAR}
DATE_MDY {MONTH}[/\-.]{DAY}[/\-.]{YEAR}
DATE_YMD {YEAR}[/\-.]{MONTH}[/\-.]{DAY}
DATE_DM {DAY}[/\-.]{MONTH}
DATE_MD {MONTH}[/\-.]{DAY}
DATE_MY {MONTH}[/\-.]{YEAR}
DATE_YM {YEAR}[/\-.]{MONTH}
IDAY (([]?[-])|([-][-])|([][]))
IMONTH (([]?[-])|([][-]))
IMONTH_NAME (""|""|""|""|"̧"|""|"ڧ"|""|"¢"|""|""|"Ԣ"|"ע")
IYEAR ({IDIGIT}{2,2}|{IDIGIT}{4,4})
IDATE_DMY {IDAY}[/\-.]{IMONTH}[/\-.]{IYEAR}
IDATE_MDY {IMONTH}[/\-.]{IDAY}[/\-.]{IYEAR}
IDATE_YMD {IYEAR}[/\-.]{IMONTH}[/\-.]{IDAY}
IDATE_YM {IYEAR}[/\-.]{IMONTH}
IDATE_MY {IMONTH}[/\-.]{IYEAR}
IDATE_MD {IMONTH}[/\-.]{IDAY}
IDATE_DM {IDAY}[/\-.]{IMONTH}
TELNO1 {DIGIT}{3,4}({WHITESPACE}+|"-"|"/"){DIGIT}{3,4}
TELNO2 (({DIGIT}{2,2})?({DIGIT}{2,5}))?{DIGIT}{3,4}{DIGIT}{3,4}
TELNO3 "("{WHITESPACE}*{DIGIT}{2,5}{WHITESPACE}*")"({WHITESPACE}+|"-"|"/")?{DIGIT}{3,4}({WHITESPACE}+|"-"|"/")?{DIGIT}{3,4}
TELNO4 {DIGIT}{2,5}({WHITESPACE}+|"-"|"/"){DIGIT}{3,4}({WHITESPACE}+|"-"|"/")?{DIGIT}{3,4}
TELNO5 "+"{DIGIT}{2,2}({WHITESPACE}+|"-"|"/")({TELNO3}|{TELNO4})
TELNO6 "("{DIGIT}{2,2}")"({WHITESPACE}+|"-"|"/"){TELNO4}
ITELNO1 {IDIGIT}{3,4}({WHITESPACE}+|"-"|"/"){IDIGIT}{3,4}
ITELNO2 (({IDIGIT}{2,2})?({IDIGIT}{2,5}))?{IDIGIT}{3,4}{IDIGIT}{3,4}
ITELNO3 "("{WHITESPACE}*{IDIGIT}{2,5}{WHITESPACE}*")"({WHITESPACE}+|"-"|"/")?{IDIGIT}{3,4}({WHITESPACE}+|"-"|"/")?{IDIGIT}{3,4}
ITELNO4 {IDIGIT}{2,5}({WHITESPACE}+|"-"|"/"){IDIGIT}{3,4}({WHITESPACE}+|"-"|"/")?{IDIGIT}{3,4}
ITELNO5 "+"{IDIGIT}{2,2}({WHITESPACE}+|"-"|"/")({ITELNO3}|{ITELNO4})
ITELNO6 "("{IDIGIT}{2,2}")"({WHITESPACE}+|"-"|"/"){ITELNO4}
URL (("http://")|("www.")|("http://www."))([^ \t\n,.<>;'"{}[\]|`!()\^$#@]+".")+[^ \t\n,.<>;'"{}[\]|`!()\^$#@]+
EMAIL [^ \t\n,/<>?;':"{}[\]|`!()+=*&\^%$#@]+"@"[^ \t\n,/<>?;':"{}[\]|`!()+=*&\^%$#@]+
NETSTR ({URL}|{EMAIL})
SAYAS_MODES ("literal"|"date"|"time"|"phone"|"net"|"postal"|"currency"|"math"|"fraction"|"measure"|"ordinal"|"cardinal"|"name")
SAYAS_MODETYPES ("DMY"|"MDY"|"YMD"|"YM"|"MY"|"MD"|"HM"|"HMS"|"EMAIL"|"URL")
SAYAS_TAG "<"{WHITESPACE}*"SAYAS"{WHITESPACE}+"MODE"{WHITESPACE}*"="{WHITESPACE}*\"{SAYAS_MODES}\"({WHITESPACE}+"MODETYPE"{WHITESPACE}*"="{WHITESPACE}*\"{SAYAS_MODETYPES}\")?{WHITESPACE}*">"
ALPHANUM1 ((({DIGIT}+|{IDIGIT}+)("-")?{CHARACTER}+("-")?)+({DIGIT}+|{IDIGIT}+)?)|({CHARACTER}+("-")?({IDIGIT}+|{DIGIT}+)("-")?)+({CHARACTER}+)?
ALPHANUM2 ((({DIGIT}+|{IDIGIT}+)("-")?{ISCII_CHAR}+("-")?)+({DIGIT}+|{IDIGIT}+)?)|({ISCII_CHAR}+("-")?({IDIGIT}+|{DIGIT}+)("-")?)+({ISCII_CHAR}+)?
PUNC ([!'";:.,?]|"-")
WORD_DELIM ([`~@#$^&*()_+=|[{}<>/\\]|"]")
WHITESPACE [ \t]
%{
//DELIMITER ({WHITESPACE}|[\n]|{PUNC}|{WORD_DELIM})
%}
DELIMITER (.)?
TAG "<"[^<>\n]+">"
SP_YEAR {DIGIT}{4,4}
SP_IYEAR {IDIGIT}{4,4}
%x TOKEN
%x SW_TOKEN
%x NUMRANGE_tag
%x MARKED_UP_TEXT
%x SCAN_NORD
%x SCAN_NUM
%x SCAN_NFRAC
%x SCAN_NFLOAT
%x SCAN_NTEL
%x SCAN_NTIME
%x SCAN_NET
%x SCAN_NDATE
%x SCAN_NYEAR
%x SCAN_NZIP
%x SCAN_NPRCT
%x SCAN_NRATIO
%x SCAN_NDIG
%x SCAN_NLITERAL
%x SCAN_NMONEY
%x SCAN_LCMONEY
%x INTO_SAYAS_MODE
%x OTHER_TAG

%%
%{
printf("Begin State: %d\n", Begin_State);
BEGIN(Begin_State);
%}
<INITIAL,TOKEN>
{
{SP_YEAR}|{SP_IYEAR}/{DELIMITER} tokenList.append(EST_String("<NYEAR>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NUM1}/{DELIMITER} tokenList.append(EST_String("<NUM1>")); printf("*** yytext1 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INUM1}/{DELIMITER} tokenList.append(EST_String("<NUM1>")); printf("*** yytext1 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NUM2}/{DELIMITER} tokenList.append(EST_String("<NUM>")); printf("*** yytext2 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NUM3}/{DELIMITER} tokenList.append(EST_String("<NUM>")); printf("*** yytext2 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INUM2}/{DELIMITER} tokenList.append(EST_String("<NUM>")); printf("*** yytext2 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INUM3}/{DELIMITER} tokenList.append(EST_String("<NUM>")); printf("*** yytext2 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NFLOAT1}/{DELIMITER} tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NFLOAT2}/{DELIMITER} tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NFLOAT3}/{DELIMITER} tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INFLOAT1}/{DELIMITER} tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INFLOAT2}/{DELIMITER} tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INFLOAT3}/{DELIMITER} tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NUMFRAC}/{DELIMITER} tokenList.append(EST_String("<NFRAC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INUMFRAC}/{DELIMITER} tokenList.append(EST_String("<NFRAC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NUMORD}/{DELIMITER} tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INUMORD}/{DELIMITER} tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NUMROM}/{DELIMITER} tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NUMPRCT}/{DELIMITER} tokenList.append(EST_String("<NPRCT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INUMPRCT}/{DELIMITER} tokenList.append(EST_String("<NPRCT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);

{HOUR_12}/({WHITESPACE}*(([AaPp]"."?[Mm]"."?)|("ʺ")){DELIMITER}) tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{IHOUR_12}/({WHITESPACE}*(([AaPp]"."?[Mm]"."?)|("ʺ")){DELIMITER}) tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TIME_HM_12}/({WHITESPACE}*(([AaPp]"."?[Mm]"."?)|("ʺ")){DELIMITER}) tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITIME_HM_12}/({WHITESPACE}*(([AaPp]"."?[Mm]"."?)|("ʺ")){DELIMITER}) tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TIME_HM_24}/({WHITESPACE}*(([Hh][Rr][Ss])|([Hh][Oo][Uu][Rr][Ss])|("ʺ")){DELIMITER}) tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITIME_HM_24}/({WHITESPACE}*(([Hh][Rr][Ss])|([Hh][Oo][Uu][Rr][Ss])|("ʺ")){DELIMITER}) tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TIME_HMS1}/{DELIMITER} tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITIME_HMS1}/{DELIMITER} tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TIME_HMS2}/{DELIMITER} tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITIME_HMS2}/{DELIMITER} tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);

{DATE_DMY}/{DELIMITER} tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{IDATE_DMY}/{DELIMITER} tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{DATE_MDY}/{DELIMITER} tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{IDATE_MDY}/{DELIMITER} tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{DATE_YMD}/{DELIMITER} tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{IDATE_YMD}/{DELIMITER} tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);

{TELNO1}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITELNO1}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TELNO2}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITELNO2}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TELNO3}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITELNO3}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TELNO4}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITELNO4}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TELNO5}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ITELNO5}/{DELIMITER} tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);

{URL} tokenList.append(EST_String("<URL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{EMAIL} tokenList.append(EST_String("<EMAIL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{NETSTR} tokenList.append(EST_String("<NET>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);

{NUMRATIO}/{DELIMITER} tokenList.append(EST_String("<NRATIO>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{INUMRATIO}/{DELIMITER} tokenList.append(EST_String("<NRATIO>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);

{ALPHANUM1}/{DELIMITER} tokenList.append(EST_String("<ALPHANUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{ALPHANUM2}/{DELIMITER} tokenList.append(EST_String("<ALPHANUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);

\" {
if(Inside_Engine_ID == 1) 
{
	printf("%s", yytext);
	while( ( c = yyinput() ) != '>' )
	{
		printf("%c", c);
	}
	printf("%c", c);
	Inside_Engine_ID = 0;
	BEGIN(TOKEN);
}
else  tokenList.append(EST_String("<PUNC>"));tokenList.append(EST_String(yytext));BEGIN(TOKEN);
}
{WHITESPACE}+ BEGIN(TOKEN);
[\n]+ BEGIN(TOKEN);
{PUNC} tokenList.append(EST_String("<PUNC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{WORD_DELIM} tokenList.append(EST_String("<DELIMITER>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
{TAG} yyless(0);BEGIN(MARKED_UP_TEXT);
. yyless(0);BEGIN(SW_TOKEN);
}

<SW_TOKEN>
{
({CHARACTER}+|{ISCII_CHAR}+)/{DELIMITER} tokenList.append(EST_String(yytext));BEGIN(TOKEN);
([^ \t\n,./<>?;':"[{}\\|=+_)(*&^%$#@!`~\-\]])+/{DELIMITER} tokenList.append(EST_String(yytext));BEGIN(TOKEN);
}

%{
/*
<NUMRANGE_tag>
{
{SP_YEAR}|{SP_IYEAR}/{DELIMITER} {
				fprintf(fout,"<NYEAR> %s </NYEAR>", yytext);
				inside_NUMRANGE = 1;
				BEGIN(NUMRANGE_tag);
				}
{NUM1}/{DELIMITER} {
			if(inside_NUMRANGE == 0)
			{
				fprintf(fout,"<NUM> %s </NUM>", yytext);BEGIN(NUMRANGE_tag);
			}
			else 
			{
				fprintf(fout,"<NYEAR> %s </NYEAR></NRANGE>", yytext);
				inside_NUMRANGE = 0;
				BEGIN(TOKEN);
			}
		}	
{NUM2}/{DELIMITER} fprintf(fout,"<NUM> %s </NUM>", yytext);BEGIN(NUMRANGE_tag);
{NUM3}/{DELIMITER} fprintf(fout,"<NFLOAT> %s </NFLOAT>", yytext);BEGIN(NUMRANGE_tag);
{INUM1}/{DELIMITER} {
			if(inside_NUMRANGE == 0)
			{
				fprintf(fout,"<NUM> %s </NUM>", yytext);BEGIN(NUMRANGE_tag);
			}
			else 
			{
				fprintf(fout,"<NYEAR> %s </NYEAR></NRANGE>", yytext);
				inside_NUMRANGE = 0;
				BEGIN(TOKEN);
			}
		}	
{INUM2}/{DELIMITER} fprintf(fout,"<NUM> %s </NUM>", yytext);BEGIN(NUMRANGE_tag);
{INUM3}/{DELIMITER} fprintf(fout,"<NFLOAT> %s </NFLOAT>", yytext);BEGIN(NUMRANGE_tag);
{WHITESPACE}*"-"{WHITESPACE}* fprintf(fout, "%s", yytext);BEGIN(NUMRANGE_tag);
{DELIMITER} inside_NUMRANGE=0;fprintf(fout, " </NRANGE>%s", yytext);BEGIN(TOKEN);
}

*/
%}

<MARKED_UP_TEXT>
{
"<"{WHITESPACE}*"NUM"{WHITESPACE}*">" BEGIN(SCAN_NUM);
"<"{WHITESPACE}*"/NUM"{WHITESPACE}*">" BEGIN(TOKEN);
""{WHITESPACE}*"<NORD"{WHITESPACE}*">" BEGIN(SCAN_NORD);
"<"{WHITESPACE}*"/NORD"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NTEL"{WHITESPACE}*">" BEGIN(SCAN_NTEL);
"<"{WHITESPACE}*"/NTEL"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NDATE"{WHITESPACE}*">" BEGIN(SCAN_NDATE);
"<"{WHITESPACE}*"/NDATE"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NYEAR"{WHITESPACE}*">" BEGIN(SCAN_NYEAR);
"<"{WHITESPACE}*"/NYEAR"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NTIME"{WHITESPACE}*">" BEGIN(SCAN_NTIME);
"<"{WHITESPACE}*"/NTIME"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NFRAC"{WHITESPACE}*">" BEGIN(SCAN_NFRAC);
"<"{WHITESPACE}*"/NFRAC"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NFLOAT"{WHITESPACE}*">" BEGIN(SCAN_NFLOAT);
"<"{WHITESPACE}*"/NFLOAT"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NZIP"{WHITESPACE}*">" BEGIN(SCAN_NZIP);
"<"{WHITESPACE}*"/NZIP"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NPRCT"{WHITESPACE}*">" BEGIN(SCAN_NPRCT);
"<"{WHITESPACE}*"/NPRCT"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NMONEY"{WHITESPACE}*">" BEGIN(SCAN_NMONEY);
"<"{WHITESPACE}*"/NMONEY"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"LCMONEY"{WHITESPACE}*">" BEGIN(SCAN_LCMONEY);
"<"{WHITESPACE}*"/LCMONEY"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"NLITERAL"{WHITESPACE}*">" BEGIN(SCAN_NLITERAL);
"<"{WHITESPACE}*"/NLITERAL"{WHITESPACE}*">" BEGIN(TOKEN);
{SAYAS_TAG} yyless(0);BEGIN(INTO_SAYAS_MODE);
"<"{WHITESPACE}*"/SAYAS"{WHITESPACE}*">" BEGIN(TOKEN);
"<"{WHITESPACE}*"ENGINE"{WHITESPACE}+"ID"{WHITESPACE}*"="{WHITESPACE}*\"[^"]+\"{WHITESPACE}+"DATA"{WHITESPACE}*"="{WHITESPACE}*\" printf("%s", yytext);Inside_Engine_ID = 1;BEGIN(TOKEN);
. yyless(0);BEGIN(OTHER_TAG);
}

<OTHER_TAG>
{
"<"[^<>]+">" printf("%s",yytext);BEGIN(TOKEN);
}


<SCAN_NUM>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NUM);
{NUM1} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 101;
    }
  else
    {
      tokenList.append(EST_String("<NUM1>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{NUM2} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 101;
    }
  else
    {
      tokenList.append(EST_String("<NUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{NUM3} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 102;
    }
  else
    {
      tokenList.append(EST_String("<NUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{INUM1} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 201;
    }
  else
    {
      tokenList.append(EST_String("<NUM1>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{INUM2} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 201;
    }
  else
    {
      tokenList.append(EST_String("<NUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{INUM3} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 202;
    }
  else
    {
      tokenList.append(EST_String("<NUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
. return 0;
}


<SCAN_NORD>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NORD);
{NUM1} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 101;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{NUM2} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 101;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{NUM3} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 102;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{INUM1} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 201;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{INUM2} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 201;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{INUM3} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 202;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{NUMORD} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 104;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{INUMORD} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 204;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
{NUMROM} {
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 105;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
. return 0;
}

<SCAN_NTEL>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NTEL);
{TELNO1} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{TELNO2} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{TELNO5} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 105;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{TELNO6} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 106;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{TELNO3} {
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{TELNO4} {
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 104;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{ITELNO1} {
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{ITELNO2} {
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 202;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{ITELNO5} {
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 205;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{ITELNO6} {
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 206;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{ITELNO3} {
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{ITELNO4} {
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 204;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. yyless(0);return 0;
}

<SCAN_NTIME>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NTEL);
{TIME_HOUR_12} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{TIME_HM_12} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{TIME_HM_24} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{TIME_HMS1} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 104;

     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{TIME_HMS2} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 105;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{ITIME_HOUR_12} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{ITIME_HM_12} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 202;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{ITIME_HM_24} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{ITIME_HMS1} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 204;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{ITIME_HMS2} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 205;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
. yyless(0);return 0;
}


<SCAN_NDATE>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NDATE);
{DATE_DMY} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{DATE_MDY} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{DATE_YMD} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{DATE_DM} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 104;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{DATE_MD} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 105;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{DATE_MY} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 106;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{DATE_YM} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 107;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{IDATE_DMY} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{IDATE_MDY} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 202;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{IDATE_YMD} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{IDATE_DM} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 204;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{IDATE_MD} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 205;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{IDATE_MY} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 206;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
{IDATE_YM} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 207;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
. yyless(0);return 1;
}


<SCAN_NYEAR>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NYEAR);
{YEAR} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NYEAR>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{IYEAR} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NYEAR>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. yyless(0);return 0;
}

<SCAN_NMONEY>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NMONEY);
. yyless(0);return -1;
}

<SCAN_LCMONEY>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_LCMONEY);
. yyless(0);return -1;
}

<SCAN_NFRAC>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NFRAC);
{NUMFRAC} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NFRAC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{INUMFRAC} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NFRAC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. yyless(0);return 0;
}

<SCAN_NFLOAT>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NFLOAT);
{NFLOAT1} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{NFLOAT2} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{NFLOAT3} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{INFLOAT1} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{INFLOAT2} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 202;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{INFLOAT3} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. yyless(0);return 0;
}


<SCAN_NZIP>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NZIP);
{DIGIT}{3}[ \-\t]?{DIGIT}{3} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NZIP>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{IDIGIT}{3}[ \-\t]?{IDIGIT}{3} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NZIP>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. yyless(0);return 0;
}


<SCAN_NPRCT>
{
({WHITESPACE}|\n)+ printf("%s", yytext);
 {NUMPRCT} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NPRCT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{INUMPRCT} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NPRCT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. yyless(0);return 0;
}



<SCAN_NPRCT>
{
({WHITESPACE}|\n)+ printf("%s", yytext);
{NUMRATIO} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NRATIO>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{INUMRATIO} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NRATIO>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. yyless(0);return 0;
}

<SCAN_NET>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NET);
 {URL} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<URL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{EMAIL} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<EMAIL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. yyless(0);return 0;
}

<SCAN_NLITERAL>
{
({WHITESPACE}|[\n])+ BEGIN(SCAN_NLITERAL);
{NUM1} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NLITERAL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
{INUM1} {
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NLITERAL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
. printf(" <NLITERAL>:%s ", yytext);
}

<INTO_SAYAS_MODE>
{
"<"{WHITESPACE}*"SAYAS"{WHITESPACE}+"MODE"{WHITESPACE}*"="{WHITESPACE}*\"
{SAYAS_MODES}/\"{WHITESPACE}*">" {
				if(strcmp(yytext,"literal") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NLITERAL);
				}
				else if(strcmp(yytext,"date") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NDATE);
				}
				else if(strcmp(yytext,"time") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NTIME);
				}
				else if(strcmp(yytext,"phone") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NTEL);
				}
				else if(strcmp(yytext,"net") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NET);
				}
				else if(strcmp(yytext,"postal") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(TOKEN);
				}
				else if(strcmp(yytext,"currency") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NMONEY);
				}
				else if(strcmp(yytext,"fraction") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NFRAC);
				}
				else if(strcmp(yytext,"ordinal") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NORD);
				}
				else if(strcmp(yytext,"cardinal") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NUM);
				}
		 }
{SAYAS_MODES}\"{WHITESPACE}+"MODETYPE"{WHITESPACE}*"="{WHITESPACE}*\" 
{SAYAS_MODETYPES}/\"{WHITESPACE}*">" {
					if(strcmp(yytext,"DMY") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"MDY") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"YMD") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"YM") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"MY") == 0)
					{
					  while(yyinput() != '>');
					   BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"MD") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);

					}
					else if(strcmp(yytext,"HM") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NTIME);
					}
					else if(strcmp(yytext,"HMS") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NTIME);
					}
					else if(strcmp(yytext,"EMAIL") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NTIME);
					}
					else if(strcmp(yytext,"URL") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NTIME);
					}
			 }
}
%%

/*

int main(int argc, char *argv[])
{
  YY_BUFFER_STATE string_buffer;
  char *str;
	if(argc != 3 )
		exit(0);
	else
	{
	  yyin = fopen(argv[1],"r");
		fout = fopen(argv[2],"w");
		Init_Data_Structures();
	}

	yylex(TOKEN,-1);
	str = (char *)malloc(30*sizeof(char));
	strcpy(str,"54.29");
	string_buffer = yy_scan_string(str);
	printf("Float: %d\n",yylex(SCAN_NFLOAT, strlen(str)));
	yy_delete_buffer(string_buffer);
	string_buffer = yy_scan_string(str);
	printf("Time: %d\n",yylex(SCAN_NTIME, strlen(str)));
	yy_delete_buffer(string_buffer);
	string_buffer = yy_scan_string(str);
	printf("Date: %d\n",yylex(SCAN_NDATE, strlen(str)));
	yy_delete_buffer(string_buffer);
	string_buffer = yy_scan_string(str);
	printf("Year: %d\n",yylex(SCAN_NYEAR, strlen(str)));
	yy_delete_buffer(string_buffer);
	return 1;
}

*/

