
/************************************************************************************/
/* Copyright (c) 2003, Outside Echo Ltd. & Hewlett-Packard.                         */
/* All rights reserved.                                                             */  
/*                                                                                  */
/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met:                    */
/*                                                                                  */
/*    * Redistributions of source code must retain the above copyright notice, this */
/*      list of conditions and the following disclaimer.                            */
/*    * Redistributions in binary form must reproduce the above copyright notice,   */
/*      this list of conditions and the following disclaimer in the documentation   */
/*      and/or other materials provided with the distribution.                      */
/*    * Neither the name of Outside Echo Ltd. & Hewlett-Packard                     */
/*      nor the names of its contributors may be used to endorse or promote products*/ 
/*      derived from this software without specific prior written permission.       */
/*                                                                                  */ 
/*                                                                                  */
/*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS NAMELY     */
/*   OUTSIDE ECHO LTD AND HEWLETT-PACKARD "AS IS" AND ANY                           */
/*   EXPRESS  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED     */
/*   WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/*   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE    */
/*   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL     */
/*   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR     */
/*   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER     */
/*   CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  */
/*   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE  */
/*   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH  DAMAGE.          */
/*                                                                                  */
/************************************************************************************/
/*                                                                                  */
/*                                                                                  */
/* AUTHOR: Panchapagesan. K., Hewlett-Packard Labs (India)                                 */
/* Email: sameer.badaskar@hp.com                                                      */
/* CREATED:  April 2, 2004                                                           */
/* MODIFIED: June 17, 2004                                                            */
/*                                                                                  */
/************************************************************************************/

/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>
#include <unistd.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)


#define YY_USES_REJECT
typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 199
#define YY_END_OF_BUFFER 200
static yyconst short int yy_acclist[3519] =
    {   0,
      200,   60,  199,   55,   60,  199,   56,  199,   57,   60,
      199,   54,   57,   60,  199,   58,   60,  199,   60,  199,
       58,   60,  199,   58,   60,  199,   57,   60,  199, 8194,
       60,  199,16386, 8194,   60,  199,16386,16405, 8194,   60,
      199,16386,16405, 8194,   60,  199,16386,16405, 8194,   60,
      199,16386,16405,   58,   60,  199,   60,  199, 8210,   60,
      199,16402, 8210,   60,  199,16402,   60,  199,   58,   60,
      199,   60,  199,   60,  199,   60,  199, 8195,   60,  199,
    16387, 8195,   60,  199,16387,16406, 8195,   60,  199,16387,
    16406, 8195,   60,  199,16387,16406, 8195,   60,  199,16387,

    16406, 8254,  199,16446,  199, 8253, 8254,  199,16445,16446,
     8253, 8254,  199,16445,16446,   92,  199,   92,  199,   92,
      199,  112,  199,  102,  112,  199,  102,  199,  103,  112,
      199,  103,  112,  199,  103,  112,  199,  103,  112,  199,
      111,  112,  199,  111,  112,  199,  112,  199,  106,  112,
      199,  101,  199,   94,  101,  199,   94,  199,   95,  101,
      199,   98,  101,  199,  166,  199,  163,  166,  199,  163,
      199,  166,  199,  166,  199,  174,  199,  167,  174,  199,
      167,  199,  174,  199,  174,  199,  126,  199,  113,  126,
      199,  113,  199,  126,  199,  126,  199,  126,  199,  126,

      199,  138,  199,  127,  138,  199,  127,  199,  138,  199,
      128,  138,  199,  128,  138,  199,  128,  138,  199,  138,
      199,  133,  138,  199,  133,  138,  199,  133,  138,  199,
      190,  199,  187,  190,  199,  187,  199,  190,  199,  190,
      199,  190,  199,  154,  199,  139,  154,  199,  139,  199,
      154,  199,  154,  199,  154,  199,  154,  199,  154,  199,
      154,  199,  154,  199,  154,  199,  154,  199,  154,  199,
      158,  199,  155,  158,  199,  155,  199,  158,  199,  158,
      199,  178,  199,  175,  178,  199,  175,  199,  178,  199,
      178,  199,  182,  186,  199,  179,  182,  183,  186,  199,

      179,  183,  199,  182,  186,  199,  182,  186,  199,  194,
      199,  191,  194,  199,  191,  199,  192,  194,  199,  193,
      194,  199,  160,  199,  159,  160,  199,  159,  199,  162,
      199,  161,  162,  199,  161,  199,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
      199,  199,  199,   55,   56, 8194, 8194, 8194, 8194, 8211,
    16403, 8194, 8194, 8194, 8194, 8194,16386,16409, 8194,16386,
    16405,16409, 8194,16386,16405,16409, 8194,16386,16405,16409,
     8194,16386,16405,16409, 8194,16386,16405,16409, 8194, 8194,
     8194, 8244,16436, 8194, 8244,16436, 8194, 8245,16437, 8194,

     8245,16437, 8194, 8194, 8194, 8194, 8194,16386,16405,16409,
     8194,16386,16409, 8194,16386,16409, 8194,16386,16409, 8194,
     8194, 8244,16436, 8194, 8244,16436, 8194, 8245,16437, 8194,
     8194,16386,16409, 8194,16386,16409, 8194,16386,16409, 8194,
    16386,16409, 8194,16386,16409, 8194, 8244,16436, 8194, 8194,
    16386,16409, 8194,16386,16409, 8194,16386,16409, 8194,16386,
    16409, 8194,16386,16409, 8194,16386,16409, 8194, 8244,16436,
     8194, 8194,16386,16409, 8194,16386,16409, 8244,16436, 8244,
    16436, 8210, 8210, 8210, 8210, 8244,16436, 8210, 8210, 8210,
    16402, 8210,16402, 8210, 8244,16436, 8210,16402, 8210,16402,

     8210,16402, 8245,16437, 8245,16437, 8195, 8195, 8195, 8195,
     8212,16404, 8195, 8195, 8195, 8195, 8195, 8195, 8195, 8244,
    16436, 8195, 8245,16437, 8195, 8245,16437, 8195,16387,16410,
     8195,16387,16406,16410, 8195,16387,16406,16410, 8195, 8195,
     8195, 8195, 8195, 8195, 8244,16436, 8195, 8245,16437, 8195,
    16387,16406,16410, 8195,16387,16410, 8195,16387,16410, 8195,
    16387,16410, 8195,16387,16410, 8195,16387,16410, 8195,16387,
    16410, 8195,16387,16410, 8195,16387,16410, 8195,16387,16410,
     8254,16446, 8254, 8253, 8254,16446, 8253, 8254, 8253, 8254,
    16445,16446, 8253, 8254,16445,16446,  102,  103,  103,  103,

      103,  111,  111,  111,  111,  111,  106,   94,   95,   98,
      163,  167,  113,  127,  130,  128,  130,  128,  130,  128,
      130,  130,  130,  130,  130,  130,  135,  133,  135,  133,
      135,  133,  135,  135,  135,  135,  135,  135,  187,  139,
      155,  156,  157,  175,  179,  183,  180,  181,  191,  192,
      193,  159,  161,16582,16582,16582,16582,   48,   49, 8211,
    16403,16409,16409,16409, 8211, 8244,16436, 8245,16437, 8200,
    16392,16409, 8200,16392,16409, 8200,16392,16409, 8206,16398,
     8194, 8194, 8194, 8194, 8194, 8194, 8196, 8197,16386,16388,
    16389,16409, 8194, 8196, 8197,16386,16388,16389,16409, 8194,

     8196, 8197,16386,16388,16389,16409, 8194, 8196, 8197,16386,
    16388,16389,16409, 8194, 8196, 8197,16386,16388,16389,16409,
     8194, 8196, 8197,16386,16388,16389,16409, 8194, 8244,16436,
     8194, 8245,16437, 8194, 8194, 8194, 8194, 8194, 8196, 8197,
    16386,16388,16389,16409, 8194, 8196, 8197,16386,16388,16389,
    16409, 8194, 8196, 8197,16386,16388,16389,16409, 8194, 8196,
     8197,16386,16388,16389,16409, 8194, 8196, 8197,16386,16388,
    16389,16409, 8194, 8196, 8197,16386,16388,16389,16409, 8194,
     8245,16437, 8194, 8194, 8194, 8242,16409,16434, 8242,16409,
    16434, 8242,16409,16434, 8244, 8244, 8244,16436, 8244,16436,

     8244, 8244,16436, 8208, 8244,16400,16436, 8245, 8245, 8245,
    16437, 8245,16437, 8245, 8245,16437, 8245,16437, 8245,16437,
     8245,16437, 8245,16437, 8200,16392,16407,16409, 8200,16392,
    16407,16409, 8200,16392,16407,16409, 8200,16392,16407,16409,
     8200,16392,16407,16409, 8200,16392,16407,16409, 8206,16398,
     8206,16398, 8206,16398, 8206,16398, 8206,16398, 8194, 8194,
     8194, 8194, 8242,16407,16409,16434, 8242,16407,16409,16434,
     8242,16407,16409,16434, 8244, 8213, 8244,16436, 8245,16437,
     8194, 8194, 8194, 8194, 8194, 8196, 8197,16386,16388,16389,
    16409, 8194, 8196, 8197,16386,16388,16389,16409, 8194, 8196,

     8197,16386,16388,16389,16409, 8194, 8194, 8196, 8197,16386,
    16388,16389, 8194, 8196, 8197,16386,16388,16389, 8194, 8196,
     8197,16386,16388,16389, 8194, 8196, 8197,16386,16388,16389,
     8194, 8194, 8194, 8194,   59, 8244,16436, 8244,16436, 8210,
    16402, 8210,16402, 8245,16437, 8245,16437, 8212,16404,16410,
    16410,16410, 8212, 8203,16395,16410, 8203,16395,16410, 8203,
    16395,16410, 8207,16399, 8243,16410,16435, 8243,16410,16435,
     8243,16410,16435, 8195, 8195, 8195, 8195, 8195, 8195, 8244,
    16436, 8195, 8245,16437, 8195, 8198, 8199,16387,16390,16391,
    16410, 8195, 8198, 8199,16387,16390,16391,16410, 8195, 8198,

     8199,16387,16390,16391,16410, 8195, 8195, 8195, 8195, 8195,
     8245,16437, 8195, 8198, 8199,16387,16390,16391,16410, 8195,
     8198, 8199,16387,16390,16391,16410, 8195, 8198, 8199,16387,
    16390,16391,16410, 8203,16395,16408,16410, 8203,16395,16408,
    16410, 8203,16395,16408,16410, 8203,16395,16408,16410, 8203,
    16395,16408,16410, 8203,16395,16408,16410, 8207,16399, 8207,
    16399, 8207,16399, 8207,16399, 8207,16399, 8243,16408,16410,
    16435, 8243,16408,16410,16435, 8243,16408,16410,16435, 8244,
     8214, 8244,16436, 8245,16437, 8195, 8195, 8195, 8195, 8195,
     8195, 8195, 8198, 8199,16387,16390,16391, 8195,  103,  104,

      105,  103,  104,  105,  103,  104,  105,  103,  104,  105,
      109,  111,  111,  106,  107,  108,   95,   96,   97,   98,
       99,  100,  164,  165,  168,  171,  130,  130,  130,  130,
      130,  130,  130,  130,  130,  130,  130,  130,  129,  130,
      129,  130,  129,  130,  129,  130,  129,  130,  129,  130,
      135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
      135,  135,  134,  135,  134,  135,  134,  135,  134,  135,
      134,  135,  134,  135,  189,  143,  144,  143,  144,  143,
      144,  143,  144,  150,  151,  150,  151,  150,  151,  150,
      151,  184,  185,16580,   93, 8242,16409,16434, 8242,16409,

    16434, 8242,16409,16434, 8208,16400, 8200, 8200, 8200, 8200,
     8211,16403, 8200, 8200, 8200, 8200,16392, 8206, 8206,16398,
    16409,16409,16409, 8200,16392,16409, 8200,16392,16409, 8200,
    16392,16409, 8200,16392,16409, 8206,16398, 8206,16398, 8206,
    16398, 8194, 8196, 8197, 8194, 8196, 8197, 8194, 8196, 8197,
     8194, 8196, 8197, 8211,16403, 8194, 8196, 8197, 8194, 8196,
     8197, 8194, 8196, 8197, 8194, 8196, 8197, 8193, 8194, 8196,
     8197,16385,16386,16409, 8193, 8194, 8196, 8197,16385,16386,
    16409, 8193, 8194, 8196, 8197,16385,16386,16409, 8193, 8194,
     8196, 8197,16385,16386,16409, 8194, 8196, 8197, 8194, 8196,

     8197, 8194, 8196, 8197, 8244,16436, 8194, 8196, 8197, 8244,
    16436, 8194, 8196, 8197, 8244,16436, 8194, 8196, 8197, 8245,
    16437, 8194, 8196, 8197, 8245,16437, 8194, 8196, 8197, 8245,
    16437, 8194, 8196, 8197, 8194, 8196, 8197, 8244,16436, 8194,
     8196, 8197, 8194, 8196, 8197, 8244,16436, 8194, 8196, 8197,
     8194, 8196, 8197, 8244,16436, 8193, 8194, 8196, 8197,16385,
    16386, 8193, 8194, 8196, 8197,16385,16386, 8193, 8194, 8196,
     8197,16385,16386, 8193, 8194, 8196, 8197,16385,16386, 8244,
    16436, 8244,16436, 8245,16437, 8200,16392,16407,16409, 8200,
    16392,16407,16409, 8200,16392,16407,16409, 8200,16392,16407,

    16409, 8200,16392,16407,16409, 8200,16392,16407,16409, 8206,
    16398, 8206,16398, 8206,16398, 8206,16398, 8206,16398, 8245,
    16437, 8242, 8242, 8242,16409,16434, 8242, 8242, 8242,16434,
     8244, 8208, 8244, 8208, 8244, 8208, 8244,16436, 8208, 8244,
    16436, 8208, 8244, 8208, 8244,16436, 8208, 8244,16436, 8245,
     8209, 8245,16401,16437,16407,16409,16407,16409,16407,16409,
     8242,16407,16409,16434, 8242,16407,16409,16434, 8242,16407,
    16409,16434, 8213, 8200, 8200,16392,16407,16409, 8200, 8200,
     8200, 8200, 8200,16392,16407,16409, 8206,16398, 8206, 8206,
    16398, 8200,16392,16409, 8200,16392,16409, 8200,16392,16409,

     8200,16392,16409, 8206,16398, 8206,16398, 8206,16398, 8242,
     8242,16407,16409,16434, 8242, 8242, 8213, 8213, 8244, 8213,
     8244, 8213, 8244,16436, 8213, 8244, 8213, 8244,16436, 8213,
     8244, 8213, 8244,16436, 8213, 8244,16436, 8213, 8245,16437,
     8200,16392, 8200,16392, 8200,16392, 8242,16434, 8194, 8196,
     8197, 8194, 8196, 8197, 8194, 8196, 8197, 8194, 8196, 8197,
     8200,16392, 8200,16392, 8200,16392, 8244, 8210,16402, 8245,
     8243,16410,16435, 8243,16410,16435, 8243,16410,16435, 8203,
     8203, 8203, 8203, 8212,16404, 8203, 8203, 8203, 8203,16395,
     8207, 8207,16399, 8243, 8243, 8243, 8243, 8243,16410,16435,

     8243,16435,16410,16410,16410, 8203,16395,16410, 8203,16395,
    16410, 8203,16395,16410, 8203,16395,16410, 8207,16399, 8207,
    16399, 8207,16399, 8244,16436, 8244,16436, 8245,16437, 8195,
     8198, 8199, 8195, 8198, 8199, 8195, 8198, 8199, 8195, 8198,
     8199, 8212,16404, 8195, 8198, 8199, 8195, 8198, 8199, 8195,
     8198, 8199, 8195, 8198, 8199, 8195, 8198, 8199, 8195, 8198,
     8199, 8195, 8198, 8199, 8244,16436, 8195, 8198, 8199, 8244,
    16436, 8195, 8198, 8199, 8245,16437, 8195, 8198, 8199, 8245,
    16437, 8195, 8198, 8199, 8245,16437, 8193, 8195, 8198, 8199,
    16385,16387,16410, 8193, 8195, 8198, 8199,16385,16387, 8203,

    16395,16408,16410, 8203,16395,16408,16410, 8203,16395,16408,
    16410, 8203,16395,16408,16410, 8203,16395,16408,16410, 8203,
    16395,16408,16410, 8207,16399, 8207,16399, 8207,16399, 8207,
    16399, 8207,16399, 8245,16437,16408,16410,16408,16410,16408,
    16410, 8243,16408,16410,16435, 8243,16408,16410,16435, 8243,
    16408,16410,16435, 8214, 8203, 8203, 8203, 8203,16395,16408,
    16410, 8203, 8203, 8203,16395,16408,16410, 8207,16399, 8207,
     8207,16399, 8243, 8243, 8243, 8243,16408,16410,16435, 8214,
     8214, 8244, 8214, 8244, 8214, 8244,16436, 8214, 8244, 8214,
     8244,16436, 8214, 8244, 8214, 8244,16436, 8214, 8244,16436,

     8214, 8245,16437, 8203,16395,16410, 8203,16395,16410, 8203,
    16395,16410, 8203,16395,16410, 8207,16399, 8207,16399, 8207,
    16399, 8203,16395, 8203,16395, 8203,16395, 8243,16435, 8195,
     8198, 8199, 8203,16395, 8203,16395, 8203,16395,  103,  103,
      103,  103,  110,  111,  106,   95,   98,  164,  165,  130,
      130,  129,  130,  135,  135,  134,  135,  146,  146,  143,
      144,  146,  143,  144,  146,  143,  144,  146,  143,  144,
      146,  145,  143,  144,  145,  144,  145,  143,  146,  143,
      146,  153,  153,  150,  151,  153,  150,  151,  153,  150,
      151,  153,  150,  151,  153,  152,  150,  151,  152,  151,

      152,  150,  153,  150,  153,  156,  157,  184,  185, 8390,
     8242,16409,16434, 8242,16434, 8208, 8209,16401, 8196, 8197,
    16388,16389, 8200, 8206,16398,16409, 8200, 8200, 8206,16398,
     8206,16398, 8206, 8200, 8201, 8202,16392,16393,16394, 8206,
    16398, 8193, 8194, 8193, 8194, 8193, 8194, 8193, 8194, 8211,
    16403, 8193, 8194, 8193, 8194, 8193, 8194, 8193, 8194,16386,
     8193, 8194,16386, 8193, 8194,16386, 8193, 8194,16386, 8193,
     8194, 8193, 8194, 8193, 8194, 8244,16436, 8193, 8194, 8244,
    16436, 8193, 8194, 8244,16436, 8193, 8194, 8245,16437, 8193,
     8194, 8245,16437, 8193, 8194, 8245,16437, 8193, 8194, 8193,

     8194, 8244,16436, 8193, 8194, 8193, 8194, 8244,16436, 8193,
     8194, 8193, 8194, 8244,16436, 8193, 8194, 8193, 8194, 8193,
     8194, 8193, 8194, 8244,16436, 8217, 8244,16436, 8217, 8245,
    16437, 8200, 8200, 8206,16398, 8206, 8206,16398, 8213, 8217,
     8245,16437, 8242, 8242,16434, 8242, 8209, 8245, 8209, 8245,
     8209, 8245,16437, 8209, 8245,16437, 8209, 8245, 8209, 8245,
    16437, 8209, 8245,16437, 8242,16407,16409,16434, 8213, 8213,
     8215, 8200, 8200, 8206, 8200, 8200, 8206,16398, 8206, 8215,
     8213, 8213, 8213, 8213, 8245, 8213, 8245, 8213, 8245,16437,
     8213, 8245,16437, 8213, 8245, 8213, 8245,16437, 8213, 8245,

    16437, 8242,16434, 8243,16410,16435, 8243,16435, 8198, 8199,
    16390,16391, 8203, 8207,16399, 8243, 8243, 8243,16435,16410,
     8203, 8203, 8207,16399, 8207,16399, 8207, 8244,16436, 8218,
     8244,16436, 8218, 8245,16437, 8203, 8204, 8205,16395,16396,
    16397, 8207,16399, 8193, 8195, 8193, 8195, 8193, 8195, 8193,
     8195, 8212,16404, 8193, 8195, 8193, 8195, 8193, 8195, 8193,
     8195, 8193, 8195, 8193, 8195, 8244,16436, 8193, 8195, 8244,
    16436, 8193, 8195, 8245,16437, 8193, 8195, 8245,16437, 8193,
     8195, 8245,16437, 8193, 8195,16387, 8193, 8195, 8203, 8203,
     8207,16399, 8207, 8207,16399, 8214, 8218, 8245,16437, 8243,

    16408,16410,16435, 8214, 8214, 8216, 8203, 8203, 8207, 8216,
     8214, 8214, 8214, 8214, 8245, 8214, 8245, 8214, 8245,16437,
     8214, 8245,16437, 8214, 8245, 8214, 8245,16437, 8214, 8245,
    16437, 8203, 8203, 8207,16399, 8207, 8243,16435,   63,  104,
      105,  107,  108,   96,   97,   99,  100,  164,  165,  168,
      169,  170,  171,  172,  173,  143,  144,  145,  146,  150,
      151,  152,  153,  184,  185, 8388, 8217, 8209, 8196, 8197,
     8196, 8197, 8196, 8197, 8217, 8206,16398, 8227,16419, 8227,
    16419, 8227,16419, 8227,16419, 8227,16419, 8227,16419, 8206,
    16398, 8200, 8201, 8202, 8200, 8201, 8202, 8200, 8201, 8202,

     8200, 8201, 8202, 8211,16403, 8200, 8201, 8202, 8206,16398,
     8194, 8194, 8194, 8194, 8194, 8231,16386,16423, 8194, 8231,
    16386,16423, 8194, 8231,16386,16423, 8194, 8231,16386,16423,
     8194, 8194, 8194, 8244,16436, 8217, 8244, 8217, 8244, 8217,
     8244,16436, 8217, 8244,16436, 8217, 8244, 8217, 8244,16436,
     8217, 8244,16436, 8217, 8245, 8217, 8245, 8217, 8245,16437,
     8217, 8245,16437, 8217, 8245, 8217, 8245,16437, 8217, 8245,
    16437, 8213, 8217, 8227,16419, 8227,16419, 8227,16419, 8227,
    16419, 8227,16419, 8227,16419, 8213, 8217, 8245, 8213, 8217,
     8245, 8213, 8217, 8245,16437, 8213, 8217, 8245,16437, 8213,

     8217, 8245, 8213, 8217, 8245,16437, 8213, 8217, 8245,16437,
     8242,16434, 8223, 8225,16415,16417, 8223, 8225,16415,16417,
     8215, 8215, 8215, 8215, 8215, 8217, 8227,16419, 8227,16419,
     8227,16419, 8227,16419, 8227,16419, 8227,16419, 8215, 8215,
     8217, 8218, 8198, 8199, 8198, 8199, 8198, 8199, 8218, 8207,
    16399, 8243,16435, 8228,16420, 8228,16420, 8228,16420, 8228,
    16420, 8228,16420, 8228,16420, 8207,16399, 8244,16436, 8218,
     8244, 8218, 8244, 8218, 8244,16436, 8218, 8244,16436, 8218,
     8244, 8218, 8244,16436, 8218, 8244,16436, 8218, 8245, 8218,
     8245, 8218, 8245,16437, 8218, 8245,16437, 8218, 8245, 8218,

     8245,16437, 8218, 8245,16437, 8203, 8204, 8205, 8203, 8204,
     8205, 8203, 8204, 8205, 8203, 8204, 8205, 8212,16404, 8203,
     8204, 8205, 8207,16399, 8195, 8195, 8195, 8195, 8195, 8232,
    16387,16424, 8214, 8218, 8228,16420, 8228,16420, 8228,16420,
     8228,16420, 8228,16420, 8228,16420, 8214, 8218, 8245, 8214,
     8218, 8245, 8214, 8218, 8245,16437, 8214, 8218, 8245,16437,
     8214, 8218, 8245, 8214, 8218, 8245,16437, 8214, 8218, 8245,
    16437, 8224, 8226,16416,16418, 8224, 8226,16416,16418, 8216,
     8216, 8216, 8216, 8216, 8218, 8216, 8216, 8218, 8228,16420,
     8228,16420, 8228,16420, 8228,16420, 8228,16420, 8228,16420,

       64,   65,   67,   79,  164,  165,  115,  121,  142,  142,
      142,  142,  142,  142,  145,  140,  141,  142,  142,  142,
      149,  149,  149,  149,  149,  149,  152,  147,  148,  149,
      149,  149,  176,  177,  184,  185, 8217, 8201, 8202,16393,
    16394, 8217, 8217, 8206,16398, 8227, 8227, 8227, 8206, 8206,
     8206,16398, 8229,16421, 8197,16389, 8229,16421, 8206, 8229,
    16398,16421, 8194, 8231, 8194, 8231, 8194, 8231, 8194, 8211,
     8231,16403, 8194, 8231, 8194, 8231, 8194, 8231,16386,16423,
     8194, 8231,16386,16423, 8194, 8231,16386,16423, 8194, 8231,
    16386,16423, 8194, 8231, 8194, 8231, 8244,16436, 8194, 8231,

     8244,16436, 8194, 8231, 8245,16437, 8194, 8231, 8245,16437,
     8194, 8231, 8194, 8231, 8244,16436, 8194, 8231, 8194, 8231,
     8244,16436, 8194, 8231, 8194, 8231, 8244,16436, 8213, 8217,
     8223, 8225, 8227,16415,16417,16419, 8223, 8225, 8227,16415,
    16417, 8223, 8225, 8227,16415,16417,16419, 8223, 8225, 8227,
    16415,16417, 8242,16434, 8219,16411, 8223, 8225, 8223, 8225,
     8223, 8225, 8223, 8225, 8223, 8225, 8225,16417, 8225,16417,
     8215, 8217, 8215, 8217, 8215, 8217, 8223,16415, 8223, 8227,
    16415,16419, 8223, 8227,16415, 8223,16415, 8223, 8227,16415,
    16419, 8223, 8227,16415,   47,   49,   47,   49, 8218, 8204,

     8205,16396,16397, 8218, 8218, 8207,16399, 8220,16412, 8243,
    16435, 8228, 8228, 8228, 8207, 8207, 8207,16399, 8230,16422,
     8199,16391, 8230,16422, 8207, 8230,16399,16422, 8195, 8232,
     8195, 8232, 8195, 8232, 8195, 8212, 8232,16404, 8195, 8232,
     8195, 8232, 8195, 8232, 8195, 8232, 8244,16436, 8195, 8232,
     8245,16437, 8195, 8232, 8245,16437, 8195, 8232,16387,16424,
     8214, 8218, 8224, 8226, 8228,16416,16418,16420, 8224, 8226,
     8228,16416,16418, 8224, 8226, 8228,16416,16418,16420, 8224,
     8226, 8228,16416,16418, 8224, 8226, 8224, 8226, 8224, 8226,
     8224, 8226, 8224, 8226, 8226,16418, 8226,16418, 8216, 8218,

     8216, 8218, 8216, 8218, 8224,16416, 8224, 8228,16416,16420,
     8224, 8228,16416, 8224,16416, 8224, 8228,16416,16420, 8224,
     8228,16416,   66,   68,   80,   69,   75,   81,   73,   71,
      105,  108,   97,  100,  164,  165,  169,  170,  172,  173,
      114,  115,  120,  121,  131,  136,  188,  188,  140,  141,
      142,  141,  140,  140,  142,  147,  148,  149,  148,  147,
      147,  149,  184,  185, 8196,16388, 8201, 8202, 8206,16398,
     8229, 8229, 8229, 8229,16421, 8197, 8197, 8197, 8229, 8229,
     8229,16421, 8229, 8206, 8229, 8206, 8229, 8206, 8229, 8206,
     8229,16398,16421, 8194, 8231,16386,16423, 8194, 8231,16386,

    16423, 8194, 8231,16386,16423, 8194, 8231,16386,16423, 8223,
     8225, 8227, 8223, 8225, 8227, 8223, 8225, 8227, 8223, 8225,
     8227, 8223, 8225, 8227, 8221,16413, 8219, 8223, 8225,16415,
    16417, 8223, 8225,16415,16417, 8225, 8225, 8225, 8225, 8225,
     8223, 8223, 8223, 8223, 8223, 8227, 8223, 8227, 8223, 8227,
     8223, 8227, 8223, 8223, 8227, 8198,16390, 8204, 8205, 8222,
    16414, 8220, 8207,16399, 8230, 8230, 8230, 8230,16422, 8199,
     8199, 8199, 8230, 8230, 8230, 8230,16422, 8207, 8230, 8207,
     8230, 8207, 8230, 8207, 8230,16399,16422, 8195, 8232,16387,
    16424, 8224, 8226, 8228, 8224, 8226, 8228, 8224, 8226, 8228,

     8224, 8226, 8228, 8224, 8226, 8228, 8224, 8226,16416,16418,
     8224, 8226,16416,16418, 8226, 8226, 8226, 8226, 8226, 8224,
     8224, 8224, 8224, 8224, 8228, 8224, 8228, 8224, 8228, 8224,
     8228, 8224, 8224, 8228,   70,   76,   82,   74,   72,   90,
       77,   83,  104,  107,   96,   99,  114,  115,  120,  121,
      132,  137,  140,  141,  147,  148, 8196, 8196, 8235,16427,
     8235,16427, 8206, 8235,16427, 8229, 8202,16394, 8229, 8206,
     8229,16398, 8194, 8231,16386,16423, 8194, 8231,16386,16423,
     8194, 8231,16386,16423, 8194, 8231,16386,16423, 8221, 8225,
    16417, 8225,16417, 8223,16415, 8223,16415, 8198, 8198, 8222,

     8236,16428, 8236,16428, 8207, 8236,16428, 8230, 8205,16397,
     8230, 8207, 8230,16399, 8195, 8232,16387,16424, 8226,16418,
     8226,16418, 8224,16416, 8224,16416,   78,   84,   85,  170,
      173,  119,  115,  125,  121,  141,  140,  148,  147, 8233,
    16425, 8234,16426, 8201,16393, 8235,16427, 8235, 8235,16427,
     8235, 8235, 8202, 8194, 8231,16386,16423, 8194, 8231,16386,
    16423, 8194, 8231,16386,16423, 8194, 8231,16386,16423, 8204,
    16396, 8236,16428, 8236, 8236,16428, 8236, 8236, 8205, 8195,
     8232,16387,16424,   86,   87,  169,  172,  118,  124,  119,
      115,  125,  121, 8233,16425, 8233, 8234,16426, 8234, 8201,

     8235,16427, 8235,16427, 8194, 8231,16386,16423, 8194, 8231,
    16386,16423, 8194, 8231,16386,16423, 8194, 8231,16386,16423,
     8204, 8236,16428, 8236,16428, 8195, 8232,16387,16424,   88,
      118,  124,  119,  115,  125,  121, 8233,16425, 8234,16426,
     8194, 8231,16386,16423, 8194, 8231,16386,16423, 8194, 8231,
    16386,16423, 8194, 8231,16386,16423, 8195, 8232,16387,16424,
      118,  118,  124,  124,  115,  121, 8237,16429, 8238,16430,
     8194, 8231,16386,16423, 8194, 8231,16386,16423, 8194, 8231,
    16386,16423, 8194, 8231,16386,16423, 8195, 8232,16387,16424,
      118,  124,  116,  122,  115,  121,  195, 8237,16429, 8237,

    16429, 8237, 8237,16429, 8238,16430, 8238,16430, 8238, 8238,
    16430, 8194, 8231,16386,16423, 8194, 8231,16386,16423, 8194,
     8231,16386,16423, 8194, 8231,16386,16423, 8195, 8232,16387,
    16424,  117,  123,  116,  116,  116,  122,  122,  122,  115,
      121, 8237,16429, 8237,16429, 8238,16430, 8238,16430, 8194,
     8231,16386,16423, 8194, 8231,16386,16423, 8194, 8231,16386,
    16423, 8194, 8231,16386,16423, 8195, 8232,16387,16424,  117,
      123,  116,  116,  122,  122,  115,  121,  197, 8237,16429,
     8238,16430, 8194, 8231,16386, 8194, 8231,16386, 8194, 8231,
    16386, 8194, 8231,16386, 8195, 8232,16387,  117,  123,  116,

      122, 8194, 8194,16386, 8194,16386, 8194,16386, 8194,16386,
     8194, 8194, 8194, 8195, 8195,16387,   89,   91
    } ;

static yyconst short int yy_accept[2895] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    2,    4,    7,
        9,   12,   16,   19,   21,   24,   27,   30,   34,   39,
       44,   49,   54,   57,   59,   63,   67,   69,   72,   74,
       76,   78,   82,   87,   92,   97,  102,  105,  106,  111,
      116,  118,  120,  122,  124,  127,  129,  132,  135,  138,
      141,  144,  147,  149,  152,  154,  157,  159,  162,  165,

      167,  170,  172,  174,  176,  178,  181,  183,  185,  187,
      189,  192,  194,  196,  198,  200,  202,  204,  207,  209,
      211,  214,  217,  220,  222,  225,  228,  231,  233,  236,
      238,  240,  242,  244,  246,  249,  251,  253,  255,  257,
      259,  261,  263,  265,  267,  269,  271,  273,  276,  278,
      280,  282,  284,  287,  289,  291,  293,  296,  301,  304,
      307,  310,  312,  315,  317,  320,  323,  325,  328,  330,
      332,  335,  337,  338,  339,  340,  341,  342,  343,  344,
      345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
      354,  354,  355,  356,  356,  356,  356,  356,  356,  357,

      358,  359,  362,  363,  364,  365,  366,  369,  373,  377,
      381,  385,  389,  390,  391,  394,  397,  400,  403,  404,
      405,  406,  407,  411,  414,  417,  420,  421,  424,  427,
      430,  431,  434,  437,  440,  443,  446,  449,  450,  453,
      456,  459,  462,  465,  468,  471,  472,  475,  478,  478,
      478,  480,  480,  482,  483,  484,  485,  488,  489,  490,
      492,  494,  497,  499,  501,  503,  503,  503,  503,  503,
      505,  505,  507,  508,  509,  510,  513,  514,  515,  516,
      517,  518,  519,  522,  525,  528,  531,  535,  539,  540,
      541,  542,  543,  544,  547,  550,  554,  557,  560,  563,

      566,  569,  572,  575,  578,  581,  583,  584,  587,  589,
      593,  597,  597,  597,  597,  597,  597,  597,  597,  597,
      598,  598,  598,  599,  600,  601,  602,  602,  602,  602,
      602,  602,  602,  602,  602,  603,  604,  605,  606,  607,
      607,  607,  607,  608,  609,  609,  610,  610,  611,  612,
      612,  612,  612,  612,  613,  613,  613,  613,  613,  613,
      613,  614,  614,  614,  614,  614,  614,  614,  614,  615,
      615,  615,  616,  618,  620,  620,  620,  620,  622,  623,
      624,  624,  625,  626,  627,  627,  627,  627,  628,  630,
      632,  632,  632,  632,  634,  635,  636,  637,  638,  639,

      639,  639,  640,  640,  640,  641,  641,  641,  641,  641,
      641,  641,  641,  641,  642,  643,  644,  645,  645,  645,
      647,  647,  648,  648,  648,  648,  648,  649,  649,  649,
      649,  650,  651,  652,  653,  654,  654,  654,  654,  654,
      655,  656,  657,  657,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  660,
      660,  660,  660,  660,  660,  662,  662,  663,  664,  665,
      665,  665,  665,  666,  666,  668,  670,  670,  673,  676,
      679,  681,  682,  683,  684,  685,  686,  693,  700,  707,
      714,  721,  728,  731,  734,  735,  736,  737,  738,  745,

      752,  759,  766,  773,  780,  783,  784,  785,  786,  786,
      789,  792,  795,  796,  797,  799,  801,  802,  804,  808,
      809,  810,  812,  814,  815,  817,  819,  821,  823,  825,
      825,  825,  825,  825,  825,  825,  825,  825,  825,  825,
      825,  825,  829,  833,  837,  841,  845,  849,  851,  853,
      855,  857,  859,  860,  861,  862,  863,  863,  867,  871,
      875,  876,  879,  881,  881,  881,  882,  883,  884,  885,
      892,  899,  906,  907,  913,  919,  925,  931,  931,  931,
      932,  933,  934,  935,  935,  936,  938,  940,  942,  944,
      944,  944,  946,  948,  948,  950,  950,  950,  951,  952,

      953,  954,  954,  954,  957,  960,  963,  965,  965,  968,
      971,  974,  975,  976,  977,  978,  979,  982,  985,  992,
      999, 1006, 1007, 1008, 1009, 1010, 1013, 1020, 1027, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1038, 1042, 1046, 1050, 1054, 1058, 1060, 1062, 1064,
     1066, 1068, 1068, 1072, 1076, 1080, 1081, 1084, 1086, 1087,
     1088, 1089, 1090, 1091, 1092, 1098, 1099, 1099, 1099, 1099,
     1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099, 1099,
     1099, 1099, 1099, 1099, 1099, 1099, 1099, 1102, 1105, 1108,
     1111, 1112, 1112, 1112, 1112, 1112, 1113, 1114, 1114, 1114,

     1117, 1117, 1117, 1120, 1120, 1120, 1123, 1124, 1124, 1125,
     1125, 1125, 1126, 1126, 1126, 1126, 1127, 1127, 1127, 1127,
     1127, 1127, 1127, 1127, 1127, 1127, 1127, 1127, 1127, 1127,
     1127, 1128, 1129, 1130, 1130, 1131, 1132, 1133, 1134, 1135,
     1136, 1137, 1138, 1139, 1139, 1141, 1143, 1145, 1147, 1149,
     1151, 1151, 1151, 1152, 1153, 1154, 1154, 1155, 1156, 1157,
     1158, 1159, 1160, 1161, 1162, 1163, 1163, 1165, 1167, 1169,
     1171, 1173, 1175, 1175, 1175, 1176, 1176, 1176, 1176, 1176,
     1176, 1176, 1178, 1180, 1182, 1184, 1184, 1184, 1184, 1184,
     1184, 1186, 1188, 1190, 1192, 1192, 1192, 1192, 1192, 1192,

     1192, 1192, 1192, 1193, 1193, 1193, 1194, 1194, 1194, 1194,
     1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1194, 1195,
     1195, 1195, 1195, 1195, 1196, 1196, 1196, 1196, 1196, 1196,
     1196, 1196, 1196, 1196, 1196, 1196, 1196, 1196, 1199, 1202,
     1205, 1207, 1207, 1207, 1207, 1207, 1207, 1208, 1209, 1210,
     1213, 1214, 1215, 1216, 1218, 1219, 1221, 1221, 1222, 1223,
     1224, 1224, 1224, 1224, 1227, 1230, 1233, 1236, 1238, 1240,
     1242, 1245, 1248, 1251, 1256, 1259, 1262, 1265, 1268, 1275,
     1282, 1289, 1296, 1299, 1302, 1307, 1312, 1317, 1322, 1327,
     1332, 1335, 1340, 1343, 1348, 1351, 1356, 1362, 1368, 1374,

     1380, 1382, 1384, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1390, 1394, 1398, 1402, 1406, 1410, 1412, 1414, 1416,
     1418, 1420, 1422, 1422, 1422, 1422, 1423, 1424, 1427, 1428,
     1429, 1431, 1432, 1434, 1436, 1439, 1442, 1444, 1447, 1450,
     1451, 1455, 1457, 1459, 1461, 1465, 1469, 1473, 1473, 1474,
     1474, 1474, 1474, 1474, 1475, 1479, 1480, 1481, 1482, 1483,
     1487, 1489, 1490, 1492, 1492, 1492, 1492, 1492, 1495, 1498,
     1501, 1504, 1506, 1508, 1510, 1511, 1515, 1516, 1517, 1518,
     1520, 1522, 1525, 1527, 1530, 1532, 1535, 1538, 1541, 1541,
     1541, 1541, 1541, 1541, 1543, 1545, 1547, 1547, 1549, 1552,

     1555, 1558, 1561, 1561, 1561, 1563, 1565, 1567, 1567, 1568,
     1570, 1570, 1570, 1571, 1574, 1577, 1580, 1580, 1580, 1580,
     1580, 1581, 1582, 1583, 1586, 1587, 1588, 1589, 1591, 1592,
     1594, 1595, 1596, 1597, 1598, 1601, 1603, 1603, 1604, 1605,
     1606, 1606, 1606, 1606, 1609, 1612, 1615, 1618, 1620, 1622,
     1624, 1626, 1628, 1630, 1633, 1636, 1639, 1644, 1647, 1650,
     1653, 1656, 1659, 1662, 1667, 1672, 1677, 1682, 1687, 1694,
     1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1704, 1708,
     1712, 1716, 1720, 1724, 1726, 1728, 1730, 1732, 1734, 1736,
     1738, 1740, 1742, 1746, 1750, 1754, 1754, 1755, 1755, 1755,

     1755, 1755, 1756, 1757, 1758, 1762, 1763, 1764, 1768, 1770,
     1771, 1773, 1774, 1775, 1776, 1780, 1781, 1783, 1785, 1788,
     1790, 1793, 1795, 1798, 1801, 1804, 1804, 1804, 1804, 1807,
     1810, 1813, 1816, 1818, 1820, 1822, 1822, 1822, 1822, 1824,
     1826, 1828, 1828, 1830, 1833, 1835, 1837, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1840, 1841, 1842,
     1843, 1844, 1845, 1845, 1845, 1846, 1846, 1846, 1847, 1847,
     1847, 1848, 1849, 1850, 1850, 1850, 1850, 1850, 1850, 1850,

     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1851, 1851, 1852, 1852, 1854, 1854, 1855, 1855,
     1856, 1856, 1858, 1858, 1858, 1858, 1858, 1859, 1860, 1860,
     1860, 1863, 1866, 1869, 1872, 1873, 1876, 1876, 1878, 1878,
     1880, 1882, 1882, 1883, 1884, 1884, 1884, 1887, 1890, 1893,
     1896, 1897, 1900, 1900, 1902, 1902, 1904, 1906, 1907, 1908,
     1908, 1908, 1908, 1908, 1908, 1908, 1909, 1909, 1910, 1910,
     1910, 1910, 1910, 1911, 1911, 1911, 1911, 1911, 1911, 1911,
     1911, 1911, 1911, 1911, 1911, 1911, 1911, 1911, 1911, 1911,

     1911, 1911, 1911, 1911, 1911, 1911, 1911, 1911, 1914, 1916,
     1917, 1919, 1919, 1923, 1923, 1923, 1923, 1923, 1924, 1926,
     1927, 1927, 1927, 1927, 1927, 1927, 1928, 1929, 1931, 1933,
     1934, 1934, 1934, 1934, 1934, 1940, 1942, 1944, 1946, 1948,
     1952, 1954, 1956, 1958, 1961, 1964, 1967, 1970, 1972, 1974,
     1978, 1982, 1986, 1990, 1994, 1998, 2000, 2004, 2006, 2010,
     2012, 2016, 2016, 2016, 2016, 2018, 2020, 2022, 2024, 2026,
     2029, 2032, 2032, 2032, 2032, 2032, 2032, 2033, 2034, 2036,
     2037, 2039, 2043, 2044, 2046, 2047, 2049, 2051, 2054, 2057,
     2059, 2062, 2065, 2065, 2065, 2065, 2069, 2070, 2071, 2071,

     2071, 2071, 2071, 2071, 2071, 2072, 2072, 2073, 2074, 2075,
     2075, 2075, 2075, 2076, 2077, 2079, 2080, 2080, 2081, 2081,
     2082, 2083, 2084, 2086, 2088, 2091, 2094, 2096, 2099, 2102,
     2104, 2104, 2104, 2104, 2104, 2104, 2104, 2104, 2107, 2109,
     2109, 2109, 2109, 2109, 2113, 2113, 2113, 2113, 2113, 2114,
     2116, 2117, 2118, 2120, 2121, 2121, 2121, 2121, 2121, 2121,
     2122, 2123, 2125, 2127, 2128, 2130, 2133, 2136, 2136, 2136,
     2136, 2136, 2142, 2144, 2146, 2148, 2150, 2154, 2156, 2158,
     2160, 2162, 2164, 2168, 2172, 2176, 2180, 2184, 2187, 2189,
     2189, 2189, 2189, 2189, 2189, 2190, 2191, 2193, 2194, 2196,

     2200, 2200, 2200, 2200, 2204, 2205, 2206, 2206, 2206, 2206,
     2206, 2206, 2206, 2207, 2207, 2208, 2209, 2210, 2210, 2211,
     2211, 2212, 2213, 2214, 2216, 2218, 2221, 2224, 2226, 2229,
     2232, 2232, 2232, 2232, 2233, 2234, 2236, 2237, 2239, 2239,
     2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239,
     2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239,
     2239, 2239, 2239, 2239, 2239, 2239, 2240, 2240, 2240, 2240,
     2240, 2242, 2242, 2242, 2244, 2244, 2244, 2246, 2246, 2246,
     2248, 2248, 2249, 2250, 2250, 2250, 2250, 2253, 2253, 2253,
     2253, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,

     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256, 2256,
     2256, 2256, 2260, 2260, 2260, 2260, 2260, 2260, 2260, 2264,
     2264, 2264, 2264, 2264, 2264, 2264, 2264, 2264, 2265, 2266,
     2266, 2266, 2266, 2266, 2266, 2266, 2266, 2266, 2267, 2267,
     2267, 2267, 2267, 2267, 2267, 2267, 2267, 2267, 2267, 2267,
     2267, 2267, 2268, 2269, 2269, 2271, 2273, 2275, 2275, 2276,
     2276, 2278, 2278, 2278, 2278, 2280, 2282, 2284, 2284, 2286,
     2288, 2290, 2292, 2292, 2292, 2292, 2295, 2298, 2301, 2306,
     2309, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 2312, 2313,

     2314, 2315, 2319, 2323, 2327, 2331, 2332, 2333, 2334, 2336,
     2338, 2340, 2343, 2346, 2348, 2351, 2354, 2356, 2358, 2361,
     2364, 2366, 2369, 2372, 2374, 2374, 2376, 2378, 2380, 2380,
     2382, 2384, 2386, 2389, 2392, 2396, 2400, 2403, 2407, 2411,
     2411, 2413, 2413, 2417, 2421, 2421, 2421, 2422, 2423, 2424,
     2425, 2427, 2427, 2429, 2431, 2433, 2433, 2435, 2437, 2439,
     2440, 2442, 2442, 2442, 2442, 2442, 2443, 2443, 2445, 2447,
     2449, 2449, 2450, 2450, 2452, 2452, 2452, 2454, 2454, 2454,
     2454, 2456, 2458, 2460, 2460, 2462, 2464, 2466, 2468, 2470,
     2472, 2474, 2477, 2480, 2482, 2485, 2488, 2490, 2492, 2495,

     2498, 2500, 2503, 2506, 2506, 2506, 2506, 2509, 2512, 2515,
     2520, 2523, 2525, 2525, 2525, 2525, 2525, 2525, 2525, 2526,
     2527, 2528, 2529, 2533, 2535, 2535, 2537, 2539, 2541, 2541,
     2543, 2545, 2547, 2550, 2553, 2557, 2561, 2564, 2568, 2572,
     2576, 2580, 2580, 2580, 2581, 2582, 2583, 2584, 2586, 2587,
     2589, 2589, 2591, 2593, 2595, 2595, 2597, 2599, 2601, 2601,
     2601, 2601, 2601, 2601, 2601, 2601, 2601, 2601, 2601, 2601,
     2602, 2602, 2602, 2602, 2602, 2602, 2602, 2602, 2602, 2602,
     2602, 2602, 2603, 2603, 2603, 2604, 2604, 2604, 2604, 2605,
     2605, 2605, 2605, 2605, 2605, 2605, 2605, 2605, 2605, 2605,

     2605, 2605, 2605, 2606, 2607, 2607, 2607, 2607, 2607, 2607,
     2607, 2607, 2607, 2607, 2607, 2607, 2607, 2607, 2607, 2607,
     2607, 2607, 2607, 2607, 2607, 2607, 2607, 2607, 2607, 2607,
     2607, 2608, 2608, 2608, 2609, 2609, 2609, 2609, 2609, 2609,
     2609, 2609, 2609, 2610, 2611, 2612, 2612, 2613, 2614, 2615,
     2616, 2618, 2618, 2618, 2619, 2620, 2621, 2621, 2622, 2623,
     2624, 2624, 2625, 2626, 2627, 2628, 2630, 2630, 2630, 2631,
     2632, 2633, 2634, 2635, 2635, 2636, 2637, 2637, 2637, 2637,
     2637, 2637, 2637, 2637, 2637, 2637, 2637, 2637, 2637, 2637,
     2637, 2637, 2637, 2637, 2637, 2637, 2637, 2638, 2638, 2642,

     2642, 2643, 2644, 2646, 2646, 2646, 2646, 2646, 2646, 2647,
     2648, 2649, 2650, 2651, 2653, 2655, 2657, 2659, 2663, 2663,
     2663, 2663, 2663, 2665, 2667, 2669, 2673, 2675, 2677, 2681,
     2685, 2689, 2693, 2695, 2699, 2703, 2707, 2711, 2713, 2717,
     2719, 2723, 2725, 2729, 2729, 2729, 2729, 2731, 2737, 2742,
     2748, 2753, 2753, 2755, 2757, 2759, 2761, 2763, 2765, 2767,
     2769, 2771, 2773, 2775, 2777, 2779, 2783, 2786, 2788, 2792,
     2795, 2795, 2797, 2799, 2799, 2800, 2800, 2804, 2804, 2805,
     2806, 2808, 2808, 2810, 2812, 2812, 2812, 2812, 2812, 2812,
     2813, 2814, 2815, 2816, 2817, 2819, 2821, 2823, 2825, 2829,

     2829, 2829, 2829, 2829, 2831, 2833, 2835, 2839, 2841, 2843,
     2845, 2849, 2853, 2857, 2861, 2863, 2869, 2874, 2880, 2885,
     2887, 2889, 2891, 2893, 2895, 2897, 2899, 2901, 2903, 2905,
     2907, 2911, 2914, 2916, 2920, 2923, 2923, 2923, 2923, 2923,
     2923, 2923, 2923, 2924, 2924, 2924, 2925, 2925, 2925, 2925,
     2926, 2926, 2926, 2926, 2926, 2927, 2927, 2927, 2928, 2928,
     2928, 2928, 2929, 2929, 2930, 2930, 2931, 2931, 2931, 2932,
     2932, 2933, 2933, 2934, 2934, 2935, 2936, 2937, 2937, 2939,
     2939, 2939, 2941, 2941, 2941, 2941, 2941, 2941, 2941, 2941,
     2941, 2941, 2941, 2941, 2941, 2941, 2941, 2941, 2941, 2942,

     2943, 2943, 2943, 2943, 2944, 2945, 2945, 2946, 2946, 2947,
     2947, 2948, 2949, 2952, 2952, 2953, 2954, 2956, 2959, 2959,
     2960, 2961, 2963, 2964, 2965, 2965, 2965, 2965, 2965, 2965,
     2965, 2965, 2965, 2965, 2965, 2965, 2965, 2965, 2965, 2965,
     2965, 2965, 2965, 2965, 2965, 2965, 2967, 2969, 2969, 2969,
     2969, 2969, 2971, 2972, 2973, 2974, 2976, 2977, 2978, 2979,
     2980, 2981, 2983, 2984, 2986, 2988, 2990, 2994, 2994, 2998,
     3002, 3006, 3010, 3010, 3010, 3010, 3013, 3016, 3019, 3022,
     3025, 3027, 3028, 3032, 3036, 3037, 3038, 3039, 3040, 3041,
     3042, 3043, 3044, 3045, 3047, 3049, 3051, 3053, 3054, 3056,

     3056, 3058, 3060, 3062, 3063, 3063, 3063, 3063, 3063, 3065,
     3066, 3067, 3068, 3070, 3071, 3072, 3073, 3074, 3075, 3076,
     3078, 3080, 3082, 3084, 3088, 3088, 3092, 3095, 3098, 3101,
     3104, 3107, 3111, 3115, 3116, 3117, 3118, 3119, 3120, 3121,
     3122, 3123, 3124, 3126, 3128, 3130, 3132, 3133, 3135, 3135,
     3135, 3136, 3136, 3136, 3137, 3137, 3137, 3137, 3138, 3138,
     3139, 3139, 3140, 3140, 3141, 3141, 3141, 3141, 3142, 3142,
     3142, 3143, 3143, 3144, 3145, 3146, 3147, 3147, 3147, 3147,
     3147, 3147, 3147, 3147, 3147, 3147, 3147, 3147, 3147, 3147,
     3147, 3147, 3147, 3147, 3147, 3147, 3147, 3147, 3147, 3147,

     3147, 3147, 3147, 3147, 3147, 3148, 3149, 3149, 3149, 3150,
     3151, 3152, 3153, 3153, 3155, 3155, 3155, 3157, 3157, 3157,
     3157, 3157, 3157, 3157, 3157, 3157, 3157, 3157, 3157, 3157,
     3157, 3157, 3157, 3157, 3157, 3157, 3157, 3157, 3158, 3159,
     3159, 3161, 3161, 3163, 3166, 3167, 3169, 3170, 3173, 3177,
     3181, 3185, 3189, 3190, 3192, 3194, 3196, 3198, 3198, 3199,
     3200, 3201, 3201, 3203, 3203, 3205, 3208, 3209, 3211, 3212,
     3215, 3219, 3221, 3223, 3225, 3227, 3227, 3227, 3228, 3228,
     3228, 3229, 3229, 3229, 3230, 3230, 3230, 3230, 3231, 3231,
     3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232,

     3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232,
     3232, 3232, 3232, 3232, 3232, 3232, 3233, 3234, 3234, 3235,
     3236, 3236, 3237, 3238, 3239, 3240, 3240, 3240, 3240, 3242,
     3242, 3244, 3244, 3244, 3244, 3244, 3244, 3244, 3246, 3248,
     3249, 3251, 3252, 3253, 3254, 3258, 3262, 3266, 3270, 3270,
     3272, 3274, 3275, 3277, 3278, 3279, 3280, 3284, 3284, 3285,
     3285, 3285, 3285, 3286, 3286, 3287, 3288, 3288, 3288, 3288,
     3288, 3289, 3289, 3289, 3289, 3289, 3290, 3290, 3290, 3290,
     3290, 3290, 3290, 3291, 3292, 3293, 3294, 3294, 3294, 3294,
     3296, 3297, 3299, 3300, 3300, 3300, 3300, 3300, 3300, 3300,

     3300, 3300, 3301, 3303, 3305, 3309, 3313, 3317, 3321, 3321,
     3322, 3324, 3326, 3330, 3330, 3331, 3331, 3331, 3331, 3331,
     3331, 3332, 3332, 3332, 3333, 3333, 3333, 3333, 3333, 3333,
     3333, 3333, 3333, 3334, 3335, 3336, 3337, 3337, 3337, 3337,
     3339, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341,
     3341, 3341, 3345, 3349, 3353, 3357, 3361, 3361, 3361, 3361,
     3361, 3361, 3361, 3361, 3362, 3363, 3363, 3363, 3363, 3364,
     3365, 3365, 3365, 3365, 3365, 3365, 3365, 3365, 3365, 3365,
     3365, 3366, 3367, 3367, 3367, 3367, 3367, 3367, 3367, 3369,
     3369, 3369, 3369, 3371, 3375, 3379, 3383, 3387, 3391, 3391,

     3391, 3391, 3391, 3391, 3392, 3392, 3392, 3393, 3393, 3393,
     3393, 3394, 3394, 3394, 3394, 3395, 3396, 3397, 3397, 3398,
     3398, 3398, 3400, 3402, 3403, 3405, 3405, 3407, 3409, 3410,
     3412, 3416, 3420, 3424, 3428, 3432, 3432, 3432, 3432, 3432,
     3432, 3432, 3432, 3432, 3432, 3432, 3432, 3433, 3433, 3434,
     3434, 3435, 3436, 3437, 3437, 3438, 3439, 3440, 3441, 3442,
     3442, 3442, 3444, 3446, 3448, 3450, 3454, 3458, 3462, 3466,
     3470, 3470, 3470, 3470, 3470, 3470, 3470, 3470, 3470, 3470,
     3470, 3470, 3470, 3470, 3470, 3471, 3472, 3473, 3474, 3475,
     3476, 3477, 3478, 3478, 3479, 3481, 3483, 3486, 3489, 3492,

     3495, 3498, 3498, 3498, 3498, 3498, 3498, 3498, 3498, 3498,
     3498, 3498, 3498, 3498, 3498, 3498, 3499, 3500, 3501, 3502,
     3503, 3505, 3507, 3509, 3511, 3512, 3513, 3514, 3515, 3517,
     3517, 3517, 3517, 3517, 3517, 3517, 3517, 3517, 3517, 3517,
     3517, 3517, 3517, 3517, 3517, 3517, 3517, 3518, 3518, 3518,
     3518, 3518, 3518, 3518, 3518, 3518, 3518, 3518, 3518, 3518,
     3518, 3518, 3518, 3518, 3518, 3519, 3519, 3519, 3519, 3519,
     3519, 3519, 3519, 3519, 3519, 3519, 3519, 3519, 3519, 3519,
     3519, 3519, 3519, 3519, 3519, 3519, 3519, 3519, 3519, 3519,
     3519, 3519, 3519, 3519

    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    5,    6,    6,    7,    8,    9,   10,
       11,    8,   12,   13,   14,   15,   16,   17,   18,   19,
       20,   21,   21,   22,   22,   22,   22,   23,    4,   24,
       25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
       35,   36,   37,   30,   30,   38,   39,   40,   41,   42,
       30,   43,   44,   45,   46,   47,   30,   48,   49,   50,
        6,   51,   52,    6,   51,    6,   53,   54,   55,   56,

       57,   58,   54,   59,   60,   54,   54,   61,   62,   63,
       64,   65,   54,   66,   67,   68,   69,   54,   70,   54,
       71,   54,    6,    6,    6,   51,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
       72,   73,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   74,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,

       72,   75,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   76,   72,   72,   72,   72,   72,   77,   72,   78,
       72,   72,   72,   72,   79,   72,   72,   72,   80,   72,
       72,   72,   72,   72,    1,    1,    1,    1,   81,   81,
       82,   83,   84,   85,   86,   86,   87,   87,   87,   87,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[88] =
    {   0,
        1,    2,    3,    2,    4,    2,    5,    5,    2,    2,
        2,    5,    2,    1,    6,    5,    1,    1,    1,    1,
        1,    1,    7,    8,    5,    9,    5,   10,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1
    } ;

static yyconst short int yy_base[3098] =
    {   0,
        0,    0,    0,    0,   87,    0,    0,    0,  173,  175,
      198,  284,  370,  456,  542,  628,  714,  800,  886,  972,
     1058, 1144, 1230, 1299, 1368, 1454, 1540, 1626, 1712, 1798,
     1884, 1970,    0,    0,    0,    0, 2056, 2142,  177,  179,
      181,  183, 2206, 2251, 7915, 7914, 7937, 7908, 7933, 7929,
    25937,25937,25937,25937,  185,  171, 7903, 2319, 2405,  271,
      208,  307,    0, 2480, 2567,  161,  174, 7902, 7861, 7842,
     2641, 2728, 2814, 2900, 2986, 3072, 3158,25937, 3210, 3296,
    25937,  210,  297,25937,  192,  211,  337,  404,  425,  489,
      194, 7871,  196,  437,25937,  221,  234,  327,  278,25937,

      236,  245,  243,  294,25937,  247,  274,  380,  399,25937,
      276,  292,  413,  508,  529,  484,25937,  294,  305,  581,
      595,  617,  639,  640,  662,  668,  674, 7879,  314,  316,
    25937,  315,  272,25937,  320,  382,  555,  684,  748,  757,
      766,  502,  723,  775,  827,  833,25937,  401,  405,  794,
      741,25937,  407,  416,  812,  753,25937,  426,  434,  848,
      849,25937,  438,  458,  856,  808,25937,  460,  464,25937,
      466,  487,  449, 7782, 7695, 7657,  304, 7628, 7631,  245,
     7616, 7602, 7607,  363,  459, 7594,  428, 7591,    0, 7622,
        0, 7647, 7645,  920,  906,  861,  932,  873, 7619,  994,

    25937,    0,  944, 3377, 1006,  959, 3463, 3537, 3611, 1008,
     1027, 1064, 1094,    0, 3686,  413, 3773,  456, 3859, 1023,
     1100, 1116, 1137, 3934, 4008, 4082, 1150,  455,  469, 7564,
     1063, 4156, 4230,  665, 4304, 4378,  447,  513, 4452, 4526,
     1181, 1208,  607, 4600,  522, 1106, 1269,  591, 7610, 1248,
     4668, 4755, 1277, 7607,25937, 1321,    0,    0,    0, 4842,
     7597, 1335, 7594,  596, 7593,  645, 7561, 7558, 1355, 4916,
     4990, 1376, 7564, 1408,25937,    0, 1102,    0, 1441, 1129,
     1177,    0,    0,    0,  715, 5077, 5163, 1565, 5249, 1234,
     1468, 1342, 1428,  657, 7517, 1651, 1418,  727,  830, 1463,

     1575, 1654, 1108, 1661, 1671, 5335,25937, 5386,25937, 5438,
     5524,  529, 7550, 1562,  646, 7549, 7557, 1571, 7541,  502,
     1204, 1427, 1757, 1747, 1790, 1822,  522,  822, 1532,  950,
     1029,  639, 1520,  865, 7532,25937, 7531,  950, 7530,  985,
      310, 1434, 1791,  663, 1551, 1670, 1549, 1636,  666, 1678,
     1764, 1763, 1772,  706, 1872, 1890, 1900, 1841, 1847, 1855,
      718, 1933, 1926, 1874, 1957, 1898, 1984, 1997,  726, 2006,
     2020, 2028, 2070, 2084, 2092, 2106, 2098, 2131, 2153, 2163,
     2175, 2043, 2181, 2188, 2164, 2130, 2406, 2821, 2848, 2862,
     2872, 2884, 2907, 2937, 2949, 2993, 2195, 2209, 2392, 7537,

        0,  850, 1019,  583,  877, 2421, 2445, 2014, 2656, 2962,
     3026, 2327, 3044,  927, 2434, 2400,  983, 2662, 2603,  997,
     1066,25937, 2674, 3100, 2840, 1196,25937, 2615, 3114, 3485,
     1017, 2686, 2735, 1033, 1035,  986, 7534, 7512, 7531, 1044,
      191, 7540, 7500,  849, 7465, 7463, 7454, 7468, 7438, 7424,
     7438, 7427, 7420, 7430, 7410, 7398, 7401, 7436,    0, 3122,
     3492, 1276, 1277, 3311,    0, 3035, 3507, 3581, 2229, 3173,
     1065, 1020,25937, 2900,    0,    0, 3185, 5604, 5678, 3045,
     3072, 5752, 3131, 3318, 3493, 3324, 5828, 1462, 2825, 2895,
        0, 3332, 1135, 7379, 5914, 3340, 3514, 3363,    0, 1464,

     3546, 3542,    0, 3449, 7362, 3323, 1635, 1683, 3543, 3887,
     3896, 3920, 7407,25937, 5977, 3575,    0, 3601, 6048, 7406,
    25937, 3939, 3581,    0, 3624, 7347, 7326, 7315, 7297, 6134,
     3873, 3963, 1329, 1061, 7295, 2215, 4024, 4091, 1364, 1385,
     3971, 4114, 6209, 6283, 6357, 6431, 6505, 3662, 4048, 4071,
     4106, 4130, 3605, 3850, 4163, 3984, 4184, 6579, 6653, 6727,
     1576, 6802, 7280, 3609, 1093, 1761, 4153, 6888, 4008, 6964,
     4185, 2960, 4192, 3884, 3102, 4198, 4233, 4152, 1148, 2824,
     4188, 4268, 4006, 3473,25937, 7051, 4324, 7138, 7321, 7225,
     1351, 7299, 4333, 4358,    0, 3973, 4077, 4300, 4376, 3471,

    25937, 4227, 4247, 7385, 7471, 4284, 4339, 4346, 4447, 4521,
     4550, 7557, 4394, 7644, 4411, 4417, 7731, 7283, 7818,    0,
     4430, 4535, 4544, 4564, 4556, 7279,    0,    0, 4570, 7904,
     4576, 4937, 1774, 7278, 1984, 4943, 4949, 1569, 1979, 4958,
     5200, 7990, 8076, 8162, 8248, 8334, 4675, 4964, 4970, 5175,
     5184, 5210, 8420, 8506, 8592, 1643, 8679, 7272, 4681, 5224,
     4858, 5559, 5138, 5233, 5634, 5270, 7309, 5169, 7318, 5332,
     7316, 7309, 7304, 7286,  635, 7277, 7236, 7209, 7208, 1013,
     7211, 7216, 7211, 7192, 4929, 5150, 5647, 5722, 5743, 6171,
    25937, 7165, 7164, 7163, 7068,25937, 7017, 5098, 5321, 5709,

     5398, 5404, 5414, 5459, 5471, 5568, 5550, 6951, 5501, 6939,
     5572, 5654, 5729, 5795, 5694, 5717, 5739, 5910, 5927, 5877,
     5966, 5916, 1466, 1483, 6148, 6125, 6238, 6135, 6120, 6181,
     6224, 6258,25937, 6269, 6296, 6309, 6320, 6332, 6343, 6370,
     6289, 6363, 6383, 6394, 6406, 6417,25937, 6437, 6444, 6450,
     6457, 6468, 6415, 6426,25937, 6478, 6446, 6453, 6459, 6469,
     6491, 6527, 6543, 6563, 6579, 6601, 6505, 6594,25937, 6614,
     6637, 6648, 6654, 6668,    0, 1153,  305, 6740, 6753, 6776,
     6879, 6898, 6920, 7213, 7308, 6908, 6866, 6875, 7249, 7255,
     7332, 7340, 7346, 7426, 7281, 7385, 7363, 7437, 7450, 7483,

     7564, 7522, 7497, 7518, 7491, 7465, 7911, 6905, 6909, 1409,
     6888, 6877, 6875, 6876, 6866, 6863, 6837, 6846, 6897, 6834,
     6830, 6824, 6834,25937, 1206, 7592, 7635, 1275, 7926, 7939,
     7605, 7934, 7962, 7951, 3885, 2405, 6731, 8049, 8062, 8094,
        0, 6727, 6715, 6712, 6711, 7903, 6755, 3895,25937,    0,
        0, 2812, 1459, 8765,25937, 7956, 8816, 8153, 8163, 8199,
     8082, 8128, 8251, 8891, 4470, 4954, 8266, 8039, 8277, 8288,
     6754, 8965,25937,    0, 8114, 8234, 8175, 8188, 9041, 4195,
     4235, 4508, 8212,    0, 9128, 3611, 1214,    0, 6705, 1268,
     4516, 1574, 7398, 1380, 6279, 1555, 4078, 4523, 8320, 8309,

     1595, 1691, 6699, 9214, 6669, 8352, 8386, 8409, 8424, 8449,
     8472, 9289, 9363, 9437, 9511, 9585, 8307, 8501, 8512, 8535,
     8558, 6636, 5173, 5237, 5232,25937, 4299, 8593, 4074, 6637,
     8618, 9589, 6682,25937, 9663, 8522,    0,    0, 8372, 8768,
     9734, 9820,    0, 8903, 9894, 9968,10042, 1798, 6694, 6628,
     8641, 8320, 2244, 8962, 9295, 2810, 1461, 8780, 8565,10116,
     8848, 8579, 9379, 9223, 8792, 9392, 9415, 2201, 9453, 6621,
     9466, 8807, 9477, 9489, 8961,10190, 2836, 6631,10264, 6676,
    25937,    0,10315, 8839,    0,    0, 8837,10367, 6169, 4215,
    10453, 8859, 9242, 9498, 9576, 9850, 9354, 8868, 9611, 9882,

     9548, 9958, 6649, 8413, 9994,10107,10158, 6723,10028,10529,
    10616, 8921,10068, 9858,10222,10276, 4313, 4200, 6628, 9339,
     6641, 6706,25937,    0,    0, 5910, 1470,10702,25937, 9200,
    25937, 4446, 4973, 6593,10715, 9599,10801,10735,10756,10770,
     9243,10270,10818,10904, 8482, 2998, 9462, 9304,10811,10851,
     1792, 1828,10991, 6632,11077,25937,    0, 9362,11164, 9557,
     9378, 9953,    0,    0, 5667, 6580, 1074, 1885,11251, 4536,
    11079, 6584, 9990,10864,11089,11325,11331,11377,11463,11549,
    11635,11721,11807, 9476,10875,11340,11349,11361, 6574,11893,
        0, 8963,11979,12065,12151, 2095, 6637, 6552,10118, 9497,

     2402, 9966, 3577, 1565,11438,10155, 9741,12237,11371, 9747,
    11386,10457, 2851, 6550,12323,12409, 6595,25937,12448,12518,
    10102,    0,    0,10242,12570,10677,11470,11486, 2420,11503,
     7512,11521, 9761,11560,11583,11656,11447,10262,11619,11671,
    11757,11497,10379,11742,11693,11911,11997, 6583, 6591, 1164,
     6582, 6575, 6562, 6561, 1617, 6555, 6552, 6542, 6519, 6530,
     6508, 6471, 6474, 6475, 6458, 6455, 6451, 6451, 6405, 6403,
     1715, 6411, 6387, 6380,10483,10460,11608,11833,11598,11844,
    25937,25937,10886,10536,11832,10722,10607,10728,11424,10683,
    10693,10851,10839,10963,11068,11105,11120,11715,11063,11284,

    11854,11371,11877, 1554,12008,12029, 1564,12003,12089,12093,
    12115,12136,11820,11377,11793,11522,12140,11705,12114,11905,
    12163,12237,12250, 1458, 1764, 1891,12056, 1987, 2113,12099,
    12145, 2231,12198, 1386,12280, 2646,12299, 1848, 2081,12309,
    12319,12352,12375,12424,12336,12433,12382,12449, 2813,12412,
     2174, 2797, 5643, 2287, 2417,12453,12644,12650,12656,12662,
    12465,12668,12471,12674, 2841, 6166, 2695,25937,25937,12542,
    12674,12615,12621, 1481,12760,12692, 1819,12633,12761, 6379,
     6360, 1825,25937, 6309, 6311, 6299, 6290, 6266, 2165, 6271,
     6266, 6268,12768,12774,12780,12801,12722,12742,12748,12838,

    12834,12840,12808,12781, 2089, 2209, 6216,12867,12853,25937,
        0,12859,  381, 7907, 3899, 2401, 1627, 2007,12879,12910,
    12887,12916,12933,12945,12896,12958,12970,12976,12985,12991,
    13012,13003,13019,13025,13087,13041, 6264,    0,25937,    0,
    13139,13047,13064,13226, 8950, 8498, 7915,13099,    0,    0,
     5691, 2227,13313, 6209, 2768, 9225, 2221, 9294, 2266, 8957,
     2880,    0,    0,    0,13399,13406,13434,13441, 2242,13517,
    13604, 6203,13108,13124,13413,13471,13483,13459,13678,13684,
    13693,13715,13786,13792,13798, 6245,25937,13807,13808,    0,
        0,13809,13860, 2935, 6187,13934,25937,    0,13815,13827,

    13833,13846,13868, 2968,14008, 1743,13920,13940,13947,13963,
    13983,14008,14020,14032,14047,14053, 2967, 6238, 6155, 6205,
    14074,    0, 6188,25937,14031,14032,    0,    0,14074,14103,
    14125,14132,14160,14167, 6180,14190, 6179,14155,14142, 3319,
     3322, 6107,14162, 1078, 9891, 4222, 4180, 2971, 2303,14168,
    14174,14180,14186,14272,14193,14203,14278,14253,14213,14284,
    14231,14237,14295,14243, 3431,14382,14469,14555,14259,14266,
    14533,14641,14481, 6157,14599,25937,    0,14728,14541,14488,
    14605,    0,    0, 5741,    0, 6105, 3019,14815,14654, 6096,
    14889,14616,14497,14895,14627,14503,14904,14510,14910,14997,

    13869, 3457, 6065,15083,25937,    0,14634,14526,14878,14845,
    15084, 3834,15169, 3458,15068,14851,14857, 3542, 6123, 5903,
     5947,15220,    0, 5944,25937,15126,15104,    0,    0,14931,
    15195,15132,14872,15155,15015,15235,15021,15045,15250, 5929,
     5920, 5899, 5910, 5881, 5884, 5890, 5889, 5881, 5792, 2979,
     5789, 5748, 5758, 5728, 5718, 5705, 5700, 5682, 5674, 5648,
     3187, 5633, 3521, 5644, 3970,25937, 5605, 4052, 5603,15241,
     5626,15247,15201, 5620,15207,15278, 5606,15284,15225, 5594,
    15256,15327,15268,15339, 1232,15345,15351,15292, 1352,15298,
    15304,15390,15311,15397,15403,15409,15430,15398,15351,15371,

    15457,15443,15452,15411,15404,15482,15488,15509,15430,15450,
    15536, 5557,15536,15542,15483,15489, 5555, 5558,15570, 5558,
    15570,15585,15591,15607,15613,15619,15625,15566,15600,15572,
    15578,15584,15590,15606,15677,15618,15704,15695,15646,15732,
     5520, 5500, 5497, 5467, 5388, 5364, 4197,25937, 5376, 5367,
    15723, 1590,15666, 1670,15744,15750,15771,15716,15692,15780,
     3867,    0,25937,15787,25937,15803,15809, 4361,15866, 3036,
    15815,15836,15881, 4934,15917,15968, 1035, 3382,15822, 1046,
        0,15894,15929,15935,15943, 5357, 3098,25937,    0,    0,
    15980,15986,16007,16022,16034,16043,16052,16073,16080,16086,

    16064,16167, 9255, 9300, 9293,16253,16260,16284,16360, 5356,
    25937,16434,16073,    0, 3954,16296, 5347,25937,16435,16270,
        0,    0,16102,    0,16108,16125,16313,16324,16433,16439,
    16500,16506, 5340,25937,16471,16448,    0,    0,16539,16519,
    16545,16551,16572,16584,16590,16608, 5339,25937,16629,    0,
    16680,16641,16629,16653,16680,16692,16698,16704,16716,    0,
        0, 5322,16732,    0, 4164,    0,16667,25937,16679,16685,
     4939,16771, 3486,16706,16718,16724,16730,16816,16822, 7534,
    16908,16994, 1205, 4695,16757, 1246,    0,16843,17077, 5295,
    25937,17151,16805,    0, 4227,16930, 5294,25937,17221,17307,

        0,16855,16944,16769,16778,16792, 5293, 3499,25937,    0,
        0,16798,16894,16954,17254,16871,16969,17260,17278,17388,
    16980,16929,17475,    0,17174,16986,17084,17090,17168,17180,
    17204,17210, 5277,25937,17549,    0,    0,17284,17555,17641,
    17266,17576,17290, 5273,25937,17727,    0,17778,    0,    0,
    17588,17308,17314,17482,17496,17502,17508,17514, 5249, 5246,
     5244, 5232, 5221, 5210, 4140, 5192, 4258, 5199, 4302,25937,
     5152, 4335, 5150, 5143, 5141, 4553, 5035, 4561, 5017, 5010,
     4563,25937, 4571, 4573,25937, 5171, 5204, 5207,25937, 5015,
    17588,17659,17665,17612,17618,17624,17695,17727,17739,17680,

    17686,17713,17790,17731,17802,17814,17820,17826,17767,17773,
    17779,17785,17871,17857,17823,17798,17877,17894, 1750,17835,
    17841, 2145,17927,17913,17936,17884,17877,17963,17970,17976,
    17982,18003,17924,17938,18009,18015,17956,17969, 4997,18050,
        0, 5308,18050, 1707,25937,18062,18074,18080,18086,25937,
    18092,18098,18104,18110,18116,18122, 6075,18063, 1749,25937,
    18069,18075,18081,18087,25937,18093,18099,18105,18111,18117,
    18123,25937,25937,18209,18200,18150,18236, 4985, 4928, 4911,
     4897, 4871, 4874, 4804, 4746,18238,18247,18251,18262,18268,
    18289,18212,18263,18230,18322, 4272,25937,18322,18334, 5160,

     4743,    0,    0,18355,18341,18364,18370,18397, 4643,25937,
        0,18410,18416,18437,18446, 1856,18467,18494,18506,18483,
    18528,18424, 4638, 9852,25937,    0,18604,18535,18691, 9276,
     9889, 9960,    0,18778, 4947,18865, 3237, 7963, 4970, 7908,
     5199, 8953, 5256,18951,18958,18982,25937,19057,19108,18519,
    18547, 4660,    0,    0, 4636,25937,18557,    0,18569,19159,
    18580, 4596,25937,    0,19210,19261,19312,18589,18595,18989,
     4553,19008, 4598, 5143,25937,18969,18955, 5246, 4584,    0,
        0, 4576,    0,    0,19010,19004,19288,19016,19339, 4541,
    25937,    0,19055,19061,19294,19345, 1884,19431,19380,19174,

    19328,19393,19121, 4528, 3959,25937,    0,19518,19163,    0,
    19605,19692, 3557,19779,25937,19865,19951,19068,19110, 4526,
    25937,    0,19320,19157,20037,19301, 4508,25937,    0,20123,
    20209,20295,19366,19402,19408, 4502, 5363, 4475, 5635, 4476,
     4460, 5636,25937, 5710, 5726,25937, 5915, 5926, 5928,25937,
     5940, 4506, 4458, 5978,25937, 6003, 6138,25937, 4460, 6146,
     6172,25937, 6206,25937, 6213,25937, 1877,19483, 4451,19855,
     4443,19507, 4434,19886, 4433,25937,25937,19883,19489, 2826,
    19898,19800, 2839,19904,19913,19984,19990,19991,19997,20003,
    20076,20029,19999,19972,20085,20086,20123,20160,20171,20135,

    20115,20144,20242,20248,20156, 4433,25937, 4431,25937, 4333,
    20258, 4375,20258,20295,20319,20331,20337,20278,20284,20301,
    20307,20313,25937,25937, 2871, 4316, 4305, 4301, 4330,20399,
    20385,20408,20370,20349,20435, 3134,20444,20457,20421,20467,
     3177,20478,20471,20413,20488, 4342,25937,20488,20494,20506,
    20518,20530,25937,20564,20570,20591,25937,20577,20597, 4328,
    20603,20630,    0,25937,20643,20649,20670,10095,20692,10097,
     9954,11646, 8968, 8150, 9614, 4279,25937,20657,    0,20763,
        0,25937,20784,    0, 4239,25937,20796,    0,20784, 4226,
    25937,20809,    0, 4199,25937,20821,    0,20833,20839, 1692,

     4211,25937,    0,25937,20780,20786,20792,20804,20798,25937,
    20817,20810,20831,25937,20823,20837, 4194,20870,    0,20956,
    25937,20844,20850,20971, 4448,21058, 4192,25937,    0,20910,
    20857,21144,    0, 4160,25937,    0,20917,20864, 4140,25937,
        0,20931, 4101,25937,    0,20943,20937,20949, 4045, 6267,
    25937, 6268, 6270,25937, 4053, 6318, 6331,25937, 6344,25937,
     6392,25937, 6393,25937, 3547, 6395, 6404,25937, 4043, 6405,
    25937, 4036,25937,25937,25937,25937, 4060,21027, 4032,21079,
    21156,21162,21183,21189,21195,21216,21157,21137,21243,21184,
    21164,21258, 3353,21259,21280,21266,21290, 3487,21301,21251,

    21236,21337,21337,21343,21375,21349,21316,21322,21411,21346,
    25937,25937, 2229,25937,21417,21423,25937,21364,21370, 3993,
     4000,21441,21447,21388,21394,21482,21468,21488,21509,21495,
     3488,21480,21450,21456,21542,21463, 5563,25937,21537,21551,
    21557,21563,21628,21575,21581,21587,21593,21640,21646,21667,
    21673,21679,25937,21746,    0,21797,    0, 2241,25937,21620,
    25937,21643,21681,21693,21848,21699,21705,21732,21783,21744,
    21750,21934,    0,21985,    0, 6415, 6418,25937, 3994, 6479,
    25937, 3975, 6491,25937, 6492, 3962,21821,21860,21801,21807,
    21884,21893,21899,21949,21905,21955,21896,21935,21920,22012,

    21947,21956,22033,22027,22039,22060,22046, 5955,22021,22001,
    22027,22089,22033, 6555,22104,22110,22116,22057,22063,22069,
     2642,25937,25937,25937,25937, 3954, 3919,22140,22146,22095,
    22101,22172, 3586,22193,22114, 3956,22202,22202,22208,25937,
    22288, 3919,    0,25937,22340,10791,13402,11831, 3904,22149,
    22155,25937,22426, 3883,    0,25937,22161, 6546,25937, 6557,
     5784, 6580,25937, 3867,22232,22173,22244,22250,22315,22256,
    22301,22361,22373,22459,22380,22397,22468, 3967,22500,22409,
     4128,22513,22513,22530,22471,22477, 3884, 3852, 3835,22548,
    25937,22489,25937,22587,22600,22560,22609,22622,22501,22557,

    22631,25937,    0,22717,22631,22644,22730,22736,    0,25937,
        0,22572,22585, 6591,25937, 5953, 3101, 6026,22676,22662,
    22742,22764,22700,22723,22797,22810,22803,22838,22787,22793,
    22751,22851,25937,22864,25937,22805,    0, 6175, 3841,    0,
        0,22891,22877,22900,22906,22922,22864,22870,22956,22877,
    22891,22962,22969,22983,22990,22911, 3130,    0, 6582, 3588,
    23042,22998,23051,23064,25937,23019,23005,23093,23106,25937,
    23094,23106,23115,23121,23127,23072,23078,23167,23112,23118,
    23189,23130, 6593, 4277, 3832,23201,23207,23213,23219,23160,
    23173,23179,23185,23256,23277,23283,23289,23230, 3859, 4400,

    10189,23318,23341,23350,23291,23297,23317,23368,23374,23388,
    23394,23335,23341,23347,23353,23424,23365, 5056,25937, 6631,
    23436,23442,23448,25937,23454,23395,23401,23407,25937,23413,
    23484,23505,23511,23517,23458, 3861,  914, 3723, 3623, 3625,
     2884, 3123, 3603, 3866, 3546,23546,23569,23510,23516,23587,
    23593,23599,23605,23546,23552,23558,23564,23635,23576, 6632,
     5191,23647,    0,23588,    0,23659,23680,23686,23692,23633,
      550, 3528, 3514, 3452, 3452, 3423, 3361, 3340, 3265, 3231,
     3152, 3114, 3079, 3072,23721,23679,23750,25937,23691,25937,
    25937,25937, 5239,25937,    0,    0,23778,11089,15093,11899,

    23865, 2989, 2961, 2945, 2953, 2925, 2922, 2914, 2876, 2767,
     2726, 2596, 2507, 2464, 2439,25937,25937,25937,25937,12051,
        0,11680,21669,11971, 9917, 8448,10154, 4450,    0, 2412,
     2384, 2367, 2355, 2252, 2248, 6666, 2210, 2200, 2188, 2140,
     2074, 2068, 2070, 2045, 1978, 6688,25937, 1944, 1888, 6701,
     1883, 1841, 1788, 1711, 1618, 1573, 1521, 6762, 5367, 1513,
     1331, 1321, 1318, 5374,25937, 1248, 1175, 1160, 1133, 1127,
     6765, 6774, 5378, 5557,10019, 1055,  982,  765, 2862,  644,
      581,  559,  489, 1698, 1785,  459,  373, 2993,  229, 6775,
      194, 6919,25937,23952,23962,23972,23982,23992,24002,24012,

    24022,24032,24042,24052,24062,24072,24082,24092,24102,24112,
    24122,24132,24142,24152,24162,24172,24178,24188,24198,24208,
    24218,24228,24238,24244,24254,24264,24274,24284,24294,24304,
    24314,24324,24334,24340,24350,24360,24370,24380,24386,24396,
    24406,24416,24426,24436,24446,24456,24466,24476,24486,24496,
    24506,24516,24526,24536,24546,24556,24566,24576,24586,24596,
    24606,24616,24626,24633,24643,24653,24663,24673,24683,24693,
    24703,24713,24723,24733,24740,24750,24760,24770,24780,24790,
    24800,24810,24820,24830,24840,24850,24860,24870,24880,24890,
    24897,24907,24917,24927,24937,24947,24957,24967,24977,24987,

    24997,25007,25017,25027,25037,25047,25057,25064,25074,25084,
    25094,25104,25114,25124,25134,25144,25154,25164,25174,25184,
    25194,25204,25214,25224,25234,25244,25254,25261,25271,25278,
    25288,25298,25308,25318,25328,25338,25348,25358,25368,25378,
    25388,25398,25408,25418,25428,25438,25448,25458,25468,25475,
    25485,25492,25502,25512,25522,25532,25542,25552,25562,25572,
    25579,25589,25599,25609,25619,25629,25639,25649,25659,25666,
    25676,25686,25696,25706,25716,25726,25736,25746,25756,25766,
    25776,25786,25796,25806,25816,25826,25836,25846,25856,25866,
    25876,25882,25892,25899,25906,25916,25926

    } ;

static yyconst short int yy_def[3098] =
    {   0,
     2893,    1,    1,    1, 2893,    5, 2894, 2894, 2895, 2895,
     2896, 2896, 2897, 2897, 2898, 2898, 2899, 2899, 2900, 2900,
     2901, 2901, 2902, 2902, 2903, 2903, 2904, 2904, 2905, 2905,
     2906, 2906, 2894, 2894, 2894, 2894, 2907, 2907, 2908, 2908,
     2909, 2909, 2894, 2894, 2894, 2894, 2893, 2910, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2910, 2893,   58,   59,
       59,   59, 2911, 2893, 2893,   65,   64, 2910,   64,   64,
     2910, 2893,   72,   72,   72,   72, 2912, 2893, 2893, 2913,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2914, 2893, 2893,
     2893, 2914, 2914, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2915, 2910,
     2916, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2910, 2893,

     2893, 2917, 2893, 2893, 2910, 2893,   58,   59,   59,  209,
      209,  209, 2893, 2916, 2893,  215, 2893,  217, 2893,  204,
     2910, 2893,  209,  209,  209,   58, 2893,  215,  215,  217,
      219,   58,  209,  209,   58,   58,  215,  219,   58,   58,
      240,  240,  240,  240,  215,  219,  240,  240, 2918, 2910,
     2893, 2893,  251, 2910, 2893, 2910,  251, 2916,  252, 2893,
      260,  251,  260,  260,  260,  252,  252,  252, 2910,  217,
     2910,  270, 2910, 2893, 2893, 2919, 2893,  204, 2910, 2893,
     2893, 2916,  215,  217,  217, 2893,  286,  286, 2893,  204,
     2910, 2893, 2893,  215,  217,  286,  286,  286,  286,  286,

      286,  286,  286,  286,  286, 2920, 2893, 2920, 2893, 2893,
     2921, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2922,

     2923, 2893, 2922, 2922, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2924, 2916, 2893,
     2893, 2893, 2893, 2893, 2925, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893,  215,  217, 2893, 2926, 2926,  479,
     2927, 2893, 2893,  204, 2910, 2893, 2893,  487,  487,  487,
      487,  487,  215,  217, 2893,  204, 2910, 2893,  487,  487,

      487,  487,  487,  487,  217,  495,  495,  495, 2893, 2928,
     2928, 2928, 2910, 2893,  215,  215, 2916,  215, 2893, 2910,
     2893,  217,  217, 2916,  217,  217,  217,  217,  217, 2893,
     2893, 2893, 2893, 2893, 2893, 2910, 2910, 2910, 2910, 2910,
     2893,  479,  479,  479,  479,  479,  479, 2927, 2927, 2927,
     2927, 2927,  482,  204, 2910, 2893, 2893, 2928, 2928, 2928,
     2910, 2893,  217,  530, 2893,  482,  482, 2893, 2910, 2893,
      570,  570, 2893,  570,  570,  570,  570,  530, 2893,  568,
      568, 2910,  568,  530, 2893, 2893,  586, 2893,  588, 2893,
      590,  217,  592, 2893, 2929, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2930, 2930,  605, 2931, 2893, 2932, 2932,
     2932, 2893, 2893, 2893, 2910, 2893, 2893,  217, 2893,  619,
      619,  612,  614, 2910, 2893,  217,  619,  619,  619, 2893,
     2893, 2893, 2893, 2893, 2910, 2910, 2910, 2910, 2910, 2893,
      605,  605,  605,  605,  605,  605, 2931, 2931, 2931, 2931,
     2931, 2893, 2932, 2932, 2932, 2910, 2893,  217,  614, 2910,
     2893, 2893, 2910, 2893,  619, 2910, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2933, 2934, 2934, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2935, 2935, 2935,
     2936, 2893, 2893, 2893, 2893, 2893, 2910, 2893, 2893, 2937,
     2938, 2910, 2910, 2939, 2893, 2940, 2893, 2893, 2893, 2893,
     2910, 2910, 2910, 2939,  864,  864,  864, 2940, 2940, 2940,
     2910, 2893, 2893, 2937, 2893,  614, 2910, 2893, 2893,  879,
      879,  879, 2893, 2938, 2893,  885,  885,  217,  217,  217,
      872,  885,  872,  885,  872,  885,  879,  879,  879,  879,

      885,  885,  217, 2893, 2893, 2910, 2910, 2910, 2910, 2910,
      864,  864,  864,  864,  864,  864, 2940, 2940, 2940, 2940,
     2940,  217,  904,  904,  904, 2893, 2893, 2935, 2893, 2893,
     2935,  614, 2910, 2893,  885,  885, 2938,  885,  885, 2910,
     2893, 2893,  942, 2893, 2935, 2935, 2935, 2893, 2941, 2893,
     2910, 2893, 2910, 2893,  864, 2910, 2910, 2910, 2893,  864,
     2940, 2893, 2940,  924, 2910, 2910, 2910,  864,  864,  864,
      864, 2940, 2940, 2940, 2893, 2935, 2893, 2893, 2942, 2910,
     2893,  935, 2942,  885, 2938,  885,  885, 2893,  964,  964,
     2893, 2893, 2893,  864,  864,  864, 2893, 2935, 2893, 2893,

     2893, 2893,  991,  991,  864,  864,  864,  991, 2910, 2893,
     2893, 2943, 2910, 2944, 2944, 2944, 2893, 2893, 2893, 2893,
     2910, 2893, 2893, 2945, 2938, 2910, 2910, 2946, 2893, 2947,
     2893, 2893, 2893, 2893, 2944, 2944, 2893, 2893, 2893, 2893,
     2910, 2910, 2910, 2946, 1044, 1044, 1044, 2947, 2947, 2947,
      885,  885, 2893, 2910, 2893, 2893, 2945, 2893, 2893, 2910,
     2893, 2893, 2938,  885,  885, 1053, 1053, 1053, 2893, 1069,
     1037, 2893, 2910, 2910, 2910, 2910, 2910, 1044, 1044, 1044,
     1044, 1044, 1044, 2947, 2947, 2947, 2947, 2947, 1053, 2893,
     1090, 2893, 2944, 2944, 2944, 2893, 2948, 2893, 2910, 2893,

     2910, 2893, 2910, 2910, 1044, 2910, 2893, 1044, 2947, 2893,
     2947, 2893, 2893, 2893, 2944, 2949, 2910, 2893,  885, 2949,
      885, 2938,  885,  885, 2893, 2910, 2910, 2910, 1044, 1044,
     1044, 1044, 2947, 2947, 2947, 2893, 2893, 2893, 1044, 1044,
     1044, 2893, 2944, 2893, 1044, 1044, 1044, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2950, 2951, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2952, 2952, 2893,
     2953, 2893, 2954, 2893, 2910, 2910, 2910, 2893, 2955, 2893,
     2893, 2910, 2910, 2910, 2893, 2910, 2893, 2955, 2955, 2893,
     2893, 2893, 2893, 2910, 2956, 2955, 2910, 1331, 2893, 2957,
     2893, 2910, 2893, 2893, 1344, 1344, 1344, 2893, 2938,  885,
      885,  885, 2893, 1353, 1353, 1331,  885, 1331,  885, 1331,
      885, 1356, 1358, 1360, 2893, 2893, 2893, 2893,  885, 2893,
     2893, 2893, 2910, 2910, 2893, 2910, 2910, 2893, 2955, 2893,
     2955, 2893, 2893, 2952, 2893, 2910, 2893, 1353, 1353, 2938,
     1353, 1353, 2893, 2893, 2893, 2952, 2893, 2958, 2910, 2893,

     2910, 2893, 2893, 2910, 2959, 2910, 2910, 2893, 2893, 2910,
     2910, 2893, 2910, 2893, 2955, 2893, 2893, 2960, 2893, 2910,
     2961, 2938, 2910, 2893, 1353, 1353, 2938, 1353, 1353, 2952,
     2893, 2893, 2893, 2893, 2893, 2962, 2963, 2964, 2964, 2893,
     2893, 2893, 2893, 2965, 2893, 2910, 2910, 2910, 2893, 2966,
     2893, 2893, 2964, 2893, 2893, 2910, 2910, 2910, 2893, 2910,
     2893, 2966, 2966, 2893,  885, 2893, 2893, 2893, 2893, 2893,
     2910, 2967, 2966, 2910, 2893, 2893, 2968, 2893, 2910, 2893,
     2893, 2938,  885,  885, 1353, 1353, 1353, 2893, 2893, 2893,
     2910, 2910, 2893, 2910, 2910, 2893, 2966, 2893, 2966, 2893,

     2893, 2893, 2893, 2964, 2893, 2969, 2910, 2893, 2910, 2893,
     2893, 2910, 2970, 2910, 2910, 2893, 2893, 2893, 2971, 2893,
     2910, 2972, 2938, 2910, 2893, 1353, 1353, 2938, 1353, 1353,
     2910, 2910, 2893, 2910, 2893, 2966, 2893, 2964, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2973, 2974,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2975, 2893, 2893, 2893, 2893, 2893, 2910, 2976, 2893,
     2977, 2893, 2910, 2910, 2978, 2978, 1676, 2893, 2979, 2979,
     2979, 2977, 2893, 2893, 2910, 2910, 2893, 2893, 2980, 2938,
     2977, 2910, 2910, 2910, 2893, 2893, 2893, 2893, 1478, 2910,

     2893, 2893, 1702, 1702, 1702, 2893, 2893, 2893, 2893, 2910,
     2893, 1709, 1709, 2938, 1709, 1709, 2910, 2893, 1353, 1353,
     2938, 1353, 1353, 2981, 2910, 1676, 1676, 1676, 2893, 2979,
     2979, 2979, 2910, 2893, 1353, 1353, 2938, 1353, 1353, 2893,
     2982, 2893, 2983, 2984, 2910, 2893, 2910, 2893, 2985, 2938,
     2986, 2910, 1676, 1676, 1676, 2893, 2979, 2979, 2979, 2987,
     2988, 2893, 2989, 2990, 2893, 2991, 2893, 2893, 2893, 2893,
     2910, 2992, 2893, 2993, 2893, 2893, 2994, 2893, 2910, 2910,
     2995, 2995, 1782, 2893, 2996, 2996, 2996, 2993, 2893, 2910,
     2893, 1789, 1789, 2938, 1789, 1789, 2910, 2893, 2997, 2997,

     2938, 1800, 1800, 2893, 2893, 2910, 2910, 2893, 2893, 2998,
     2938, 2993, 2910, 2910, 2910, 2893, 2893, 2893, 2893, 2893,
     2910, 2893, 2893, 2999, 2910, 1782, 1782, 1782, 2893, 2996,
     2996, 2996, 2910, 2893, 1800, 1800, 2938, 1800, 1800, 3000,
     3001, 2910, 2893, 2910, 2893, 3002, 2938, 3003, 3004, 3005,
     2910, 1782, 1782, 1782, 2893, 2996, 2996, 2996, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 3006,
     3007, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 3008, 2910,

     2910, 2938, 3009, 2893, 2893, 2893, 2910, 2910, 2910, 2893,
     2938, 2893, 2893, 3009, 3010, 3011, 3012, 3013, 2910, 2893,
     2893, 2910, 2910, 2893, 2893, 3014, 2893, 2910, 2893, 2029,
     2029, 2029, 2938, 2893, 2034, 2893, 2036, 2893, 2034, 2893,
     2034, 2893, 2034, 2893, 2893, 2893, 2893, 3015, 3016, 3017,
     3018, 2893, 3019, 3020, 2910, 2893, 2910, 2938, 2893, 3021,
     3022, 2910, 2893, 2938, 3023, 3024, 3023, 3025, 3026, 3025,
     3027, 3028, 3029, 2893, 2893, 2893, 3030, 2910, 2910, 2938,
     3031, 2893, 3032, 3033, 2893, 2893, 2893, 2910, 2910, 2910,
     2893, 2938, 2893, 2893, 3031, 3034, 3035, 3036, 3037, 2910,

     2893, 2893, 2910, 2910, 2893, 2893, 3038, 2893, 2910, 2938,
     2893, 2893, 2112, 2893, 2893, 3039, 3040, 3041, 3042, 2910,
     2893, 2938, 2910, 2893, 3043, 3044, 2910, 2893, 2938, 3045,
     3046, 3045, 3047, 3048, 3047, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 3049,
     3050, 3051, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 3052, 2893, 2893, 2893, 2910,
     2910, 3053, 2893, 2893, 2893, 3054, 2893, 2893, 2893, 2910,
     2910, 3055, 2938, 2893, 2893, 2893, 3056, 2893, 2893, 2269,
     2269, 2269, 2893, 2893, 2893, 2910, 2893, 2910, 2938, 2893,
     3057, 2893, 3058, 3059, 2910, 2893, 2910, 2938, 2893, 2910,
     2893, 2910, 2938, 2910, 2893, 2910, 2938, 2893, 2893, 3060,

     3061, 2893, 3062, 2893, 2893, 2893, 2910, 2910, 3063, 2893,
     2893, 2893, 3064, 2893, 2893, 2893, 2910, 2910, 2938, 3065,
     2893, 2893, 2893, 3066, 2893, 2893, 2910, 2893, 2938, 2910,
     2893, 3067, 3068, 2910, 2893, 2938, 2910, 2893, 2910, 2893,
     2938, 2910, 2910, 2893, 2938, 2910, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 3069, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     3070, 2910, 3071, 3070, 2893, 3072, 2910, 3073, 2269, 2269,
     2269, 2269, 2893, 3074, 3075, 3076, 3077, 3060, 2893, 2893,
     2893, 2893, 3078, 2910, 3079, 3078, 2893, 3080, 2910, 3081,
     2326, 3082, 3083, 3084, 3085, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     3069, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 3086, 2893,
     3087, 2893, 2893, 2893, 2893, 2893, 2893, 3088, 3089, 2893,
     3090, 2910, 3091, 2893, 2893, 2545, 2545, 2545, 3060, 3092,
     3078, 2893, 3079, 2910, 3091, 2893, 2326, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 3069, 2893, 2893, 3086,
     2893, 3087, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 3089, 3090, 2545, 2545, 2545, 2545, 3093, 2893,
     3078, 2553, 2326, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 3094, 2893, 2893, 3086,
     3087, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2545, 2545, 2545, 2545, 2326, 2893, 3095, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 3096, 2893,
     2893, 2893, 3097, 2545, 2545, 2545, 2545, 2326, 3095, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 3096, 3096, 2893, 3096, 2893, 3097, 3097, 2893, 3097,
     2545, 2545, 2545, 2545, 2326, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 3096, 3096, 3097, 3097, 2545, 2545, 2545, 2545, 2326,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 3096, 3097, 2893, 2797, 2797, 2797,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2797, 2797, 2797, 2797, 2893, 2893, 2893, 2893, 2801, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893,    0, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893

    } ;

static yyconst short int yy_nxt[26025] =
    {   0,
       48,   49,   50,   51,   52,   53,   54,   53,   51,   55,
       53,   56,   51,   57,   57,   53,   58,   59,   60,   61,
       62,   62,   51,   63,   53,   53,   51,   53,   64,   64,
       64,   64,   64,   64,   64,   64,   65,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   66,   67,   64,   64,
       68,   53,   64,   64,   64,   64,   64,   64,   69,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   70,
       64,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   72,   73,   74,   75,   76,   76,   77,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,

       78,   78,   78,   77,   77,   77,   77,   77,   77,   78,
       78,   78,   78,   78,   78,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   78,   78,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   77,   77,
       77,   77,   77,   77,   82,   78,   82,   78,  168,  169,
      168,  169,  171,  172,  171,  172,  194,  197,  197,  197,
      197,  197,  197,  320,  320,  810,   83,  263,   83,   85,

       86,  195,  195,  195,  195,  195,  195,  259,  259,  238,
      264,  312,  320,  320,   87,   88,   89,   90,   87,   87,
      265,  266,  344,  344,  239,  240,  241,  242,  243,  244,
      335, 2886,  338,  313,   91,  344,  344,  349,  349,  442,
      336,  336,  339,  340,   92,   93,  349,  349,  354,  354,
      245,  215,  198,  198,  198,  198,  198,  198,  350,  351,
      351,  351,  351,  351,  351, 2891,  196,  196,  196,  196,
      196,  196,  231,  245,  215,  354,  354,  361,  361,   94,
       94,   94,   94,   94,   94,   85,   86,  232,  233,  234,
      347,  235,  236,  361,  361,  369,  369,  445,  314,  401,

       87,   88,   89,   90,   87,   87,  369,  369,  246,  352,
      237,  341,  315,  446,  215,  402,  402,  402,  402, 1235,
       91,  405,  405,  247,  248,  241,  242,  243,  244,  316,
       92,   93,  401,  237,  317,  441,  318,  215,  321,  345,
      319,  404,  401,  346,  346,  346,  346,  346,  346,  322,
      215,  216,  442,  323,  324,  325,  326,  323,  323,  348,
      348,  348,  348,  348,  348,   94,   94,   94,   94,   94,
       94,   96,   97,  215,  216,  353,  353,  353,  353,  353,
      353,  327,  403,  405,  405,  328,   98,   98,   98,   98,
       98,   98,  355, 1666,  356, 1667,  357,  357,  357,  357,

      357,  357,  414,  414,  327,  329,  414,  414,  417,  417,
     2886,  358,  328,  359,  362,  450,  322,  417,  417,  451,
      323,  324,  325,  326,  323,  323,  331,  420,  420,  363,
      363,  363,  363,  363,  363,  420,  420,  322,  341,  431,
      431,  323,  324,  325,  326,  323,  323,  330,  519,  342,
      436,   99,   99,   99,   99,   99,   99,   96,   97,  431,
      431,  434,  434, 2890,  332,  434,  434,  435,  435,  561,
      330,  519,   98,   98,   98,   98,   98,   98,  519,  328,
      360,  360,  360,  360,  360,  360,  455,  332,  435,  435,
      333,  456,  437,  562,  364,  364,  364,  364,  364,  364,

      328,  322,  519,  320,  320,  323,  324,  325,  326,  323,
      323,  452,  328,  519,  578,  453,  562, 2889,  343,  343,
      343,  343,  343,  343,  365,  365,  365,  365,  365,  365,
      312,  334,  526,  527,  528,  529,  519,   99,   99,   99,
       99,   99,   99,  101,  102,  367,  367,  367,  367,  367,
      367, 2771,  313,  519,  334,  579, 2893,  691,  103,  103,
      103,  103,  103,  103,  328,  368,  368,  368,  368,  368,
      368,  406,  407,  407,  407,  407,  407,  519,  579, 2893,
      691, 2802,  370,  410,  411,  411,  411,  411,  411,  366,
      366,  366,  366,  366,  366,  371,  376,  372,  373,  373,

      373,  373,  374,  375,  484,  582,  486, 2886,  568,  377,
      401,  378,  373,  373,  379,  379,  380,  381,  376, 2888,
      484,  582,  486,  104,  104,  104,  104,  104,  104,  101,
      102,  377,  260,  372,  379,  379,  379,  382,  383,  381,
      376,  385,  261,  261,  103,  103,  103,  103,  103,  103,
      215,  216,  777,  377,  386,  384,  382,  382,  382,  382,
      383,  381,  387,  391,  344,  344,  567,  349,  349,  391,
      691,  656, 1163,  215,  216,  391,  392, 1164,  554,  555,
      556,  264,  392,  669,  393,  670, 2887,  213,  392,  671,
      393,  265,  266,  215,  691,  657,  393,  408,  408,  408,

      407,  407,  407,  409,  409,  409,  215,  354,  354,  104,
      104,  104,  104,  104,  104,  106,  107,  215,  657,  361,
      361,  388,  389,  389,  389,  389,  390,  369,  369,  215,
      108,  108,  108,  108,  108,  108,  412,  412,  412,  494,
      659,  660,  661,  394,  389,  389,  395,  395,  396,  388,
      395,  395,  395,  397,  398,  399,  397,  397,  397,  397,
      398,  408,  408,  408,  409,  409,  409,  409,  409,  409,
      408,  408,  408,  409,  409,  406,  406,  406,  406,  408,
      408,  408,  406,  406,  406,  406,  406,  406,  412,  412,
      412,  526,  527,  528,  529,  109,  109,  109,  109,  109,

      109,  106,  107, 2884,  411,  411,  411,  413,  413,  413,
      415,  415,  415,  415,  415,  415,  108,  108,  108,  108,
      108,  108,  416,  416,  416,  416,  416,  416,  418,  418,
      418,  418,  418,  418,  419,  419,  419,  419,  419,  419,
      412,  412,  412,  659,  660,  661,  412,  412,  412,  421,
      426,  402,  402,  810,  422,  427,  413,  413,  413,  413,
      413,  413,  423,  428,  424,  424,  424,  424,  424,  424,
      425,  429,  432,  432,  432,  432,  432,  432,  405,  405,
      442,  109,  109,  109,  109,  109,  109,  111,  112,  433,
      433,  433,  433,  433,  433,  113,  691,  114,  692,  693,

      694,  695,  115,  115,  115,  115,  115,  115,  413,  413,
      410,  410,  410,  410,  410,  410,  410,  410,  410,  410,
      691,  194,  460,  460,  460,  460,  460,  460,  414,  414,
      430,  430,  430,  430,  430,  430,  195,  195,  195,  195,
      195,  195,  461,  461,  461,  461,  461,  461,  462,  462,
      462,  462,  462,  462,  463,  463,  463,  463,  463,  463,
      474,  474,  474,  474,  474,  474, 2772,  116,  116,  116,
      116,  116,  116,  111,  112,  481,  481,  481,  481,  481,
      481,  113, 2773,  114,  417,  417,  335,  436,  115,  115,
      115,  115,  115,  115,  691,  464,  336,  336,  420,  420,

      465,  196,  196,  196,  196,  196,  196,  477,  466,  507,
      467,  468,  468,  468,  468,  469,  470,  691,  431,  431,
     2883,  338,  478,  479,  479,  479,  479,  480,  508,  437,
      331,  339,  340,  191,  434,  434,  435,  435,  471,  536,
      537,  538,  539,  540,  540, 1169,  401,  215,  810, 1170,
      245, 2009, 2009,  116,  116,  116,  116,  116,  116,  118,
      119,  471, 1681, 1681,  564,  508,  215,  421,  332,  472,
      215,  216,  422,  245,  120,  121,  122,  123,  123,  123,
      487,  488,  489,  490,  491,  492,  776,  442,  425,  215,
     1769,  332, 1770, 2882,  216,  509,  842,  843,  844,  845,

      841,  541,  565,  215,  328,  841, 2893,  584,  216,  662,
      510,  511,  511,  511,  511,  512,  542,  543,  544,  545,
      546,  547,  666,  841,  841,  565,  215,  191,  841, 2893,
      664,  216,  548,  549,  550,  551,  552,  552,  508,  124,
      125,  126,  127,  127,  127,  118,  119, 1053,  841, 2893,
      471,  557,  476,  487,  488,  489,  490,  491,  492, 2871,
      120,  121,  122,  123,  123,  123,  558,  559,  559,  559,
      559,  560, 2893,  471, 2870,  901,  215,  902,  608,  841,
      401,  216,  581,  602,  602,  602,  602,  602,  602,  621,
      621,  621,  621,  621,  484,  582,  486,  426,  901,  215,

      902, 1542,  427,  841,  216,  321, 1543,  825, 2869,  583,
      607,  607,  607,  607,  607,  607,  826, 1234,  429, 2868,
      237,  484,  582,  486,  215,  124,  125,  126,  127,  127,
      127,  129,  130,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  131,  237, 1906,  131, 1907,  215,  327,  519,
      245,  215,  131,  131,  131,  131,  131,  131,  609,  610,
      610,  610,  610,  611,  251,  251,  251,  251,  251,  251,
      568,  327,  519,  245,  215,  191,  828,  831,  833,  328,
     2867,  131,  484,  582,  486,  829, 2090, 2090,  132,  832,
      834,  832,  834,  513,  513,  513,  513,  513,  513,  133,

      129,  130,  131,  131,  131,  131,  131,  131,  131,  131,
      131,  131,  215,  216,  131,  635,  636,  637,  638,  639,
      639,  131,  131,  131,  131,  131,  131, 1787, 1787,  253,
      253,  253,  253,  253,  253,  215,  216,  251,  251,  251,
      251,  251,  251,  948,  526,  527,  528,  529,  191, 2866,
      131,  513,  513,  513,  513,  513,  513,  132,  253,  253,
      253,  253,  253,  253, 1910, 1012, 1911,  949,  133,  135,
      136,  270,  270,  270,  270,  270,  270,  951,  951,  952,
      953,  953,  191, 2811,  137,  138,  139,  140,  141,  141,
      949,  191,  520,  520,  520,  520,  520,  520,  951,  951,

      952, 2811,  253,  253,  253,  253,  253,  253, 1618,  594,
     1282,  519,  191,  401,  595,  252,  253,  253,  253,  253,
      253,  253,  596,  647,  648,  649,  650,  651,  651,  652,
      597,  659,  660,  661, 1283,  519,  272,  272,  272,  272,
      272,  272,  603,  685,  685,  685,  685,  685,  685,  142,
      143,  144,  145,  146,  146,  135,  136,  272,  272,  272,
      272,  272,  272,  891,  662,  891, 1613, 1210,  191,  640,
      137,  138,  139,  140,  141,  141,  659,  663,  661, 1211,
     1614, 1211, 1274,  472, 1212,  664,  191,  422,  191,  598,
      599,  599,  599,  599,  600,  191, 1213,  191, 1213,  627,

      628,  628,  628,  628,  629,  892,  885,  892,  885,  653,
      654,  654,  654,  654,  655,  698,  698,  698,  698,  698,
      698,  333,  604,  605,  605,  605,  605,  606,  892,  885,
      892,  885, 1317,  329, 1406,  142,  143,  144,  145,  146,
      146,  148,  149, 1448,  621,  621,  621,  621,  621,  641,
      642,  643,  644,  645,  646, 1204,  150,  150,  150,  150,
      150,  150,  334,  314, 1592, 1207,  622,  701,  701,  701,
      701,  701,  701, 2811, 1593,  330,  662,  315,  623,  624,
      625, 2811, 1099, 1099, 1100,  334,  519,  293,  659,  663,
      661,  825,  191,  294,  316,  328,  191,  664,  330,  317,

      826,  668,  674,  191,  675,  319,  294,  328,  676,  677,
      519,  678,  679, 2863,  979,  680,  681,  294,  519,  682,
      683,  151,  151,  151,  151,  151,  151,  148,  149,  294,
      704,  704,  704,  704,  704,  704,  924,  979, 1514,  626,
     1369,  519,  150,  150,  150,  150,  150,  150,  705, 1548,
     1101, 1101,  622, 1549,  191,  662,  665,  665,  665,  665,
      665,  665,  662, 1369,  623,  624,  625,  659,  663,  661,
      191,  828,  662,  293, 2811,  666,  664,  579, 2893,  294,
      829, 1116,  702,  664,  925,  666,  703,  703,  703,  703,
      703,  703,  294,  664,  707,  707,  707,  707,  707,  707,

      579, 2893, 2890,  294, 1116, 1669, 1764,  151,  151,  151,
      151,  151,  151,  153,  154,  294, 1565,  706,  706,  706,
      706,  706,  706, 1945, 1945,  626, 2893,  471,  155,  155,
      155,  155,  155,  155, 1370,  621,  621,  621,  621,  621,
     1566, 2886,  665,  665,  665,  665,  665,  665,  329, 2893,
      471, 1204,  621,  621,  621,  621,  621, 1370,  321,  686,
     1592, 2458,  989,  687,  688,  689,  690,  687,  687,  686,
      191, 2811, 1613,  687,  688,  689,  690,  687,  687,  350,
      708,  708,  708,  708,  708,  708, 1614,  352, 1096, 2890,
      330,  331,  341,  156,  156,  156,  156,  156,  156,  153,

      154,  327,  686,  699,  534, 2893,  687,  688,  689,  690,
      687,  687, 1097,  330,  155,  155,  155,  155,  155,  155,
     1277, 1751,  328,  333,  327,  427, 1282,  534, 2893,  332,
     1960, 1960,  328, 2886,  686, 1097,  949, 1465,  687,  688,
      689,  690,  687,  687,  709,  709,  709,  709,  709,  709,
     1283, 2862,  332,  710,  710,  710,  710,  710,  710,  949,
     1465, 1621, 1621, 1621,  334,  328,  328,  717, 2258,  359,
     2259, 1466,  700,  700,  700,  700,  700,  700, 2167,  156,
      156,  156,  156,  156,  156,  158,  159,  334,  711,  711,
      711,  711,  711,  711, 1466, 2861, 2315,  328, 2316, 1613,

      160,  160,  160,  160,  160,  160,  712,  712,  712,  712,
      712,  712,  713, 1614,  356, 2372,  714,  714,  714,  714,
      714,  714,  715,  715,  715,  715,  715,  715,  716,  716,
      716,  716,  716,  716,  362, 2860,  718,  718,  718,  718,
      718,  718,  721,  721,  721,  721,  721,  721, 2811,  719,
      719,  719,  719,  719,  719,  722,  722,  722,  722,  722,
      722,  526,  527,  528,  529,  161,  161,  161,  161,  161,
      161,  158,  159,  723,  723,  723,  723,  723,  723,  724,
      724,  724,  724,  724,  724,  725,  160,  160,  160,  160,
      160,  160, 1099, 1099, 1100, 1615, 2857,  726,  728,  726,

      727,  727,  727,  727,  727,  727,  191,  370, 1670, 1616,
      729,  191,  729,  465,  720,  720,  720,  720,  720,  720,
      371,  734,  731,  732,  732,  732,  732,  733,  371,  370,
      781,  782,  783,  784,  785,  785,  731,  732,  732,  732,
      732,  733,  371, 2855,  735,  736,  736,  736,  736,  737,
      375,  161,  161,  161,  161,  161,  161,  163,  164,  737,
      737,  737,  737,  737,  737,  751,  639,  639,  639,  639,
      639,  376,  165,  165,  165,  165,  165,  165,  730,  730,
      730,  730,  730,  730,  377,  376,  738,  739,  739,  739,
      739,  740,  381,  734,  778,  778,  778, 2854,  377,  744,

      735,  736,  736,  736,  736,  737,  381,  376,  741,  742,
      742,  742,  742,  743,  745,  746,  746,  746,  746,  747,
      377, 1615,  731,  732,  732,  732,  732,  733,  377, 2853,
     2852,  756,  376, 1097, 1661, 1616, 2851,  166,  166,  166,
      166,  166,  166,  163,  164,  377, 1207,  735,  736,  736,
      736,  736,  737,  381,  370, 1593, 1097, 1661,  165,  165,
      165,  165,  165,  165,  370,  385, 1647,  371, 2850,  738,
      739,  739,  739,  739,  740,  375,  744,  371,  386,  735,
      736,  736,  736,  736,  737,  375,  386, 1627, 1627, 1627,
     1648,  748,  749,  749,  749,  749,  750,  752,  752,  752,

      752,  752,  752,  751,  737,  737,  737,  737,  737,  737,
      751,  753,  754,  754,  754,  754,  755,  773,  971,  971,
      971,  971,  971,  166,  166,  166,  166,  166,  166,  173,
      835,  773,  540,  540,  540,  540,  540,  174,  175, 1615,
     2849,  176,  191, 1941,  177,  753,  754,  754,  754,  754,
      755,  178, 1662, 1616,  179, 1764, 2811, 1401, 1401, 1402,
      180,  181,  519,  182,  836,  519,  183,  184,  185,  186,
      187,  191, 2848,  188,  173, 1662,  762,  762,  762,  762,
      762,  762,  174,  175, 1709,  519,  176,  836,  519,  177,
      774,  774,  774,  774,  774,  774,  178,  519, 2521,  179,

     1628, 1628, 1628,  837, 1773,  180,  181, 1709,  182,  595,
     2549,  183,  184,  185,  186,  187, 2845, 2844,  188,  199,
      200,  519,  201,  201,  201,  202,  201,  201,  201,  201,
      201,  203,  204,  205,  206,  207,  208,  209,  210,  211,
      212,  213,  201,  201,  201,  201,  214,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  216,  215,  215,  215,  215,  215,  199,
      201,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  216,  215,  215,  215,
      217,  217,  217,  217,  218,  217,  217,  217,  217,  217,

      199,  199,  199,  199,  199,  199,  219,  756,  790,  791,
      792,  793,  794,  794,  773, 1509, 1509, 1510,  220,  221,
      222,  223, 2843, 2842,  224,  225,  226,  227,  191,  191,
      787,  787,  787,  228,  778,  778,  778,  779,  779,  779,
      779,  779,  779, 2841, 1669, 1305,  228, 1306,  229,  215,
      796,  796,  796,  796,  796,  796, 2840,  228,  780,  780,
      780,  779,  779,  779,  779,  779,  779, 1669, 1305,  228,
     1306,  229,  215,  762,  762,  762,  762,  762,  762,  230,
      190,  797,  797,  797,  797,  797,  797,  757,  758,  758,
      758,  758,  759,  250,  190, 2811,  251,  251,  251,  251,

      251,  251, 1132, 1132, 1132, 1132, 1132,  191,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      190, 2839,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  190,  190,  190,  190,  190,  190,  190,  190,  190,
      190,  253,  253,  253,  253,  253,  253,  254,  255, 2838,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      256,  254,  255,  257,  257,  257,  257,  257,  257,  255,
      255,  255,  255,  255,  258,  259,  259,  259,  259,  259,

      259,  259,  259,  260,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  261,  261,  259,  259,  254,  255,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  254,  254,
      254,  254,  254,  254,  254,  254,  254,  254,  262,  262,
      262,  262,  262,  262,  269, 2837, 1941,  270,  270,  270,
      270,  270,  270, 1238, 1238, 1238, 1238, 1238,  191,  786,
      786,  786,  779,  779,  779,  779,  779,  779,  798,  798,
      798,  798,  798,  798,  799,  799,  799,  799,  799,  799,
      800,  800,  800,  800,  800,  800,  804,  804,  804,  804,

      804,  804,  432,  432,  432,  432,  432,  432, 1634, 1634,
     1634, 2587,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  271,  272,  272,  272,  272,  272,  272,  273,  274,
     2836,  275,  275,  275,  276,  275,  275,  275,  275,  275,
      277,  278,  279,  280,  273,  273,  273,  273,  273,  273,
      281,  275,  275,  275,  275,  282,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  283,  283,  273,  275,
      283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  283,  283,  283,  284,

      284,  284,  284,  285,  284,  284,  284,  284,  284,  286,
      287,  287,  287,  287,  288,  289,  433,  433,  433,  433,
      433,  433,  385, 2811, 1404, 1003,  893,  290,  291,  292,
     1251, 1251, 1251, 1251, 1251,  386,  293,  191, 1906,  191,
     2378,  802,  294,  387,  526,  527,  528,  529, 1405,  391,
     1417, 1910, 1315, 2380, 1316,  294,  803,  803,  803,  803,
      803,  803,  392,  391,  894, 1518,  294,  534, 2893,  885,
      393, 1405, 2225,  391, 1418, 1315,  392, 1316,  294, 1254,
     1254, 1254, 1254, 1254,  393,  766,  392,  894,  295, 1519,
      534, 2893,  885, 2885,  392,  296,  895, 1418,  297,  297,

      298,  289,  760,  761,  761,  761,  761,  762,  766, 2420,
     2886,  519, 1519,  290,  291,  292,  846,  846,  846,  846,
      846,  846,  293, 1267, 1267, 1267, 1267, 1267,  294,  763,
      764,  764,  764,  764,  765,  519, 2777,  896,  391,  885,
     2778,  294, 2835,  760,  761,  761,  761,  761,  762, 1417,
      385,  392,  294,  753,  754,  754,  754,  754,  755,  393,
      896,  895,  885,  386,  294,  767,  768,  768,  768,  768,
      769,  387, 2811, 1418,  295,  787,  787,  787, 2834, 2833,
     1869,  299,  297,  297,  297,  300,  301,  289,  770,  771,
      771,  771,  771,  772,  385,  191, 1418, 2890,  191,  290,

      291,  292,  896,  885, 1870, 1418, 1405,  386,  293, 2811,
     2832, 1460, 1460, 1461,  294,  387, 2831, 2830,  760,  761,
      761,  761,  761,  762, 2886,  896,  885,  294, 1418, 1405,
      763,  764,  764,  764,  764,  765,  477, 1670,  294,  789,
      789,  789,  465,  788,  788,  788,  788,  788,  788, 1772,
      294,  467,  468,  468,  468,  468,  469,  795,  795,  795,
      295,  854,  854,  854,  854,  854,  854,  302,  300,  303,
      303,  303,  304,  289,  760,  761,  761,  761,  761,  762,
      606,  606,  606,  606,  606,  290,  291,  292,  856,  856,
      856,  856,  856,  856,  293,  526,  527,  528,  529, 1670,

      294,  421, 2657, 1000,  465, 2658,  422,  788,  788,  788,
      788,  788,  788,  294,  423,  805,  801,  801,  801,  801,
      801,  801,  425,  825,  294,  788,  788,  788,  788,  788,
      788, 2657,  826, 2815, 2658, 2236,  294,  885,  827,  827,
      827,  827,  827,  827, 2237, 2814,  295,  474,  474,  474,
      474,  474,  474,  305,  303,  303,  303,  303,  304,  307,
      885,  307,  307,  307,  307,  307,  307,  307,  307,  307,
      307,  307,  307,  307,  509, 2779,  888, 2813, 2241, 2780,
      307,  307,  307,  307,  307,  307,  477, 2242, 1881,  838,
      839,  839,  839,  839,  840,  806,  806,  806,  806,  806,

      806,  467,  468,  468,  468,  468,  469, 2812,  307,  307,
      308,  309, 1882,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  308,  308,  308,  308,
      308,  308,  309,  309,  309,  309,  309,  309,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      309,  309,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  308,  308,  308,  308,  308,  308,  308,  308,  308,
      308,  308,  308,  308,  308,  308,  308,  309, 2811,  309,

      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  464,  526,  527,  528,  529,  465,  309,  309,
      309,  309,  309,  309,  923,  466, 2810,  467,  468,  468,
      468,  468,  469,  470,  861,  862,  863,  863,  863,  863,
      868,  869,  870,  870,  870,  870,  309,  309,  897,  898,
      899,  900,  897,  897, 2393,  471,  906,  907,  908,  909,
      910,  910,  565, 2394, 1765, 1766, 2893,  311,  311,  311,
      311,  311,  311,  311,  311,  311,  311,  190,  471,  917,
      918,  919,  920,  921,  921,  565,  472, 1765, 1766, 2893,
      190,  190, 2809,  190,  190,  190,  190,  190,  190, 1681,

     1681, 1681, 1681, 1681,  191,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  190, 2808,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  476,  476,
      476,  476,  476,  476,  476,  476,  476,  476,  190,  190,
      190,  190,  190,  190,  482,  897,  898,  899,  900,  897,
      897, 1518, 1017, 1789,  584,  483,  484,  485,  486,  487,
      488,  489,  490,  491,  492,  191,  426, 1773, 2398, 1989,
     2807,  427,  595,  828,  477, 1519, 1789, 2399,  493,  428,

     1773, 1990,  829, 1990, 2806,  595, 1018,  429,  835,  864,
      865,  866,  866,  866,  867,  541, 2893,  471, 1519, 2805,
      191,  493, 1884,  469,  469,  469,  469,  469,  469, 1018,
      911,  912,  913,  914,  915,  916, 1848,  494,  495, 2893,
      471,  191,  836,  895,  509, 1019, 1885,  893, 2365,  483,
      496,  497,  498,  499,  500,  501,  502,  503,  504,  838,
      839,  839,  839,  839,  840,  836,  807,  807,  807,  807,
      807,  807,  493,  830,  830,  830,  830,  830,  830, 2804,
     1519,  837,  835, 2482,  896,  894,  885, 2236,  932, 2700,
      885, 1512, 2701, 2803,  940,  493, 2237,  469,  469,  469,

      469,  469,  469, 1519,  191, 2784,  964,  896,  894,  885,
      564,  505,  506,  885,  932, 1513,  836,  513,  513,  513,
      513,  513,  513,  483,  496,  497,  498,  499,  500,  501,
      502,  503,  504,  526,  527,  528,  529,  940, 1513,  836,
      520,  520,  520,  520,  520,  520,  493,  579,  565, 2893,
      237,  901, 2893,  902,  215,  837,  513,  513,  513,  513,
      513,  513,  520,  520,  520,  520,  520,  520, 2781,  493,
      579,  565, 2893,  237,  901, 2893,  902,  215,  856,  961,
      961,  961,  961,  961, 2776,  505,  513,  514, 2775,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  515,

      513,  514,  516,  516,  516,  516,  516,  516,  514,  514,
      514,  514,  514,  517,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  513,  514,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  518,  518,  518,
      518,  518,  518,  520,  521, 2774,  521,  521,  521,  521,
      521,  521,  521,  521,  521,  521,  522,  520,  521,  523,
      523,  523,  523,  523,  523,  521,  521,  521,  521,  521,

      524,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  521,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  476,  476,  476,  476,  476,  476,
      476,  476,  476,  476,  525,  525,  525,  525,  525,  525,
      530,  191, 2771, 2736, 2720,  465,  965,  966,  967,  967,
      967,  967, 1513,  531,  541,  467,  468,  468,  468,  468,
      469,  532, 2685, 2639, 2638,  999,  835,  533,  927,  942,
      943,  943,  943,  943,  944, 1513, 1314,  927, 2637, 2618,

      533,  465,  534,  928,  928,  928,  928,  928,  928, 1996,
      191,  533,  928,  928,  928,  928,  928,  928, 2609,  885,
      836,  927,  929,  533, 2782,  534,  191,  885,  887, 2783,
      836,  929, 1996,  535,  472,  553,  931,  931,  931,  931,
      931,  931,  885,  836, 1668,  929,  191,  554,  555,  556,
      885,  887,  520,  836,  929,  929,  213, 2241,  888,  837,
     2325,  930,  215, 2589,  557,  595, 2242, 1668, 2393,  837,
      930, 1565,  541,  215,  603,  215,  245, 2394,  929,  945,
      946,  946,  946,  946,  947, 2588,  215,  942,  943,  943,
      943,  943,  944, 2564,  930, 1566,  215,  475,  215,  245,

      972,  973,  974,  974,  974,  974, 2561, 1008,  494,  482,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      475,  554,  555,  556,  994,  995,  996,  996,  996,  996,
      213, 2560, 2527, 2526,  472,  191,  215,  951,  951,  952,
      540,  540,  540,  953,  953,  953, 2489,  215,  579,  215,
     2893,  191,  216, 1888,  598,  599,  599,  599,  599,  600,
      215,  962,  962,  962,  961,  961,  961,  963,  963,  963,
      215,  579,  215, 2893, 2487,  216, 2486, 1889,  608, 1365,
     2485, 2479,  494,  482,  962,  962,  962,  963,  963,  963,
      963,  963,  963, 2476,  483,  554,  555,  556,  487,  488,

      489,  490,  491,  492,  951,  951,  952,  953,  953,  953,
      953,  953,  953, 1350, 1305,  954, 1306,  493,  191,  962,
      962,  962,  963,  963,  856,  856,  856,  856,  191, 2398,
      955,  547,  547,  547,  547,  547, 1350, 1305, 2399, 1306,
      493, 2142,  956,  962,  962,  962,  856,  856,  856,  856,
      856,  856, 1353,  578,  990,  956,  494,  482, 1014, 1015,
     1015, 1015, 1015, 1016,  477, 2143,  956,  191,  483,  554,
      555,  556,  487,  488,  489,  490,  491,  492,  956,  968,
      969,  970,  970,  970,  971,  557,  893,  191,  957, 1004,
      191,  493,  565,  997,  579, 2893, 1356, 2893, 1647, 1001,

      945,  946,  946,  946,  946,  947, 2074,  191,  998,  998,
      998,  998,  998,  998,  493,  565,  990,  579, 2893,  191,
     2893,  191, 1648, 1772,  894, 2460,  191,  565,  885, 2074,
      494,  566, 2893,  885, 1002, 1984, 1358,  894, 1357, 1350,
     1440,  885, 1441,  554,  555,  556, 1772,  894,  603,  191,
      565,  885,  213,  191,  565, 2893,  885, 2893,  215, 2145,
      894, 1357, 1350, 1440,  885, 1441,  191, 1771,  885,  215,
      475,  215,  888,  229, 1359,  896,  885,  565, 2718, 1350,
     2893, 2719,  215, 2146, 1005, 1006, 1007, 1007, 1007, 1007,
     1771,  885,  215,  475,  215,  191,  229, 1359,  896,  885,

      835, 1017, 1350, 1869,  494,  568,  191,  888, 1020, 1020,
     1020, 1020, 1020, 1020, 1017, 1662,  483,  554,  569,  556,
      492,  570,  571,  572,  492,  492,  573, 1870,  598,  599,
      599,  599,  599,  600,  836, 1018, 2149, 1009, 1662,  493,
      251,  251,  251,  251,  251,  251, 1013,  608, 1018,  270,
      270,  270,  270,  270,  270,  191, 2439,  836, 1018,  594,
     2150, 2421,  493,  819,  595, 1028, 1028, 1028, 1028, 1028,
     1028, 1018,  596,  837, 1019,  819,  819, 1017,  494,  568,
      597,  600,  600,  600,  600,  600,  600, 1019,  191, 1941,
      483,  554,  569,  556,  574,  575,  576,  577,  574,  574,

      573, 2700, 2413, 2000, 2701,  253,  253,  253,  253,  253,
      253, 1018,  603,  493,  272,  272,  272,  272,  272,  272,
     1030, 1030, 1030, 1030, 1030, 1030, 2000, 1014, 1015, 1015,
     1015, 1015, 1016,  472, 1018, 2412,  493, 2411,  191,  598,
      599,  599,  599,  599,  600, 1901, 1898, 1017, 1032, 2325,
     1019, 2325,  494,  568,  595, 1895,  595,  600,  600,  600,
      600,  600,  600, 1892,  483,  554,  569,  556,  492,  570,
      571,  572,  492,  492,  573,  602,  602,  602,  602,  602,
      602, 1018, 1033, 1326, 1326, 1327,  867,  493, 2369,  480,
      480,  480, 1044, 1045, 1046, 1046, 1046, 1047, 1048, 1049,

     1050, 1050, 1050, 1050, 1018, 1033, 2366, 2365, 2356, 1360,
      493, 1070, 1070, 1070, 1070, 1070, 1070, 1362, 2355, 2352,
     1019, 1034, 1032,  472, 1366,  472,  494,  580, 1035, 1035,
     1035, 1035, 1035, 1035, 2349,  191, 1071, 1489,  483,  554,
      569,  556,  492,  570,  571,  572,  492,  492,  573,  631,
     1361, 1032, 1350,  191, 2154,  191, 1033,  632, 1350,  534,
     2893,  493, 2157,  633, 1881,  640, 1357, 1350,  191,  229,
      215, 1483, 2161, 1361, 1884, 1350,  633,  640, 2155, 1033,
     2303, 1350,  534, 2893,  493, 1033, 2158,  633, 1882, 1357,
     1350,  191,  229,  215, 1483, 1034, 2162, 1353, 1885,  633,

      494,  568, 1035, 1035, 1035, 1035, 1035, 1035, 1033, 1072,
     1485,  191, 1764,  484,  582,  486,  574,  575,  576,  577,
      574,  574, 2300,  191, 1034, 1073, 1074, 1075, 1076, 1077,
     1077, 1036, 1036, 1036, 1036, 1036, 1036, 1084, 1085, 1086,
     1087, 1088, 1088,  215,  216, 1078, 1079, 1080, 1081, 1082,
     1083, 1070, 1070, 1070, 1070, 1070, 1070, 1090, 1091, 1091,
     1091, 1091, 1092,  191, 2281,  191,  215,  216,  513,  514,
      191,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  586,  513,  514,  251,  251,  251,  251,  251,  251,
      514,  514,  514,  514,  514,  517,  587,  587,  587,  587,

      587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
      587,  587,  587,  587,  587,  587,  587,  587,  513,  514,
      587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
      587,  587,  587,  587,  587,  587,  587,  587,  587,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  190, 1030, 1109, 1109, 1109,
     1109, 1109, 1126, 1127, 1128, 1128, 1128, 1128,  250,  190,
      191,  251,  251,  251,  251,  251,  251, 1787, 1787, 1787,
     1787, 1787,  191,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,

      252,  252,  252,  252,  252,  190,  819,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  190,  190,  190,  190,
      190,  190,  190,  190,  190,  190,  253,  253,  253,  253,
      253,  253,  254,  255, 2229,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  256,  254,  255,  257,  257,
      257,  257,  257,  257,  255,  255,  255,  255,  255,  258,
      259,  259,  259,  259,  259,  259,  259,  259,  588,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  254,  255,  259,  259,  259,  259,  259,  259,

      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  254,  254,  254,  254,  254,  254,  254,
      254,  254,  254,  262,  262,  262,  262,  262,  262,  592,
      819,  819,  270,  270,  270,  270,  270,  270,  652, 1133,
     1134, 1135, 1135, 1135, 1135, 1175, 1175, 1175, 1175, 1175,
     1175, 1677, 1677, 1677, 1677, 1677, 1099, 1099, 1100,  640,
     2228,  191, 1099, 1099, 1100, 2227,  191, 1326, 1326, 1327,
      191,  480,  480,  480,  480,  480,  191, 1110, 1110, 1110,
     2226, 2078,  519, 1110, 1110, 1110, 2225,  593,  593,  593,
      593,  593,  593,  593,  593,  593,  593,  520,  520,  520,

      520,  520,  520,  269, 2078,  519,  270,  270,  270,  270,
      270,  270, 2210, 1440,  519, 1441, 2167,  191, 1093, 1094,
     1094, 1094, 1094, 1095,  639,  639,  639, 1101, 1101, 1101,
     1101, 1101, 1101, 1101, 1101, 1101, 1440,  519, 1441, 1090,
     1091, 1091, 1091, 1091, 1092, 1109, 1109, 1109, 1111, 1111,
     1111, 1111, 1111, 1111, 1111, 1111, 1111, 2718, 2160, 2159,
     2719,  271,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  272,  272,  272,  272,  272,  272,  273,  612, 2156,
      275,  275,  275,  276,  275,  275,  275,  275,  275,  613,
      614,  615,  616,  273,  273,  273,  273,  273,  273,  281,

      275,  275,  275,  275,  282,  283,  283,  283,  283,  283,
      283,  283,  617,  283,  283,  283,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  283,  273,  275,  283,
      283,  283,  283,  283,  283,  617,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  283,  283,  284,  284,
      284,  618,  285,  284,  284,  284,  284,  284,  619,  620,
      620,  620,  620,  621,  622,  191,  685,  685,  685,  685,
      685,  685, 2163, 2153,  923, 2152,  623,  624,  625, 1183,
     1183, 1183, 1183, 1183, 1183,  293, 1766,  191, 1110, 1110,
     1110,  294, 2793, 2151, 2148, 2794, 2164, 1110, 1110, 1110,

      674, 1102,  675, 1669,  294, 2165,  676,  677, 1888, 1766,
      679,  652,  565,  680,  681,  294, 2893,  682,  683, 1139,
     1140, 1141, 1141, 1141, 1141,  603, 1669,  294, 1103, 2166,
      519, 2147, 1889,  925, 1142,  565, 2144,  626,  924, 2893,
     2793, 1103, 2141, 2794,  627,  628,  628,  628,  628,  629,
      630,  191, 1103, 2140,  519,  595, 1111, 1111, 1030, 1030,
     1030, 1030, 2139,  631, 1103, 1030, 1030, 1030, 1030, 1030,
     1030,  632, 2138,  191, 1104, 2893,  471,  633, 2137,  579,
     2893, 1105,  646,  646,  646,  646,  646,  519, 2136, 1772,
      633, 1093, 1094, 1094, 1094, 1094, 1095,  191, 2893,  471,

      191,  633,  579, 2893,  191, 1129, 1130, 1131, 1131, 1131,
     1132,  519, 1772,  633, 1143, 1143, 1143, 1143, 1143, 1143,
      191,  191,  191,  634,  472, 1945, 1945, 1945, 1945, 1945,
      598,  599,  599,  599,  599,  600,  307, 2071,  307,  307,
      307,  307,  307,  307,  307,  307,  307,  307,  307,  307,
      307, 1145, 1146, 1147, 1147, 1147, 1147,  307,  307,  307,
      307,  307,  307, 1149, 2350, 1150,  191,  191, 2864, 1151,
     1152, 2865, 1153, 1154,  191, 2864, 1155, 1156, 2865, 2874,
     1157, 1158, 2875,  191,  191,  307,  307,  307, 2351,  307,
      307,  307,  307,  307,  307,  307,  307,  307,  307,  307,

      307,  307,  698,  698,  698,  698,  698,  698,  307,  307,
      307,  307,  307,  307, 1186, 1186, 1186, 1186, 1186, 1186,
      701,  701,  701,  701,  701,  701, 1187,  819, 1985, 1983,
     1188, 1188, 1188, 1188, 1188, 1188,  307,  307,  308,  309,
     1982,  309,  309,  309,  309,  309,  309,  309,  309,  309,
      309,  309,  309,  309,  308,  308,  308,  308,  308,  308,
      309,  309,  309,  309,  309,  309,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  309,  309,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,

      310,  310,  310,  310,  310,  310,  310,  310,  310,  308,
      308,  308,  308,  308,  308,  308,  308,  308,  308,  308,
      308,  308,  308,  308,  308,  309, 1981,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
     1189, 1189, 1189, 1189, 1189, 1189,  309,  309,  309,  309,
      309,  309,  704,  704,  704,  704,  704,  704, 2874, 1980,
     1136, 2875, 1979, 1978, 1993,  595, 1192, 1192, 1192, 1192,
     1192, 1192, 1941, 1939,  309,  309, 1994,  773, 1994,  751,
     1190, 1137, 1193, 1193, 1193, 1193, 1193, 1193, 1194, 1194,
     1194, 1194, 1194, 1194, 1018,  311,  311,  311,  311,  311,

      311,  311,  311,  311,  311,  848, 1901,  849,  849,  849,
      850,  849,  849,  849,  849,  849,  849, 1018, 1898,  849,
      480,  480,  480,  480,  480,  480,  849,  849,  849,  849,
      849,  851, 1895, 1019,  472, 1144, 2353, 2142, 1892,  852,
     1138, 1138, 1138, 1138, 1138, 1138, 1890, 1887,  321, 1191,
     1191, 1191, 1191, 1191, 1191,  849, 1628, 1628, 1628, 1176,
     2354, 2143,  852, 1177, 1178, 1179, 1180, 1177, 1177, 1064,
      712,  712,  712,  712,  712,  712, 1886, 1883,  853,  848,
     1880,  849,  849,  849,  850,  849,  849,  849,  849,  849,
      849,  327, 1064,  849,  480,  480,  480,  480,  480,  480,

      849,  849,  849,  849,  849,  851, 1879, 1051, 1066, 1052,
      341, 2357, 1878,  852,  327, 1070, 1070, 1070, 1070, 1070,
     1070, 1184,  328,  329, 1254, 1254, 1254, 2145, 1877,  849,
     1051,  901, 1052,  902, 1176, 2358,  852, 1876, 1177, 1178,
     1179, 1180, 1177, 1177,  331,  711,  711,  711,  711,  711,
      711, 2146,  853,  857,  901, 1176,  902, 1875,  465, 1177,
     1178, 1179, 1180, 1177, 1177,  330,  466, 1874,  858,  859,
      859,  859,  859,  860,  470, 1198, 1198, 1198, 1198, 1198,
     1198, 1051,  332, 1052,  328, 2616, 1873,  836,  330, 1872,
     1185, 1185, 1185, 1185, 1185, 1185,  471,  328,  716,  716,

      716,  716,  716,  716, 1051,  332, 1052, 1195, 2617, 1196,
      836, 1197, 1197, 1197, 1197, 1197, 1197, 1871,  328,  471,
      715,  715,  715,  715,  715,  715,  837,  472,  871,  872,
     1868,  873,  873,  873,  874,  873,  873,  873,  873,  873,
      875,  876,  877,  878,  879,  880,  881,  882,  879,  879,
      883,  873,  873,  873,  873,  884,  885,  885,  885,  885,
      885,  885,  885,  886,  885,  885,  885,  885,  885,  885,
      885,  885,  887,  885,  885,  885,  885,  885,  871,  873,
      885,  885,  885,  885,  885,  885,  886,  885,  885,  885,
      885,  885,  885,  885,  885,  887,  885,  885,  885,  888,

      888,  888,  889,  890,  888,  888,  888,  888,  888,  871,
      871,  871,  871,  871,  871,  904, 2359, 1207, 1867, 1866,
      465, 1865, 1199, 1864, 1200, 1863, 1208, 2361,  531, 2149,
      858,  859,  859,  859,  859,  860,  532,  191, 1862, 1861,
     2360, 2363,  533, 1202, 1202, 1202, 1202, 1202, 1202,  836,
     1446, 2362, 1447, 2150, 2616,  533, 2189,  534, 1203, 1203,
     1203, 1203, 1203, 1203, 1860, 2364,  533, 1204, 2190, 1859,
     2190,  191,  836, 1446,  191, 1447, 1205, 2617,  533, 2154,
      534, 1850, 1206, 1206, 1206, 1206, 1206, 1206,  905,  472,
      513, 1201, 1201, 1201, 1201, 1201, 1201, 1209, 1209, 1209,

     1209, 1209, 1209, 2155, 2367,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513, 2659, 2368,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  933,  934,
     2660,  934,  934,  934,  934,  934,  934,  934,  934,  934,
      934,  935,  933,  934,  936,  936,  936,  936,  936,  936,
      934,  934,  934,  934,  934,  937,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  933,  934,

      938,  938,  938,  938,  938,  938,  938,  938,  938,  938,
      938,  938,  938,  938,  938,  938,  938,  938,  938,  933,
      933,  933,  933,  933,  933,  933,  933,  933,  933,  939,
      939,  939,  939,  939,  939,  530,  728, 1849, 1520, 2157,
      465, 1214, 1214, 1214, 1214, 1214, 1214, 2370,  531,  725,
      467,  468,  468,  468,  468,  469,  532, 1960, 1960, 1960,
     1960, 1960,  533, 2158, 1214, 1214, 1214, 1214, 1214, 1214,
      989, 2371,  333, 2161, 1824,  533, 2683,  534, 1053, 1634,
     1634, 1634, 1219, 1176,  191, 1766,  533, 1177, 1178, 1179,
     1180, 1177, 1177, 1764, 1220, 1762, 1220, 2162,  533, 2684,

      534, 1218, 1218, 1218, 1218, 1218, 1218, 2163,  535,  472,
      954, 2893,  534,  334, 2165,  191, 1218, 1218, 1218, 1218,
     1218, 1218,  958,  958,  959,  547,  547,  547,  960,  960,
      960, 2164,  191, 1761, 2893,  534,  334,  956, 2166, 1215,
      733,  733,  733,  733,  733,  733,  328, 1267, 1267, 1267,
      956, 1216, 1760, 1216, 1217, 1217, 1217, 1217, 1217, 1217,
     1419,  956, 1221, 1221, 1221, 1221, 1221, 1221, 2350, 2477,
      734, 2353,  191,  956,  733,  733,  733,  733,  733,  733,
     1364, 1724,  903,  957,  954,  731,  732,  732,  732,  732,
      733,  191, 2351, 2478, 1662, 2354,  958,  958,  959,  960,

      960,  960,  960,  960,  960, 1224, 1224, 1224, 1224, 1224,
     1224,  956, 1222, 1222, 1222, 1222, 1222, 1222,  751, 2480,
     1650,  579,  819, 2893,  956, 1222, 1222, 1222, 1222, 1222,
     1222,  751, 2357, 1649, 1646,  956, 1223, 1223, 1223, 1223,
     1223, 1223,  751, 2481,  579, 2359, 2893,  956, 1222, 1222,
     1222, 1222, 1222, 1222,  751, 1645, 2358,  957,  954, 1222,
     1222, 1222, 1222, 1222, 1222,  751, 1644, 1643, 1642, 2360,
      958,  958,  959,  960,  960,  955,  955,  955,  955, 1224,
     1224, 1224, 1224, 1224, 1224,  956, 1223, 1223, 1223, 1223,
     1223, 1223,  751, 2361, 2363,  744, 2483,  442,  956, 1225,

     1225, 1225, 1225, 1225, 1225, 2367, 2370, 1641, 1569,  956,
      745,  746,  746,  746,  746,  747, 2558, 2362, 2364, 2477,
     2484,  956,  747,  747,  747,  747,  747,  747, 1568, 2368,
     2371,  957,  954,  747,  747,  747,  747,  747,  747, 1567,
     2559, 1564, 1563, 2478,  958,  958,  959,  955,  955,  955,
      955,  955,  955, 1226, 1226, 1226, 1226, 1226, 1226,  956,
     1226, 1226, 1226, 1226, 1226, 1226, 1225, 1225, 1225, 1225,
     1225, 1225,  956, 1227, 1227, 1227, 1227, 1227, 1227,  756,
     2480, 1562, 1561,  956, 1223, 1223, 1223, 1223, 1223, 1223,
      751,  773, 2483, 2562, 1560,  956,  755,  755,  755,  755,

      755,  755, 1559, 1558, 2481,  957,  954,  755,  755,  755,
      755,  755,  755,  773, 1557, 1556, 2484, 2563,  958,  958,
      959,  854,  854,  854,  854,  854,  854, 1228, 1228, 1228,
     1228, 1228, 1228,  956, 1228, 1228, 1228, 1228, 1228, 1228,
     1229, 1229, 1229, 1229, 1229, 1229,  956, 2558, 1555,  773,
     1230, 1230, 1230, 1230, 1230, 1230, 2193,  956, 2614,  753,
      754,  754,  754,  754,  755,  773, 1554, 1553, 2194,  956,
     2194, 2559, 1230, 1230, 1230, 1230, 1230, 1230, 1552,  957,
      975, 2562, 2615, 2659, 1551,  773,  769,  769,  769,  769,
      769,  769, 2614, 1550, 2683,  976,  976,  976,  976,  976,

      976,  773,  766, 1547, 1546, 2563, 2660,  977, 1231, 1231,
     1231, 1231, 1231, 1231,  929, 1545, 2615, 2684, 1544, 1541,
      977, 1540,  191, 1520, 1230, 1230, 1230, 1230, 1230, 1230,
     1506,  977, 2760, 2760, 1413, 1413, 1414,  929,  480,  480,
      480,  480,  480,  977, 1230, 1230, 1230, 1230, 1230, 1230,
     1003, 1506, 1500,  978,  975, 2761, 2761, 1490,  476,  191,
     1231, 1231, 1231, 1231, 1231, 1231, 1442, 2846,  191,  976,
      976,  976,  976,  976,  976,  769,  769,  769,  769,  769,
      769,  977,  767,  768,  768,  768,  768,  769,  929, 2846,
      773, 2847,  534, 2893,  977, 1232, 1232, 1232, 1232, 1232,

     1232, 1442, 2858,  191, 1419,  977, 1398, 1445, 1398,  191,
     1307,  929,  595, 2847, 1382,  534, 2893,  977, 1232, 1232,
     1232, 1232, 1232, 1232, 1008, 2859, 2856,  978,  975, 1229,
     1229, 1229, 1229, 1229, 1229, 1233, 1233, 1233, 1233, 1233,
     1233, 1018, 1372,  931,  931,  931,  931,  931,  931, 1231,
     1231, 1231, 1231, 1231, 1231,  977, 1236, 1237, 1238, 1238,
     1238, 1238,  929, 2858, 1018,  579, 2872, 2893,  977, 1239,
     1239, 1239, 1239, 1239, 1239, 2872, 2892, 1371,  903,  977,
     1019,  191,  191, 1311, 1311,  929, 2859, 1311,  579, 2873,
     2893,  977, 1240, 1241, 1242, 1243, 1244, 1244, 2873, 1311,

     2847,  978,  980,  981, 1307,  981,  981,  981,  981,  981,
      981,  981,  981,  981,  981,  982,  983,  981,  984,  984,
      984,  984,  984,  984,  981,  981,  981,  981,  981,  985,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  980,  981,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  986,  986,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  987,  987,  987,  987,  987,  987,  991,
      819, 1292, 1291, 1290,  465, 1245, 1246, 1246, 1246, 1246,

     1246, 1289,  819, 1288,  992,  992,  992,  992,  992,  992,
      993, 1247, 1247, 1247, 1246, 1246, 1246, 1248, 1248, 1248,
     2892,  819, 1287,  836, 1249, 1250, 1251, 1251, 1251, 1251,
     1286,  819,  471, 1247, 1247, 1247, 1248, 1248, 1248, 1248,
     1248, 1248, 1285, 1284, 2847, 1281,  836, 1252, 1253, 1254,
     1254, 1254, 1254, 1280,  352,  471, 1255, 1255, 1255, 1255,
     1255, 1255,  837,  472,  871,  891,  350,  873,  873,  873,
      874,  873,  873,  873,  873,  873,  875,  876,  877,  878,
      897,  898,  899,  900,  897,  897,  883,  873,  873,  873,
      873,  884,  885,  885,  885,  885,  885,  885,  885,  886,

      885,  885,  885,  885,  885,  885,  885,  892,  885,  885,
      885,  885,  885,  885,  871,  873,  885,  885,  885,  885,
      885,  885,  886,  885,  885,  885,  885,  885,  885,  885,
      892,  885,  885,  885,  885,  888,  888,  888,  889,  890,
      888,  888,  888,  888,  888,  871,  871,  871,  871,  871,
      871,  513,  514, 1182,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  513,  513,  514,  513,  513,  513,
      513,  513,  513,  514,  514,  514,  514,  514,  517,  587,
      587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
      587,  587,  587,  587,  587,  587,  587,  587,  587,  587,

      587,  513,  514,  587,  587,  587,  587,  587,  587,  587,
      587,  587,  587,  587,  587,  587,  587,  587,  587,  587,
      587,  587,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  254,  255,
     1181,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  256,  254,  255,  257,  257,  257,  257,  257,  257,
      255,  255,  255,  255,  255,  258,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  254,  255,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,

      259,  259,  259,  259,  259,  259,  259,  259,  259,  254,
      254,  254,  254,  254,  254,  254,  254,  254,  254,  262,
      262,  262,  262,  262,  262,  190, 1247, 1247, 1247, 1248,
     1248, 1245, 1245, 1245, 1245, 1181, 1181, 1181,  250,  190,
     1174,  251,  251,  251,  251,  251,  251, 1173, 1172, 1171,
     1168, 1167,  191,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  190, 1166,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252, 1011,
      252,  252,  252,  252,  252,  252,  190,  190,  190,  190,

      190,  190,  190,  190,  190,  190,  253,  253,  253,  253,
      253,  253,  520, 1165, 1162,  520,  520,  520,  520,  520,
      520, 1247, 1247, 1247, 1245, 1245, 1245, 1245, 1245, 1245,
     1256, 1257, 1258, 1259, 1260, 1260, 1261, 1262, 1262, 1262,
     1262, 1262, 1161, 1160, 1159, 1263, 1263, 1263, 1148,  678,
     1125, 1098, 1089, 1263, 1263, 1263, 1053, 1010,  988, 1263,
     1263, 1263, 1265, 1266, 1267, 1267, 1267, 1267,  950,  941,
      593,  593,  593,  593,  593,  593,  593,  593,  593,  593,
      520,  520,  520,  520,  520,  520, 1022,  941, 1023, 1023,
     1023, 1024, 1023, 1023, 1023, 1023, 1023, 1023,  941, 1363,

     1023, 1268, 1268, 1268, 1268, 1268, 1268, 1023, 1023, 1023,
     1023, 1023, 1025, 1262, 1262, 1262, 1264, 1264, 1264,  941,
     1026, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1261,
     1261, 1261, 1261,  191,  191,  922, 1023,  565, 1270, 1263,
     1263, 1263, 2893, 1026, 1269, 1269, 1269, 1269, 1269, 1269,
     1270, 1272,  903, 1271, 1271, 1271, 1271, 1271, 1271, 1027,
      565,  824,  823, 1272,  822, 2893,  606,  606,  606,  606,
      606,  606, 1022,  821, 1023, 1023, 1023, 1024, 1023, 1023,
     1023, 1023, 1023, 1023, 1274,  820, 1023,  819,  818,  422,
      817,  816,  805, 1023, 1023, 1023, 1023, 1023, 1025,  800,

      800,  800,  800,  800,  800,  815, 1026, 1261, 1261, 1261,
     1261, 1261, 1261, 1276, 1276, 1276, 1276, 1276, 1276, 1277,
      814,  813, 1023,  802,  427, 1534, 1534, 1535,  812, 1026,
      811, 1273, 1273, 1273, 1273, 1273, 1273,  442,  803,  803,
      803,  803,  803,  803,  810, 1027, 1278, 1278, 1278, 1278,
     1278, 1278,  606,  606,  606,  606,  606,  606, 1037,  809,
      442,  191,  808,  595,  401,  421,  337,  697,  696,  684,
      422,  596,  806,  806,  806,  806,  806,  806,  423,  597,
     1275, 1275, 1275, 1275, 1275, 1275,  425,  673,  672,  667,
      658,  191, 1018, 1293,  606,  606,  606,  606,  606,  804,

      804,  804,  804,  804,  804, 1294,  831, 1294, 1295, 1295,
     1295, 1295, 1295, 1295, 1301, 1018, 1783, 1783, 1783, 1783,
     1783, 1302, 1302, 1302, 1302, 1302, 1302,  591,  590,  263,
      589, 1019,  472,  259,  191,  585,  825,  563, 1038, 1039,
     1039, 1039, 1039, 1040,  190,  826,  191,  193,  192,  191,
      457, 1296, 1296, 1296, 1296, 1296, 1296,  190,  190,  454,
      190,  190,  190,  190,  190,  190,  449,  448,  447,  444,
      443,  191,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  190,  440,  475,  475,  475,  475,

      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  476,  476,  476,  476,  476,
      476,  476,  476,  476,  476, 1041, 1042, 1043, 1043, 1043,
     1043,  513,  514,  439,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  515,  513,  514,  516,  516,  516,
      516,  516,  516,  514,  514,  514,  514,  514,  517,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475, 1051,  475, 1052,  475,  475,  475,  475,  475,  475,
      475,  513,  514,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475, 1051,  475, 1052,  475,  475,  475,

      475,  475,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  518,  518,  518,  518,  518,  518, 1054, 1055,
      438, 1056, 1056, 1056, 1057, 1056, 1056, 1056, 1056, 1056,
     1058, 1059, 1060, 1061, 1054, 1054, 1054, 1054, 1054, 1054,
     1062, 1056, 1056, 1056, 1056, 1063, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1065, 1064, 1064, 1064, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1054, 1056,
     1064, 1064, 1064, 1064, 1064, 1064, 1065, 1064, 1064, 1064,
     1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1066,
     1066, 1066, 1067, 1068, 1066, 1066, 1066, 1066, 1066, 1069,

     1069, 1069, 1069, 1069, 1069,  630,  401,  337, 1314, 2274,
      595,  268,  426,  465,  465, 1312, 1708,  427,  631, 1313,
     1313, 1313, 1313, 1313, 1313,  428,  632, 1297,  267,  191,
      191,  193,  633,  429,  192,  191, 2893,  189,  189, 1298,
      828, 1298,  836, 1301, 2893,  633, 2893,  565, 2893,  829,
     1302, 1302, 1302, 1302, 1302, 1302,  633,  245, 2893,  215,
     1303, 2893, 2893,  833, 2273,  836, 2893, 2893,  633,  465,
      565, 1303, 1319, 1319, 1319, 1319, 1319, 1319,  634,  472,
      245,  837,  215,  472, 2893,  598,  599,  599,  599,  599,
      600, 1102, 1279, 1279, 1279, 1279, 1279, 1279, 2893, 2893,

     2893, 2893, 2893, 1106, 1106, 1107,  534, 1299, 1299, 1299,
     1299, 1299, 1299, 2893, 2893, 2893, 2893, 2893, 1103, 2893,
     1300, 1300, 1300, 1300, 1300, 1300, 2893, 2893, 2893,  534,
     2893, 1103, 1304, 1304, 1304, 1304, 1304, 1304,  472, 2893,
     2893, 2893, 1103, 1304, 1304, 1304, 1304, 1304, 1304, 2893,
      927, 2893, 2893, 2893, 1103, 1328, 1329, 1329, 1329, 1329,
     1329, 2893, 2893,  927, 1104, 1308, 1308, 1308, 1308, 1308,
     1308,  646,  646,  646, 1108, 1108, 1108, 1102, 1308, 1308,
     1308, 1308, 1308, 1308,  929, 2893, 2893, 2893, 2893, 1106,
     1106, 1107, 2893, 2893, 2893,  927, 2893,  929, 1322, 1323,

     1323, 1323, 1323, 1323, 1103, 2893, 2893,  929, 2893,  191,
     1309, 1309, 1309, 1309, 1309, 1309, 2893, 1103, 2893, 2893,
      929, 2893, 2893,  930, 2893, 2893, 2893, 2893, 1103,  929,
     1333, 1333, 1333, 1333, 1333, 1333,  930, 2893, 2893, 2893,
     1103, 1324, 1324, 1325, 1323, 1323, 1323, 1322, 1322, 1322,
     1104, 2274,  929, 2893,  835,  191,  465, 1108, 1108, 1108,
     1108, 1108, 1108, 1102,  835, 2893, 2893, 2893,  930, 1320,
     1320, 1320, 1320, 1320, 1320, 1106, 1106, 1107, 2893, 1320,
     1320, 1320, 1320, 1320, 1320, 2893, 2893, 2893,  836,  565,
     1103, 1335, 1335, 1335, 1335, 1335, 1335, 2893,  836, 2893,

      835, 2893,  191, 1103, 1336, 1336, 1336, 1336, 1336, 1336,
     2893,  836,  565,  997, 1103, 1321, 1321, 1321, 1321, 1321,
     1321,  836, 2893, 2893, 2893,  472, 1103,  837,  998,  998,
      998,  998,  998,  998,  836, 2893, 1104,  837, 2893, 2893,
     2893, 2893, 2893, 1108, 1108, 1105, 1105, 1105, 1105, 1102,
     1334, 1334, 1334, 1334, 1334, 1334, 2893,  836, 2893, 2893,
     2893, 1106, 1106, 1107, 1324, 1324, 1325, 1322, 1322, 1322,
     1322, 1322, 1322,  837, 2893, 2893, 1103, 2893,  191, 1326,
     1326, 1327,  854,  854,  854,  854,  854,  854, 2893, 1103,
     1330, 1330, 1330, 1329, 1329, 1329, 1328, 1328, 1328, 2893,

     1103, 1330, 1330, 1330, 1328, 1328, 1328, 1328, 1328, 1328,
     1368, 2893, 1103, 2893, 2893,  190,  190,  190,  190,  190,
      190, 1367, 1104, 1328, 1379, 1379, 1379, 1379, 1379, 1105,
     1105, 1105, 1105, 1105, 1105, 1102, 1400, 1400, 1400, 1400,
     1400, 1400, 2893, 2893, 1350, 2893, 2893, 1106, 1106, 1107,
     2893, 1361, 2893, 1350, 2893, 1350, 2893, 2893, 2893, 1359,
     2893, 2893, 1103, 2893, 1350, 2893, 2893, 1350, 1322, 1373,
     1373, 1373, 1373, 1373, 1361, 1103, 1350, 2893, 1350,  191,
     2893, 2893, 1359, 1353, 2893,  932, 1103, 1350,  513,  513,
      513,  513,  513,  513, 1353, 2893, 2893, 2893, 1103, 1374,

     1374, 1375, 1373, 1373, 1373, 1376, 1376, 1376, 1104, 2893,
     2893, 2893, 2893,  191, 1004, 1028, 1028, 1028, 1028, 1028,
     1028, 1112, 1374, 1374, 1375, 1376, 1376, 1376, 1376, 1376,
     1376, 2893, 2893, 2893, 2893, 2893,  191, 1374, 1374, 1375,
     1376, 1376, 1322, 1322, 1322, 1322, 2893, 2893, 1113, 2274,
     2893,  191,  565, 2893,  465, 1033, 2893, 2893, 2893, 2893,
     2893, 1113, 1374, 1374, 1375, 1322, 1322, 1322, 1322, 1322,
     1322, 2893, 1113,  954, 2893,  565,  191, 2893, 1033, 2893,
     2893, 2893, 2893, 2893, 1113, 2893, 2893,  565,  955,  916,
      916,  916,  916,  916, 1114, 1460, 1460, 1461, 2893, 1707,

      956, 1115, 1115, 1115, 1115, 1115, 1115, 1112, 2893, 2893,
      565, 2893, 2893,  956, 1380, 1380, 1380, 1379, 1379, 1379,
     1381, 1381, 1381,  472,  956, 1380, 1380, 1380, 1381, 1381,
     1381, 1381, 1381, 1381, 1113,  932,  956,  237, 2893, 2893,
     2893, 1033,  215, 2893, 2893, 2893,  957, 1113, 1380, 1380,
     1380, 1381, 1381, 1328, 1328, 1328, 1328, 2893, 1113, 2893,
      237, 2893, 2893, 1047, 1033,  215,  606,  606,  606, 2893,
     1113, 1380, 1380, 1380, 1328, 1328, 1328, 1328, 1328, 1328,
     1114, 1400, 1400, 1400, 1400, 1400, 1400, 1115, 1115, 1115,
     1115, 1115, 1115, 1112,  927, 1400, 1400, 1400, 1400, 1400,

     1400, 1383, 2893,  513,  513,  513,  513,  513,  513, 1384,
     1384, 1384, 1384, 1384, 1384, 1385, 2893, 2893, 2893, 2893,
     1113, 2893, 2893, 2893, 2893, 2893, 1383, 1033,  929, 2893,
     2893, 2893, 2893, 1113, 1384, 1384, 1384, 1384, 1384, 1384,
     1385, 2893, 2893, 2893, 1113, 2893, 2893, 2893, 2893, 2893,
     1033,  929, 2893, 2893, 2893, 2893, 1113, 1399, 1399, 1399,
     1399, 1399, 1399, 2893, 2893, 2893, 1114,  930,  191, 2893,
     2893, 2893, 2893, 1036, 1036, 1036, 1036, 1036, 1036, 1117,
     1118, 2893, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
     1118, 1118, 1119, 1120, 1118, 1121, 1121, 1121, 1121, 1121,

     1121, 1118, 1118, 1118, 1118, 1118, 1122, 1123, 1123, 1123,
     1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123,
     1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1117,
     1118, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123,
     1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123, 1123,
     1117, 1117, 1117, 1117, 1117, 1117, 1117, 1117, 1117, 1117,
     1124, 1124, 1124, 1124, 1124, 1124, 1318, 2893,  849,  849,
      849,  850,  849,  849,  849,  849,  849,  849, 2893, 2893,
      849,  854,  854,  854,  854,  854,  854,  849,  849,  849,
      849,  849,  851, 2893, 2893,  191, 1399, 1399, 1399, 1399,

     1399, 1399, 2893, 2893, 2893, 2893, 2893,  191, 1322, 1410,
     1410, 1410, 1410, 1410, 2893, 2893,  849,  857, 2893,  191,
     2893, 2893,  465, 1328, 1415, 1415, 1415, 1415, 1415, 2893,
      466, 2893,  858,  859,  859,  859,  859,  860,  470,  476,
      476,  476,  476,  476,  476,  476,  476,  476,  476, 2893,
      932,  836,  932,  513,  513,  513,  513,  513,  513, 2893,
      471,  962,  962,  962, 1319, 1319, 1319, 1319, 1319, 1319,
     2893, 2893, 2893, 2893,  836, 1321, 1321, 1321, 1321, 1321,
     1321, 2893, 2893,  471,  931,  931,  931,  931,  931,  931,
      837,  472,  848, 2893,  849,  849,  849,  850,  849,  849,

      849,  849,  849,  849, 1393, 2893,  849,  480,  867,  867,
      867,  867,  867,  849,  849,  849,  849,  849,  851, 2893,
      513,  513,  513,  513,  513,  513,  852, 1437, 1437, 2893,
     2893, 1394, 1437, 2893, 2893,  190, 1437, 2893,  836, 2893,
     2893, 2893,  849, 1437, 1394, 1437, 2893, 1437,  191,  852,
     2893, 1706, 2893, 2893, 2275, 1394, 2893, 2893, 1364,  465,
     2893,  836, 1393, 1403, 1501,  853, 1331, 1394,  465, 2273,
     2893,  465, 2893, 2893,  465, 2893, 2893, 1395, 2893, 2893,
     2893, 1332, 1332, 1332, 1332, 1332, 1332,  993, 2893, 1394,
     1394, 1502, 2893,  229,  215,  579,  836,  836, 1018,  579,

      836, 2893, 1394, 1394, 1502, 2893, 2893, 2893, 2893,  471,
     2893,  534, 2893, 1394, 1394, 1502,  229,  215,  579,  836,
      836, 1018,  579,  836, 2893, 1394, 1394, 1502,  472, 2893,
     2893, 2893,  471, 2893,  534, 1395, 1395, 1503, 2893,  837,
      472, 1337, 1338,  472, 1339, 1339, 1339, 1340, 1339, 1339,
     1339, 1339, 1339, 1339, 1341, 1342, 1343, 1344, 1345, 1346,
     1347, 1344, 1344, 1348, 1339, 1339, 1339, 1339, 1349, 1350,
     1350, 1350, 1350, 1350, 1350, 1350, 1351, 1350, 1350, 1350,
     1350, 1350, 1350, 1350, 1350, 1352, 1350, 1350, 1350, 1350,
     1350, 1337, 1339, 1350, 1350, 1350, 1350, 1350, 1350, 1351,

     1350, 1350, 1350, 1350, 1350, 1350, 1350, 1350, 1352, 1350,
     1350, 1350, 1353, 1353, 1353, 1354, 1355, 1353, 1353, 1353,
     1353, 1353, 1337, 1337, 1337, 1337, 1337, 1337,  513,  514,
     2893,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  515,  513,  514,  516,  516,  516,  516,  516,  516,
      514,  514,  514,  514,  514,  517,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  513,  514,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  513,

      513,  513,  513,  513,  513,  513,  513,  513,  513,  518,
      518,  518,  518,  518,  518,  904, 2893, 2893, 2893, 2893,
      465, 2893, 2893, 2893,  964, 2893, 1362, 2893,  531, 2893,
      858,  859,  859,  859,  859,  860,  532,  466, 2893, 2893,
     2893, 2893,  533,  997, 2893,  470, 2893, 2893, 2893,  836,
     2893, 2893, 2893, 2893, 2893,  533, 2038,  534, 1430, 1430,
     1430, 1430, 1430, 1430, 2893, 2893,  533, 2893,  534, 2893,
      191, 2893,  836, 2893, 2893, 2893, 2893, 2038,  533, 2893,
      534, 1450, 1450, 1450, 1450, 1450, 1450, 2893,  905,  472,
      954,  534, 2893, 2893, 2042, 1363,  954,  837, 2039, 2034,

     2893, 2040, 1377, 1377, 1378,  916,  916,  916,  960,  960,
      960,  854,  854,  854,  854,  854,  854,  956, 2893, 2039,
     2034, 2039, 2034,  956, 1456, 1457, 1457, 1457, 1457, 1457,
      956, 2893, 2893,  565, 2893, 2043,  956, 2034, 2893, 2041,
     2893,  956, 2039, 2034, 2034, 2893, 2893,  956, 2893, 2893,
     2893, 1443, 2893,  956, 2893,  997,  565, 2893, 2043,  956,
     2034, 2893, 2041,  957,  954, 2893, 2893, 2034, 2893,  957,
     1430, 1430, 1430, 1430, 1430, 1430, 1377, 1377, 1378,  960,
      960,  960,  960,  960,  960, 1462, 1463, 1463, 1463, 1463,
     1463,  956, 1409, 1409, 1409, 1319, 1319, 1319, 1319, 1319,

     1319, 2893, 2893, 2893,  956, 1411, 1411, 1412, 1410, 1410,
     1410, 1322, 1322, 1322, 2893,  956, 2893, 2893, 2893,  191,
     1444, 1444, 1444, 1444, 1444, 1444, 2893,  956, 1411, 1411,
     1412, 1322, 1322, 1322, 1322, 1322, 1322,  957,  954, 2893,
     2893, 2893,  191, 1470, 1470, 1470, 1470, 1470, 1470, 2893,
     1377, 1377, 1378,  960,  960,  955,  955,  955,  955, 1473,
     1473, 1473, 1473, 1473, 1473,  956, 1413, 1413, 1414,  971,
      971,  971,  480,  480,  480, 1460, 1460, 1461,  956, 1413,
     1413, 1414,  854,  854,  854,  854,  854,  854, 2893,  956,
     1416, 1416, 1416, 1415, 1415, 1415, 1328, 1328, 1328, 1318,

     2893,  956, 1416, 1416, 1416, 1328, 1328, 1328, 1328, 1328,
     1328,  957,  954, 2893,  854,  996,  996,  996,  996,  996,
     2893, 2893, 2893, 2893, 1377, 1377, 1378,  955,  955,  955,
      955,  955,  955,  847, 2893, 2893, 2893, 2893, 2893,  956,
     2893, 2893, 2893, 1028, 1028, 1028, 1028, 1028, 1028, 1433,
     2893, 2893,  956, 2893,  465, 2893,  847, 1462, 1497, 1497,
     1497, 1497, 1497,  956, 1332, 1332, 1332, 1332, 1332, 1332,
      993, 2893,  847, 2893, 2893,  956, 2893, 1318, 1508, 1508,
     1508, 1508, 1508, 1508,  191,  957,  954,  565, 2893, 1413,
     1413, 1414,  996,  996,  996,  854,  854,  854, 1377, 1377,

     1378,  854,  854,  854,  854,  854,  854, 1451, 2893, 2893,
      565,  847, 1431,  956, 2893, 2275, 2893,  465, 2893, 2893,
      465, 1452, 2893,  472, 2893, 2893,  956, 1332, 1332, 1332,
     1332, 1332, 1332,  993,  847, 2893, 2893,  956, 1472, 1472,
     1472, 1472, 1472, 1472, 2893, 2893, 2893, 2893, 2893,  956,
      847, 2893, 2893, 2893, 2893,  471,  579, 2893, 2893,  957,
      190,  190,  190,  190,  190,  190,  190,  190,  190,  190,
      190,  190,  190,  190,  190,  190,  513, 2893,  471,  579,
     1453, 1453, 1453, 1453, 1453, 1453,  472, 2893, 2893,  472,
     2893,  513,  513,  513,  513,  513,  513,  513,  513,  513,

      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513, 2893, 2893,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513, 1386, 1387, 2893, 1387, 1387, 1387,
     1387, 1387, 1387, 1387, 1387, 1387, 1387, 1388, 1386, 1387,
     1389, 1389, 1389, 1389, 1389, 1389, 1387, 1387, 1387, 1387,
     1387, 1390, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1387, 1386, 1386, 1386, 1386,
     1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,

     1386, 1386, 1386, 1386, 1386, 1391, 1391, 1391, 1391, 1391,
     1391, 1391, 1391, 1391, 1391, 1392, 1392, 1392, 1392, 1392,
     1392, 1393, 1508, 1508, 1508, 1508, 1508, 1508, 1508, 1508,
     1508, 1508, 1508, 1508, 2893, 2893,  944,  944,  944,  944,
      944,  944, 1462, 1536, 1536, 1536, 1536, 1536, 1394, 2893,
     2893, 1318, 2893, 2268, 2893,  836, 2893, 2893,  465, 1032,
     2893, 1394, 2893, 1413, 1413, 1414,  854,  854,  854,  854,
      854,  854, 1394, 2893, 2893, 2893, 2893, 2893,  836, 2893,
     2893, 2893, 2893, 1432, 1394,  847, 2893, 2893,  465, 2893,
     2040, 2893, 1445, 1033, 1395,  975,  471,  595, 1332, 1332,

     1332, 1332, 1332, 1332,  993, 2893, 2893, 2893,  847, 2893,
     1396, 1396, 1396, 1396, 1396, 1396, 1033, 2893, 2273,  471,
     2893, 2893,  977,  465,  847,  534, 1018,  472, 2041,  929,
     2893, 2893, 1034, 2034, 2893,  977, 2893, 2893, 2893, 1438,
     1438, 1438, 1438, 1438, 1438, 2893,  977, 2893,  534, 1018,
     2893, 2041,  929, 2893, 1142, 2040, 2034,  472,  977, 1434,
      534, 2042, 2893, 2893,  465, 1019, 2893, 1511,  978,  975,
     2893, 2893,  595, 2893, 1332, 1332, 1332, 1332, 1332, 1332,
      993, 2893, 2893,  534, 1396, 1396, 1396, 1396, 1396, 1396,
     2893, 2893,  472, 2041, 1502, 1318,  977, 2893, 2034, 2893,

      579, 1018, 2043,  929, 2034, 2893, 2893, 1502, 2893,  977,
      854, 1007, 1007, 1007, 1007, 1007, 2041,  191, 1502, 2893,
      977, 2034, 2893,  579, 1018, 2043,  929, 2034, 2893,  847,
     1502, 2893,  977,  472, 1143, 1143, 1143, 1143, 1143, 1143,
     1503, 2893,  978,  975,  251,  251,  251,  251,  251,  251,
     2876, 2877,  847, 2893, 2878,  191, 2893, 2879, 1309, 1309,
     1309, 1309, 1309, 1309, 2880, 2893, 2893, 2881,  847, 2893,
      977, 1456, 1491, 1491, 1491, 1491, 1491,  929, 2893, 2893,
     2893, 2893, 2893,  977,  270,  270,  270,  270,  270,  270,
     2893, 2893, 2893, 2893,  977,  191, 2268, 2893, 2038, 2893,

      929,  465, 2893, 2893, 2893, 2893,  977, 2893, 1318,  253,
      253,  253,  253,  253,  253,  932,  978,  954, 2893, 2893,
     1326, 1326, 1327, 1007, 1007, 1007,  854,  854,  854, 1407,
     1407, 1408,  854,  854,  854,  854,  854,  854, 2893,  471,
     2039, 2034,  847, 2893,  956,  191, 2893, 2893, 2893,  272,
      272,  272,  272,  272,  272, 2275, 2893,  956, 2893, 1318,
      465, 2893,  471, 2039, 2034,  847, 2893, 2893,  956, 2893,
      472, 1326, 1326, 1327,  854,  854,  854,  854,  854,  854,
      956,  847,  191,  513,  513,  513,  513,  513,  513, 2893,
      957,  975, 2893,  847, 2893, 2893,  579, 2893, 1383, 1507,

     1507, 1507, 1507, 1507, 1507, 2893, 1384, 1384, 1384, 1384,
     1384, 1384, 1385, 2893, 2893, 2893,  847, 2893,  977,  579,
     2893, 2893, 2893, 1032, 2893,  929, 2893, 2893, 2893,  472,
     2893,  977,  847, 2893, 2893, 2893, 1507, 1507, 1507, 1507,
     1507, 1507,  977, 2737, 2738, 2893, 2739, 2893,  929, 2740,
     2741, 2742, 2743, 2744,  977,  932, 2745, 1033,  513,  513,
      513,  513,  513,  513,  978, 1397, 2893, 1397, 1397, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1397, 1032, 1421, 1397,
     1033, 2893, 2893, 1458, 1458, 1459, 1397, 1397, 1397, 1397,
     1397, 1422, 2893, 2893, 2893, 2893, 1034,  191, 2893, 2893,

     2893, 2893, 2893, 1438, 1438, 1438, 1438, 1438, 1438, 2893,
     2893, 1033, 2893, 2893, 2893, 1397, 1397, 2893, 1397, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 2893, 2893,
     1397, 2893, 2893, 2893, 1033, 2893, 2893, 1397, 1397, 1397,
     1397, 1397, 1422, 1455, 1455, 1455, 1455, 1455, 1455, 2893,
     1034, 1457, 1457, 1457, 1456, 1456, 1456, 1439, 1439, 1439,
     1439, 1439, 1439, 2893, 2893, 2893, 1397, 1423, 1424, 2893,
     1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424, 1424,
     1425, 1423, 1424, 1426, 1426, 1426, 1426, 1426, 1426, 1424,
     1424, 1424, 1424, 1424, 1427, 1423, 1423, 1423, 1423, 1423,

     1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423,
     1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1424, 1423,
     1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423,
     1423, 1423, 1423, 1423, 1423, 1423, 1423, 1423, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1428, 1428, 1428, 1429, 1429,
     1429, 1429, 1429, 1429,  991, 2893, 2893, 2893, 1501,  465,
     1036, 1036, 1036, 1036, 1036, 1036, 2893, 2893, 2893,  992,
      992,  992,  992,  992,  992,  993, 1572, 1572, 1572, 1572,
     1572, 1572, 2893, 2893, 2893, 1502, 2893, 2893,  836, 2893,
     2893, 2893, 1018, 2893, 2893, 1570, 2893,  471, 1502, 1571,

     1571, 1571, 1571, 1571, 1571, 2893, 2893, 2893, 2893, 1502,
     2893,  836, 2893, 2893, 2893, 1018, 2893, 2893, 2893, 2893,
      471, 1502, 2893, 2893, 2893, 2893, 2893,  837,  472,  254,
      255, 1503,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  256,  254,  255,  257,  257,  257,  257,  257,
      257,  255,  255,  255,  255,  255,  258,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  254,
      255,  259,  259,  259,  259,  259,  259,  259,  259,  259,
      259,  259,  259,  259,  259,  259,  259,  259,  259,  259,

      254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
      262,  262,  262,  262,  262,  262,  190, 1575, 1575, 1575,
     1575, 1575, 1575, 1578, 1578, 1578, 1578, 1578, 1578,  250,
      190, 2893,  251,  251,  251,  251,  251,  251, 1435, 2893,
     2893, 2893, 2893,  191,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  190, 2893,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  190,  190,  190,
      190,  190,  190,  190,  190,  190,  190,  253,  253,  253,

      253,  253,  253, 1449,  191, 1023, 1023, 1023, 1024, 1023,
     1023, 1023, 1023, 1023, 1023, 2893, 1032, 1023, 2893, 2893,
     2893, 2893, 2893, 1451, 1023, 1023, 1023, 1023, 1023, 1025,
     2893, 2893, 2893, 2893, 1576, 2893, 1017, 1452, 1577, 1577,
     1577, 1577, 1577, 1577, 1188, 1188, 1188, 1188, 1188, 1188,
     1033, 2893, 2893, 1023, 2893, 2893, 2893, 1017, 1456, 1531,
     1531, 1531, 1531, 1531, 1581, 1581, 1581, 1581, 1581, 1581,
     1018, 1017, 2893, 1033, 1191, 1191, 1191, 1191, 1191, 1191,
     2893, 2893, 2893, 1028, 1028, 1028, 1028, 1028, 1028, 1034,
     2893, 1018, 2038, 1018, 2893, 2893, 1453, 1453, 1453, 1453,

     1453, 1453, 1037, 2893, 2893, 1018, 2893,  595, 2893, 1019,
     2893, 2893, 2893, 2893, 1018,  596, 1454, 1454, 1454, 1454,
     1454, 1454, 2893,  597, 1464, 1464, 1464, 2893, 1018, 2893,
     1019, 1458, 1458, 1459, 2039, 2034, 1018, 1454, 1454, 1454,
     1454, 1454, 1454, 2893, 1019,  191, 2893, 2893, 2893, 2893,
     2893, 1455, 1455, 1455, 1455, 1455, 1455, 2039, 2034, 1018,
     2893, 2893, 2893, 2893, 1464, 1464, 1464, 1582, 1582, 1582,
     1582, 1582, 1582, 2893, 2893, 1019,  472, 1492, 1492, 1493,
     2893, 2893, 1038, 1039, 1039, 1039, 1039, 1040, 1498, 1498,
     1498,  191, 1463, 1463, 1463, 1462, 1462, 1462, 1573, 1456,

     1456, 1456, 1456, 1456, 1456, 1022, 2893, 1023, 1023, 1023,
     1024, 1023, 1023, 1023, 1023, 1023, 1023, 2893, 2893, 1023,
     1583, 1583, 1583, 1583, 1583, 1583, 1023, 1023, 1023, 1023,
     1023, 1025, 1462, 1462, 1462, 1462, 1462, 1462, 2893, 1026,
     2893, 2893, 2893, 2893, 2893, 1491, 1491, 1491, 1494, 1494,
     1494, 2893, 2893, 2893, 2893, 1023, 1497, 1497, 1497, 1499,
     1499, 1499, 1026, 2893, 2893, 2893, 2893, 1574, 1574, 1574,
     1574, 1574, 1574, 2893, 2893, 1584, 2893, 2893, 1027, 1585,
     1585, 1585, 1585, 1585, 1585,  606, 1047, 1047, 1047, 1047,
     1047,  520,  521, 2893,  521,  521,  521,  521,  521,  521,

      521,  521,  521,  521,  522,  520,  521,  523,  523,  523,
      523,  523,  523,  521,  521,  521,  521,  521,  524,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  521,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  476,  476,  476,  476,  476,  476,  476, 1467,
      476,  476,  525,  525,  525,  525,  525,  525, 1468, 2893,
     1071, 2893, 2893,  595, 1586, 1586, 1586, 1586, 1586, 1586,
     2825, 2893, 2893,  631, 2893, 2893, 2893, 2893, 2893, 1137,

     2893,  632, 1492, 1492, 1493, 2893, 2893,  633, 2893, 2893,
     2893, 2893, 1018, 2893, 2893, 2893,  191, 2893, 2893, 2893,
      633, 1587, 1587, 1587, 1587, 1587, 1587, 2893, 2893, 2893,
     2893,  633,  229,  215,  356, 1018, 1197, 1197, 1197, 1197,
     1197, 1197, 2893,  633, 1590, 1590, 1590, 1590, 1590, 1590,
     2893, 1019,  472, 1072, 2893,  229,  215, 2893, 1469, 1469,
     1469, 1469, 1469, 1469,  190, 2893, 2893, 2893, 2893, 2893,
     1494, 1494, 1494, 1494, 1494, 1494, 2893,  190,  190, 2893,
      190,  190,  190,  190,  190,  190, 2893, 2893, 2893, 2893,
     2893,  191,  475,  475,  475,  475,  475,  475,  475,  475,

      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  190, 2893,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  476,  476,  476,  476,  476,
      476,  476,  476,  476,  476, 1471, 1471, 1471, 1471, 1471,
     1471, 1474, 1475, 2893, 1476, 1476, 1476, 1477, 1476, 1476,
     1476, 1476, 1476, 1476, 1478, 1479, 1480, 1474, 1474, 1474,
     1474, 1474, 1474, 1481, 1476, 1476, 1476, 1476, 1482, 1483,
     1483, 1483, 1483, 1483, 1483, 1483, 1484, 1483, 1483, 1483,
     1483, 1483, 1483, 1483, 1483, 1483, 1483, 1483, 1483, 1483,

     1483, 1474, 1476, 1483, 1483, 1483, 1483, 1483, 1483, 1484,
     1483, 1483, 1483, 1483, 1483, 1483, 1483, 1483, 1483, 1483,
     1483, 1483, 1485, 1485, 1485, 1486, 1487, 1485, 1485, 1485,
     1485, 1485, 1488, 1488, 1488, 1488, 1488, 1488, 1492, 1492,
     1493, 2893, 2893, 2893, 1492, 1492, 1493, 2893, 2893, 2893,
     2893, 2893,  191, 1498, 1498, 1498, 2893, 2893,  191, 2893,
     2893, 2893, 1498, 1498, 1498, 1591, 1591, 1591, 1591, 1591,
     1591, 2893, 1204, 2893, 1498, 1498, 1498, 2893, 1102, 2893,
     2893, 1592, 2893, 2893, 1110, 1110, 1110, 1206, 1206, 1206,
     1206, 1206, 1206, 1606, 1606, 1606, 1606, 1606, 1606, 1517,

     1517, 1517, 2893, 2893, 2893, 1103, 1494, 1494, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1103, 2893,
     2893, 1499, 1499, 1499, 1499, 1499, 1499, 2893, 2893, 1103,
     1499, 1499, 1462, 1462, 1462, 1462, 1579, 2893, 2893, 1102,
     2893, 1103, 1462, 1462, 1462, 1462, 1462, 1462, 1142, 2893,
     2893, 1104, 1450, 1450, 1450, 1450, 1450, 1450, 1105, 1083,
     1083, 1083, 1083, 1083, 1102, 2893, 1103, 1450, 1450, 1450,
     1450, 1450, 1450, 2893, 2893, 2893, 1495, 1495, 1496, 1103,
     2893, 2893, 2893, 1532, 1532, 1533, 2893, 2893, 2893, 2893,
     1103, 1103, 2893, 2893, 2893, 2893, 2893,  191, 1142, 1532,

     1532, 1533, 1103, 2893, 1103, 1580, 1580, 1580, 1580, 1580,
     1580, 2893, 1104,  191, 2893, 1103, 1534, 1534, 1535, 1028,
     1028, 1028, 1028, 1028, 1028, 2893, 2893, 1103, 1538, 1538,
     1538, 1538, 1538, 1538, 1534, 1534, 1535, 1104, 1607, 1607,
     1607, 1607, 1607, 1607, 1083, 1083, 1083, 1108, 1108, 1108,
     1102, 1531, 1531, 1531, 1456, 1456, 1456, 2893, 2893, 2893,
     2893, 2893, 1495, 1495, 1496, 2893, 2893, 1456, 1456, 1456,
     1456, 1456, 1456, 1537, 1537, 1537, 2893, 1103, 1538, 1538,
     1538, 1538, 1538, 1538, 1132, 1132, 1132,  606,  606,  606,
     1103, 2893, 2893, 2893, 2893, 2893, 1537, 1537, 1537,  331,

     2893, 1103, 1028, 1028, 1028, 1028, 1028, 1028, 2893,  321,
     2893, 2893, 2893, 1103, 1177, 1178, 1179, 1180, 1177, 1177,
     1449, 2893, 2893, 1104, 1177, 1178, 1179, 1180, 1177, 1177,
     1108, 1108, 1108, 1108, 1108, 1108, 1102,  332, 2893, 2893,
     2893, 1536, 1536, 1536, 1462, 1462, 1462, 2042, 1495, 1495,
     1496, 2893,  327, 2893, 1021, 2893, 2893, 1136, 2893, 2893,
      332, 2893,  595, 1103, 1462, 1462, 1462, 1462, 1462, 1462,
     2893, 2893, 1449,  328, 2893,  327, 1103, 1021, 1137, 2893,
     2893, 2825, 2893,  328, 1534, 1534, 1535, 1103, 2043, 2893,
     2034, 1018, 2893, 1021, 1449, 2893, 2893, 2893, 2893, 1103,

     1028, 1141, 1141, 1141, 1141, 1141, 1021, 2893, 2893, 1104,
     2893, 2043, 2893, 2034, 1018, 2893, 1108, 1108, 1105, 1105,
     1105, 1105, 1102,  229,  215, 2893, 2893, 1588, 1021, 1021,
     1019,  472, 2893, 2893, 1495, 1495, 1496, 1138, 1138, 1138,
     1138, 1138, 1138, 1539, 2893, 1021,  229,  215,  595, 1103,
     2893, 1021, 1141, 1141, 1141, 1028, 1028, 1028, 1449, 2893,
     2893, 2893, 1103, 2893, 1137, 2893, 2893, 1021, 2893, 2893,
     1534, 1534, 1535, 1103, 1028, 1147, 1147, 1147, 1147, 1147,
     2893, 2893, 2893, 2893, 2893, 1103, 1609, 1609, 1609, 1609,
     1609, 1609, 1021, 2893, 1215, 1104, 1589, 1589, 1589, 1589,

     1589, 1589, 1105, 1105, 1105, 1105, 1105, 1105, 1102, 1607,
     1607, 1607, 1607, 1607, 1607, 1021, 2893,  472, 2893, 2893,
     1495, 1495, 1496, 1469, 1469, 1469, 1469, 1469, 1469, 1604,
     2893, 1021, 2042,  341,  329, 1103, 2893, 2893, 1028, 1028,
     1028, 1028, 1028, 1028, 2893,  333, 2893, 2893, 1103, 1177,
     1178, 1179, 1180, 1177, 1177, 2893, 2893, 2893, 2893, 1103,
     1177, 1178, 1179, 1180, 1177, 1177, 2893, 2893,  359, 2893,
     2893, 1103, 2893, 2043, 2893, 2034,  330, 2893, 1207, 2893,
     2893, 1104, 2893, 2893, 2893, 2893,  334, 1593, 1028, 1028,
     1028, 1028, 1028, 1028, 1501, 2893, 2043, 2893, 2034,  330,

     2827, 1605, 1605, 1605, 1605, 1605, 1605,  328,  328,  334,
     2893, 2893, 1449, 1185, 1185, 1185, 1185, 1185, 1185,  328,
     2893, 1502, 2893, 2893, 1460, 1460, 1461, 2893, 1018, 2893,
     2893, 2893, 2893, 2893, 1502, 1201, 1201, 1201, 1201, 1201,
     1201,  245, 2893,  215, 2893, 1502, 1021, 2893, 2893, 2893,
     2893, 1018, 2893, 2893, 2893, 2893, 2893, 1502, 1209, 1209,
     1209, 1209, 1209, 1209,  245, 2893,  215, 1503, 2893, 1021,
     2893, 2893, 2827, 2893, 1092, 1092, 1092, 1092, 1092, 1092,
     1112, 2893, 2893, 2893, 2893, 1021, 1610, 1610, 1610, 1610,
     1610, 1610, 1147, 1147, 1147, 1028, 1028, 1028, 1449, 2893,

     2893, 2893, 2893, 2893, 1598, 2893, 2893, 1113, 2893, 1594,
     1460, 1460, 1461,  245, 1033,  215, 1599, 2893, 1599, 2893,
     1113, 1595, 2893, 1595, 1596, 1596, 1596, 1596, 1596, 1596,
     1204, 1113, 1021, 2893, 2893, 2893,  245, 1033,  215, 1592,
     2893, 2893, 2893, 1113, 2893, 1597, 1597, 1597, 1597, 1597,
     1597, 2893, 2268, 1114, 2893, 1021, 2893,  465, 2893, 2893,
     1504, 1504, 1504, 1504, 1504, 1504, 1112, 2893, 2893, 2893,
     2893, 1021, 1225, 1225, 1225, 1225, 1225, 1225, 1028, 1028,
     1028, 1028, 1028, 1028, 1600, 1600, 1600, 1600, 1600, 1600,
     1207, 2893, 2893, 1113, 1210,  471, 2893, 2893, 2893, 1593,

     1033, 2893, 1602, 2893, 2893, 2893, 1113, 2893, 2893, 1603,
     1603, 1603, 1603, 1603, 1603, 1219, 2893, 1113,  471, 2893,
     2893,  773, 2893, 1033, 1602, 2893,  472, 2893, 2893, 1113,
     2893, 1603, 1603, 1603, 1603, 1603, 1603, 1212, 2893, 1114,
     2893, 1215, 2893, 2893, 2893, 1604, 1504, 1504, 1504, 1504,
     1504, 1504, 1112, 1216, 2893, 1216, 1608, 1608, 1608, 1608,
     1608, 1608, 2893, 2893, 1219, 2893, 2893,  773, 2893, 2893,
     1601, 1601, 1601, 1601, 1601, 1601, 1220, 2893, 1220, 1113,
     1617, 1617, 1617, 1617, 1617, 1617, 1033, 2893, 2893, 2893,
     2893, 2893, 1113, 2893, 2893, 1610, 1610, 1610, 1610, 1610,

     1610, 2893, 2893, 1113, 2893, 2893, 2893, 2893, 2893, 1033,
     2893, 2893, 2893, 2893, 2893, 1113, 2893, 1605, 1605, 1605,
     1605, 1605, 1605, 2893, 2893, 1114, 1617, 1617, 1617, 1617,
     1617, 1617, 1439, 1439, 1439, 1439, 1439, 1439, 1102, 2893,
     2893, 2893, 2893, 2893, 1611, 1611, 1611, 1611, 1611, 1611,
     1515, 1515, 1516, 1612, 1612, 1612, 1612, 1612, 1612,  751,
     2893, 2893, 2893, 2893, 2893, 1103, 1612, 1612, 1612, 1612,
     1612, 1612,  751, 2893, 2893, 2893, 2893, 2893, 1103, 1229,
     1229, 1229, 1229, 1229, 1229, 2893, 1620, 1620, 2893, 1103,
     2893, 1620, 2893, 2893,  400, 1620, 2893, 2893, 2893, 2893,

     2893, 1103, 1620, 2893, 1620, 2893, 1620,  401, 2893, 2893,
     2893, 1104, 1621, 1621, 1621, 1238, 1238, 1238, 1028, 1028,
     1028, 1028, 1028, 1028, 1112, 1245, 1622, 1622, 1622, 1622,
     1622, 1451, 1623, 1623, 1623, 1622, 1622, 1622, 1248, 1248,
     1248, 2893, 2893, 2893, 2893, 1452, 2893, 2893, 2893, 2893,
     2893, 1113, 1624, 1624, 1624, 1624, 1624, 1624, 1033, 2893,
     2893, 2893, 2893, 2893, 1113, 1623, 1623, 1623, 1248, 1248,
     1248, 1248, 1248, 1248, 2893, 1113, 2893, 2893, 2893, 2893,
     2893, 1033, 2893, 2893, 2893, 2893, 2893, 1113, 1623, 1623,
     1623, 1248, 1248, 1245, 1245, 1245, 1245, 1114, 1625, 1625,

     1625, 1625, 1625, 1625, 1453, 1453, 1453, 1453, 1453, 1453,
     1505, 2893, 1505, 1505, 1505, 1505, 1505, 1505, 1505, 1505,
     1505, 1505, 2893, 1522, 1505, 1627, 1627, 1627, 1251, 1251,
     1251, 1505, 1505, 1505, 1505, 1505, 1523, 1623, 1623, 1623,
     1245, 1245, 1245, 1245, 1245, 1245, 1247, 1247, 1247, 1624,
     1624, 1624, 1624, 1624, 1624, 2893, 2893, 2893, 2893, 2893,
     1505,  513, 1626, 1626, 1626, 1624, 1624, 1624, 1624, 1624,
     1624, 2893, 2893, 2893, 2893, 2893,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513, 2893, 2893,

      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513, 1505,
     2893, 1505, 1505, 1505, 1505, 1505, 1505, 1505, 1505, 1505,
     1505, 2893, 2893, 1505, 1261, 1629, 1629, 1629, 1629, 1629,
     1505, 1505, 1505, 1505, 1505, 1523, 1631, 1631, 1631, 1631,
     1631, 1631, 1632, 1632, 1632, 1632, 1632, 1632, 1271, 1271,
     1271, 1271, 1271, 1271, 2893, 2893, 2893, 2893, 2893, 1505,
     1524, 1525, 2893, 1525, 1525, 1525, 1525, 1525, 1525, 1525,
     1525, 1525, 1525, 1526, 1524, 1525, 1527, 1527, 1527, 1527,
     1527, 1527, 1525, 1525, 1525, 1525, 1525, 1528, 1524, 1524,

     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1525, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529,
     1529, 1530, 1530, 1530, 1530, 1530, 1530, 1630, 1630, 1630,
     2893, 2893, 2893, 1630, 1630, 1630, 2893, 2893, 2893, 1630,
     1630, 1630, 2893, 2893, 2893, 1630, 1630, 1630, 2893, 2893,
     2893, 1263, 1263, 1263, 2893, 2893, 2893, 1633, 1633, 1633,
     1635, 1635, 1635, 1635, 1635, 1635, 1273, 1273, 1273, 1273,

     1273, 1273, 1636, 1636, 1636, 1636, 1636, 1636, 1638, 1638,
     1638, 1638, 1638, 1638, 1639, 1639, 1639, 1639, 1639, 1639,
     2893, 2893, 2893, 1297, 2893, 1629, 1629, 1629, 1264, 1264,
     1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1261,
     1261, 1261, 1261, 1261, 1261, 1261, 1261, 1261, 1261, 1631,
     1631, 1631, 1631, 1631, 1631, 1631, 1631, 1631, 1631, 1631,
     1631,  421,  426, 2893, 2893, 2893,  422,  427, 2893, 1293,
     2893, 2893, 2893, 2893,  423,  428, 1637, 1637, 1637, 1637,
     1637, 1637,  425,  429, 1295, 1295, 1295, 1295, 1295, 1295,
     1295, 1295, 1295, 1295, 1295, 1295, 1651, 1651, 1651, 1651,

     1651, 1651,  825, 1299, 1299, 1299, 1299, 1299, 1299, 1658,
     2893,  826, 2893, 2893, 2893, 2893, 2893, 1652, 1652, 1652,
     1652, 1652, 1652, 1299, 1299, 1299, 1299, 1299, 1299, 1653,
     1653, 1653, 1653, 1653, 1653, 1655, 2893, 2893, 2893,  828,
     2893, 2893, 1640, 1640, 1640, 1640, 1640, 1640,  829, 2893,
     1656, 1656, 1656, 1656, 1656, 1656, 1657, 1657, 1657, 1657,
     1657, 1657, 1660, 1660, 1660, 1660, 1660, 1660,  927, 1384,
     1384, 1384, 1384, 1384, 1384, 1664, 1664, 1664, 1664, 1664,
     1664, 2893, 2893, 1384, 1384, 1384, 1384, 1384, 1384, 1659,
     1659, 1659, 1659, 1659, 1659, 1671, 1671, 1671, 1671, 1671,

     1671, 2893,  929, 1672, 1672, 1672, 1672, 1672, 1672, 2893,
     2893,  835, 1678, 1679, 1679, 1680, 1681, 1681, 2893, 1654,
     1654, 1654, 1654, 1654, 1654,  929, 1672, 1672, 1672, 1672,
     1672, 1672, 1673, 1673, 1673, 1673, 1673, 1673, 2893, 2893,
     2893,  930, 2893,  191, 2893,  836, 1324, 1324, 1325, 1673,
     1673, 1673, 1673, 1673, 1673, 2893, 2893, 2893, 2893, 2893,
      191, 1674, 1675, 1675, 1676, 1677, 1677, 2893,  836, 2893,
     2893, 2893,  191, 2893, 1674, 1675, 1675, 1676, 1677, 1677,
     2893, 2893, 2893, 2893,  837,  191, 1678, 1679, 1679, 1680,
     1681, 1681, 1682, 1682, 1682, 1682, 1682, 1682, 1330, 1330,

     1330, 1682, 1682, 1682, 1682, 1682, 1682, 1678, 1679, 1679,
     1680, 1681, 1681, 1331, 2893, 2893, 2893, 2893,  465, 1683,
     1683, 1683, 1683, 1683, 1683, 2893, 2893, 2893, 1332, 1332,
     1332, 1332, 1332, 1332,  993, 1684, 1684, 1684, 1684, 1684,
     1684, 1685, 1685, 1685, 1685, 1685, 1685,  836, 2893, 2893,
     2893, 2893,  191, 2893, 2893, 2893,  471, 1691, 1691, 1691,
     1691, 1691, 1691, 1005, 1006, 1007, 1007, 1007, 1007, 2893,
      836, 2893, 2893, 2893,  191, 2893, 2893, 2893, 2893,  471,
     1695, 1696, 1697, 1697, 1697, 1697,  837,  472, 1687, 2893,
     1688, 1688, 1688, 1689, 1688, 1688, 1688, 1688, 1688, 1688,

      997, 2893, 1688, 1335, 1335, 1335, 1335, 1335, 1335, 1688,
     1688, 1688, 1688, 1688, 1690,  998,  998,  998,  998,  998,
      998, 1374, 1374, 1375, 1673, 1673, 1673, 1673, 1673, 1673,
     2893, 2893, 2893, 2893, 2893,  191, 2893, 2893, 1688,  190,
     1725, 1726, 1726, 1727, 1728, 1728, 2893, 2893, 2893, 2893,
     2893,  191,  190,  190, 2893, 1692, 1693, 1694, 1694, 1694,
     1694, 2893, 2893, 2893, 2893, 2893,  191,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  190,
     2893,  475,  475,  475,  475,  475,  475,  475,  475,  475,

      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      476,  476,  476,  476,  476,  476,  476,  476,  476,  476,
      190,  190,  190,  190,  190,  190,  199, 1698, 2893,  201,
      201,  201,  202,  201,  201,  201,  201,  201,  201, 1699,
     1700, 1701, 1702, 1703, 1704, 1705, 1702, 1702,  573,  201,
      201,  201,  201,  214,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      216,  215,  215,  215,  215,  215,  199,  201,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  216,  215,  215,  215,  217,  217,  217,

      217,  218,  217,  217,  217,  217,  217,  199,  199,  199,
      199,  199,  199,  520,  521, 2893,  521,  521,  521,  521,
      521,  521,  521,  521,  521,  521,  522,  520,  521,  523,
      523,  523,  523,  523,  523,  521,  521,  521,  521,  521,
      524,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  521,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  476,  476,  476,  476,  476,  476,
      476,  476,  476,  476,  525,  525,  525,  525,  525,  525,

     1431, 2893, 2893, 2040, 2893,  465, 2893, 1432, 2893, 2893,
     2893, 2893,  465, 2893, 2893, 1332, 1332, 1332, 1332, 1332,
     1332,  993, 1332, 1332, 1332, 1332, 1332, 1332,  993, 1729,
     1730, 1730, 1731, 1732, 1732, 1433, 2893, 2893, 2893, 2893,
      465, 2041, 1434,  471, 2893, 2893, 2034,  465, 2893,  534,
     1332, 1332, 1332, 1332, 1332, 1332,  993, 1332, 1332, 1332,
     1332, 1332, 1332,  993, 2041, 2893,  471, 2893, 2893, 2034,
     2893, 2893,  534,  565,  472, 1729, 1730, 1730, 1731, 1732,
     1732,  472, 2893,  579, 1401, 1401, 1402, 1673, 1673, 1673,
     1673, 1673, 1673, 2893, 2893, 2893,  565, 2893,  191, 1725,

     1726, 1726, 1727, 1728, 1728, 2893,  579, 2893, 2893,  472,
      191, 2893, 2893, 2893, 2893, 2893,  472, 1710, 1711, 2893,
     1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711,
     1712, 1710, 1711, 1713, 1713, 1713, 1713, 1713, 1713, 1711,
     1711, 1711, 1711, 1711, 1714, 1715, 1715, 1715, 1715, 1715,
     1715, 1715, 1715, 1715, 1715, 1715, 1715, 1715, 1715, 1715,
     1715, 1715, 1715, 1715, 1715, 1715, 1715, 1710, 1711, 1715,
     1715, 1715, 1715, 1715, 1715, 1715, 1715, 1715, 1715, 1715,
     1715, 1715, 1715, 1715, 1715, 1715, 1715, 1715, 1710, 1710,
     1710, 1710, 1710, 1710, 1710, 1710, 1710, 1710, 1716, 1716,

     1716, 1716, 1716, 1716, 1717, 1718, 2893, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1718, 1718, 1719, 1717, 1718,
     1720, 1720, 1720, 1720, 1720, 1720, 1718, 1718, 1718, 1718,
     1718, 1721, 1717, 1717, 1717, 1717, 1717, 1717, 1717, 1717,
     1717, 1717, 1717, 1717, 1717, 1717, 1717, 1717, 1717, 1717,
     1717, 1717, 1717, 1717, 1717, 1718, 1717, 1717, 1717, 1717,
     1717, 1717, 1717, 1717, 1717, 1717, 1717, 1717, 1717, 1717,
     1717, 1717, 1717, 1717, 1717, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1722, 1722, 1723, 1723, 1723, 1723, 1723,
     1723, 1380, 1380, 1380, 1682, 1682, 1682, 1682, 1682, 1682,

     1729, 1730, 1730, 1731, 1732, 1732, 1409, 1409, 1409, 1682,
     1682, 1682, 1682, 1682, 1682, 1733, 1734, 2893, 1734, 1734,
     1734, 1734, 1734, 1734, 1734, 1734, 1734, 1734, 1735, 1733,
     1734, 1736, 1736, 1736, 1736, 1736, 1736, 1734, 1734, 1734,
     1734, 1734, 1737, 1733, 1733, 1733, 1733, 1733, 1733, 1733,
     1733, 1733, 1733, 1733, 1733, 1733, 1733, 1733, 1733, 1733,
     1733, 1733, 1733, 1733, 1733, 1733, 1734, 1733, 1733, 1733,
     1733, 1733, 1733, 1733, 1733, 1733, 1733, 1733, 1733, 1733,
     1733, 1733, 1733, 1733, 1733, 1733, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1738, 1738, 1738, 1739, 1739, 1739, 1739,

     1739, 1739, 1740, 1740, 1740, 1740, 1740, 1740, 1741, 1741,
     1741, 1741, 1741, 1741, 1742, 1742, 1742, 1742, 1742, 1742,
      520,  940,  940, 2893, 2893,  520,  520,  520,  520,  520,
      520, 1743, 1743, 1743, 1743, 1743, 1743, 2893, 2893, 2893,
     2893, 2893,  191, 1744, 1744, 1744, 1744, 1744, 1744, 1745,
     1745, 1745, 1745, 1745, 1745, 2893, 2893, 2893, 2893, 2893,
      191, 1393, 1746, 1746, 1746, 1746, 1746, 1746, 2893, 1403,
     1501, 2893, 2893, 2893,  465, 2893, 2893, 2893,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520, 1394,  520,
      520,  520,  520,  520,  520,  836, 1394, 1502, 2893, 2893,

     2893, 1394, 2893,  836, 1018, 2893, 2893, 2893, 2893, 1394,
     1502, 2893, 1394, 2893, 2893, 2893, 2893, 2893,  836, 2893,
     1394, 1502, 2893, 2893, 1394, 2893,  836, 1018, 2893, 2893,
     2893, 2893, 1394, 1502, 1395,  975, 1745, 1745, 1745, 1745,
     1745, 1745, 1395, 1503, 2893, 2893, 2893,  191, 2893, 2893,
     1384, 1384, 1384, 1384, 1384, 1384, 1746, 1746, 1746, 1746,
     1746, 1746,  977, 1746, 1746, 1746, 1746, 1746, 1746,  929,
     2893, 2893, 2893, 2893, 2893,  977, 1411, 1411, 1412, 1673,
     1673, 1673, 1673, 1673, 1673, 2893,  977, 2893, 2893, 2893,
      191, 2893,  929, 2893, 2893, 2893, 2893, 2893,  977, 1752,

     1753, 1753, 1754, 1755, 1755, 2893, 2893, 2893,  978, 1748,
      191, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 2893, 1749, 1748, 1756, 1757, 1757, 1758, 1759, 1759,
     1748, 1748, 1748, 1748, 1748, 1750, 1752, 1753, 1753, 1754,
     1755, 1755, 2893, 2893,  520,  940, 2893,  191, 1756, 1757,
     1757, 1758, 1759, 1759, 2893, 2893, 2893, 2893, 2893, 1748,
     1416, 1416, 1416, 1682, 1682, 1682, 1682, 1682, 1682, 1756,
     1757, 1757, 1758, 1759, 1759, 1397, 2893, 1397, 1397, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1397,  940, 2893, 1397,
      520,  520,  520,  520,  520,  520, 1397, 1397, 1397, 1397,

     1397, 1422,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520, 2893,  520,  520,  520,  520,  520,  520, 1309,
     1309, 1309, 1309, 1309, 1309, 1397, 1431, 2893, 2893, 2893,
     2893,  465, 2893, 1432, 2893, 2893, 2893, 2893,  465, 2893,
     2893, 1332, 1332, 1332, 1332, 1332, 1332,  993, 1332, 1332,
     1332, 1332, 1332, 1332,  993, 2893, 1032, 2893, 2893, 2893,
     2893, 1433, 2893, 2893, 2893, 2893,  465, 2893, 1434,  471,
     2893, 2893, 2893,  465, 2893,  534, 1332, 1332, 1332, 1332,
     1332, 1332,  993, 1332, 1332, 1332, 1332, 1332, 1332,  993,
     1033, 2893,  471, 2893, 2893, 2893, 1437, 1437,  534,  565,

      472, 1437, 2893, 2893, 1763, 1437, 2893,  472, 2893,  579,
     2893, 2893, 1437, 1033, 1437, 2893, 1437,  191, 2893, 2893,
     2893, 2893,  565, 1453, 1453, 1453, 1453, 1453, 1453, 1034,
      191, 2893,  579, 2893, 2893,  472, 1453, 1453, 1453, 1453,
     1453, 1453,  472, 1767, 1767, 1767, 1767, 1767, 1767, 1774,
     1774, 1774, 1774, 1774, 1774, 1775, 1775, 1775, 1775, 1775,
     1775, 1776, 1776, 1776, 1776, 1776, 1776, 1777, 1777, 1777,
     1777, 1777, 1777, 1017, 1778, 1778, 1778, 1778, 1778, 1778,
      191, 2893, 2893, 2893, 1779, 1779, 1779, 1779, 1779, 1779,
     2893, 1458, 1458, 1459, 1784, 1785, 1785, 1786, 1787, 1787,

     2893, 2893, 2893, 2893, 2893,  191, 2893, 1018, 1464, 1464,
     1464,  191, 1784, 1785, 1785, 1786, 1787, 1787, 1788, 1788,
     1788, 1788, 1788, 1788, 1784, 1785, 1785, 1786, 1787, 1787,
     1018, 2893, 2893, 2893, 1780, 1781, 1781, 1782, 1783, 1783,
     1804, 1804, 1804, 1804, 1804, 1804, 1019, 1805, 1805, 1805,
     1805, 1805, 1805, 1778, 1778, 1778, 1778, 1778, 1778, 1779,
     1779, 1779, 1779, 1779, 1779, 1780, 1781, 1781, 1782, 1783,
     1783, 2893, 2893, 2893, 2893, 2893, 1788, 1788, 1788, 1788,
     1788, 1788, 1790, 1791, 2893, 1791, 1791, 1791, 1791, 1791,
     1791, 1791, 1791, 1791, 1791, 1792, 1790, 1791, 1793, 1793,

     1793, 1793, 1793, 1793, 1791, 1791, 1791, 1791, 1791, 1794,
     1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795,
     1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795,
     1795, 1795, 1790, 1791, 1795, 1795, 1795, 1795, 1795, 1795,
     1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795, 1795,
     1795, 1795, 1795, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1790, 1790, 1790, 1796, 1796, 1796, 1796, 1796, 1796, 1797,
     1798, 2893, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798,
     1798, 1798, 1799, 1797, 1798, 1800, 1800, 1800, 1800, 1800,
     1800, 1798, 1798, 1798, 1798, 1798, 1801, 1797, 1797, 1797,

     1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797,
     1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797,
     1798, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797,
     1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 1797,
     1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802, 1802,
     1803, 1803, 1803, 1803, 1803, 1803, 1468, 2893, 2893, 2893,
      191,  595, 1812, 1812, 1812, 1812, 1812, 1812,  191, 1816,
     1817, 1818, 1818, 1818, 1818, 2893, 2893, 1137, 1829, 1830,
     1830, 1831, 1832, 1832, 1829, 1830, 1830, 1831, 1832, 1832,
     1018, 1829, 1830, 1830, 1831, 1832, 1832, 2893, 2893, 2893,

     1468, 2893, 2893, 2893, 2893,  595, 1142, 1841, 1841, 1841,
     1841, 1841, 1841, 1018, 1806, 1806, 1806, 1806, 1806, 1806,
     2893, 1137, 1145, 1146, 1147, 1147, 1147, 1147, 2893, 1019,
      472, 2893, 2893, 2893, 1018, 2893, 1469, 1469, 1469, 1469,
     1469, 1469, 1808,  191, 1809, 1809, 1809, 1810, 1809, 1809,
     1809, 1809, 1809, 1809,  191, 1539, 1809, 1018, 2893, 2893,
      595,  191, 2893, 1809, 1809, 1809, 1809, 1809, 1811, 2893,
     2893, 2893, 2893, 1019,  472, 2893, 1137, 2893, 2893, 2893,
     1469, 1469, 1469, 1469, 1469, 1469, 1143, 1143, 1143, 1143,
     1143, 1143, 1809, 2893, 2893, 2893, 2893, 1825, 1826, 1826,

     1827, 1828, 1828, 2893, 2893, 2893, 2893, 2893, 1825, 1826,
     1826, 1827, 1828, 1828, 2893, 1840, 1840, 1840, 1840, 1840,
     1840, 2893, 1472, 1472, 1472, 1472, 1472, 1472,  190,  472,
     2893, 2893, 2893, 2893, 2893, 1469, 1469, 1469, 1469, 1469,
     1469,  190,  190, 2893,  190,  190,  190,  190,  190,  190,
     2893, 2893, 2893, 2893, 2893,  191,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  190, 2893,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  476,

      476,  476,  476,  476,  476,  476,  476,  476,  476, 1813,
     1814, 1815, 1815, 1815, 1815,  273, 1819, 2893,  275,  275,
      275,  276,  275,  275,  275,  275,  275,  275, 1820, 1821,
     1822,  273,  273,  273,  273,  273,  273,  664,  275,  275,
      275,  275,  282,  283,  283,  283,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  273,  275,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  284,  284,  284,  284,
      285,  284,  284,  284,  284,  284, 1823, 1823, 1823, 1823,

     1823, 1823, 1492, 1492, 1493,  191, 2893, 2893, 1509, 1509,
     1510, 2893, 2893, 2893, 2893, 2893,  191, 1498, 1498, 1498,
     2893, 2893,  191, 1517, 1517, 1517, 1843, 1843, 1843, 1843,
     1843, 1843, 1843, 1843, 1843, 1843, 1843, 1843, 1843, 1843,
     1843, 1843, 1843, 1843,  940, 2893, 2893,  520,  520,  520,
      520,  520,  520, 1855, 1856, 1856, 1857, 1858, 1858, 1842,
     1842, 1842, 1842, 1842, 1842, 2893, 2893, 2893, 2893, 2893,
     1779, 1779, 1779, 1779, 1779, 1779, 1779, 1779, 1779, 1779,
     1779, 1779, 2893, 2893, 2893, 1788, 1788, 1788, 1788, 1788,
     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1833, 1834, 2893,

     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834, 1834,
     1835, 1833, 1834, 1836, 1836, 1836, 1836, 1836, 1836, 1834,
     1834, 1834, 1834, 1834, 1837, 1833, 1833, 1833, 1833, 1833,
     1833, 1833, 1833, 1833, 1833, 1833, 1833, 1833, 1833, 1833,
     1833, 1833, 1833, 1833, 1833, 1833, 1833, 1833, 1834, 1833,
     1833, 1833, 1833, 1833, 1833, 1833, 1833, 1833, 1833, 1833,
     1833, 1833, 1833, 1833, 1833, 1833, 1833, 1833, 1838, 1838,
     1838, 1838, 1838, 1838, 1838, 1838, 1838, 1838, 1839, 1839,
     1839, 1839, 1839, 1839, 1112, 1511, 2893, 2893, 2893, 2893,
      595, 2893, 2893, 2893, 2826,  191, 1855, 1856, 1856, 1857,

     1858, 1858, 1855, 1856, 1856, 1857, 1858, 1858, 2893, 2893,
     2893, 1113, 1502, 2893, 2893, 2893, 2893,  940, 1033, 1018,
     2893, 2893, 2893, 2893, 1113, 1502, 1439, 1439, 1439, 1439,
     1439, 1439,  237, 2893, 2893, 1113, 1502,  215, 2893,  520,
     2893, 1033, 1018, 2893, 2893, 2893, 2893, 1113, 1502, 1842,
     1842, 1842, 1842, 1842, 1842,  237, 2893, 1114, 1503,  191,
      215, 2893, 2893, 2893, 1453, 1453, 1453, 1453, 1453, 1453,
     1845, 2893, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,
     1845, 1845,  191, 1846, 1845,  520,  520,  520,  520,  520,
      520, 1845, 1845, 1845, 1845, 1845, 1847,  520,  520,  520,

      520,  520,  520,  520,  520,  520,  520, 2893, 1532, 1532,
     1533, 2893, 2893, 1851, 1852, 1852, 1853, 1854, 1854, 2893,
     1845, 1505,  191, 1505, 1505, 1505, 1505, 1505, 1505, 1505,
     1505, 1505, 1505, 2893, 2893, 1505, 1851, 1852, 1852, 1853,
     1854, 1854, 1505, 1505, 1505, 1505, 1505, 1523, 1537, 1537,
     1537, 1539, 2893, 2893, 2893, 2893,  595, 1891, 1891, 1891,
     1891, 1891, 1891, 1893, 1893, 1893, 1893, 1893, 1893, 2893,
     2893, 1505, 1137, 2893, 2893, 2893, 1779, 1779, 1779, 1779,
     1779, 1779, 1894, 1894, 1894, 1894, 1894, 1894, 1896, 1896,
     1896, 1896, 1896, 1896, 1897, 1897, 1897, 1897, 1897, 1897,

     1899, 1899, 1899, 1899, 1899, 1899, 1900, 1900, 1900, 1900,
     1900, 1900, 1915, 2893, 2893, 2893, 1788, 1788, 1788, 1788,
     1788, 1788, 2893, 2893, 1916,  472, 1916, 2893, 2893, 2893,
     2893, 1469, 1469, 1469, 1469, 1469, 1469, 1902, 1902, 1902,
     1902, 1902, 1902, 1903, 1903, 1903, 1903, 1903, 1903, 1904,
     1904, 1904, 1904, 1904, 1904, 1905, 1905, 1905, 1905, 1905,
     1905, 1908, 1908, 1908, 1908, 1908, 1908, 1587, 1587, 1587,
     1587, 1587, 1587, 1909, 1909, 1909, 1909, 1909, 1909, 1912,
     1912, 1912, 1912, 1912, 1912, 1591, 1591, 1591, 1591, 1591,
     1591, 1913, 1600, 1600, 1600, 1600, 1600, 1600, 1594, 1598,

     2893, 2893, 2893, 1914, 2893, 1914, 1596, 1596, 1596, 1596,
     1596, 1596, 1926, 1917, 1917, 1917, 1917, 1917, 1917, 1917,
     1917, 1917, 1917, 1917, 1917, 1918, 1918, 1918, 1918, 1918,
     1918, 1204, 1920, 1920, 1920, 1920, 1920, 1920, 2893, 2893,
     1592, 2893, 2893, 2893, 1923, 2893, 1919, 1919, 1919, 1919,
     1919, 1919, 1921, 1921, 1921, 1921, 1921, 1921, 1207, 1924,
     1924, 1924, 1924, 1924, 1924, 2893, 2893, 1593, 1925, 1925,
     1925, 1925, 1925, 1925, 2893, 2893, 2893, 2893, 2893, 1920,
     1920, 1920, 1920, 1920, 1920, 1928, 1928, 1928, 1928, 1928,
     1928, 2893, 1927, 1927, 1927, 1927, 1927, 1927, 1929, 1929,

     1929, 1929, 1929, 1929, 1930, 1930, 1930, 1930, 1930, 1930,
      725, 1932, 1932, 1932, 1932, 1932, 1932, 2893, 2893, 2893,
     2893, 2893,  726, 2893,  726, 1931, 1931, 1931, 1931, 1931,
     1931, 1933, 1933, 1933, 1933, 1933, 1933,  728, 1922, 1922,
     1922, 1922, 1922, 1922, 2893, 2893, 2893, 2893, 2893,  729,
     2893,  729, 1935, 1935, 1935, 1935, 1935, 1935, 1936, 1936,
     1936, 1936, 1936, 1936, 1937, 1937, 1937, 1937, 1937, 1937,
     1938, 1938, 1938, 1938, 1938, 1938, 1620, 1620, 2893, 2893,
     2893, 1620, 2893, 2893, 1940, 1620, 1942, 1943, 1943, 1944,
     1945, 1945, 1620, 2893, 1620, 2893, 1620,  401, 1623, 1623,

     1623, 1624, 1624, 1624, 1624, 1624, 1624, 1946, 1947, 1947,
     1948, 1949, 1949, 1630, 1630, 1630, 2893, 1934, 1934, 1934,
     1934, 1934, 1934, 1950, 1950, 1950, 1950, 1950, 1950, 1951,
     1951, 1951, 1951, 1951, 1951, 1952, 1952, 1952, 1952, 1952,
     1952, 1953, 1954, 1954, 1955, 1956, 1956, 1957, 1958, 1958,
     1959, 1960, 1960, 1961, 1962, 1962, 1963, 1964, 1964, 1965,
     1965, 1965, 1965, 1965, 1965, 1966, 1966, 1966, 1966, 1966,
     1966, 1967, 1967, 1967, 1967, 1967, 1967, 2893, 2893, 2893,
     2893, 1631, 1631, 1631, 1631, 1631, 1631, 1968, 1969, 1969,
     1970, 1971, 1971, 1972, 1972, 1972, 1972, 1972, 1972, 1973,

     1973, 1973, 1973, 1973, 1973,  421, 2893, 2893, 2893, 2893,
      422, 1975, 1975, 1975, 1975, 1975, 1975, 1658,  423, 2893,
     1974, 1974, 1974, 1974, 1974, 1974,  425, 1976, 1976, 1976,
     1976, 1976, 1976,  426, 2893, 2893, 2893, 2893,  427, 1986,
     1986, 1986, 1986, 1986, 1986, 1655,  428, 1987, 1987, 1987,
     1987, 1987, 1987, 2893,  429, 2893, 2893, 2893, 2893, 2893,
     1656, 1656, 1656, 1656, 1656, 1656, 1988, 1988, 1988, 1988,
     1988, 1988, 1989, 1992, 1992, 1992, 1992, 1992, 1992, 2893,
     2893, 1993, 2893, 2893, 1990, 2893, 1990, 1991, 1991, 1991,
     1991, 1991, 1991, 1994, 2893, 1994, 2893, 1659, 1659, 1659,

     1659, 1659, 1659, 1998, 1998, 1998, 1998, 1998, 1998, 2893,
     2893, 2893, 2893, 1977, 1977, 1977, 1977, 1977, 1977, 1333,
     1333, 1333, 1333, 1333, 1333, 1999, 1999, 1999, 1999, 1999,
     1999, 2003, 2003, 2003, 2003, 2003, 2003, 2004, 1681, 1681,
     1681, 1681, 1681, 1681, 2893, 2893, 2893, 2893, 2893, 2005,
     2893, 2005, 2006, 2006, 2006, 2006, 2006, 2006, 2893, 2893,
     2893, 1995, 1995, 1995, 1995, 1995, 1995, 1997, 2893, 1997,
     1997, 1997, 1997, 1997, 1997, 1997, 1997, 1997, 1997, 2893,
     2893, 1997, 2004, 2893, 2893, 2893, 2893, 2893, 1997, 1997,
     1997, 1997, 1997, 2002, 2007, 2012, 2005, 2008, 2008, 2008,

     2008, 2008, 2008, 2893, 2893, 2893, 2893, 2013,  191, 2013,
     2014, 2014, 2014, 2014, 2014, 2014, 2893, 1997, 2010, 2893,
     2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2893, 2893, 2010, 1677, 1677, 1677, 1677, 1677, 1677, 2010,
     2010, 2010, 2010, 2010, 2011, 2015, 2015, 2015, 2015, 2015,
     2015, 2016, 2016, 2016, 2016, 2016, 2016, 2893, 2893, 2017,
     2017, 2017, 2017, 2017, 2017, 2893, 2893, 2893, 2010, 2010,
      191, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
     2010, 2893, 2893, 2010, 1677, 1677, 2893, 2893, 2893, 2893,
     2010, 2010, 2010, 2010, 2010, 2011, 2018, 2018, 2018, 2018,

     2018, 2018, 1685, 2019, 2019, 2019, 2019, 2019, 2893, 2893,
     2893, 2893, 2893,  191, 2893, 2893, 2893, 2893, 2893, 2010,
     1324, 1324, 1325, 2019, 2019, 2019, 1685, 1685, 1685, 2893,
     2893, 2893, 2893, 2893,  191, 1324, 1324, 1325, 1685, 1685,
     1685, 1685, 1685, 1685, 2893, 2893, 2893, 2893, 2893,  191,
     1683, 2020, 2020, 2020, 2020, 2020, 1325, 1325, 1325, 2020,
     2020, 2020, 1683, 1683, 1683, 1325, 1325, 1325, 1683, 1683,
     1683, 1683, 1683, 1683, 2021, 2893, 2893, 2893, 2893,  465,
      992,  992,  992,  992,  992,  992,  932, 2893, 2893,  992,
      992,  992,  992,  992,  992,  993, 2022, 2022, 2022, 2022,

     2022, 2022,  854,  854,  854,  854,  854,  854, 2893, 2893,
     2893, 2893, 2893,  191, 2893,  940,  475,  471,  520,  520,
      520,  520,  520,  520, 1743, 2048, 2048, 2048, 2048, 2048,
     2893, 2893, 2893, 2893, 2893,  191, 2893, 2893, 2893,  475,
      471, 2048, 2048, 2048, 2048, 2048, 2048, 2893,  472, 2893,
     2893, 2893, 2893, 2893,  513,  513,  513,  513,  513,  513,
     2893,  190,  190,  190,  190,  190,  190, 2023, 2024, 2893,
     2025, 2025, 2025, 2026, 2025, 2025, 2025, 2025, 2025, 2025,
     2027, 2028, 2025, 2029, 2030, 2031, 2032, 2029, 2029, 2025,
     2025, 2025, 2025, 2025, 2033, 2034, 2034, 2034, 2034, 2034,

     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2035, 2034, 2034, 2034, 2034, 2034, 2023, 2025, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2035, 2034, 2034, 2034, 2036, 2036,
     2036, 2036, 2037, 2036, 2036, 2036, 2036, 2036, 2023, 2023,
     2023, 2023, 2023, 2023, 2044, 2893, 2893, 2893, 2893,  465,
     2893, 2045, 2893, 2893, 2893, 2893,  465, 2893, 2893,  992,
      992,  992,  992,  992,  992,  993,  992,  992,  992,  992,
      992,  992,  993,  940, 2893, 2046, 2893, 2893, 2893, 2893,
      465, 2893, 2893, 2893, 2893, 2893,  534, 2893, 2893,  565,

      992,  992,  992,  992,  992,  992,  993, 2893, 2893,  932,
     2893, 2893,  513,  513,  513,  513,  513,  513, 2893,  534,
     2893, 2893,  565, 2893, 2893, 2893,  579, 2893,  472, 2048,
     2048, 2049, 2049, 2049, 2049,  472, 2893, 2893, 2893,  475,
     2049, 2049, 2049, 2049, 2049, 2049, 2893, 2893, 2893,  579,
     2893,  520,  520,  520,  520,  520,  520, 2893, 2893,  472,
      513,  514,  475,  514,  514,  514,  514,  514,  514,  514,
      514,  514,  514,  515,  513,  514,  516,  516,  516,  516,
      516,  516,  514,  514,  514,  514,  514,  517,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,

      475,  475,  475, 1370,  475,  475,  475,  475,  475,  475,
      513,  514,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475, 1370,  475,  475,  475,
      475,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  518,  518,  518,  518,  518,  518,  513,  520, 1744,
     2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050, 2050,
     2050,  940,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  520, 2893,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,

      513,  513,  513,  513,  513, 2893,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520, 2050, 2050, 2051, 2051,
     2051, 2051, 2051, 2051, 2051, 2051, 2051, 2051, 2893,  520,
      520,  520,  520,  520,  520, 2052, 2052, 2052, 2052, 2052,
     2052, 2893,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  940, 2893, 2893,  520,  520,  520,  520,  520,
      520, 2053, 2053, 2053, 2053, 2053, 2053, 2054, 2054, 2054,
     2054, 2054, 2054, 2056, 2893, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2893, 2893, 2056, 2057, 2057,
     2057, 2057, 2057, 2057, 2056, 2056, 2056, 2056, 2056, 2058,

     2059, 2059, 2059, 2059, 2059, 2059, 2060, 2060, 2060, 2060,
     2060, 2060, 2893, 2893, 2893, 2893, 2893,  191, 2893, 2893,
     2893, 2893, 2893, 2056, 2061, 2061, 2061, 2061, 2061, 2061,
     1748, 2893, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     1748, 1748, 2893, 2893, 1748, 2066, 2066, 2066, 2066, 2066,
     2066, 1748, 1748, 1748, 1748, 1748, 1750, 2065, 2066, 2066,
     2066, 2066, 2066, 2893, 2893, 2893, 2893, 2893,  191, 2066,
     2066, 2067, 2067, 2067, 2067, 2893, 2893, 2893, 2893, 2893,
     1748, 2063, 2893, 2063, 2063, 2063, 2063, 2063, 2063, 2063,
     2063, 2063, 2063, 2893, 2893, 2063, 2067, 2067, 2067, 2067,

     2067, 2067, 2063, 2063, 2063, 2063, 2063, 2064, 2068, 2069,
     2069, 2069, 2069, 2069, 2069, 2069, 2069, 2069, 2069, 2069,
     2069, 2069, 2070, 2070, 2070, 2070, 2893, 2893, 2893, 2893,
     2893, 2063, 2070, 2070, 2070, 2070, 2070, 2070, 2073, 2073,
     2893, 2893, 2893, 2073, 2893, 2893,  190, 2073, 2076, 2076,
     2076, 2076, 2076, 2076, 2073, 2893, 2073, 2893, 2073,  191,
     1470, 1470, 1470, 1470, 1470, 1470, 2077, 2077, 2077, 2077,
     2077, 2077, 2075, 2893, 2075, 2075, 2075, 2075, 2075, 2075,
     2075, 2075, 2075, 2075, 2893, 2893, 2075, 2081, 2081, 2081,
     2081, 2081, 2081, 2075, 2075, 2075, 2075, 2075, 2080, 2082,

     2082, 2082, 2082, 2082, 2082, 2083, 2083, 2083, 2083, 2083,
     2083, 2084, 2084, 2084, 2084, 2084, 2084, 2085,  932,  191,
     2893, 2893, 2075, 2085, 2893, 2893, 2893, 2893, 2893, 2086,
     2893, 2086, 2893, 2893, 2893, 2088, 2893, 2086, 1787, 1787,
     1787, 1787, 1787, 1787, 2093, 2893, 2893, 2893,  475,  191,
     2096, 2096, 2096, 2096, 2096, 2096, 2094, 2893, 2094, 2097,
     2097, 2097, 2097, 2097, 2097, 2893, 2893, 2893,  522, 2893,
     2893,  475, 2893, 2098, 2098, 2098, 2098, 2098, 2098, 2099,
     2099, 2099, 2099, 2099, 2099, 2893,  513,  513,  513,  513,
      513,  513, 2893, 2893, 2893, 2893, 2893, 2087, 2087, 2087,

     2087, 2087, 2087, 2089, 2089, 2089, 2089, 2089, 2089, 2091,
     2893, 2091, 2091, 2091, 2091, 2091, 2091, 2091, 2091, 2091,
     2091,  191, 2893, 2091, 2095, 2095, 2095, 2095, 2095, 2095,
     2091, 2091, 2091, 2091, 2091, 2092,  525,  525,  525,  525,
      525,  525, 2893,  932, 2893, 2893,  513,  513,  513,  513,
      513,  513, 1804, 2101, 2101, 2101, 2101, 2101, 2893, 2091,
      520,  520,  520,  520,  520,  520, 2893, 1458, 1458, 1459,
     2893, 2893, 2893,  475, 2893, 1806, 2100, 2100, 2100, 2100,
     2100,  191, 1459, 1459, 1459, 2893, 2893, 2893, 2893, 1783,
     1783, 1783, 1783, 1783, 1783, 2091,  475, 2091, 2091, 2091,

     2091, 2091, 2091, 2091, 2091, 2091, 2091,  191, 2893, 2091,
     1138, 1138, 1138, 1138, 1138, 1138, 2091, 2091, 2091, 2091,
     2091, 2092, 2893, 2893, 2893,  525,  525,  525,  525,  525,
      525, 2893, 2893, 2893, 2893, 2100, 2100, 2100, 1806, 1806,
     1806, 2893, 2893, 2893, 2893, 2091, 2893, 2893, 2893, 2893,
     2101, 2101, 2101, 1804, 1804, 1804, 2893, 2893, 2893, 2893,
     2893, 1028, 1028, 1028, 1028, 1028, 1028, 2116, 2116, 2116,
     2116, 2116, 2116, 2893, 2893, 1783, 1783,  513,  514, 2893,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      515,  513,  514,  516,  516,  516,  516,  516,  516,  514,

      514,  514,  514,  514,  517,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
     1466,  475,  475,  475,  475,  475,  475,  513,  514,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475, 1466,  475,  475,  475,  475,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  518,  518,
      518,  518,  518,  518,  513, 2116, 2116, 2117, 2117, 2117,
     2117, 2117, 2117, 2117, 2117, 2117, 2117, 2893, 2893,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,

      513,  191, 2893,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  521, 2893,  521,  521,  521,  521,  521,  521,
      521,  521,  521,  521, 2893, 2893,  521,  523,  523,  523,
      523,  523,  523,  521,  521,  521,  521,  521,  524, 1841,
     2118, 2118, 2118, 2118, 2118, 1840, 2116, 2116, 2116, 2116,
     2116, 2118, 2118, 2118, 2118, 2118, 2118, 1458, 1458, 1459,
     2893, 2893,  521, 1459, 1459, 1459, 2893, 2893, 2893, 2102,
     2893,  191, 2893, 2893,  595, 2118, 2118, 2119, 2119, 2119,
     2119, 2119, 2119, 2119, 2119, 2119, 2119,  522, 2893, 2893,

     1137, 2893,  525,  525,  525,  525,  525,  525,  521, 2893,
      521,  521,  521,  521,  521,  521,  521,  521,  521,  521,
      940, 2893,  521,  523,  523,  523,  523,  523,  523,  521,
      521,  521,  521,  521,  524, 1806, 1806, 1806, 1806, 1806,
     1806, 1804, 1804, 1804, 1804, 1804, 1804, 2124, 2124, 2124,
     2124, 2124, 2124,  472, 2893, 2893, 2893, 2893,  521, 1138,
     1138, 1138, 1138, 1138, 1138,  525,  525,  525,  525,  525,
      525, 2126, 2126, 2126, 2126, 2126, 2126, 2893,  476,  476,
      476,  476,  476,  476,  476,  476,  476,  476,  190, 2131,
     2131, 2131, 2131, 2131, 2131, 2131, 2131, 2132, 2132, 2132,

     2132,  190,  190, 2893,  190,  190,  190,  190,  190,  190,
     2893, 2893, 2893, 2893, 2893,  191,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  190, 2893,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  476,
      476,  476,  476,  476,  476,  476,  476,  476,  476, 2103,
     2103, 2103, 2103, 2103, 2103, 2104, 2105, 2893, 2106, 2106,
     2106, 2107, 2106, 2106, 2106, 2106, 2106, 2106, 2108, 2109,
     2106, 2104, 2104, 2104, 2104, 2104, 2104, 2106, 2106, 2106,

     2106, 2106, 2110, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2104, 2106, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2112, 2112, 2112, 2112,
     2113, 2112, 2112, 2112, 2112, 2112, 2114, 2114, 2114, 2114,
     2114, 2114,  520, 2132, 2132, 2132, 2132, 2132, 2132, 2893,
     2893,  520,  520,  520,  520,  520,  520, 2133, 2134, 2134,
     2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134, 2134,
     2134, 2135, 2135, 2135, 2135, 2135, 2135, 2135, 2135, 2135,

     2135, 2893, 2893,  191, 2168, 2168, 2168, 2168, 2168, 2168,
     2893, 2893, 2893, 2893, 2893,  191, 2893, 2893, 2893, 2893,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
      525,  525, 2121, 2893, 2121, 2121, 2121, 2121, 2121, 2121,
     2121, 2121, 2121, 2121, 2893, 2893, 2121, 2125, 2125, 2125,
     2125, 2125, 2125, 2121, 2121, 2121, 2121, 2121, 2122, 2130,
     2131, 2131, 2131, 2131, 2131, 1572, 1572, 1572, 1572, 1572,
     1572, 2169, 2169, 2169, 2169, 2169, 2169, 2893, 2893, 2893,
     2893, 2893, 2121, 2170, 2170, 2170, 2170, 2170, 2170, 1575,

     1575, 1575, 1575, 1575, 1575, 2171, 2171, 2171, 2171, 2171,
     2171, 2172, 2172, 2172, 2172, 2172, 2172, 2893, 2893, 2893,
     2893, 2893, 2123, 2123, 2123, 2123, 2123, 2123, 1845, 2893,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,
     2893, 2893, 1845, 1578, 1578, 1578, 1578, 1578, 1578, 1845,
     1845, 1845, 1845, 1845, 1847, 2173, 2173, 2173, 2173, 2173,
     2173, 2174, 2174, 2174, 2174, 2174, 2174, 1581, 1581, 1581,
     1581, 1581, 1581, 2893, 2893, 2893, 2893, 2893, 1845, 2128,
     2893, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128, 2128,
     2128, 2893, 2893, 2128, 2175, 2175, 2175, 2175, 2175, 2175,

     2128, 2128, 2128, 2128, 2128, 2129, 2176, 2176, 2176, 2176,
     2176, 2176, 2177, 2177, 2177, 2177, 2177, 2177, 2178, 2178,
     2178, 2178, 2178, 2178, 1915, 2893, 2893, 2893, 2893, 2128,
     1586, 1586, 1586, 1586, 1586, 1586, 2179, 2179, 2179, 2179,
     2179, 2179, 2180, 2180, 2180, 2180, 2180, 2180, 2181, 2181,
     2181, 2181, 2181, 2181, 1590, 1590, 1590, 1590, 1590, 1590,
     2182, 2182, 2182, 2182, 2182, 2182, 2183, 2183, 2183, 2183,
     2183, 2183, 1913, 1596, 1596, 1596, 1596, 1596, 1596, 1600,
     1600, 1600, 1600, 1600, 1600, 1926, 2893, 1596, 1596, 1596,
     1596, 1596, 1596, 2184, 2184, 2184, 2184, 2184, 2184, 2893,

     2893, 2893, 2893, 2893, 1600, 1600, 1600, 1600, 1600, 1600,
     2185, 2185, 2185, 2185, 2185, 2185, 2186, 2186, 2186, 2186,
     2186, 2186, 2187, 2187, 2187, 2187, 2187, 2187, 1923, 2188,
     2188, 2188, 2188, 2188, 2188, 2893, 2893, 2189, 2893, 2893,
     2893, 2893, 2893, 1924, 1924, 1924, 1924, 1924, 1924, 2190,
     2893, 2190, 2191, 2191, 2191, 2191, 2191, 2191, 2192, 2192,
     2192, 2192, 2192, 2192, 2193, 1927, 1927, 1927, 1927, 1927,
     1927, 2196, 2893, 2893, 2893, 2893, 2194, 2893, 2194, 2893,
     2893, 2893, 2893, 2197, 2893, 2197, 2198, 2198, 2198, 2198,
     2198, 2198, 2199, 2199, 2199, 2199, 2199, 2199, 2200, 2200,

     2200, 2200, 2200, 2200, 2201, 2204, 2204, 2204, 2204, 2204,
     2204, 2893, 2893, 2893, 2893, 2893, 2202, 2893, 2202, 2205,
     2205, 2205, 2205, 2205, 2205, 2206, 2206, 2206, 2206, 2206,
     2206, 2207, 2207, 2207, 2207, 2207, 2207, 2208, 2208, 2208,
     2208, 2208, 2208, 2893, 2195, 2195, 2195, 2195, 2195, 2195,
     2209, 2209, 2209, 2209, 2209, 2209, 2212, 2212, 2893, 2893,
     2893, 2212, 2893, 2893,  400, 2212, 1945, 1945, 1945, 1945,
     1945, 1945, 2212, 2893, 2212, 2893, 2212,  401, 1951, 2213,
     2213, 2213, 2213, 2213, 2203, 2203, 2203, 2203, 2203, 2203,
     2213, 2213, 2213, 2213, 2213, 2213, 2213, 2213, 1951, 1951,

     1951, 1951, 1951, 1951, 1951, 1951, 1951, 1951, 2214, 2214,
     2214, 2214, 2214, 2214, 2215, 2215, 2215, 2215, 2215, 2215,
     2216, 2217, 2217, 2217, 2217, 2217, 2217, 2217, 2217, 2217,
     2217, 2217, 2217, 2217, 2216, 2216, 2216, 2216, 2216, 2216,
     2216, 2216, 2216, 2216, 1960, 1960, 1960, 1960, 1960, 1960,
     1966, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218, 2218,
     2218, 2218, 2218, 2218, 1966, 1966, 1966, 1966, 1966, 1966,
     1966, 1966, 1966, 1966, 2219, 2219, 2219, 2219, 2219, 2219,
     2220, 2220, 2220, 2220, 2220, 2220, 2221, 2222, 2222, 2222,
     2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222, 2222,

     2221, 2221, 2221, 2221, 2221, 2221, 2221, 2221, 2221, 2221,
     1274, 2893, 2893, 2241, 2893,  422, 2223, 2223, 2223, 2223,
     2223, 2223, 2242,  423, 2893, 1974, 1974, 1974, 1974, 1974,
     1974, 2224, 2224, 2224, 2224, 2224, 2224, 1277, 2893, 2230,
     2893, 2893,  427, 2893, 2893, 2893, 2893, 2893, 2233, 2893,
      428, 2231, 2236, 2231, 2232, 2232, 2232, 2232, 2232, 2232,
     2234, 2237, 2234, 1989, 1993, 2893, 2893, 2238, 2238, 2238,
     2238, 2238, 2238, 2893, 2893, 2893, 2893, 2893, 2239, 2239,
     2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239, 2239,
     1989, 2893, 2893, 2243, 2243, 2243, 2243, 2243, 2243, 2893,

     2893, 2893, 1990, 2893, 1990, 2240, 2240, 2240, 2240, 2240,
     2240, 2244, 2244, 2244, 2244, 2244, 2244, 1977, 1977, 1977,
     1977, 1977, 1977, 1993, 2893, 2893, 2893, 2893, 2235, 2235,
     2235, 2235, 2235, 2235, 1312, 1994, 2893, 1994, 2246, 2246,
     2246, 2246, 2246, 2246, 2244, 2244, 2244, 2244, 2244, 2244,
     1999, 1999, 1999, 1999, 1999, 1999, 2004, 2248, 2248, 2248,
     2248, 2248, 2248, 2893, 2893, 2004, 2893, 2893, 2893, 2893,
     2893, 2248, 2248, 2248, 2248, 2248, 2248, 2005, 2893, 2005,
     2249, 2249, 2249, 2249, 2249, 2249, 2250, 2250, 2250, 2250,
     2250, 2250, 2893, 2893, 2893, 2893, 2893,  191, 2004, 2893,

     2893, 2893, 2893, 2245, 2245, 2245, 2245, 2245, 2245, 2893,
     2007, 2004, 2005, 2251, 2251, 2251, 2251, 2251, 2251, 2893,
     2893, 2893, 2893, 2893,  191, 2893, 2248, 2248, 2248, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2012, 2893,
     1322, 1322, 1322, 1322, 1322, 1322, 2893, 2254, 2893, 2893,
     2013,  191, 2013, 2252, 2252, 2252, 2252, 2252, 2252, 2255,
     2893, 2255, 2256, 2256, 2256, 2256, 2256, 2256, 2254, 2893,
     2253, 2253, 2253, 2253, 2253, 2253, 2253, 2253, 2253, 2253,
     2261, 2893, 2255, 2262, 2262, 2262, 2262, 2262, 2262, 2253,
     2253, 2253, 2253, 2253, 2263, 2265, 1325, 1325, 1325, 2015,

     2015, 2015, 2015, 2015, 2015, 2893, 2893, 2266, 2893, 2266,
     2267, 2267, 2267, 2267, 2267, 2267, 2893, 2893, 2253, 1324,
     1324, 1325, 2017, 2017, 2017, 2017, 2017, 2017, 2893, 2021,
     2893, 2893, 2893,  191,  465, 2280, 2280, 2280, 2280, 2280,
     2280, 2893, 2893, 2893,  992,  992,  992,  992,  992,  992,
      993,  854,  854,  854,  854,  854,  854, 2893, 2893, 2893,
     2893, 2893,  191, 2059, 2059, 2059, 2059, 2059, 2059, 2893,
     2893, 2893,  471, 2283, 2283, 2283, 2283, 2283, 2283, 2893,
     2893, 2893, 2893, 2893,  191, 2284, 2284, 2284, 2284, 2284,
     2284, 2893, 2893, 2893, 2893,  471, 2289, 2289, 2289, 2289,

     2289, 2289, 2893,  472,  190, 2298, 2298, 2298, 2298, 2298,
     2298, 2299, 2299, 2299, 2299, 2299, 2299,  190,  190, 2893,
      190,  190,  190,  190,  190,  190, 2893, 2893, 2893, 2893,
     2893,  191,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  190, 2893,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  476,  476,  476,  476,  476,
      476,  476,  476,  476,  476,  190,  190,  190,  190,  190,
      190, 2023, 2024, 2893, 2025, 2025, 2025, 2026, 2025, 2025,

     2025, 2025, 2025, 2025, 2027, 2028, 2025, 2269, 2270, 2271,
     2272, 2269, 2269, 2025, 2025, 2025, 2025, 2025, 2033, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2035, 2034, 2034, 2034, 2034,
     2034, 2023, 2025, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2035, 2034,
     2034, 2034, 2036, 2036, 2036, 2036, 2037, 2036, 2036, 2036,
     2036, 2036, 2023, 2023, 2023, 2023, 2023, 2023,  513,  514,
     2893,  514,  514,  514,  514,  514,  514,  514,  514,  514,
      514,  515,  513,  514,  516,  516,  516,  516,  516,  516,

      514,  514,  514,  514,  514,  517,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  513,  514,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  518,
      518,  518,  518,  518,  518,  520,  521, 2893,  521,  521,
      521,  521,  521,  521,  521,  521,  521,  521,  522,  520,
      521,  523,  523,  523,  523,  523,  523,  521,  521,  521,
      521,  521,  524,  520,  520,  520,  520,  520,  520,  520,

      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  521,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  476,  476,  476,  476,
      476,  476,  476,  476,  476,  476,  525,  525,  525,  525,
      525,  525, 2044, 2893, 2893, 2893, 2893,  465, 2893, 2045,
     2893, 2893, 2893, 2893,  465, 2893, 2893,  992,  992,  992,
      992,  992,  992,  993,  992,  992,  992,  992,  992,  992,
      993, 1443, 2893, 2046, 2893, 2893, 2893, 2893,  465, 2893,
     2893, 2893, 2893, 2893,  534, 2893, 2893,  565,  992,  992,

      992,  992,  992,  992,  993, 2298, 2298, 2298, 2298, 2298,
     2298, 2085, 2893, 2893, 2073, 2073, 2893,  534, 2893, 2073,
      565, 2893, 1763, 2073,  579, 2893,  472, 2893, 2893, 2893,
     2073, 2893, 2073,  472, 2073,  191, 2077, 2077, 2077, 2077,
     2077, 2077, 2893,  191, 2893, 2893, 2893,  579, 2893, 2893,
     2301, 2301, 2301, 2301, 2301, 2301, 2085,  472, 2277, 2893,
     2277, 2277, 2277, 2277, 2277, 2277, 2277, 2277, 2277, 2277,
     2893, 2893, 2277, 2278, 2278, 2278, 2278, 2278, 2278, 2277,
     2277, 2277, 2277, 2277, 2279, 2305, 2305, 2305, 2305, 2305,
     2305, 2305, 2305, 2305, 2305, 2305, 2305, 2307, 2307, 2307,

     2307, 2307, 2307, 2893, 2893, 2893, 2893, 2893, 2277, 2056,
     2893, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     2056, 2893, 2893, 2056, 2057, 2057, 2057, 2057, 2057, 2057,
     2056, 2056, 2056, 2056, 2056, 2058, 2305, 2305, 2305, 2305,
     2305, 2305, 2305, 2305, 2305, 2305, 2305, 2305,  191, 2331,
     2331, 2331, 2331, 2331, 2331, 2893, 2893, 2893, 2893, 2056,
     2286, 2893, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2893, 2893, 2286, 2287, 2287, 2287, 2287, 2287,
     2287, 2286, 2286, 2286, 2286, 2286, 2288, 1458, 1458, 1459,
      191, 2124, 2124, 2124, 2124, 2124, 2124, 2893, 2893, 2893,

     2893,  191, 1456, 1456, 1456, 1456, 1456, 1456, 2893, 2893,
     2286, 2291, 2893, 2291, 2291, 2291, 2291, 2291, 2291, 2291,
     2291, 2291, 2291, 2893, 2893, 2291, 2292, 2292, 2292, 2292,
     2292, 2292, 2291, 2291, 2291, 2291, 2291, 2293, 2333, 2333,
     2333, 2333, 2333, 2333, 1028, 1028, 1028, 1028, 1028, 1028,
     2893, 2893, 2893, 2893, 2893, 2098, 2098, 2098, 2098, 2098,
     2098, 2291, 2295, 2893, 2295, 2295, 2295, 2295, 2295, 2295,
     2295, 2295, 2295, 2295, 2893, 2893, 2295, 2296, 2296, 2296,
     2296, 2296, 2296, 2295, 2295, 2295, 2295, 2295, 2297, 2085,
     2893, 2893, 2893, 2893, 2893, 2093, 2893, 2893, 2893, 2893,

     2893, 2086, 2893, 2086, 2893, 2893, 2893, 2094, 2893, 2094,
     2893, 2893, 2295, 2291, 2893, 2291, 2291, 2291, 2291, 2291,
     2291, 2291, 2291, 2291, 2291, 2893, 2893, 2291, 2292, 2292,
     2292, 2292, 2292, 2292, 2291, 2291, 2291, 2291, 2291, 2293,
     2085, 1459, 1459, 1459, 2893, 2893, 2311,  191, 2893, 2893,
     2893, 2893, 2088, 2893, 2086, 2893, 2893, 2893, 2312, 2893,
     2312, 2893, 2893, 2291, 2893, 2893,  191, 2893, 2893, 2306,
     2306, 2306, 2306, 2306, 2306, 2309, 2309, 2309, 2309, 2309,
     2309, 2322, 2338, 2338, 2338, 2338, 2338, 2338, 2893, 2893,
     2893, 2893, 2893, 2323, 2102, 2323, 2893, 2893, 2893,  595,

     2893, 2332, 2332, 2332, 2332, 2332, 2332, 2893, 2893, 2096,
     2096, 2096, 2096, 2096, 2096, 1137, 2893, 2893, 2893, 2893,
     2308, 2308, 2308, 2308, 2308, 2308, 2313, 2313, 2313, 2313,
     2313, 2313, 2311, 2893, 2310, 2310, 2310, 2310, 2310, 2310,
     2310, 2310, 2310, 2310, 2318, 2893, 2312, 2347, 2347, 2347,
     2347, 2347, 2347, 2310, 2310, 2310, 2310, 2310, 2319, 2893,
     2893, 2324, 2324, 2324, 2324, 2324, 2324, 2893,  472, 2893,
     2893, 2893, 2893, 2893, 1138, 1138, 1138, 1138, 1138, 1138,
     2893, 2893, 2310, 2348, 2348, 2348, 2348, 2348, 2348, 2347,
     2347, 2347, 2347, 2347, 2347, 1570, 2893, 2893, 2893, 2373,

     2373, 2373, 2373, 2373, 2373, 2179, 2179, 2179, 2179, 2179,
     2179, 2893, 2320, 2320, 2320, 2320, 2320, 2320,  190, 1576,
     2893, 2893, 2893, 2375, 2375, 2375, 2375, 2375, 2375, 2893,
     2893,  190,  190, 2893,  190,  190,  190,  190,  190,  190,
     2893, 2893, 2893, 2893, 2893,  191,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  190, 2893,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  476,
      476,  476,  476,  476,  476,  476,  476,  476,  476,  190,

      190,  190,  190,  190,  190,  513,  514, 2893,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  515,  513,
      514,  516,  516,  516,  516,  516,  516,  514,  514,  514,
      514,  514,  517,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  513,  514,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  518,  518,  518,  518,
      518,  518,  520,  521, 2893,  521,  521,  521,  521,  521,

      521,  521,  521,  521,  521,  522,  520,  521,  523,  523,
      523,  523,  523,  523,  521,  521,  521,  521,  521,  524,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  521,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  520,  520,  520,  520,  520,  520,  520,
      520,  520,  520,  476,  476,  476,  476,  476,  476,  476,
      476,  476,  476,  525,  525,  525,  525,  525,  525, 2104,
     2105, 2893, 2106, 2106, 2106, 2107, 2106, 2106, 2106, 2106,
     2106, 2106, 2108, 2109, 2106, 2104, 2104, 2104, 2104, 2104,

     2104, 2106, 2106, 2106, 2106, 2106, 2110, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2104,
     2106, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2112, 2112, 2112, 2112, 2113, 2112, 2112, 2112, 2112, 2112,
     2326, 2326, 2326, 2326, 2326, 2326, 2328, 1573, 2328, 2328,
     2328, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2893, 2893,
     2328, 2182, 2182, 2182, 2182, 2182, 2182, 2328, 2328, 2328,
     2328, 2328, 2329, 2893, 2893, 1584, 2893, 2893, 1579, 2377,

     2377, 2377, 2377, 2377, 2377, 2381, 2893, 2893, 2893, 2893,
     1588, 2893, 2893, 2893, 2384, 2893, 2328, 2382, 2893, 2382,
     2383, 2383, 2383, 2383, 2383, 2383, 2385, 2893, 2385, 2386,
     2386, 2386, 2386, 2386, 2386, 2893, 2374, 2374, 2374, 2374,
     2374, 2374, 2893, 2893, 2893, 2893, 2330, 2330, 2330, 2330,
     2330, 2330, 2121, 2893, 2121, 2121, 2121, 2121, 2121, 2121,
     2121, 2121, 2121, 2121, 2893, 2893, 2121, 2376, 2376, 2376,
     2376, 2376, 2376, 2121, 2121, 2121, 2121, 2121, 2122, 2379,
     2379, 2379, 2379, 2379, 2379, 2387, 2893, 2893, 2893, 2893,
     2893, 2390, 2393, 2893, 2893, 2893, 2893, 2388, 2189, 2388,

     2193, 2394, 2121, 2391, 2893, 2391, 2893, 2395, 2395, 2395,
     2395, 2395, 2395, 2396, 2396, 2396, 2396, 2396, 2396, 2396,
     2396, 2396, 2396, 2396, 2396, 2893, 2893, 2893, 2893, 2893,
     2398, 2893, 2123, 2123, 2123, 2123, 2123, 2123, 2335, 2399,
     2335, 2335, 2335, 2335, 2335, 2335, 2335, 2335, 2335, 2335,
     2893, 2893, 2335, 2401, 2401, 2401, 2401, 2401, 2401, 2335,
     2335, 2335, 2335, 2335, 2336, 2389, 2389, 2389, 2389, 2389,
     2389, 2392, 2392, 2392, 2392, 2392, 2392, 2189, 2893, 2893,
     2401, 2401, 2401, 2401, 2401, 2401, 2193, 2196, 2335, 2190,
     2893, 2190, 2397, 2397, 2397, 2397, 2397, 2397, 2194, 2893,

     2194, 2893, 2403, 2403, 2403, 2403, 2403, 2403, 2893, 2893,
     2400, 2400, 2400, 2400, 2400, 2400, 2201, 2893, 2337, 2337,
     2337, 2337, 2337, 2337, 2340, 2893, 2340, 2340, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2893, 2893, 2340, 2403,
     2403, 2403, 2403, 2403, 2403, 2340, 2340, 2340, 2340, 2340,
     2341, 2406, 2406, 2406, 2406, 2406, 2406, 2893, 2893, 2893,
     2893, 2196, 2893, 2893, 2893, 2893, 2402, 2402, 2402, 2402,
     2402, 2402, 2196, 2197, 2340, 2197, 2404, 2404, 2404, 2404,
     2404, 2404, 2893, 2893, 2197, 2893, 2197, 2405, 2405, 2405,
     2405, 2405, 2405, 2893, 2893, 2893, 2407, 2407, 2407, 2407,

     2407, 2407, 2893, 2893, 2342, 2342, 2342, 2342, 2342, 2342,
     2344, 2893, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2893, 2893, 2344, 2407, 2407, 2407, 2407, 2407,
     2407, 2344, 2344, 2344, 2344, 2344, 2345, 2410, 2410, 2410,
     2410, 2410, 2410, 2201, 2893, 2893, 2893, 2893, 2893, 2201,
     2893, 2893, 2893, 2893, 2893, 2202, 2893, 2202, 2893, 2893,
     2344, 2202, 2893, 2202, 2212, 2212, 2893, 2893, 2893, 2212,
     2893, 2893, 1940, 2212, 2214, 2214, 2214, 2214, 2214, 2214,
     2212, 2893, 2212, 2893, 2212,  401, 2893, 2893, 2893, 2893,
     2346, 2346, 2346, 2346, 2346, 2346, 2340, 2893, 2340, 2340,

     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2893, 2893,
     2340, 2414, 2414, 2414, 2414, 2414, 2414, 2340, 2340, 2340,
     2340, 2340, 2341, 2408, 2408, 2408, 2408, 2408, 2408, 2409,
     2409, 2409, 2409, 2409, 2409, 2415, 2415, 2415, 2415, 2415,
     2415, 2893, 2893, 2893, 2893, 2893, 2340, 2416, 2416, 2416,
     2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2416, 2219,
     2219, 2219, 2219, 2219, 2219, 2417, 2417, 2417, 2417, 2417,
     2417, 2233, 2893, 2893, 2893, 2893, 2342, 2342, 2342, 2342,
     2342, 2342, 2418, 2418, 2418, 2418, 2418, 2418, 2419, 2419,
     2419, 2419, 2419, 2419, 2419, 2419, 2419, 2419, 2419, 2419,

     2230, 2422, 2422, 2422, 2422, 2422, 2422, 2893, 2893, 2230,
     2893, 2893, 2893, 2893, 2893, 2422, 2422, 2422, 2422, 2422,
     2422, 2231, 2893, 2231, 2423, 2423, 2423, 2423, 2423, 2423,
     2424, 2424, 2424, 2424, 2424, 2424, 2233, 2430, 2430, 2430,
     2430, 2430, 2430, 2893, 2893, 2426, 2893, 2893, 2234, 2893,
     2234, 2424, 2424, 2424, 2424, 2424, 2424, 2427, 2236, 2427,
     2428, 2428, 2428, 2428, 2428, 2428, 2893, 2237, 1989, 2893,
     2893, 2893, 2241, 2429, 2429, 2429, 2429, 2429, 2429, 2432,
     1990, 2242, 1990, 2431, 2431, 2431, 2431, 2431, 2431, 1993,
     2893, 2433, 2893, 2433, 2436, 2436, 2436, 2436, 2436, 2436,

     2893, 1994, 2893, 1994, 2440, 2440, 2440, 2440, 2440, 2440,
     2441, 2441, 2441, 2441, 2441, 2441, 2425, 2425, 2425, 2425,
     2425, 2425, 2442, 2442, 2442, 2442, 2442, 2442, 2893, 2893,
     2893, 2893, 2893,  191, 2443, 2443, 2443, 2443, 2443, 2443,
     2893, 2893, 2893, 2893, 2893,  191, 2444, 2444, 2444, 2444,
     2444, 2444, 2435, 2435, 2435, 2435, 2435, 2435, 2893, 2434,
     2434, 2434, 2434, 2434, 2434, 2004, 2893, 2893, 2893, 2437,
     2437, 2437, 2437, 2437, 2437, 2893, 2893, 2893, 2893, 2893,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2248, 2254, 1333, 1333, 1333, 1333, 1333, 1333, 2893,

     2893, 2893, 2893, 2893, 2255, 2893, 2255, 2445, 2445, 2445,
     2445, 2445, 2445, 2446, 2446, 2446, 2446, 2446, 2446, 2250,
     2250, 2250, 2250, 2250, 2250, 2893, 2893, 2893, 2893, 2893,
      191, 2254, 2893, 2253, 2253, 2253, 2253, 2253, 2253, 2253,
     2253, 2253, 2253, 2261, 2004, 2255, 2447, 2447, 2447, 2447,
     2447, 2447, 2253, 2253, 2253, 2253, 2253, 2263, 2893, 2248,
     2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248, 2248,
     2248, 2265, 2893, 2283, 2283, 2283, 2283, 2283, 2283, 2893,
     2893, 2253, 2893, 2266,  191, 2266, 2448, 2448, 2448, 2448,
     2448, 2448, 2023, 2024, 2893, 2025, 2025, 2025, 2026, 2025,

     2025, 2025, 2025, 2025, 2025, 2027, 2028, 2025, 2449, 2450,
     2451, 2452, 2449, 2449, 2025, 2025, 2025, 2025, 2025, 2033,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2035, 2034, 2034, 2034,
     2034, 2034, 2023, 2025, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2035,
     2034, 2034, 2034, 2036, 2036, 2036, 2036, 2037, 2036, 2036,
     2036, 2036, 2036, 2023, 2023, 2023, 2023, 2023, 2023, 2284,
     2284, 2284, 2284, 2284, 2284, 2056, 2893, 2056, 2056, 2056,
     2056, 2056, 2056, 2056, 2056, 2056, 2056, 2893, 2893, 2056,

     2455, 2455, 2455, 2455, 2455, 2455, 2056, 2056, 2056, 2056,
     2056, 2058, 2454, 2454, 2454, 2454, 2454, 2454, 2085,  191,
     2893, 2893, 2893,  191, 2893, 2456, 2456, 2456, 2456, 2456,
     2456,  191, 2311, 2893, 2893, 2056,  191, 2456, 2456, 2456,
     2456, 2456, 2456, 2893, 2312, 2085, 2312, 2893,  191, 2457,
     2457, 2457, 2457, 2457, 2457, 2457, 2457, 2457, 2457, 2457,
     2457, 2462, 2462, 2462, 2462, 2462, 2462, 2463, 2463, 2463,
     2463, 2463, 2463, 2464, 2464, 2464, 2464, 2464, 2464, 2466,
     2466, 2466, 2466, 2466, 2466, 2465, 2465, 2465, 2465, 2465,
     2465, 2305, 2305, 2305, 2305, 2305, 2305,  191, 2305, 2305,

     2305, 2305, 2305, 2305, 1470, 1470, 1470, 1470, 1470, 1470,
     2893, 2893, 2467, 2467, 2467, 2467, 2467, 2467, 2468, 2468,
     2468, 2468, 2468, 2468, 2893, 2305, 2305, 2305, 2305, 2305,
     2305, 2305, 2305, 2305, 2305, 2305, 2305,  191, 2333, 2333,
     2333, 2333, 2333, 2333,  191, 2473, 2473, 2473, 2473, 2473,
     2473, 2307, 2307, 2307, 2307, 2307, 2307, 2311,  191, 2310,
     2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2318,
      191, 2312, 2322, 2893, 2893, 2893, 2893, 2893, 2310, 2310,
     2310, 2310, 2310, 2319, 2323, 2893, 2323, 2893, 2893, 2893,
     2893, 2332, 2332, 2332, 2332, 2332, 2332, 2893, 2472, 2472,

     2472, 2472, 2472, 2472, 2893, 2893, 2893, 2310, 2893, 2893,
     2893, 2893, 2474, 2474, 2474, 2474, 2474, 2474, 2475, 2475,
     2475, 2475, 2475, 2475, 2474, 2474, 2474, 2474, 2474, 2474,
     2475, 2475, 2475, 2475, 2475, 2475, 2893, 2469, 2469, 2469,
     2469, 2469, 2469, 2488, 2488, 2488, 2488, 2488, 2488, 2893,
     2893, 2893, 2470, 2470, 2470, 2470, 2470, 2470, 2104, 2105,
     2893, 2106, 2106, 2106, 2107, 2106, 2106, 2106, 2106, 2106,
     2106, 2108, 2109, 2106, 2104, 2104, 2104, 2104, 2104, 2104,
     2106, 2106, 2106, 2106, 2106, 2110, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,

     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2104, 2106,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2112,
     2112, 2112, 2112, 2113, 2112, 2112, 2112, 2112, 2112, 2471,
     2471, 2471, 2471, 2471, 2471, 2121, 2893, 2121, 2121, 2121,
     2121, 2121, 2121, 2121, 2121, 2121, 2121, 2381, 2387, 2121,
     2490, 2490, 2490, 2490, 2490, 2490, 2121, 2121, 2121, 2121,
     2121, 2122, 2491, 2491, 2491, 2491, 2491, 2491, 2491, 2491,
     2491, 2491, 2491, 2491, 2492, 2390, 2893, 2893, 2893, 2893,
     2384, 2893, 2893, 2893, 2893, 2121, 2493, 2893, 2493, 2494,

     2494, 2494, 2494, 2494, 2494, 2495, 2495, 2495, 2495, 2495,
     2495, 2495, 2495, 2495, 2495, 2495, 2495, 2384, 2497, 2497,
     2497, 2497, 2497, 2497, 2893, 2893, 2893, 2893, 2893, 2385,
     2893, 2385, 2496, 2496, 2496, 2496, 2496, 2496, 2497, 2497,
     2497, 2497, 2497, 2497, 2498, 2501, 2501, 2501, 2501, 2501,
     2501, 2893, 2398, 2893, 2893, 2893, 2499, 2893, 2499, 2390,
     2503, 2399, 2893, 2893, 2893, 2501, 2501, 2501, 2501, 2501,
     2501, 2391, 2504, 2391, 2504, 2505, 2505, 2505, 2505, 2505,
     2505, 2393, 2507, 2507, 2507, 2507, 2507, 2507, 2893, 2893,
     2394, 2189, 2893, 2893, 2893, 2893, 2506, 2506, 2506, 2506,

     2506, 2506, 2509, 2190, 2893, 2190, 2508, 2508, 2508, 2508,
     2508, 2508, 2893, 2893, 2510, 2893, 2510, 2513, 2513, 2513,
     2513, 2513, 2513, 2893, 2500, 2500, 2500, 2500, 2500, 2500,
     2893, 2893, 2512, 2512, 2512, 2512, 2512, 2512, 2193, 2502,
     2502, 2502, 2502, 2502, 2502, 2893, 2893, 2893, 2893, 2893,
     2194, 2893, 2194, 2515, 2515, 2515, 2515, 2515, 2515, 2516,
     2516, 2516, 2516, 2516, 2516, 2517, 2517, 2517, 2517, 2517,
     2517, 2893, 2893, 2893, 2893, 2893, 2196, 2893, 2893, 2893,
     2893, 2893, 2511, 2511, 2511, 2511, 2511, 2511, 2197, 2893,
     2197, 2404, 2404, 2404, 2404, 2404, 2404, 2518, 2518, 2518,

     2518, 2518, 2518, 2519, 2519, 2519, 2519, 2519, 2519, 2893,
     2893, 2893, 2201, 2893, 2893, 2893, 2893, 2893, 2514, 2514,
     2514, 2514, 2514, 2514, 2202, 2893, 2202, 2520, 2520, 2520,
     2520, 2520, 2520, 2522, 2522, 2522, 2522, 2522, 2522, 2523,
     2523, 2523, 2523, 2523, 2523, 2524, 2524, 2524, 2524, 2524,
     2524, 2525, 2525, 2525, 2525, 2525, 2525, 2528, 2528, 2528,
     2528, 2528, 2528, 2529, 2529, 2529, 2529, 2529, 2529, 2530,
     2530, 2530, 2530, 2530, 2530, 2531, 2531, 2531, 2531, 2531,
     2531, 2432, 2893, 2426, 2428, 2428, 2428, 2428, 2428, 2428,
     2893, 2893, 2408, 2408, 2408, 2408, 2408, 2408, 2428, 2428,

     2428, 2428, 2428, 2428, 2532, 2532, 2532, 2532, 2532, 2532,
     2236, 2534, 2534, 2534, 2534, 2534, 2534, 2893, 2893, 2237,
     2893, 2893, 2893, 2893, 2893, 2533, 2533, 2533, 2533, 2533,
     2533, 2434, 2434, 2434, 2434, 2434, 2434, 2535, 2535, 2535,
     2535, 2535, 2535, 2241, 2537, 2537, 2537, 2537, 2537, 2537,
     2893, 2893, 2242, 2538, 2538, 2538, 2538, 2538, 2538, 2893,
     2893, 2434, 2434, 2434, 2434, 2434, 2434, 2539, 2539, 2539,
     2539, 2539, 2539, 2539, 2539, 2539, 2539, 2539, 2539, 2541,
     2541, 2541, 2541, 2541, 2541, 2893, 2893, 2893, 2893, 2893,
      191, 2539, 2539, 2539, 2539, 2539, 2539, 2441, 2441, 2441,

     2441, 2441, 2441, 2446, 2446, 2446, 2446, 2446, 2446, 2443,
     2443, 2443, 2443, 2443, 2443, 2893, 2893, 2893, 2893, 2893,
      191, 2893, 2893, 2536, 2536, 2536, 2536, 2536, 2536, 2540,
     2893, 2540, 2540, 2540, 2540, 2540, 2540, 2540, 2540, 2540,
     2540, 2893, 2893, 2540, 2541, 2541, 2541, 2541, 2541, 2541,
     2540, 2540, 2540, 2540, 2540, 2543, 2444, 2444, 2444, 2444,
     2444, 2444, 2545, 2546, 2547, 2548, 2545, 2545, 2038, 2893,
     2826, 2893, 2893, 2893, 2040, 2893, 2893, 2893, 2893, 2540,
     2042, 2893, 2893, 2545, 2546, 2547, 2548, 2545, 2545, 2545,
     2546, 2547, 2548, 2545, 2545, 2545, 2546, 2547, 2548, 2545,

     2545, 2550, 2550, 2550, 2550, 2550, 2550, 2893,  237, 2893,
     2039, 2034, 2041,  215, 2893, 2893, 2893, 2034, 2893, 2893,
      191, 2043, 2893, 2034, 2551, 2551, 2551, 2551, 2551, 2551,
     2893,  237, 2893, 2039, 2034, 2041,  215, 2893, 2893, 2893,
     2034, 2893, 2893, 2893, 2043, 2893, 2034, 2286, 2893, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2893,
     2893, 2286, 2551, 2551, 2551, 2551, 2551, 2551, 2286, 2286,
     2286, 2286, 2286, 2288, 2553, 2553, 2553, 2553, 2553, 2553,
     2551, 2551, 2551, 2551, 2551, 2551, 2463, 2463, 2463, 2463,
     2463, 2463, 2893, 2893, 2893, 2893, 2893, 2286, 2291, 2893,

     2291, 2291, 2291, 2291, 2291, 2291, 2291, 2291, 2291, 2291,
      191, 2893, 2291, 2468, 2468, 2468, 2468, 2468, 2468, 2291,
     2291, 2291, 2291, 2291, 2293, 2466, 2466, 2466, 2466, 2466,
     2466, 2557, 2557, 2557, 2557, 2557, 2557, 2565, 2565, 2565,
     2565, 2565, 2565, 2893, 2893, 2893, 2893, 2893, 2291, 2552,
     2893, 2552, 2552, 2552, 2552, 2552, 2552, 2552, 2552, 2552,
     2552, 2893, 2893, 2552, 2465, 2465, 2465, 2465, 2465, 2465,
     2552, 2552, 2552, 2552, 2552, 2555, 2488, 2488, 2488, 2488,
     2488, 2488, 2566, 2566, 2566, 2566, 2566, 2566, 2490, 2490,
     2490, 2490, 2490, 2490, 2492, 2893, 2893, 2893, 2893, 2552,

     2567, 2567, 2567, 2567, 2567, 2567, 2893, 2893, 2893, 2568,
     2568, 2568, 2568, 2568, 2568, 2568, 2568, 2568, 2568, 2568,
     2568, 2570, 2570, 2570, 2570, 2570, 2570, 2893, 2893, 2553,
     2553, 2553, 2553, 2553, 2553, 2335, 2498, 2335, 2335, 2335,
     2335, 2335, 2335, 2335, 2335, 2335, 2335, 2893, 2893, 2335,
     2492, 2893, 2893, 2893, 2893, 2893, 2335, 2335, 2335, 2335,
     2335, 2336, 2493, 2893, 2493, 2569, 2569, 2569, 2569, 2569,
     2569, 2571, 2571, 2571, 2571, 2571, 2571, 2572, 2572, 2572,
     2572, 2572, 2572, 2893, 2893, 2335, 2340, 2893, 2340, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2893, 2893,

     2340, 2573, 2573, 2573, 2573, 2573, 2573, 2340, 2340, 2340,
     2340, 2340, 2341, 2498, 2893, 2893, 2573, 2573, 2573, 2573,
     2573, 2573, 2509, 2893, 2893, 2499, 2893, 2499, 2575, 2575,
     2575, 2575, 2575, 2575, 2503, 2893, 2340, 2576, 2576, 2576,
     2576, 2576, 2576, 2505, 2505, 2505, 2505, 2505, 2505, 2505,
     2505, 2505, 2505, 2505, 2505, 2577, 2577, 2577, 2577, 2577,
     2577, 2393, 2579, 2579, 2579, 2579, 2579, 2579, 2893, 2893,
     2394, 2893, 2893, 2893, 2893, 2893, 2578, 2578, 2578, 2578,
     2578, 2578, 2511, 2511, 2511, 2511, 2511, 2511, 2893, 2893,
     2398, 2893, 2893, 2574, 2574, 2574, 2574, 2574, 2574, 2399,

     2893, 2893, 2511, 2511, 2511, 2511, 2511, 2511, 2580, 2580,
     2580, 2580, 2580, 2580, 2582, 2582, 2582, 2582, 2582, 2582,
     2583, 2583, 2583, 2583, 2583, 2583, 2583, 2583, 2583, 2583,
     2583, 2583, 2584, 2584, 2584, 2584, 2584, 2584, 2585, 2585,
     2585, 2585, 2585, 2585, 2585, 2585, 2585, 2585, 2585, 2585,
     2586, 2586, 2586, 2586, 2586, 2586, 2590, 2590, 2590, 2590,
     2590, 2590, 2590, 2590, 2590, 2590, 2590, 2590, 2893, 2893,
     2581, 2581, 2581, 2581, 2581, 2581, 2592, 2592, 2592, 2592,
     2592, 2592, 2592, 2592, 2592, 2592, 2592, 2592, 2594, 2594,
     2594, 2594, 2594, 2594, 2595, 2598, 2598, 2598, 2598, 2598,

     2598, 2893, 2893, 2599, 2893, 2893, 2596, 2893, 2596, 2597,
     2597, 2597, 2597, 2597, 2597, 2600, 2893, 2600, 2538, 2538,
     2538, 2538, 2538, 2538, 2603, 2603, 2603, 2603, 2603, 2603,
     2550, 2550, 2550, 2550, 2550, 2550, 2611, 2611, 2611, 2611,
     2611, 2611, 2613, 2613, 2613, 2613, 2613, 2613, 2565, 2565,
     2565, 2565, 2565, 2565, 2566, 2566, 2566, 2566, 2566, 2566,
     2619, 2619, 2619, 2619, 2619, 2619, 2620, 2620, 2620, 2620,
     2620, 2620, 2621, 2621, 2621, 2621, 2621, 2621, 2893, 2893,
     2893, 2893, 2893, 2601, 2601, 2601, 2601, 2601, 2601, 2540,
     2893, 2540, 2540, 2540, 2540, 2540, 2540, 2540, 2540, 2540,

     2540, 2893, 2893, 2540, 2604, 2604, 2604, 2604, 2604, 2604,
     2540, 2540, 2540, 2540, 2540, 2543, 2381, 2621, 2621, 2621,
     2621, 2621, 2621, 2893, 2893, 2893, 2893, 2893, 2382, 2893,
     2382, 2571, 2571, 2571, 2571, 2571, 2571, 2893, 2893, 2540,
     2023, 2024, 2893, 2025, 2025, 2025, 2026, 2025, 2025, 2025,
     2025, 2025, 2025, 2027, 2028, 2025, 2605, 2606, 2607, 2608,
     2605, 2605, 2025, 2025, 2025, 2025, 2025, 2033, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2035, 2034, 2034, 2034, 2034, 2034,
     2023, 2025, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,

     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2035, 2034, 2034,
     2034, 2036, 2036, 2036, 2036, 2037, 2036, 2036, 2036, 2036,
     2036, 2023, 2023, 2023, 2023, 2023, 2023, 2552, 2893, 2552,
     2552, 2552, 2552, 2552, 2552, 2552, 2552, 2552, 2552, 2893,
     2893, 2552, 2622, 2622, 2622, 2622, 2622, 2622, 2552, 2552,
     2552, 2552, 2552, 2555, 2623, 2623, 2623, 2623, 2623, 2623,
     2387, 2624, 2624, 2624, 2624, 2624, 2624, 2893, 2893, 2893,
     2893, 2893, 2388, 2893, 2388, 2893, 2893, 2552, 2624, 2624,
     2624, 2624, 2624, 2624, 2625, 2625, 2625, 2625, 2625, 2625,
     2629, 2629, 2629, 2629, 2629, 2629, 2893, 2893, 2893, 2893,

     2893, 2626, 2599, 2893, 2893, 2893, 2893, 2612, 2612, 2612,
     2612, 2612, 2612, 2627, 2630, 2627, 2628, 2628, 2628, 2628,
     2628, 2628, 2893, 2893, 2893, 2893, 2631, 2893, 2631, 2633,
     2633, 2633, 2633, 2633, 2633, 2893, 2893, 2893, 2893, 2893,
     2576, 2576, 2576, 2576, 2576, 2576, 2634, 2634, 2634, 2634,
     2634, 2634, 2635, 2635, 2635, 2635, 2635, 2635, 2636, 2636,
     2636, 2636, 2636, 2636, 2640, 2640, 2640, 2640, 2640, 2640,
     2641, 2641, 2641, 2641, 2641, 2641, 2645, 2645, 2645, 2645,
     2645, 2645, 2650, 2650, 2650, 2650, 2650, 2650, 2642, 2893,
     2893, 2893, 2893, 2893, 2632, 2632, 2632, 2632, 2632, 2632,

     2643, 2595, 2643, 2644, 2644, 2644, 2644, 2644, 2644, 2893,
     2595, 2893, 2893, 2893, 2893, 2893, 2645, 2645, 2645, 2645,
     2645, 2645, 2596, 2647, 2596, 2646, 2646, 2646, 2646, 2646,
     2646, 2893, 2599, 2893, 2893, 2648, 2893, 2648, 2650, 2650,
     2650, 2650, 2650, 2650, 2600, 2038, 2600, 2652, 2653, 2654,
     2655, 2652, 2652, 2554, 2554, 2554, 2554, 2554, 2554, 2893,
     2652, 2653, 2654, 2655, 2652, 2652, 2656, 2656, 2656, 2656,
     2656, 2656, 2893, 2893, 2893, 2893, 2893, 2661, 2664, 2664,
     2664, 2664, 2664, 2664, 2893, 2893, 2893, 2039, 2034, 2662,
     2893, 2662, 2663, 2663, 2663, 2663, 2663, 2663, 2893, 2893,

     2893, 2893, 2893, 2649, 2649, 2649, 2649, 2649, 2649, 2893,
     2039, 2034, 2651, 2651, 2651, 2651, 2651, 2651, 2540, 2893,
     2540, 2540, 2540, 2540, 2540, 2540, 2540, 2540, 2540, 2540,
     2893, 2040, 2540, 2893, 2893, 2893, 2893, 2042, 2893, 2540,
     2540, 2540, 2540, 2540, 2543, 2893, 2652, 2653, 2654, 2655,
     2652, 2652, 2652, 2653, 2654, 2655, 2652, 2652, 2665, 2665,
     2665, 2665, 2665, 2665, 2893, 2666, 2893, 2893, 2540, 2041,
     2893, 2893, 2893, 2893, 2034, 2893, 2893, 2667, 2043, 2667,
     2034, 2669, 2669, 2669, 2669, 2669, 2669, 2893, 2676, 2893,
     2893, 2893, 2041, 2893, 2630, 2893, 2893, 2034, 2671, 2893,

     2677, 2043, 2677, 2034, 2670, 2670, 2670, 2670, 2670, 2670,
     2672, 2626, 2672, 2673, 2673, 2673, 2673, 2673, 2673, 2674,
     2674, 2674, 2674, 2674, 2674, 2893, 2674, 2674, 2674, 2674,
     2674, 2674, 2679, 2679, 2679, 2679, 2679, 2679, 2893, 2626,
     2893, 2893, 2893, 2893, 2893, 2668, 2668, 2668, 2668, 2668,
     2668, 2627, 2630, 2627, 2675, 2675, 2675, 2675, 2675, 2675,
     2893, 2893, 2893, 2893, 2631, 2647, 2631, 2893, 2678, 2678,
     2678, 2678, 2678, 2678, 2679, 2679, 2679, 2679, 2679, 2679,
     2681, 2681, 2681, 2681, 2681, 2681, 2682, 2682, 2682, 2682,
     2682, 2682, 2642, 2686, 2686, 2686, 2686, 2686, 2686, 2893,

     2893, 2642, 2893, 2893, 2893, 2893, 2893, 2686, 2686, 2686,
     2686, 2686, 2686, 2643, 2893, 2643, 2687, 2687, 2687, 2687,
     2687, 2687, 2688, 2688, 2688, 2688, 2688, 2688, 2893, 2893,
     2893, 2893, 2680, 2680, 2680, 2680, 2680, 2680, 2689, 2689,
     2689, 2689, 2689, 2689, 2893, 2690, 2690, 2690, 2690, 2690,
     2690, 2690, 2690, 2690, 2690, 2690, 2690, 2647, 2692, 2692,
     2692, 2692, 2692, 2692, 2893, 2893, 2893, 2893, 2893, 2648,
     2038, 2648, 2693, 2693, 2693, 2693, 2693, 2693, 2694, 2695,
     2696, 2697, 2694, 2694, 2040, 2694, 2695, 2696, 2697, 2694,
     2694, 2042, 2698, 2698, 2698, 2698, 2698, 2698, 2893, 2694,

     2695, 2696, 2697, 2694, 2694, 2893, 2694, 2695, 2696, 2697,
     2694, 2694, 2039, 2034, 2702, 2702, 2702, 2702, 2702, 2702,
     2666, 2893, 2041, 2893, 2893, 2893, 2893, 2034, 2893, 2893,
     2893, 2893, 2043, 2893, 2034, 2039, 2034, 2691, 2691, 2691,
     2691, 2691, 2691, 2661, 2893, 2041, 2893, 2893, 2893, 2893,
     2034, 2893, 2661, 2893, 2893, 2043, 2893, 2034, 2702, 2702,
     2702, 2702, 2702, 2702, 2662, 2661, 2662, 2703, 2703, 2703,
     2703, 2703, 2703, 2676, 2893, 2893, 2893, 2662, 2893, 2662,
     2704, 2704, 2704, 2704, 2704, 2704, 2705, 2705, 2705, 2705,
     2705, 2705, 2893, 2893, 2666, 2671, 2893, 2893, 2893, 2893,

     2705, 2705, 2705, 2705, 2705, 2705, 2667, 2666, 2667, 2893,
     2708, 2708, 2708, 2708, 2708, 2708, 2671, 2893, 2893, 2667,
     2893, 2667, 2708, 2708, 2708, 2708, 2708, 2708, 2672, 2893,
     2672, 2709, 2709, 2709, 2709, 2709, 2709, 2710, 2710, 2710,
     2710, 2710, 2710, 2711, 2711, 2711, 2711, 2711, 2711, 2893,
     2893, 2893, 2893, 2712, 2712, 2712, 2712, 2712, 2712, 2712,
     2712, 2712, 2712, 2712, 2712, 2893, 2893, 2893, 2676, 2893,
     2893, 2893, 2893, 2893, 2706, 2706, 2706, 2706, 2706, 2706,
     2677, 2893, 2677, 2893, 2893, 2893, 2893, 2707, 2707, 2707,
     2707, 2707, 2707, 2714, 2714, 2714, 2714, 2714, 2714, 2715,

     2715, 2715, 2715, 2715, 2715, 2716, 2716, 2716, 2716, 2716,
     2716, 2717, 2717, 2717, 2717, 2717, 2717, 2721, 2721, 2721,
     2721, 2721, 2721, 2722, 2722, 2722, 2722, 2722, 2722, 2723,
     2723, 2723, 2723, 2723, 2723, 2725, 2725, 2725, 2725, 2725,
     2725, 2726, 2726, 2726, 2726, 2726, 2726, 2893, 2713, 2713,
     2713, 2713, 2713, 2713, 2727, 2727, 2727, 2727, 2727, 2727,
     2728, 2728, 2728, 2728, 2728, 2728, 2730, 2730, 2730, 2730,
     2730, 2730, 2731, 2732, 2733, 2734, 2731, 2731, 2038, 2893,
     2893, 2893, 2893, 2893, 2040, 2893, 2893, 2893, 2893, 2893,
     2042, 2893, 2893, 2731, 2732, 2733, 2734, 2731, 2731, 2731,

     2732, 2733, 2734, 2731, 2731, 2731, 2732, 2733, 2734, 2731,
     2731, 2735, 2735, 2735, 2735, 2735, 2735, 2893, 2666, 2893,
     2039, 2034, 2041, 2893, 2893, 2893, 2893, 2034, 2893, 2893,
     2667, 2043, 2667, 2034, 2746, 2746, 2746, 2746, 2746, 2746,
     2893, 2893, 2893, 2039, 2034, 2041, 2893, 2893, 2893, 2893,
     2034, 2661, 2893, 2893, 2043, 2893, 2034, 2747, 2747, 2747,
     2747, 2747, 2747, 2662, 2893, 2662, 2703, 2703, 2703, 2703,
     2703, 2703, 2748, 2748, 2748, 2748, 2748, 2748, 2749, 2749,
     2749, 2749, 2749, 2749, 2750, 2750, 2750, 2750, 2750, 2750,
     2751, 2751, 2751, 2751, 2751, 2751, 2893, 2893, 2706, 2706,

     2706, 2706, 2706, 2706, 2752, 2752, 2752, 2752, 2752, 2752,
     2753, 2753, 2753, 2753, 2753, 2753, 2754, 2754, 2754, 2754,
     2754, 2754, 2755, 2755, 2755, 2755, 2755, 2755, 2756, 2756,
     2756, 2756, 2756, 2756, 2757, 2757, 2757, 2757, 2757, 2757,
     2758, 2758, 2758, 2758, 2758, 2758, 2759, 2759, 2759, 2759,
     2759, 2759, 2762, 2762, 2762, 2762, 2762, 2762, 2762, 2762,
     2762, 2762, 2762, 2762, 2763, 2763, 2763, 2763, 2763, 2763,
     2763, 2763, 2763, 2763, 2763, 2763, 2764, 2764, 2764, 2764,
     2764, 2764, 2764, 2764, 2764, 2764, 2764, 2764, 2765, 2765,
     2765, 2765, 2765, 2765, 2765, 2765, 2765, 2765, 2765, 2765,

     2766, 2767, 2768, 2769, 2766, 2766, 2038, 2893, 2893, 2893,
     2893, 2893, 2040, 2893, 2893, 2893, 2893, 2893, 2042, 2893,
     2893, 2766, 2767, 2768, 2769, 2766, 2766, 2766, 2767, 2768,
     2769, 2766, 2766, 2766, 2767, 2768, 2769, 2766, 2766, 2770,
     2770, 2770, 2770, 2770, 2770, 2893, 2893, 2893, 2039, 2034,
     2041, 2893, 2893, 2893, 2893, 2034, 2893, 2893, 2893, 2043,
     2893, 2034, 2785, 2785, 2785, 2785, 2785, 2785, 2893, 2893,
     2893, 2039, 2034, 2041, 2893, 2893, 2893, 2893, 2034, 2893,
     2893, 2893, 2043, 2893, 2034, 2785, 2785, 2785, 2785, 2785,
     2785, 2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786,

     2786, 2786, 2786, 2787, 2787, 2787, 2787, 2787, 2787, 2787,
     2787, 2787, 2787, 2787, 2787, 2788, 2788, 2788, 2788, 2788,
     2788, 2788, 2788, 2788, 2788, 2788, 2788, 2789, 2789, 2789,
     2789, 2789, 2789, 2789, 2789, 2789, 2789, 2789, 2789, 2790,
     2790, 2790, 2790, 2790, 2790, 2790, 2790, 2790, 2790, 2790,
     2790, 2791, 2791, 2791, 2791, 2791, 2791, 2792, 2792, 2792,
     2792, 2792, 2792, 2795, 2795, 2795, 2795, 2795, 2795, 2796,
     2796, 2796, 2796, 2796, 2796, 2797, 2798, 2799, 2800, 2797,
     2797, 2038, 2893, 2893, 2893, 2893, 2893, 2040, 2893, 2893,
     2893, 2893, 2893, 2042, 2893, 2893, 2797, 2798, 2799, 2800,

     2797, 2797, 2797, 2798, 2799, 2800, 2797, 2797, 2797, 2798,
     2799, 2800, 2797, 2797, 2801, 2801, 2801, 2801, 2801, 2801,
     2893, 2893, 2893, 2039, 2034, 2041, 2893, 2893, 2893, 2893,
     2034, 2893, 2893, 2893, 2043, 2893, 2034, 2816, 2816, 2816,
     2816, 2816, 2816, 2893, 2893, 2893, 2039, 2034, 2041, 2893,
     2893, 2893, 2893, 2034, 2893, 2893, 2893, 2043, 2893, 2034,
     2817, 2817, 2817, 2817, 2817, 2817, 2818, 2818, 2818, 2818,
     2818, 2818, 2819, 2819, 2819, 2819, 2819, 2819,  199, 2820,
     2893,  201,  201,  201,  202,  201,  201,  201,  201,  201,
      201,  204, 1700,  201, 2821, 2822, 2823, 2824, 2821, 2821,

      201,  201,  201,  201,  201,  214,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  216,  215,  215,  215,  215,  215,  199,  201,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  216,  215,  215,  215,  217,
      217,  217,  217,  218,  217,  217,  217,  217,  217,  199,
      199,  199,  199,  199,  199,  273, 2828, 2893,  275,  275,
      275,  276,  275,  275,  275,  275,  275,  275,  278, 1821,
      275,  273,  273,  273,  273,  273,  273,  275,  275,  275,
      275,  275,  282,  283,  283,  283,  283,  283,  283,  283,

      283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  273,  275,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
      283,  283,  283,  283,  283,  283,  284,  284,  284,  284,
      285,  284,  284,  284,  284,  284, 2829, 2829, 2829, 2829,
     2829, 2829,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   95,   95,   95,   95,   95,   95,   95,   95,
       95,   95,  100,  100,  100,  100,  100,  100,  100,  100,

      100,  100,  105,  105,  105,  105,  105,  105,  105,  105,
      105,  105,  110,  110,  110,  110,  110,  110,  110,  110,
      110,  110,  117,  117,  117,  117,  117,  117,  117,  117,
      117,  117,  128,  128,  128,  128,  128,  128,  128,  128,
      128,  128,  134,  134,  134,  134,  134,  134,  134,  134,
      134,  134,  147,  147,  147,  147,  147,  147,  147,  147,
      147,  147,  152,  152,  152,  152,  152,  152,  152,  152,
      152,  152,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  167,  167,  167,  167,  167,  167,  167,  167,

      167,  167,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  190, 2893, 2893, 2893, 2893,  190, 2893, 2893,
     2893,  190,  249,  249, 2893,  249,  249,  249,  249, 2893,
     2893,  249,  306,  306, 2893,  306,  306,  306,  306,  306,
      306,  306,  308,  308, 2893,  308,  308,  308,  308,  308,
      308,  308,  400, 2893, 2893, 2893, 2893,  400, 2893, 2893,
     2893,  400,  458,  458,  458,  458,  458,  458,  458, 2893,
     2893,  458,  459, 2893, 2893, 2893, 2893,  459,  473,  473,
     2893,  473,  473,  473,  473,  473,  473,  473,  249,  249,
     2893,  249,  249,  249,  249, 2893,  249,  249,  601,  601,

     2893,  601,  601,  601,  601,  601,  601,  601,  306,  306,
     2893,  306,  306,  306,  306,  306,  306,  306,  308,  308,
     2893,  308,  308,  308,  308,  308,  308,  308,  400, 2893,
     2893, 2893, 2893,  400, 2893, 2893, 2893,  400,  775, 2893,
     2893, 2893, 2893,  775,  458,  458,  458,  458,  458,  458,
      458, 2893,  458,  458,  473,  473, 2893,  473,  473,  473,
      473,  473,  473,  473,  847,  847, 2893,  847,  847,  847,
      847,  847,  847,  847,  855,  855, 2893,  855,  855,  855,
      855,  855,  855,  855,  926,  926, 2893,  926,  926,  926,
      926,  926,  926,  926,  601,  601, 2893,  601,  601,  601,

      601,  601,  601,  601, 1021, 1021, 2893, 1021, 1021, 1021,
     1021, 1021, 1021, 1021, 1029, 1029, 2893, 1029, 1029, 1029,
     1029, 1029, 1029, 1029, 1031, 1031, 2893, 1031, 1031, 1031,
     1031, 1031, 1031, 1031,  775, 2893, 2893, 2893, 2893,  775,
      400, 2893, 2893, 2893, 2893,  400, 2893, 2893, 2893,  400,
      926,  926, 2893,  926,  926,  926,  926,  926,  926,  926,
     1310, 1310, 2893, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
      473,  473, 2893,  473,  473,  473,  473,  473,  473,  473,
      459, 2893, 2893, 2893, 2893,  459,  847,  847, 2893,  847,
      847,  847,  847,  847,  847,  847,  855,  855, 2893,  855,

      855,  855,  855,  855,  855,  855, 1397, 1397, 2893, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1420, 1420, 2893, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1436, 2893, 2893, 2893,
     1436, 1436, 1436, 2893, 2893, 1436, 1031, 1031, 2893, 1031,
     1031, 1031, 1031, 1031, 1031, 1031,  601,  601, 2893,  601,
      601,  601,  601,  601,  601,  601, 1021, 1021, 2893, 1021,
     1021, 1021, 1021, 1021, 1021, 1021, 1029, 1029, 2893, 1029,
     1029, 1029, 1029, 1029, 1029, 1029, 1505, 1505, 2893, 1505,
     1505, 1505, 1505, 1505, 1505, 1505, 1521, 1521, 2893, 1521,
     1521, 1521, 1521, 1521, 1521, 1521,  400, 2893, 2893, 2893,

     2893,  400,  400, 2893, 2893,  400, 1619, 2893, 2893, 2893,
     1619, 1619, 1619, 2893, 2893, 1619,  926,  926, 2893,  926,
      926,  926,  926,  926,  926,  926, 1663, 1663, 2893, 1663,
     1663, 1663, 1663, 1663, 1663, 1663, 1665, 1665, 2893, 1665,
     1665, 1665, 1665, 1665, 1665, 1665,  855,  855, 2893,  855,
      855,  855,  855,  855,  855,  855, 1686, 1686, 2893, 1686,
     1686, 1686, 1686, 1686, 1686, 1686,  473,  473, 2893,  473,
      473,  473,  473,  473,  473,  473, 1397, 1397, 2893, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1747, 1747, 2893, 1747,
     1747, 1747, 1747, 1747, 1747, 1747, 1748, 1748, 2893, 1748,

     1748, 1748, 1748, 1748, 1748, 1748, 1420, 1420, 2893, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1436, 2893, 2893, 2893,
     1436, 1436, 1436, 2893, 2893, 1436, 1437, 2893, 2893, 2893,
     1437, 1437, 1437, 1031, 1031, 2893, 1031, 1031, 1031, 1031,
     1031, 1031, 1031, 1768, 1768, 2893, 1768, 1768, 1768, 1768,
     1768, 1768, 1768, 1029, 1029, 2893, 1029, 1029, 1029, 1029,
     1029, 1029, 1029, 1807, 1807, 2893, 1807, 1807, 1807, 1807,
     1807, 1807, 1807,  601,  601, 2893,  601,  601,  601,  601,
      601,  601,  601, 1505, 1505, 2893, 1505, 1505, 1505, 1505,
     1505, 1505, 1505, 1844, 1844, 2893, 1844, 1844, 1844, 1844,

     1844, 1844, 1844, 1845, 1845, 2893, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1521, 1521, 2893, 1521, 1521, 1521, 1521,
     1521, 1521, 1521, 1619, 2893, 2893, 2893, 1619, 1619, 1619,
     2893, 2893, 1619, 1620, 2893, 2893, 2893, 1620, 1620, 1620,
     1997, 1997, 2893, 1997, 1997, 1997, 1997, 1997, 1997, 1997,
     2001, 2001, 2893, 2001, 2001, 2001, 2001, 2001, 2001, 2001,
      855,  855, 2893,  855,  855,  855,  855,  855,  855,  855,
     2009, 2009, 2893, 2009, 2009, 2009, 2009, 2009, 2009, 2009,
     2010, 2010, 2893, 2010, 2010, 2010, 2010, 2010, 2010, 2010,
      473,  473, 2893,  473,  473,  473,  473,  473,  473,  473,

     2047, 2047, 2893, 2047, 2047, 2047, 2047, 2047, 2047, 2047,
      926,  926, 2893,  926,  926,  926,  926,  926,  926,  926,
     2055, 2055, 2893, 2055, 2055, 2055, 2055, 2055, 2055, 2055,
     2056, 2056, 2893, 2056, 2056, 2056, 2056, 2056, 2056, 2056,
     1747, 1747, 2893, 1747, 1747, 1747, 1747, 1747, 1747, 1747,
     2062, 2062, 2893, 2062, 2062, 2062, 2062, 2062, 2062, 2062,
     1748, 1748, 2893, 1748, 1748, 1748, 1748, 1748, 1748, 1748,
     2063, 2063, 2893, 2063, 2063, 2063, 2063, 2063, 2063, 2063,
     2072, 2893, 2893, 2893, 2072, 2072, 2072, 2893, 2893, 2072,
     2073, 2893, 2893, 2893, 2073, 2893, 2073, 2075, 2075, 2893,

     2075, 2075, 2075, 2075, 2075, 2075, 2075, 2079, 2079, 2893,
     2079, 2079, 2079, 2079, 2079, 2079, 2079, 1029, 1029, 2893,
     1029, 1029, 1029, 1029, 1029, 1029, 1029, 1031, 1031, 2893,
     1031, 1031, 1031, 1031, 1031, 1031, 1031, 2090, 2090, 2893,
     2090, 2090, 2090, 2090, 2090, 2090, 2090, 2091, 2091, 2893,
     2091, 2091, 2091, 2091, 2091, 2091, 2091,  520,  520, 2893,
      520,  520,  520,  520,  520,  520,  520,  601,  601, 2893,
      601,  601,  601,  601,  601,  601,  601, 2115, 2115, 2893,
     2115, 2115, 2115, 2115, 2115, 2115, 2115, 2120, 2120, 2893,
     2120, 2120, 2120, 2120, 2120, 2120, 2120, 2121, 2121, 2893,

     2121, 2121, 2121, 2121, 2121, 2121, 2121, 1844, 1844, 2893,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 2127, 2127, 2893,
     2127, 2127, 2127, 2127, 2127, 2127, 2127, 1845, 1845, 2893,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 2128, 2128, 2893,
     2128, 2128, 2128, 2128, 2128, 2128, 2128, 2211, 2893, 2893,
     2893, 2211, 2211, 2211, 2893, 2893, 2211, 2212, 2893, 2893,
     2893, 2212, 2893, 2212, 2247, 2247, 2893, 2247, 2247, 2247,
     2247, 2247, 2247, 2247,  855,  855, 2893,  855,  855,  855,
      855,  855,  855,  855, 2253, 2253, 2893, 2253, 2253, 2253,
     2253, 2253, 2253, 2253, 2257, 2257, 2893, 2257, 2257, 2257,

     2257, 2257, 2257, 2257, 2260, 2260, 2893, 2260, 2260, 2260,
     2260, 2260, 2260, 2260, 2264, 2264, 2893, 2264, 2264, 2264,
     2264, 2264, 2264, 2264,  473,  473, 2893,  473,  473,  473,
      473,  473,  473,  473, 2276, 2276, 2893, 2276, 2276, 2276,
     2276, 2276, 2276, 2276, 2055, 2055, 2893, 2055, 2055, 2055,
     2055, 2055, 2055, 2055, 2277, 2277, 2893, 2277, 2277, 2277,
     2277, 2277, 2277, 2277, 2056, 2056, 2893, 2056, 2056, 2056,
     2056, 2056, 2056, 2056,  926,  926, 2893,  926,  926,  926,
      926,  926,  926,  926, 2282, 2282, 2893, 2282, 2282, 2282,
     2282, 2282, 2282, 2282, 2285, 2285, 2893, 2285, 2285, 2285,

     2285, 2285, 2285, 2285, 2286, 2286, 2893, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2290, 2290, 2893, 2290, 2290, 2290,
     2290, 2290, 2290, 2290, 2294, 2294, 2893, 2294, 2294, 2294,
     2294, 2294, 2294, 2294, 2291, 2291, 2893, 2291, 2291, 2291,
     2291, 2291, 2291, 2291, 2295, 2295, 2893, 2295, 2295, 2295,
     2295, 2295, 2295, 2295, 1437, 2893, 2893, 2893, 1437, 2893,
     1437, 2072, 2893, 2893, 2893, 2072, 2072, 2072, 2893, 2893,
     2072, 2073, 2893, 2893, 2893, 2073, 2073, 2073, 2302, 2302,
     2893, 2302, 2302, 2302, 2302, 2302, 2302, 2302, 1029, 1029,
     2893, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 2304, 2304,

     2893, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 1031, 1031,
     2893, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 2310, 2310,
     2893, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2314, 2314,
     2893, 2314, 2314, 2314, 2314, 2314, 2314, 2314, 2317, 2317,
     2893, 2317, 2317, 2317, 2317, 2317, 2317, 2317, 2321, 2321,
     2893, 2321, 2321, 2321, 2321, 2321, 2321, 2321,  601,  601,
     2893,  601,  601,  601,  601,  601,  601,  601, 2327, 2327,
     2893, 2327, 2327, 2327, 2327, 2327, 2327, 2327, 2120, 2120,
     2893, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2328, 2328,
     2893, 2328, 2328, 2328, 2328, 2328, 2328, 2328, 2121, 2121,

     2893, 2121, 2121, 2121, 2121, 2121, 2121, 2121, 2334, 2334,
     2893, 2334, 2334, 2334, 2334, 2334, 2334, 2334, 2335, 2335,
     2893, 2335, 2335, 2335, 2335, 2335, 2335, 2335, 2339, 2339,
     2893, 2339, 2339, 2339, 2339, 2339, 2339, 2339, 2343, 2343,
     2893, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2340, 2340,
     2893, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 2344, 2344,
     2893, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 1620, 2893,
     2893, 2893, 1620, 2893, 1620, 2211, 2893, 2893, 2893, 2211,
     2211, 2211, 2893, 2893, 2211, 2212, 2893, 2893, 2893, 2212,
     2212, 2212, 2438, 2438, 2893, 2438, 2438, 2438, 2438, 2438,

     2438, 2438,  855,  855, 2893,  855,  855,  855,  855,  855,
      855,  855, 2253, 2253, 2893, 2253, 2253, 2253, 2253, 2253,
     2253, 2253, 2260, 2260, 2893, 2260, 2260, 2260, 2260, 2260,
     2260, 2260, 2264, 2264, 2893, 2264, 2264, 2264, 2264, 2264,
     2264, 2264, 2453, 2453, 2893, 2453, 2453, 2453, 2453, 2453,
     2453, 2453, 2055, 2055, 2893, 2055, 2055, 2055, 2055, 2055,
     2055, 2055, 2056, 2056, 2893, 2056, 2056, 2056, 2056, 2056,
     2056, 2056, 1437, 2893, 2893, 2893, 1437, 1437, 1437, 2459,
     2459, 2893, 2459, 2459, 2459, 2459, 2459, 2459, 2459, 2461,
     2461, 2893, 2461, 2461, 2461, 2461, 2461, 2461, 2461, 1029,

     1029, 2893, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 2310,
     2310, 2893, 2310, 2310, 2310, 2310, 2310, 2310, 2310, 2317,
     2317, 2893, 2317, 2317, 2317, 2317, 2317, 2317, 2317, 2321,
     2321, 2893, 2321, 2321, 2321, 2321, 2321, 2321, 2321, 2120,
     2120, 2893, 2120, 2120, 2120, 2120, 2120, 2120, 2120, 2121,
     2121, 2893, 2121, 2121, 2121, 2121, 2121, 2121, 2121, 1620,
     2893, 2893, 2893, 1620, 1620, 1620, 2540, 2540, 2893, 2540,
     2540, 2540, 2540, 2540, 2540, 2540, 2542, 2542, 2893, 2542,
     2542, 2542, 2542, 2542, 2542, 2542, 2544, 2544, 2893, 2544,
     2544, 2544, 2544, 2544, 2544, 2544,  855,  855, 2893,  855,

      855,  855,  855,  855,  855,  855, 2285, 2285, 2893, 2285,
     2285, 2285, 2285, 2285, 2285, 2285, 2286, 2286, 2893, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2290, 2290, 2893, 2290,
     2290, 2290, 2290, 2290, 2290, 2290, 2291, 2291, 2893, 2291,
     2291, 2291, 2291, 2291, 2291, 2291, 2552, 2552, 2893, 2552,
     2552, 2552, 2552, 2552, 2552, 2552, 2554, 2554, 2893, 2554,
     2554, 2554, 2554, 2554, 2554, 2554, 2556, 2556, 2893, 2556,
     2556, 2556, 2556, 2556, 2556, 2556, 1029, 1029, 2893, 1029,
     1029, 1029, 1029, 1029, 1029, 1029, 2334, 2334, 2893, 2334,
     2334, 2334, 2334, 2334, 2334, 2334, 2335, 2335, 2893, 2335,

     2335, 2335, 2335, 2335, 2335, 2335, 2339, 2339, 2893, 2339,
     2339, 2339, 2339, 2339, 2339, 2339, 2340, 2340, 2893, 2340,
     2340, 2340, 2340, 2340, 2340, 2340, 2591, 2591, 2893, 2591,
     2591, 2591, 2591, 2591, 2591, 2591, 2593, 2593, 2893, 2593,
     2593, 2593, 2593, 2593, 2593, 2593, 2602, 2602, 2893, 2602,
     2602, 2602, 2602, 2602, 2602, 2602, 2540, 2540, 2893, 2540,
     2540, 2540, 2540, 2540, 2540, 2540, 2542, 2542, 2893, 2542,
     2542, 2542, 2542, 2542, 2542, 2542,  459, 2893, 2893, 2893,
     2893,  459, 2610, 2610, 2893, 2610, 2610, 2610, 2610, 2610,
     2610, 2610, 2073, 2893, 2893, 2893, 2073, 2893, 2073, 2212,

     2893, 2893, 2893, 2212, 2893, 2212, 2699, 2699, 2699, 2893,
     2699, 2699, 2699, 2699, 2699, 2699, 2724, 2724, 2893, 2724,
     2724, 2724, 2724, 2724, 2724, 2724, 2729, 2729, 2893, 2729,
     2729, 2729, 2729, 2729, 2729, 2729,   47, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893
    } ;

static yyconst short int yy_chk[26025] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    9,    9,   10,   10,   39,   39,
       40,   40,   41,   41,   42,   42,   55,   56,   56,   56,
       56,   56,   56,   85,   85,  441,    9,   66,   10,   11,

       11,   55,   55,   55,   55,   55,   55,   66,   66,   61,
       67,   82,   86,   86,   11,   11,   11,   11,   11,   11,
       67,   67,   96,   96,   61,   61,   61,   61,   61,   61,
       91, 2891,   93,   82,   11,   97,   97,  101,  101,  441,
       91,   91,   93,   93,   11,   11,  102,  102,  106,  106,
       61,   61,   56,   56,   56,   56,   56,   56,  103,  103,
      103,  103,  103,  103,  103, 2889,   55,   55,   55,   55,
       55,   55,   60,   61,   61,  107,  107,  111,  111,   11,
       11,   11,   11,   11,   11,   12,   12,   60,   60,   60,
       99,   60,   60,  112,  112,  118,  118,  180,   83,  133,

       12,   12,   12,   12,   12,   12,  119,  119,   62,  104,
       60,  341,   83,  180,   60,  129,  129,  130,  130,  777,
       12,  135,  135,   62,   62,   62,   62,   62,   62,   83,
       12,   12,  777,   60,   83,  177,   83,   60,   87,   98,
       83,  133,  132,   98,   98,   98,   98,   98,   98,   87,
       62,   62,  177,   87,   87,   87,   87,   87,   87,   99,
       99,   99,   99,   99,   99,   12,   12,   12,   12,   12,
       12,   13,   13,   62,   62,  104,  104,  104,  104,  104,
      104,   87,  132,  136,  136,  341,   13,   13,   13,   13,
       13,   13,  108, 1313,  108, 1313,  108,  108,  108,  108,

      108,  108,  148,  148,   87,   88,  149,  149,  153,  153,
     2887,  109,   87,  109,  113,  184,   88,  154,  154,  184,
       88,   88,   88,   88,   88,   88,   89,  158,  158,  113,
      113,  113,  113,  113,  113,  159,  159,   89,   94,  163,
      163,   89,   89,   89,   89,   89,   89,   88,  216,   94,
      173,   13,   13,   13,   13,   13,   13,   14,   14,  164,
      164,  168,  168, 2886,   89,  169,  169,  171,  171,  228,
       88,  216,   14,   14,   14,   14,   14,   14,  237,   88,
      109,  109,  109,  109,  109,  109,  187,   89,  172,  172,
       90,  187,  173,  228,  113,  113,  113,  113,  113,  113,

       89,   90,  237,  320,  320,   90,   90,   90,   90,   90,
       90,  185,   94,  229,  238,  185,  228, 2883,   94,   94,
       94,   94,   94,   94,  114,  114,  114,  114,  114,  114,
      312,   90,  218,  218,  218,  218,  229,   14,   14,   14,
       14,   14,   14,   15,   15,  115,  115,  115,  115,  115,
      115, 2771,  312,  245,   90,  238,  238,  327,   15,   15,
       15,   15,   15,   15,   90,  116,  116,  116,  116,  116,
      116,  137,  137,  137,  137,  137,  137,  245,  238,  238,
      327, 2771,  120,  142,  142,  142,  142,  142,  142,  114,
      114,  114,  114,  114,  114,  120,  121,  120,  120,  120,

      120,  120,  120,  120,  248,  248,  248, 2882,  243,  121,
      404,  121,  121,  121,  121,  121,  121,  121,  122, 2881,
      243,  243,  243,   15,   15,   15,   15,   15,   15,   16,
       16,  122,  264,  122,  122,  122,  122,  122,  122,  122,
      123,  124,  264,  264,   16,   16,   16,   16,   16,   16,
      243,  243,  404,  123,  124,  123,  123,  123,  123,  123,
      123,  123,  124,  125,  344,  344,  234,  349,  349,  126,
      332,  294,  675,  243,  243,  127,  125,  675,  234,  234,
      234,  266,  126,  315,  125,  315, 2880,  234,  127,  315,
      126,  266,  266,  234,  332,  294,  127,  138,  138,  138,

      138,  138,  138,  138,  138,  138,  234,  354,  354,   16,
       16,   16,   16,   16,   16,   17,   17,  234,  294,  361,
      361,  124,  124,  124,  124,  124,  124,  369,  369,  234,
       17,   17,   17,   17,   17,   17,  143,  143,  143,  234,
      298,  298,  298,  125,  125,  125,  125,  125,  125,  126,
      126,  126,  126,  126,  126,  127,  127,  127,  127,  127,
      127,  139,  139,  139,  139,  139,  139,  139,  139,  139,
      140,  140,  140,  140,  140,  140,  140,  140,  140,  141,
      141,  141,  141,  141,  141,  141,  141,  141,  144,  144,
      144,  285,  285,  285,  285,   17,   17,   17,   17,   17,

       17,   18,   18, 2878,  143,  143,  143,  143,  143,  143,
      150,  150,  150,  150,  150,  150,   18,   18,   18,   18,
       18,   18,  151,  151,  151,  151,  151,  151,  155,  155,
      155,  155,  155,  155,  156,  156,  156,  156,  156,  156,
      145,  145,  145,  299,  299,  299,  146,  146,  146,  160,
      161,  402,  402,  444,  160,  161,  144,  144,  144,  144,
      144,  144,  160,  161,  160,  160,  160,  160,  160,  160,
      160,  161,  165,  165,  165,  165,  165,  165,  405,  405,
      444,   18,   18,   18,   18,   18,   18,   19,   19,  166,
      166,  166,  166,  166,  166,   19,  334,   19,  328,  328,

      328,  328,   19,   19,   19,   19,   19,   19,  145,  145,
      145,  145,  145,  145,  146,  146,  146,  146,  146,  146,
      334,  194,  195,  195,  195,  195,  195,  195,  414,  414,
      161,  161,  161,  161,  161,  161,  194,  194,  194,  194,
      194,  194,  196,  196,  196,  196,  196,  196,  197,  197,
      197,  197,  197,  197,  198,  198,  198,  198,  198,  198,
      203,  203,  203,  203,  203,  203, 2737,   19,   19,   19,
       19,   19,   19,   20,   20,  206,  206,  206,  206,  206,
      206,   20, 2737,   20,  417,  417,  338,  436,   20,   20,
       20,   20,   20,   20,  330,  200,  338,  338,  420,  420,

      200,  194,  194,  194,  194,  194,  194,  205,  200,  210,
      200,  200,  200,  200,  200,  200,  200,  330,  431,  431,
     2877,  340,  205,  205,  205,  205,  205,  205,  211,  436,
      331,  340,  340,  205,  434,  434,  435,  435,  200,  220,
      220,  220,  220,  220,  220,  680,  403,  210,  440,  680,
      210, 1677, 1677,   20,   20,   20,   20,   20,   20,   21,
       21,  200, 1680, 1680,  231,  212,  211,  421,  331,  200,
      210,  211,  421,  210,   21,   21,   21,   21,   21,   21,
      212,  212,  212,  212,  212,  212,  403,  440,  421,  211,
     1444,  331, 1444, 2876,  211,  213,  472,  472,  472,  472,

      471,  221,  231,  212,  331,  534,  231,  246,  212,  303,
      213,  213,  213,  213,  213,  213,  221,  221,  221,  221,
      221,  221,  303,  471,  565,  231,  212,  221,  534,  231,
      303,  212,  222,  222,  222,  222,  222,  222,  223,   21,
       21,   21,   21,   21,   21,   22,   22, 1067,  565,  246,
      246,  227, 1067,  223,  223,  223,  223,  223,  223, 2870,
       22,   22,   22,   22,   22,   22,  227,  227,  227,  227,
      227,  227,  246,  246, 2869,  493,  223,  493,  281,  579,
      776,  223,  241,  277,  277,  277,  277,  277,  277,  303,
      303,  303,  303,  303,  241,  241,  241,  426,  493,  223,

      493, 1150,  426,  579,  223,  321, 1150,  825, 2868,  242,
      280,  280,  280,  280,  280,  280,  825,  776,  426, 2867,
      241,  242,  242,  242,  241,   22,   22,   22,   22,   22,
       22,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,  241, 1585,   23, 1585,  241,  321,  887,
      242,  242,   23,   23,   23,   23,   23,   23,  281,  281,
      281,  281,  281,  281,  250,  250,  250,  250,  250,  250,
      247,  321,  887,  242,  242,  250,  828,  462,  463,  321,
     2866,   23,  247,  247,  247,  828, 1783, 1783,   23,  462,
      463,  462,  463,  253,  253,  253,  253,  253,  253,   23,

       24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
       24,   24,  247,  247,   24,  290,  290,  290,  290,  290,
      290,   24,   24,   24,   24,   24,   24, 1786, 1786,  250,
      250,  250,  250,  250,  250,  247,  247,  256,  256,  256,
      256,  256,  256,  533,  890,  890,  890,  890,  256, 2863,
       24,  262,  262,  262,  262,  262,  262,   24,  253,  253,
      253,  253,  253,  253, 1589,  591, 1589,  533,   24,   25,
       25,  269,  269,  269,  269,  269,  269,  539,  539,  539,
      539,  539,  269, 2862,   25,   25,   25,   25,   25,   25,
      533,  539,  272,  272,  272,  272,  272,  272,  540,  540,

      540, 2861,  256,  256,  256,  256,  256,  256, 1234,  274,
      810,  894,  540, 1234,  274,  591,  262,  262,  262,  262,
      262,  262,  274,  292,  292,  292,  292,  292,  292,  293,
      274,  297,  297,  297,  810,  894,  269,  269,  269,  269,
      269,  269,  279,  322,  322,  322,  322,  322,  322,   25,
       25,   25,   25,   25,   25,   26,   26,  272,  272,  272,
      272,  272,  272,  488,  300,  500, 1224,  723,  279,  291,
       26,   26,   26,   26,   26,   26,  300,  300,  300,  723,
     1224,  723, 1274,  274,  724,  300,  853, 1274,  957,  274,
      274,  274,  274,  274,  274,  291,  724, 1027,  724,  297,

      297,  297,  297,  297,  297,  488,  488,  500,  500,  293,
      293,  293,  293,  293,  293,  342,  342,  342,  342,  342,
      342,  333,  279,  279,  279,  279,  279,  279,  488,  488,
      500,  500,  853,  329,  957,   26,   26,   26,   26,   26,
       26,   27,   27, 1027,  300,  300,  300,  300,  300,  291,
      291,  291,  291,  291,  291, 1204,   27,   27,   27,   27,
       27,   27,  333,  314, 1204, 1207,  288,  345,  345,  345,
      345,  345,  345, 2860, 1207,  329,  301,  314,  288,  288,
      288, 2857,  638,  638,  638,  333,  896,  288,  301,  301,
      301, 1652, 1104,  288,  314,  333,  638,  301,  329,  314,

     1652,  314,  318,  561,  318,  314,  288,  329,  318,  318,
      896,  318,  318, 2856,  561,  318,  318,  288,  892,  318,
      318,   27,   27,   27,   27,   27,   27,   28,   28,  288,
      347,  347,  347,  347,  347,  347,  507,  561, 1104,  288,
      901,  892,   28,   28,   28,   28,   28,   28,  348, 1155,
      638,  638,  296, 1155, 1317,  302,  301,  301,  301,  301,
      301,  301,  304,  901,  296,  296,  296,  302,  302,  302,
      656, 1654,  305,  296, 2855,  304,  302,  507,  507,  296,
     1654,  656,  346,  304,  508,  305,  346,  346,  346,  346,
      346,  346,  296,  305,  350,  350,  350,  350,  350,  350,

      507,  507, 2884,  296,  656, 1317, 2300,   28,   28,   28,
       28,   28,   28,   29,   29,  296, 1171,  348,  348,  348,
      348,  348,  348, 1944, 1944,  296,  508,  508,   29,   29,
       29,   29,   29,   29,  902,  302,  302,  302,  302,  302,
     1171, 2884,  304,  304,  304,  304,  304,  304,  324,  508,
      508, 1919,  305,  305,  305,  305,  305,  902,  323,  324,
     1919, 2300,  566,  324,  324,  324,  324,  324,  324,  323,
     1406, 2854, 1225,  323,  323,  323,  323,  323,  323,  351,
      351,  351,  351,  351,  351,  351, 1225,  353,  633, 2885,
      324,  325,  343,   29,   29,   29,   29,   29,   29,   30,

       30,  323,  325,  343,  566,  566,  325,  325,  325,  325,
      325,  325,  633,  324,   30,   30,   30,   30,   30,   30,
     1277, 1406,  324,  326,  323, 1277, 1282,  566,  566,  325,
     1959, 1959,  323, 2885,  326,  633,  948, 1051,  326,  326,
      326,  326,  326,  326,  352,  352,  352,  352,  352,  352,
     1282, 2853,  325,  353,  353,  353,  353,  353,  353,  948,
     1051, 1238, 1238, 1238,  326,  325,  343,  360, 2016,  360,
     2016, 1052,  343,  343,  343,  343,  343,  343, 2167,   30,
       30,   30,   30,   30,   30,   31,   31,  326,  355,  355,
      355,  355,  355,  355, 1052, 2852, 2097,  326, 2097, 1226,

       31,   31,   31,   31,   31,   31,  356,  356,  356,  356,
      356,  356,  357, 1226,  357, 2167,  357,  357,  357,  357,
      357,  357,  358,  358,  358,  358,  358,  358,  359,  359,
      359,  359,  359,  359,  362, 2851,  360,  360,  360,  360,
      360,  360,  363,  363,  363,  363,  363,  363, 2849,  362,
      362,  362,  362,  362,  362,  364,  364,  364,  364,  364,
      364, 1068, 1068, 1068, 1068,   31,   31,   31,   31,   31,
       31,   32,   32,  365,  365,  365,  365,  365,  365,  366,
      366,  366,  366,  366,  366,  367,   32,   32,   32,   32,
       32,   32,  639,  639,  639, 1228, 2848,  367,  368,  367,

      367,  367,  367,  367,  367,  367,  639,  370, 1318, 1228,
      368,  635,  368, 1318,  362,  362,  362,  362,  362,  362,
      370,  371,  370,  370,  370,  370,  370,  370,  370,  372,
      408,  408,  408,  408,  408,  408,  371,  371,  371,  371,
      371,  371,  372, 2845,  372,  372,  372,  372,  372,  372,
      372,   32,   32,   32,   32,   32,   32,   37,   37,  382,
      382,  382,  382,  382,  382,  382,  635,  635,  635,  635,
      635,  373,   37,   37,   37,   37,   37,   37,  368,  368,
      368,  368,  368,  368,  373,  374,  373,  373,  373,  373,
      373,  373,  373,  375, 1239, 1239, 1239, 2844,  374,  377,

      374,  374,  374,  374,  374,  374,  374,  376,  375,  375,
      375,  375,  375,  375,  377,  377,  377,  377,  377,  377,
      376, 1229,  376,  376,  376,  376,  376,  376,  376, 2843,
     2842,  386,  378, 1096, 1305, 1229, 2841,   37,   37,   37,
       37,   37,   37,   38,   38,  378, 1922,  378,  378,  378,
      378,  378,  378,  378,  379, 1922, 1096, 1305,   38,   38,
       38,   38,   38,   38,  380,  385, 1289,  379, 2840,  379,
      379,  379,  379,  379,  379,  379,  381,  380,  385,  380,
      380,  380,  380,  380,  380,  380,  385, 1251, 1251, 1251,
     1289,  381,  381,  381,  381,  381,  381,  383,  383,  383,

      383,  383,  383,  383,  384,  384,  384,  384,  384,  384,
      384,  386,  386,  386,  386,  386,  386,  397,  968,  968,
      968,  968,  968,   38,   38,   38,   38,   38,   38,   43,
      469,  398,  536,  536,  536,  536,  536,   43,   43, 1232,
     2839,   43,  536, 2413,   43,  385,  385,  385,  385,  385,
      385,   43, 1306, 1232,   43, 2458, 2838,  953,  953,  953,
       43,   43, 1352,   43,  469, 1357,   43,   43,   43,   43,
       43,  953, 2837,   43,   44, 1306,  397,  397,  397,  397,
      397,  397,   44,   44, 1369, 1352,   44,  469, 1357,   44,
      398,  398,  398,  398,  398,  398,   44, 1359, 2413,   44,

     1254, 1254, 1254,  469, 1449,   44,   44, 1369,   44, 1449,
     2458,   44,   44,   44,   44,   44, 2835, 2834,   44,   58,
       58, 1359,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,

       58,   58,   58,   58,   58,   58,   59,  387,  412,  412,
      412,  412,  412,  412,  399, 1101, 1101, 1101,   59,   59,
       59,   59, 2833, 2832,   59,   59,   59,   59, 1316, 1101,
     1255, 1255, 1255,   59,  406,  406,  406,  406,  406,  406,
      406,  406,  406, 2831, 1316,  836,   59,  836,   59,   59,
      415,  415,  415,  415,  415,  415, 2830,   59,  407,  407,
      407,  407,  407,  407,  407,  407,  407, 1316,  836,   59,
      836,   59,   59,  399,  399,  399,  399,  399,  399,   59,
       64,  416,  416,  416,  416,  416,  416,  387,  387,  387,
      387,  387,  387,   64,   64, 2815,   64,   64,   64,   64,

       64,   64, 1129, 1129, 1129, 1129, 1129,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64, 2814,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   65,   65, 2813,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,

       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   71, 2812, 2521,   71,   71,   71,
       71,   71,   71, 1236, 1236, 1236, 1236, 1236,   71,  409,
      409,  409,  409,  409,  409,  409,  409,  409,  418,  418,
      418,  418,  418,  418,  419,  419,  419,  419,  419,  419,
      423,  423,  423,  423,  423,  423,  428,  428,  428,  428,

      428,  428,  432,  432,  432,  432,  432,  432, 1267, 1267,
     1267, 2521,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   72,   72,
     2811,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,

       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   73,  433,  433,  433,  433,
      433,  433,  388, 2810,  956,  580,  489,   73,   73,   73,
     1249, 1249, 1249, 1249, 1249,  388,   73,  956, 2180,  852,
     2180,  425,   73,  388, 1355, 1355, 1355, 1355,  956,  389,
      977, 2183,  852, 2183,  852,   73,  425,  425,  425,  425,
      425,  425,  389,  390,  489, 1113,   73,  580,  580,  489,
      389,  956, 2225,  391,  977,  852,  390,  852,   73, 1252,
     1252, 1252, 1252, 1252,  390,  392,  391,  489,   73, 1113,
      580,  580,  489, 2879,  391,   73,  490,  977,   73,   73,

       73,   74,  388,  388,  388,  388,  388,  388,  393, 2225,
     2879, 1361, 1113,   74,   74,   74,  474,  474,  474,  474,
      474,  474,   74, 1265, 1265, 1265, 1265, 1265,   74,  389,
      389,  389,  389,  389,  389, 1361, 2741,  490,  394,  490,
     2741,   74, 2809,  390,  390,  390,  390,  390,  390, 1394,
      395,  394,   74,  391,  391,  391,  391,  391,  391,  394,
      490,  572,  490,  395,   74,  392,  392,  392,  392,  392,
      392,  395, 2808, 1394,   74,  410,  410,  410, 2807, 2806,
     1550,   74,   74,   74,   74,   74,   74,   75,  393,  393,
      393,  393,  393,  393,  396, 1404, 1394, 2888, 1448,   75,

       75,   75,  572,  572, 1550, 1417, 1404,  396,   75, 2805,
     2804, 1046, 1046, 1046,   75,  396, 2803, 2802,  394,  394,
      394,  394,  394,  394, 2888,  572,  572,   75, 1417, 1404,
      395,  395,  395,  395,  395,  395,  466, 1670,   75,  411,
      411,  411, 1670,  410,  410,  410,  410,  410,  410, 1448,
       75,  466,  466,  466,  466,  466,  466,  413,  413,  413,
       75,  480,  480,  480,  480,  480,  480,   75,   75,   75,
       75,   75,   75,   76,  396,  396,  396,  396,  396,  396,
     1046, 1046, 1046, 1046, 1046,   76,   76,   76,  481,  481,
      481,  481,  481,  481,   76, 1487, 1487, 1487, 1487, 1687,

       76,  424, 2617,  575, 1687, 2617,  424,  411,  411,  411,
      411,  411,  411,   76,  424,  429,  424,  424,  424,  424,
      424,  424,  424,  460,   76,  413,  413,  413,  413,  413,
      413, 2657,  460, 2784, 2657, 2236,   76,  575,  460,  460,
      460,  460,  460,  460, 2236, 2783,   76,  483,  483,  483,
      483,  483,  483,   76,   76,   76,   76,   76,   76,   77,
      575,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,  470, 2742,  575, 2782, 2241, 2742,
       77,   77,   77,   77,   77,   77,  477, 2241, 1561,  470,
      470,  470,  470,  470,  470,  429,  429,  429,  429,  429,

      429,  477,  477,  477,  477,  477,  477, 2781,   77,   77,
       79,   79, 1561,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   80, 2780,   80,

       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,  464, 2037, 2037, 2037, 2037,  464,   80,   80,
       80,   80,   80,   80,  506,  464, 2779,  464,  464,  464,
      464,  464,  464,  464,  484,  484,  484,  484,  484,  484,
      486,  486,  486,  486,  486,  486,   80,   80,  492,  492,
      492,  492,  492,  492, 2393,  464,  496,  496,  496,  496,
      496,  496,  506, 2393, 1440, 1441,  506,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,  204,  464,  498,
      498,  498,  498,  498,  498,  506,  464, 1440, 1441,  506,
      204,  204, 2778,  204,  204,  204,  204,  204,  204, 1678,

     1678, 1678, 1678, 1678,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  204,  204,  204,  204,  204, 2777,  204,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  204,  207,  504,  504,  504,  504,  504,
      504, 1502,  600, 1465,  584,  207,  207,  207,  207,  207,
      207,  207,  207,  207,  207, 1514,  430, 1773, 2398, 2431,
     2776,  430, 1773,  461,  485, 1502, 1465, 2398,  207,  430,

     1808, 2431,  461, 2431, 2775, 1808,  600,  430,  467,  485,
      485,  485,  485,  485,  485,  497,  584,  584, 1502, 2774,
      485,  207, 1563,  467,  467,  467,  467,  467,  467,  600,
      497,  497,  497,  497,  497,  497, 1514,  207,  208,  584,
      584,  497,  467,  502,  509,  600, 1563,  501, 2365,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  509,
      509,  509,  509,  509,  509,  467,  430,  430,  430,  430,
      430,  430,  208,  461,  461,  461,  461,  461,  461, 2773,
     1518,  467,  468, 2365,  502,  501,  502, 2533,  516, 2660,
      501, 1103, 2660, 2772,  523,  208, 2533,  468,  468,  468,

      468,  468,  468, 1518, 1103, 2745,  553,  502,  501,  502,
      564,  208,  209,  501,  518, 1103,  468,  518,  518,  518,
      518,  518,  518,  209,  209,  209,  209,  209,  209,  209,
      209,  209,  209, 2113, 2113, 2113, 2113,  525, 1103,  468,
      525,  525,  525,  525,  525,  525,  209,  553,  564,  553,
      209,  886,  564,  886,  209,  468,  516,  516,  516,  516,
      516,  516,  523,  523,  523,  523,  523,  523, 2743,  209,
      553,  564,  553,  209,  886,  564,  886,  209,  548,  548,
      548,  548,  548,  548, 2740,  209,  215,  215, 2739,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,

      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  217,  217, 2738,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,

      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      219, 1512, 2736, 2699, 2685,  219,  554,  554,  554,  554,
      554,  554, 1512,  219,  531,  219,  219,  219,  219,  219,
      219,  219, 2639, 2589, 2588,  574,  835,  219,  510,  531,
      531,  531,  531,  531,  531, 1512,  848,  511, 2587, 2564,

      219,  848,  219,  510,  510,  510,  510,  510,  510, 1661,
     2554,  219,  511,  511,  511,  511,  511,  511, 2549,  574,
      835,  512,  510,  219, 2744,  219, 1315,  574,  574, 2744,
      848,  511, 1661,  219,  219,  224,  512,  512,  512,  512,
      512,  512,  574,  835, 1315,  510, 2542,  224,  224,  224,
      574,  574,  522,  848,  511,  512,  224, 2536,  574,  835,
     2105,  510,  224, 2527,  532, 2105, 2536, 1315, 2578,  848,
      511, 1565,  541,  224,  596,  224,  224, 2578,  512,  532,
      532,  532,  532,  532,  532, 2526,  224,  541,  541,  541,
      541,  541,  541, 2486,  512, 1565,  224, 1715,  224,  224,

      556,  556,  556,  556,  556,  556, 2482,  583,  224,  225,
      522,  522,  522,  522,  522,  522,  522,  522,  522,  522,
     1715,  225,  225,  225,  569,  569,  569,  569,  569,  569,
      225, 2479, 2421, 2420, 2105,  569,  225,  537,  537,  537,
      537,  537,  537,  537,  537,  537, 2379,  225,  583,  225,
      583,  537,  225, 1568,  596,  596,  596,  596,  596,  596,
      225,  549,  549,  549,  549,  549,  549,  549,  549,  549,
      225,  583,  225,  583, 2377,  225, 2372, 1568,  597,  897,
     2369, 2355,  225,  226,  550,  550,  550,  550,  550,  550,
      550,  550,  550, 2349,  226,  226,  226,  226,  226,  226,

      226,  226,  226,  226,  538,  538,  538,  538,  538,  538,
      538,  538,  538,  897,  929,  542,  929,  226,  538,  551,
      551,  551,  551,  551,  551,  551,  551,  551, 2343, 2581,
      542,  542,  542,  542,  542,  542,  897,  929, 2581,  929,
      226, 1865,  542,  552,  552,  552,  552,  552,  552,  552,
      552,  552,  897,  578,  567,  542,  226,  232,  597,  597,
      597,  597,  597,  597,  555, 1865,  542, 2339,  232,  232,
      232,  232,  232,  232,  232,  232,  232,  232,  542,  555,
      555,  555,  555,  555,  555,  557,  571, 2334,  542,  581,
      555,  232,  567,  573,  578,  578,  880,  567, 1647,  576,

      557,  557,  557,  557,  557,  557, 1765, 1447,  573,  573,
      573,  573,  573,  573,  232,  567,  990,  578,  578, 2327,
      567, 2317, 1647, 1447,  571, 2301, 2294,  581,  571, 1765,
      232,  233,  581,  576,  577, 1647,  881,  576,  880,  880,
     1018,  576, 1018,  233,  233,  233, 1447,  571,  603, 1446,
      581,  571,  233, 2290,  990,  581,  576,  990,  233, 1867,
      576,  880,  880, 1018,  576, 1018, 2285, 1446,  577,  233,
     1795,  233,  576,  233,  881,  577,  577,  990, 2684,  881,
      990, 2684,  233, 1867,  582,  582,  582,  582,  582,  582,
     1446,  577,  233, 1795,  233,  582,  233,  881,  577,  577,

      927,  598,  881, 1869,  233,  235, 2276,  577,  602,  602,
      602,  602,  602,  602, 1017, 1996,  235,  235,  235,  235,
      235,  235,  235,  235,  235,  235,  235, 1869,  603,  603,
      603,  603,  603,  603,  927,  598, 1872,  587, 1996,  235,
      587,  587,  587,  587,  587,  587,  593,  608, 1017,  593,
      593,  593,  593,  593,  593, 2260, 2246,  927,  598,  594,
     1872, 2229,  235, 2228,  594,  606,  606,  606,  606,  606,
      606, 1017,  594,  927,  598, 2227, 2226,  599,  235,  236,
      594,  598,  598,  598,  598,  598,  598, 1017, 1668, 2212,
      236,  236,  236,  236,  236,  236,  236,  236,  236,  236,

      236, 2700, 2210, 1668, 2700,  587,  587,  587,  587,  587,
      587,  599,  615,  236,  593,  593,  593,  593,  593,  593,
      607,  607,  607,  607,  607,  607, 1668,  608,  608,  608,
      608,  608,  608,  594,  599, 2208,  236, 2206,  615,  594,
      594,  594,  594,  594,  594, 2175, 2173, 1032,  609, 2325,
      599, 2828,  236,  239, 2325, 2171, 2828,  599,  599,  599,
      599,  599,  599, 2169,  239,  239,  239,  239,  239,  239,
      239,  239,  239,  239,  239,  613,  613,  613,  613,  613,
      613, 1032,  609,  865,  865,  865,  865,  239, 2159,  865,
      865,  865,  615,  615,  615,  615,  615,  615,  616,  616,

      616,  616,  616,  616, 1032,  609, 2153, 2152, 2141,  882,
      239,  621,  621,  621,  621,  621,  621,  891, 2140, 2138,
     1032,  609,  610, 2325,  898, 2828,  239,  240,  609,  609,
      609,  609,  609,  609, 2136, 2127,  622, 1070,  240,  240,
      240,  240,  240,  240,  240,  240,  240,  240,  240,  622,
      882,  611,  882, 2120, 1876, 2104,  610,  622,  898,  891,
      891,  240, 1878,  622, 1881,  624,  898,  898, 2090,  240,
      240, 1070, 1883,  882, 1884,  882,  622,  631, 1876,  610,
     2082,  898,  891,  891,  240,  611, 1878,  622, 1881,  898,
      898,  624,  240,  240, 1070,  610, 1883,  898, 1884,  622,

      240,  244,  610,  610,  610,  610,  610,  610,  611,  622,
     1070, 2079, 2073,  244,  244,  244,  244,  244,  244,  244,
      244,  244, 2071, 2062,  611,  623,  623,  623,  623,  623,
      623,  611,  611,  611,  611,  611,  611,  625,  625,  625,
      625,  625,  625,  244,  244,  624,  624,  624,  624,  624,
      624,  629,  629,  629,  629,  629,  629,  631,  631,  631,
      631,  631,  631, 2055, 2052, 2023,  244,  244,  251,  251,
     2009,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,

      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  252,  647,  647,  647,  647,
      647,  647,  659,  659,  659,  659,  659,  659,  252,  252,
     2001,  252,  252,  252,  252,  252,  252, 1784, 1784, 1784,
     1784, 1784,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,

      252,  252,  252,  252,  252,  252, 1985,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      252,  252,  260,  260, 1984,  260,  260,  260,  260,  260,
      260,  260,  260,  260,  260,  260,  260,  260,  260,  260,
      260,  260,  260,  260,  260,  260,  260,  260,  260,  260,
      260,  260,  260,  260,  260,  260,  260,  260,  260,  260,
      260,  260,  260,  260,  260,  260,  260,  260,  260,  260,
      260,  260,  260,  260,  260,  260,  260,  260,  260,  260,

      260,  260,  260,  260,  260,  260,  260,  260,  260,  260,
      260,  260,  260,  260,  260,  260,  260,  260,  260,  260,
      260,  260,  260,  260,  260,  260,  260,  260,  260,  270,
     1983, 1982,  270,  270,  270,  270,  270,  270,  632,  661,
      661,  661,  661,  661,  661,  685,  685,  685,  685,  685,
      685, 1674, 1674, 1674, 1674, 1674,  636,  636,  636,  640,
     1981, 1674,  637,  637,  637, 1980, 1771,  866,  866,  866,
      636,  866,  866,  866,  866,  866,  637,  648,  648,  648,
     1979, 1771, 2035,  649,  649,  649, 1978,  270,  270,  270,
      270,  270,  270,  270,  270,  270,  270,  270,  270,  270,

      270,  270,  270,  271, 1771, 2035,  271,  271,  271,  271,
      271,  271, 1939, 1033, 2039, 1033, 1890,  271,  632,  632,
      632,  632,  632,  632,  636,  636,  636,  636,  636,  636,
      637,  637,  637,  637,  637,  637, 1033, 2039, 1033,  640,
      640,  640,  640,  640,  640,  648,  648,  648,  648,  648,
      648,  649,  649,  649,  649,  649,  649, 2718, 1880, 1879,
     2718,  271,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  271,  271,  271,  271,  271,  271,  286,  286, 1877,
      286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
      286,  286,  286,  286,  286,  286,  286,  286,  286,  286,

      286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
      286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
      286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
      286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
      286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
      286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
      286,  286,  286,  286,  287,  663,  686,  686,  686,  686,
      686,  686, 1886, 1875,  923, 1874,  287,  287,  287,  698,
      698,  698,  698,  698,  698,  287, 2074, 2000,  650,  650,
      650,  287, 2761, 1873, 1871, 2761, 1886,  651,  651,  651,

      668,  641,  668, 2000,  287, 1887,  668,  668, 1888, 2074,
      668,  652,  923,  668,  668,  287,  923,  668,  668,  663,
      663,  663,  663,  663,  663,  660, 2000,  287,  641, 1887,
     2041, 1868, 1888,  925,  664,  923, 1866,  287,  924,  923,
     2793,  641, 1864, 2793,  287,  287,  287,  287,  287,  287,
      289,  660,  641, 1863, 2041,  289,  650,  650,  650,  650,
      650,  650, 1862,  289,  641,  651,  651,  651,  651,  651,
      651,  289, 1861, 2078,  641,  925,  925,  289, 1860,  924,
      924,  641,  641,  641,  641,  641,  641, 2043, 1859, 2078,
      289,  652,  652,  652,  652,  652,  652,  666,  925,  925,

     1844,  289,  924,  924, 1833,  660,  660,  660,  660,  660,
      660, 2043, 2078,  289,  664,  664,  664,  664,  664,  664,
     1807, 1797, 1790,  289,  289, 1942, 1942, 1942, 1942, 1942,
      289,  289,  289,  289,  289,  289,  306, 1762,  306,  306,
      306,  306,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  666,  666,  666,  666,  666,  666,  306,  306,  306,
      306,  306,  306,  670, 2137,  670, 1747, 1733, 2859,  670,
      670, 2859,  670,  670, 1717, 2864,  670,  670, 2864, 2873,
      670,  670, 2873, 1710, 1686,  306,  306,  308, 2137,  308,
      308,  308,  308,  308,  308,  308,  308,  308,  308,  308,

      308,  308,  699,  699,  699,  699,  699,  699,  308,  308,
      308,  308,  308,  308,  701,  701,  701,  701,  701,  701,
      702,  702,  702,  702,  702,  702,  703, 1650, 1649, 1646,
      703,  703,  703,  703,  703,  703,  308,  308,  310,  310,
     1645,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,

      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  311, 1644,  311,  311,  311,
      311,  311,  311,  311,  311,  311,  311,  311,  311,  311,
      704,  704,  704,  704,  704,  704,  311,  311,  311,  311,
      311,  311,  705,  705,  705,  705,  705,  705, 2874, 1643,
      662, 2874, 1642, 1641, 2437,  662,  707,  707,  707,  707,
      707,  707, 1620, 1618,  311,  311, 2437, 1617, 2437, 1612,
      706,  662,  709,  709,  709,  709,  709,  709,  711,  711,
      711,  711,  711,  711,  662,  311,  311,  311,  311,  311,

      311,  311,  311,  311,  311,  478, 1580,  478,  478,  478,
      478,  478,  478,  478,  478,  478,  478,  662, 1577,  478,
      478,  478,  478,  478,  478,  478,  478,  478,  478,  478,
      478,  478, 1574,  662,  662,  665, 2139, 2142, 1571,  478,
      662,  662,  662,  662,  662,  662, 1569, 1567,  687,  706,
      706,  706,  706,  706,  706,  478, 1253, 1253, 1253,  687,
     2139, 2142,  478,  687,  687,  687,  687,  687,  687,  665,
      712,  712,  712,  712,  712,  712, 1564, 1562,  478,  479,
     1560,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  687,  665,  479,  479,  479,  479,  479,  479,  479,

      479,  479,  479,  479,  479,  479, 1559, 1065,  665, 1065,
      700, 2144, 1558,  479,  687,  665,  665,  665,  665,  665,
      665,  700,  687,  688, 1253, 1253, 1253, 2145, 1557,  479,
     1065, 1351, 1065, 1351,  688, 2144,  479, 1556,  688,  688,
      688,  688,  688,  688,  689,  713,  713,  713,  713,  713,
      713, 2145,  479,  482, 1351,  689, 1351, 1555,  482,  689,
      689,  689,  689,  689,  689,  688,  482, 1554,  482,  482,
      482,  482,  482,  482,  482,  715,  715,  715,  715,  715,
      715, 1484,  689, 1484,  700, 2561, 1553,  482,  688, 1552,
      700,  700,  700,  700,  700,  700,  482,  688,  716,  716,

      716,  716,  716,  716, 1484,  689, 1484,  714, 2561,  714,
      482,  714,  714,  714,  714,  714,  714, 1551,  689,  482,
      717,  717,  717,  717,  717,  717,  482,  482,  487,  487,
     1549,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  487,  487,  487,  487,  487,  487,

      487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  487,  495, 2147,  722, 1548, 1547,
      495, 1546,  718, 1545,  718, 1544,  722, 2148,  495, 2149,
      495,  495,  495,  495,  495,  495,  495, 1026, 1543, 1542,
     2147, 2151,  495,  719,  719,  719,  719,  719,  719,  495,
     1026, 2148, 1026, 2149, 2616,  495, 2508,  495,  720,  720,
      720,  720,  720,  720, 1541, 2151,  495,  721, 2508, 1540,
     2508, 1524,  495, 1026, 1521, 1026,  721, 2616,  495, 2154,
      495, 1520,  721,  721,  721,  721,  721,  721,  495,  495,
      515,  718,  718,  718,  718,  718,  718,  722,  722,  722,

      722,  722,  722, 2154, 2156,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515, 2618, 2156,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  519,  519,
     2618,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,

      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  519,  519,  519,  519,  519,
      519,  519,  519,  519,  519,  530,  728, 1519, 1503, 2157,
      530,  726,  726,  726,  726,  726,  726, 2160,  530,  725,
      530,  530,  530,  530,  530,  530,  530, 1957, 1957, 1957,
     1957, 1957,  530, 2157,  725,  725,  725,  725,  725,  725,
      989, 2160,  690, 2161, 1490,  530, 2638,  530, 1486, 1266,
     1266, 1266,  730,  690, 1474, 1442,  530,  690,  690,  690,
      690,  690,  690, 1437,  730, 1435,  730, 2161,  530, 2638,

      530,  729,  729,  729,  729,  729,  729, 2163,  530,  530,
      543,  989,  989,  690, 2165, 1423,  728,  728,  728,  728,
      728,  728,  543,  543,  543,  543,  543,  543,  543,  543,
      543, 2163, 1420, 1419,  989,  989,  690,  543, 2165,  727,
      731,  731,  731,  731,  731,  731,  690, 1266, 1266, 1266,
      543,  727, 1418,  727,  727,  727,  727,  727,  727,  727,
     1395,  543,  730,  730,  730,  730,  730,  730, 2350, 2352,
      734, 2353, 1386,  543,  732,  732,  732,  732,  732,  732,
      895, 1372, 1354,  543,  544,  734,  734,  734,  734,  734,
      734, 1337, 2350, 2352, 1307, 2353,  544,  544,  544,  544,

      544,  544,  544,  544,  544,  741,  741,  741,  741,  741,
      741,  544,  735,  735,  735,  735,  735,  735,  735, 2356,
     1292,  895, 1291,  895,  544,  736,  736,  736,  736,  736,
      736,  736, 2357, 1290, 1288,  544,  737,  737,  737,  737,
      737,  737,  737, 2356,  895, 2359,  895,  544,  738,  738,
      738,  738,  738,  738,  738, 1287, 2357,  544,  545,  739,
      739,  739,  739,  739,  739,  739, 1286, 1285, 1284, 2359,
      545,  545,  545,  545,  545,  545,  545,  545,  545,  742,
      742,  742,  742,  742,  742,  545,  740,  740,  740,  740,
      740,  740,  740, 2361, 2363,  744, 2366, 1281,  545,  743,

      743,  743,  743,  743,  743, 2367, 2370, 1280, 1174,  545,
      744,  744,  744,  744,  744,  744, 2476, 2361, 2363, 2477,
     2366,  545,  745,  745,  745,  745,  745,  745, 1173, 2367,
     2370,  545,  546,  746,  746,  746,  746,  746,  746, 1172,
     2476, 1170, 1169, 2477,  546,  546,  546,  546,  546,  546,
      546,  546,  546,  748,  748,  748,  748,  748,  748,  546,
      749,  749,  749,  749,  749,  749,  750,  750,  750,  750,
      750,  750,  546,  751,  751,  751,  751,  751,  751,  756,
     2480, 1168, 1167,  546,  752,  752,  752,  752,  752,  752,
      752,  760, 2483, 2485, 1166,  546,  753,  753,  753,  753,

      753,  753, 1165, 1164, 2480,  546,  547,  754,  754,  754,
      754,  754,  754,  761, 1163, 1162, 2483, 2485,  547,  547,
      547,  547,  547,  547,  547,  547,  547,  757,  757,  757,
      757,  757,  757,  547,  758,  758,  758,  758,  758,  758,
      759,  759,  759,  759,  759,  759,  547, 2558, 1161,  762,
      760,  760,  760,  760,  760,  760, 2514,  547, 2560,  756,
      756,  756,  756,  756,  756,  763, 1160, 1159, 2514,  547,
     2514, 2558,  761,  761,  761,  761,  761,  761, 1158,  547,
      558, 2562, 2560, 2659, 1157,  764,  767,  767,  767,  767,
      767,  767, 2614, 1156, 2683,  558,  558,  558,  558,  558,

      558,  765,  766, 1154, 1153, 2562, 2659,  558,  762,  762,
      762,  762,  762,  762,  558, 1152, 2614, 2683, 1151, 1149,
      558, 1148, 1117, 1114,  763,  763,  763,  763,  763,  763,
     1098,  558, 2720, 2760,  970,  970,  970,  558,  970,  970,
      970,  970,  970,  558,  764,  764,  764,  764,  764,  764,
     1003, 1097, 1089,  558,  559, 2720, 2760, 1072, 1066, 1054,
      765,  765,  765,  765,  765,  765, 1034, 2836, 1021,  559,
      559,  559,  559,  559,  559,  768,  768,  768,  768,  768,
      768,  559,  766,  766,  766,  766,  766,  766,  559, 2846,
      774, 2836, 1003, 1003,  559,  770,  770,  770,  770,  770,

      770, 1019, 2850,  980,  978,  559,  950, 1022,  949,  933,
      930,  559, 1022, 2846,  922, 1003, 1003,  559,  771,  771,
      771,  771,  771,  771, 1008, 2850, 2846,  559,  560,  772,
      772,  772,  772,  772,  772,  773,  773,  773,  773,  773,
      773, 1022,  905,  560,  560,  560,  560,  560,  560,  774,
      774,  774,  774,  774,  774,  560,  778,  778,  778,  778,
      778,  778,  560, 2858, 1022, 1008, 2871, 1008,  560,  779,
      779,  779,  779,  779,  779, 2872, 2890,  903,  889,  560,
     1022,  871,  847,  845,  844,  560, 2858,  843, 1008, 2871,
     1008,  560,  780,  780,  780,  780,  780,  780, 2872,  842,

     2890,  560,  562,  562,  837,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  568,
      823,  822,  821,  820,  568,  781,  781,  781,  781,  781,

      781,  819,  818,  817,  568,  568,  568,  568,  568,  568,
      568,  782,  782,  782,  782,  782,  782,  782,  782,  782,
     2892,  816,  815,  568,  786,  786,  786,  786,  786,  786,
      814,  813,  568,  783,  783,  783,  783,  783,  783,  783,
      783,  783,  812,  811, 2892,  809,  568,  787,  787,  787,
      787,  787,  787,  808,  710,  568,  788,  788,  788,  788,
      788,  788,  568,  568,  570,  570,  708,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,

      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  570,  570,  570,  570,  570,  570,  570,  570,  570,
      570,  586,  586,  697,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,

      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  586,  586,
      586,  586,  586,  586,  586,  586,  586,  586,  588,  588,
      695,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,

      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  588,  588,  588,  588,  588,
      588,  588,  588,  588,  588,  590,  784,  784,  784,  784,
      784,  784,  784,  784,  784,  694,  693,  692,  590,  590,
      684,  590,  590,  590,  590,  590,  590,  683,  682,  681,
      679,  678,  590,  590,  590,  590,  590,  590,  590,  590,
      590,  590,  590,  590,  590,  590,  590,  590,  590,  590,
      590,  590,  590,  590,  590,  590,  677,  590,  590,  590,
      590,  590,  590,  590,  590,  590,  590,  590,  590,  590,
      590,  590,  590,  590,  590,  590,  590,  590,  590,  590,

      590,  590,  590,  590,  590,  590,  590,  590,  590,  590,
      590,  590,  592,  676,  674,  592,  592,  592,  592,  592,
      592,  785,  785,  785,  785,  785,  785,  785,  785,  785,
      789,  789,  789,  789,  789,  789,  790,  790,  790,  790,
      790,  790,  673,  672,  671,  791,  791,  791,  669,  667,
      658,  634,  626,  792,  792,  792,  618,  589,  563,  793,
      793,  793,  795,  795,  795,  795,  795,  795,  535,  529,
      592,  592,  592,  592,  592,  592,  592,  592,  592,  592,
      592,  592,  592,  592,  592,  592,  604,  528,  604,  604,
      604,  604,  604,  604,  604,  604,  604,  604,  527,  893,

      604,  796,  796,  796,  796,  796,  796,  604,  604,  604,
      604,  604,  604,  791,  791,  791,  791,  791,  791,  526,
      604,  792,  792,  792,  792,  792,  792,  793,  793,  793,
      793,  793,  793,  520,  513,  505,  604,  893,  798,  794,
      794,  794,  893,  604,  797,  797,  797,  797,  797,  797,
      798,  799,  494,  798,  798,  798,  798,  798,  798,  604,
      893,  458,  457,  799,  456,  893,  604,  604,  604,  604,
      604,  604,  605,  455,  605,  605,  605,  605,  605,  605,
      605,  605,  605,  605,  800,  454,  605,  453,  452,  800,
      451,  450,  805,  605,  605,  605,  605,  605,  605,  800,

      800,  800,  800,  800,  800,  449,  605,  794,  794,  794,
      794,  794,  794,  803,  803,  803,  803,  803,  803,  804,
      448,  447,  605,  802,  804, 1131, 1131, 1131,  446,  605,
      445,  799,  799,  799,  799,  799,  799,  443,  802,  802,
      802,  802,  802,  802,  442,  605,  806,  806,  806,  806,
      806,  806,  605,  605,  605,  605,  605,  605,  612,  439,
      438, 1780,  437,  612,  400,  801,  339,  337,  335,  319,
      801,  612,  805,  805,  805,  805,  805,  805,  801,  612,
      801,  801,  801,  801,  801,  801,  801,  317,  316,  313,
      295,  273,  612,  826, 1131, 1131, 1131, 1131, 1131,  804,

      804,  804,  804,  804,  804,  826,  831,  826,  826,  826,
      826,  826,  826,  826,  831,  612, 1780, 1780, 1780, 1780,
     1780,  831,  831,  831,  831,  831,  831,  268,  267,  265,
      263,  612,  612,  261,  254,  249,  827,  230,  612,  612,
      612,  612,  612,  612,  614,  827,  199,  193,  192,  190,
      188,  827,  827,  827,  827,  827,  827,  614,  614,  186,
      614,  614,  614,  614,  614,  614,  183,  182,  181,  179,
      178,  614,  614,  614,  614,  614,  614,  614,  614,  614,
      614,  614,  614,  614,  614,  614,  614,  614,  614,  614,
      614,  614,  614,  614,  614,  176,  614,  614,  614,  614,

      614,  614,  614,  614,  614,  614,  614,  614,  614,  614,
      614,  614,  614,  614,  614,  614,  614,  614,  614,  614,
      614,  614,  614,  614,  614,  614,  614,  614,  614,  614,
      614,  617,  617,  175,  617,  617,  617,  617,  617,  617,
      617,  617,  617,  617,  617,  617,  617,  617,  617,  617,
      617,  617,  617,  617,  617,  617,  617,  617,  617,  617,
      617,  617,  617,  617,  617,  617,  617,  617,  617,  617,
      617,  617,  617,  617,  617,  617,  617,  617,  617,  617,
      617,  617,  617,  617,  617,  617,  617,  617,  617,  617,
      617,  617,  617,  617,  617,  617,  617,  617,  617,  617,

      617,  617,  617,  617,  617,  617,  617,  617,  617,  617,
      617,  617,  617,  617,  617,  617,  617,  617,  619,  619,
      174,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,
      619,  619,  619,  619,  619,  619,  619,  619,  619,  619,

      619,  619,  619,  619,  619,  630,  128,   92, 1314, 2040,
      630,   70,  807, 1314, 2040,  846, 1347,  807,  630,  846,
      846,  846,  846,  846,  846,  807,  630,  829,   69,   68,
       57,   50,  630,  807,   49,   48,   47,   46,   45,  829,
      830,  829, 1314,  832,    0,  630,    0, 2040,    0,  830,
      832,  832,  832,  832,  832,  832,  630, 1347,    0, 1347,
      834,    0,    0,  833, 2038, 1314,    0,    0,  630, 2038,
     2040,  833,  856,  856,  856,  856,  856,  856,  630,  630,
     1347, 1314, 1347, 2040,    0,  630,  630,  630,  630,  630,
      630,  642,  807,  807,  807,  807,  807,  807,    0,    0,

        0,    0,    0,  642,  642,  642, 2038,  829,  829,  829,
      829,  829,  829,    0,    0,    0,    0,    0,  642,    0,
      830,  830,  830,  830,  830,  830,    0,    0,    0, 2038,
        0,  642,  834,  834,  834,  834,  834,  834, 2038,    0,
        0,    0,  642,  833,  833,  833,  833,  833,  833,    0,
      838,    0,    0,    0,  642,  868,  868,  868,  868,  868,
      868,    0,    0,  839,  642,  838,  838,  838,  838,  838,
      838,  642,  642,  642,  642,  642,  642,  643,  839,  839,
      839,  839,  839,  839,  838,    0,    0,    0,    0,  643,
      643,  643,    0,    0,    0,  840,    0,  839,  861,  861,

      861,  861,  861,  861,  643,    0,    0,  838,    0,  861,
      840,  840,  840,  840,  840,  840,    0,  643,    0,    0,
      839,    0,    0,  838,    0,    0,    0,    0,  643,  840,
      875,  875,  875,  875,  875,  875,  839,    0,    0,    0,
      643,  862,  862,  862,  862,  862,  862,  862,  862,  862,
      643, 2274,  840,    0,  858,  862, 2274,  643,  643,  643,
      643,  643,  643,  644,  859,    0,    0,    0,  840,  858,
      858,  858,  858,  858,  858,  644,  644,  644,    0,  859,
      859,  859,  859,  859,  859,    0,    0,    0,  858, 2274,
      644,  877,  877,  877,  877,  877,  877,    0,  859,    0,

      860,    0,  877,  644,  878,  878,  878,  878,  878,  878,
        0,  858, 2274,  883,  644,  860,  860,  860,  860,  860,
      860,  859,    0,    0,    0, 2274,  644,  858,  883,  883,
      883,  883,  883,  883,  860,    0,  644,  859,    0,    0,
        0,    0,    0,  644,  644,  644,  644,  644,  644,  645,
      876,  876,  876,  876,  876,  876,    0,  860,    0,    0,
        0,  645,  645,  645,  863,  863,  863,  863,  863,  863,
      863,  863,  863,  860,    0,    0,  645,    0,  863,  867,
      867,  867,  867,  867,  867,  867,  867,  867,    0,  645,
      869,  869,  869,  869,  869,  869,  869,  869,  869,    0,

      645,  870,  870,  870,  870,  870,  870,  870,  870,  870,
      900,    0,  645,    0,    0,  876,  876,  876,  876,  876,
      876,  899,  645,  917,  917,  917,  917,  917,  917,  645,
      645,  645,  645,  645,  645,  646,  952,  952,  952,  952,
      952,  952,    0,    0,  900,    0,    0,  646,  646,  646,
        0,  900,    0,  900,    0,  899,    0,    0,    0,  899,
        0,    0,  646,    0,  899,    0,    0,  900,  906,  906,
      906,  906,  906,  906,  900,  646,  900,    0,  899,  906,
        0,    0,  899,  900,    0,  939,  646,  899,  939,  939,
      939,  939,  939,  939,  899,    0,    0,    0,  646,  907,

      907,  907,  907,  907,  907,  907,  907,  907,  646,    0,
        0,    0,    0,  907, 1004,  646,  646,  646,  646,  646,
      646,  653,  908,  908,  908,  908,  908,  908,  908,  908,
      908,    0,    0,    0,    0,    0,  908,  909,  909,  909,
      909,  909,  909,  909,  909,  909,    0,    0,  653, 2826,
        0,  909, 1004,    0, 2826,  653,    0, 1004,    0,    0,
        0,  653,  910,  910,  910,  910,  910,  910,  910,  910,
      910,    0,  653,  911,    0, 1004,  910,    0,  653,    0,
     1004,    0,    0,    0,  653,    0,    0, 2826,  911,  911,
      911,  911,  911,  911,  653, 1045, 1045, 1045,    0, 1346,

      911,  653,  653,  653,  653,  653,  653,  654,    0,    0,
     2826,    0,    0,  911,  918,  918,  918,  918,  918,  918,
      918,  918,  918, 2826,  911,  919,  919,  919,  919,  919,
      919,  919,  919,  919,  654,  936,  911, 1346,    0,    0,
        0,  654, 1346,    0,    0,    0,  911,  654,  920,  920,
      920,  920,  920,  920,  920,  920,  920,    0,  654,    0,
     1346,    0,    0, 1045,  654, 1346, 1045, 1045, 1045,    0,
      654,  921,  921,  921,  921,  921,  921,  921,  921,  921,
      654,  959,  959,  959,  959,  959,  959,  654,  654,  654,
      654,  654,  654,  655,  928,  962,  962,  962,  962,  962,

      962,  928,    0,  936,  936,  936,  936,  936,  936,  928,
      928,  928,  928,  928,  928,  928,    0,    0,    0,    0,
      655,    0,    0,    0,    0,    0,  931,  655,  928,    0,
        0,    0,    0,  655,  931,  931,  931,  931,  931,  931,
      931,    0,    0,    0,  655,    0,    0,    0,    0,    0,
      655,  928,    0,    0,    0,    0,  655,  951,  951,  951,
      951,  951,  951,    0,    0,    0,  655,  928,  951,    0,
        0,    0,    0,  655,  655,  655,  655,  655,  655,  657,
      657,    0,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,

      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  854,    0,  854,  854,
      854,  854,  854,  854,  854,  854,  854,  854,    0,    0,
      854,  854,  854,  854,  854,  854,  854,  854,  854,  854,
      854,  854,  854,    0,    0,  940,  958,  958,  958,  958,

      958,  958,    0,    0,    0,    0,    0,  958,  965,  965,
      965,  965,  965,  965,    0,    0,  854,  857,    0,  965,
        0,    0,  857,  972,  972,  972,  972,  972,  972,    0,
      857,    0,  857,  857,  857,  857,  857,  857,  857,  940,
      940,  940,  940,  940,  940,  940,  940,  940,  940,    0,
      987,  857,  984,  987,  987,  987,  987,  987,  987,    0,
      857,  961,  961,  961,  961,  961,  961,  961,  961,  961,
        0,    0,    0,    0,  857,  992,  992,  992,  992,  992,
      992,    0,    0,  857,  998,  998,  998,  998,  998,  998,
      857,  857,  864,    0,  864,  864,  864,  864,  864,  864,

      864,  864,  864,  864,  944,    0,  864,  864,  864,  864,
      864,  864,  864,  864,  864,  864,  864,  864,  864,    0,
      984,  984,  984,  984,  984,  984,  864, 1012, 1012,    0,
        0,  944, 1012,    0,    0, 1012, 1012,    0,  944,    0,
        0,    0,  864, 1012,  944, 1012,    0, 1012, 1012,  864,
        0, 1345,    0,    0, 2042,  944,    0,    0, 1360, 2042,
        0,  944,  975,  954, 1092,  864,  872,  944,  954, 2273,
        0,  872,    0,    0, 2273,    0,    0,  944,    0,    0,
        0,  872,  872,  872,  872,  872,  872,  872,    0,  975,
      954, 1092,    0, 1345, 1345, 2042,  975,  954, 1092, 1360,

      872, 1360,  975,  954, 1092,    0,    0,    0,    0,  872,
        0, 2273,    0,  975,  954, 1092, 1345, 1345, 2042,  975,
      954, 1092, 1360,  872, 1360,  975,  954, 1092, 2042,    0,
        0,    0,  872,    0, 2273,  975,  954, 1092,    0,  872,
      872,  879,  879, 2273,  879,  879,  879,  879,  879,  879,
      879,  879,  879,  879,  879,  879,  879,  879,  879,  879,
      879,  879,  879,  879,  879,  879,  879,  879,  879,  879,
      879,  879,  879,  879,  879,  879,  879,  879,  879,  879,
      879,  879,  879,  879,  879,  879,  879,  879,  879,  879,
      879,  879,  879,  879,  879,  879,  879,  879,  879,  879,

      879,  879,  879,  879,  879,  879,  879,  879,  879,  879,
      879,  879,  879,  879,  879,  879,  879,  879,  879,  879,
      879,  879,  879,  879,  879,  879,  879,  879,  885,  885,
        0,  885,  885,  885,  885,  885,  885,  885,  885,  885,
      885,  885,  885,  885,  885,  885,  885,  885,  885,  885,
      885,  885,  885,  885,  885,  885,  885,  885,  885,  885,
      885,  885,  885,  885,  885,  885,  885,  885,  885,  885,
      885,  885,  885,  885,  885,  885,  885,  885,  885,  885,
      885,  885,  885,  885,  885,  885,  885,  885,  885,  885,
      885,  885,  885,  885,  885,  885,  885,  885,  885,  885,

      885,  885,  885,  885,  885,  885,  885,  885,  885,  885,
      885,  885,  885,  885,  885,  904,    0,    0,    0,    0,
      904,    0,    0,    0,  964,    0, 1356,    0,  904,    0,
      904,  904,  904,  904,  904,  904,  904,  964,    0,    0,
        0,    0,  904,  993,    0,  964,    0,    0,    0,  904,
        0,  964,    0,    0,    0,  904, 1703,  904,  993,  993,
      993,  993,  993,  993,  964,    0,  904,    0, 1356, 1356,
     1041,    0,  904,    0,    0,  964,    0, 2030,  904,    0,
      904, 1030, 1030, 1030, 1030, 1030, 1030,  964,  904,  904,
      912, 1356, 1356,    0, 1705, 1358,  955,  964, 1703, 1703,

        0, 1704,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  955,  955,  955,  955,  955,  955,  912,    0, 2030,
     2030, 1703, 1703,  955, 1041, 1041, 1041, 1041, 1041, 1041,
      912,    0,    0, 1358,    0, 1705,  955, 1705, 1358, 1704,
        0,  912, 2030, 2030, 1704,    0,    0,  955,    0,    0,
        0, 1020,    0,  912,    0,  997, 1358,    0, 1705,  955,
     1705, 1358, 1704,  912,  913,    0,    0, 1704,    0,  955,
      997,  997,  997,  997,  997,  997,  913,  913,  913,  913,
      913,  913,  913,  913,  913, 1048, 1048, 1048, 1048, 1048,
     1048,  913,  963,  963,  963,  963,  963,  963,  963,  963,

      963,    0,    0,    0,  913,  966,  966,  966,  966,  966,
      966,  966,  966,  966,    0,  913,    0,    0,    0,  966,
     1020, 1020, 1020, 1020, 1020, 1020,    0,  913,  967,  967,
      967,  967,  967,  967,  967,  967,  967,  913,  914,    0,
        0,    0,  967, 1058, 1058, 1058, 1058, 1058, 1058,    0,
      914,  914,  914,  914,  914,  914,  914,  914,  914, 1061,
     1061, 1061, 1061, 1061, 1061,  914,  969,  969,  969,  969,
      969,  969,  969,  969,  969, 1047, 1047, 1047,  914,  971,
      971,  971,  971,  971,  971,  971,  971,  971,    0,  914,
      973,  973,  973,  973,  973,  973,  973,  973,  973,  994,

        0,  914,  974,  974,  974,  974,  974,  974,  974,  974,
      974,  914,  915,    0,  994,  994,  994,  994,  994,  994,
        0,    0,    0,    0,  915,  915,  915,  915,  915,  915,
      915,  915,  915,  994,    0,    0,    0,    0,    0,  915,
        0,    0,    0, 1047, 1047, 1047, 1047, 1047, 1047, 1001,
        0,    0,  915,    0, 1001,    0,  994, 1084, 1084, 1084,
     1084, 1084, 1084,  915, 1001, 1001, 1001, 1001, 1001, 1001,
     1001,    0,  994,    0,    0,  915,    0,  995, 1100, 1100,
     1100, 1100, 1100, 1100, 1060,  915,  916, 1001,    0,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  916,  916,

      916,  916,  916,  916,  916,  916,  916, 1036,    0,    0,
     1001,  995,  999,  916,    0, 2275,    0,  999,    0,    0,
     2275, 1036,    0, 1001,    0,    0,  916,  999,  999,  999,
      999,  999,  999,  999,  995,    0,    0,  916, 1060, 1060,
     1060, 1060, 1060, 1060,    0,    0,    0,    0,    0,  916,
      995,    0,    0,    0,    0,  999, 2275,    0,    0,  916,
      932,  932,  932,  932,  932,  932,  932,  932,  932,  932,
      932,  932,  932,  932,  932,  932,  935,    0,  999, 2275,
     1036, 1036, 1036, 1036, 1036, 1036,  999,    0,    0, 2275,
        0,  935,  935,  935,  935,  935,  935,  935,  935,  935,

      935,  935,  935,  935,  935,  935,  935,  935,  935,  935,
      935,  935,  935,    0,    0,  935,  935,  935,  935,  935,
      935,  935,  935,  935,  935,  935,  935,  935,  935,  935,
      935,  935,  935,  935,  941,  941,    0,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,

      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  941,  941,  941,  941,  941,  941,  941,  941,  941,
      941,  942, 1107, 1107, 1107, 1107, 1107, 1107, 1110, 1110,
     1110, 1110, 1110, 1110,    0,    0,  942,  942,  942,  942,
      942,  942, 1133, 1133, 1133, 1133, 1133, 1133,  942,    0,
        0,  996,    0, 2024,    0,  942,    0,    0, 2024, 1014,
        0,  942,    0,  996,  996,  996,  996,  996,  996,  996,
      996,  996,  942,    0,    0,    0,    0,    0,  942,    0,
        0,    0,    0, 1000,  942,  996,    0,    0, 1000,    0,
     2031,    0, 1445, 1014,  942,  945, 2024, 1445, 1000, 1000,

     1000, 1000, 1000, 1000, 1000,    0,    0,    0,  996,    0,
      945,  945,  945,  945,  945,  945, 1014,    0, 2825, 2024,
        0,    0,  945, 2825,  996, 1000, 1445, 2024, 2031,  945,
        0,    0, 1014, 2031,    0,  945,    0,    0,    0, 1014,
     1014, 1014, 1014, 1014, 1014,    0,  945,    0, 1000, 1445,
        0, 2031,  945,    0, 1062, 2271, 2031, 1000,  945, 1002,
     2825, 2032,    0,    0, 1002, 1445,    0, 1102,  945,  946,
        0,    0, 1102,    0, 1002, 1002, 1002, 1002, 1002, 1002,
     1002,    0,    0, 2825,  946,  946,  946,  946,  946,  946,
        0,    0, 2825, 2271, 1102, 1005,  946,    0, 2271,    0,

     1002, 1102, 2032,  946, 2032,    0,    0, 1102,    0,  946,
     1005, 1005, 1005, 1005, 1005, 1005, 2271, 1073, 1102,    0,
      946, 2271,    0, 1002, 1102, 2032,  946, 2032,    0, 1005,
     1102,    0,  946, 1002, 1062, 1062, 1062, 1062, 1062, 1062,
     1102,    0,  946,  947, 1009, 1009, 1009, 1009, 1009, 1009,
     2875, 2875, 1005,    0, 2875, 1009,    0, 2875,  947,  947,
      947,  947,  947,  947, 2875,    0,    0, 2875, 1005,    0,
      947, 1073, 1073, 1073, 1073, 1073, 1073,  947,    0,    0,
        0,    0,    0,  947, 1013, 1013, 1013, 1013, 1013, 1013,
        0,    0,    0,    0,  947, 1013, 2268,    0, 2270,    0,

      947, 2268,    0,    0,    0,    0,  947,    0, 1006, 1009,
     1009, 1009, 1009, 1009, 1009, 1121,  947,  960,    0,    0,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,  960,
      960,  960,  960,  960,  960,  960,  960,  960,    0, 2268,
     2270, 2270, 1006,    0,  960, 1099,    0,    0,    0, 1013,
     1013, 1013, 1013, 1013, 1013, 2827,    0,  960,    0, 1007,
     2827,    0, 2268, 2270, 2270, 1006,    0,    0,  960,    0,
     2268, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
      960, 1006, 1106, 1121, 1121, 1121, 1121, 1121, 1121,    0,
      960,  976,    0, 1007,    0,    0, 2827,    0,  976, 1099,

     1099, 1099, 1099, 1099, 1099,    0,  976,  976,  976,  976,
      976,  976,  976,    0,    0,    0, 1007,    0,  976, 2827,
        0,    0,    0, 1015,    0,  976,    0,    0,    0, 2827,
        0,  976, 1007,    0,    0,    0, 1106, 1106, 1106, 1106,
     1106, 1106,  976, 2701, 2701,    0, 2701,    0,  976, 2701,
     2701, 2701, 2701, 2701,  976, 1124, 2701, 1015, 1124, 1124,
     1124, 1124, 1124, 1124,  976,  979,    0,  979,  979,  979,
      979,  979,  979,  979,  979,  979,  979, 1016,  979,  979,
     1015,    0,    0, 1042, 1042, 1042,  979,  979,  979,  979,
      979,  979,    0,    0,    0,    0, 1015, 1042,    0,    0,

        0,    0,    0, 1015, 1015, 1015, 1015, 1015, 1015,    0,
        0, 1016,    0,    0,    0,  979,  983,    0,  983,  983,
      983,  983,  983,  983,  983,  983,  983,  983,    0,    0,
      983,    0,    0,    0, 1016,    0,    0,  983,  983,  983,
      983,  983,  983, 1138, 1138, 1138, 1138, 1138, 1138,    0,
     1016, 1042, 1042, 1042, 1042, 1042, 1042, 1016, 1016, 1016,
     1016, 1016, 1016,    0,    0,    0,  983,  988,  988,    0,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,

      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  988,  991,    0,    0,    0, 1112,  991,
     1143, 1143, 1143, 1143, 1143, 1143,    0,    0,    0,  991,
      991,  991,  991,  991,  991,  991, 1176, 1176, 1176, 1176,
     1176, 1176,    0,    0,    0, 1112,    0,    0,  991,    0,
        0,    0, 1112,    0,    0, 1175,    0,  991, 1112, 1175,

     1175, 1175, 1175, 1175, 1175,    0,    0,    0,    0, 1112,
        0,  991,    0,    0,    0, 1112,    0,    0,    0,    0,
      991, 1112,    0,    0,    0,    0,    0,  991,  991, 1010,
     1010, 1112, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,

     1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010, 1010,
     1010, 1010, 1010, 1010, 1010, 1010, 1011, 1184, 1184, 1184,
     1184, 1184, 1184, 1187, 1187, 1187, 1187, 1187, 1187, 1011,
     1011,    0, 1011, 1011, 1011, 1011, 1011, 1011, 1011,    0,
        0,    0,    0, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
     1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
     1011, 1011, 1011, 1011, 1011, 1011, 1011,    0, 1011, 1011,
     1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
     1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
     1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,

     1011, 1011, 1011, 1028, 1126, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1028,    0, 1035, 1028,    0,    0,
        0,    0,    0, 1035, 1028, 1028, 1028, 1028, 1028, 1028,
        0,    0,    0,    0, 1186,    0, 1038, 1035, 1186, 1186,
     1186, 1186, 1186, 1186, 1188, 1188, 1188, 1188, 1188, 1188,
     1035,    0,    0, 1028,    0,    0,    0, 1039, 1126, 1126,
     1126, 1126, 1126, 1126, 1190, 1190, 1190, 1190, 1190, 1190,
     1038, 1040,    0, 1035, 1191, 1191, 1191, 1191, 1191, 1191,
        0,    0,    0, 1028, 1028, 1028, 1028, 1028, 1028, 1035,
        0, 1039, 2546, 1038,    0,    0, 1035, 1035, 1035, 1035,

     1035, 1035, 1037,    0,    0, 1040,    0, 1037,    0, 1038,
        0,    0,    0,    0, 1039, 1037, 1038, 1038, 1038, 1038,
     1038, 1038,    0, 1037, 1049, 1049, 1049,    0, 1040,    0,
     1039, 1043, 1043, 1043, 2546, 2546, 1037, 1039, 1039, 1039,
     1039, 1039, 1039,    0, 1040, 1043,    0,    0,    0,    0,
        0, 1040, 1040, 1040, 1040, 1040, 1040, 2546, 2546, 1037,
        0,    0,    0,    0, 1050, 1050, 1050, 1192, 1192, 1192,
     1192, 1192, 1192,    0,    0, 1037, 1037, 1074, 1074, 1074,
        0,    0, 1037, 1037, 1037, 1037, 1037, 1037, 1085, 1085,
     1085, 1074, 1049, 1049, 1049, 1049, 1049, 1049, 1183, 1043,

     1043, 1043, 1043, 1043, 1043, 1044,    0, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044,    0,    0, 1044,
     1193, 1193, 1193, 1193, 1193, 1193, 1044, 1044, 1044, 1044,
     1044, 1044, 1050, 1050, 1050, 1050, 1050, 1050,    0, 1044,
        0,    0,    0,    0,    0, 1074, 1074, 1074, 1074, 1074,
     1074,    0,    0,    0,    0, 1044, 1085, 1085, 1085, 1085,
     1085, 1085, 1044,    0,    0,    0,    0, 1183, 1183, 1183,
     1183, 1183, 1183,    0,    0, 1194,    0,    0, 1044, 1194,
     1194, 1194, 1194, 1194, 1194, 1044, 1044, 1044, 1044, 1044,
     1044, 1053, 1053,    0, 1053, 1053, 1053, 1053, 1053, 1053,

     1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
     1053, 1053, 1053, 1053, 1053, 1053, 1053, 1053, 1055,    0,
     1071,    0,    0, 1055, 1195, 1195, 1195, 1195, 1195, 1195,
     2798,    0,    0, 1071,    0,    0,    0,    0,    0, 1055,

        0, 1071, 1075, 1075, 1075,    0,    0, 1071,    0,    0,
        0,    0, 1055,    0,    0,    0, 1075,    0,    0,    0,
     1071, 1196, 1196, 1196, 1196, 1196, 1196,    0,    0,    0,
        0, 1071, 2798, 2798, 1197, 1055, 1197, 1197, 1197, 1197,
     1197, 1197,    0, 1071, 1199, 1199, 1199, 1199, 1199, 1199,
        0, 1055, 1055, 1071,    0, 2798, 2798,    0, 1055, 1055,
     1055, 1055, 1055, 1055, 1059,    0,    0,    0,    0,    0,
     1075, 1075, 1075, 1075, 1075, 1075,    0, 1059, 1059,    0,
     1059, 1059, 1059, 1059, 1059, 1059,    0,    0,    0,    0,
        0, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059,

     1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059,
     1059, 1059, 1059, 1059, 1059,    0, 1059, 1059, 1059, 1059,
     1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059,
     1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059,
     1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059,
     1059, 1069, 1069,    0, 1069, 1069, 1069, 1069, 1069, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,

     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
     1069, 1069, 1069, 1069, 1069, 1069, 1069, 1069, 1076, 1076,
     1076,    0,    0,    0, 1077, 1077, 1077,    0,    0,    0,
        0,    0, 1076, 1086, 1086, 1086,    0,    0, 1077,    0,
        0,    0, 1087, 1087, 1087, 1200, 1200, 1200, 1200, 1200,
     1200,    0, 1202,    0, 1088, 1088, 1088,    0, 1078,    0,
        0, 1202,    0,    0, 1109, 1109, 1109, 1202, 1202, 1202,
     1202, 1202, 1202, 1214, 1214, 1214, 1214, 1214, 1214, 1111,

     1111, 1111,    0,    0,    0, 1078, 1076, 1076, 1076, 1076,
     1076, 1076, 1077, 1077, 1077, 1077, 1077, 1077, 1078,    0,
        0, 1086, 1086, 1086, 1086, 1086, 1086,    0,    0, 1078,
     1087, 1087, 1087, 1087, 1087, 1087, 1189,    0,    0, 1105,
        0, 1078, 1088, 1088, 1088, 1088, 1088, 1088, 1137,    0,
        0, 1078, 1109, 1109, 1109, 1109, 1109, 1109, 1078, 1078,
     1078, 1078, 1078, 1078, 1079,    0, 1105, 1111, 1111, 1111,
     1111, 1111, 1111,    0,    0,    0, 1079, 1079, 1079, 1105,
        0,    0,    0, 1127, 1127, 1127,    0,    0,    0,    0,
     1105, 1079,    0,    0,    0,    0,    0, 1127, 1142, 1128,

     1128, 1128, 1105,    0, 1079, 1189, 1189, 1189, 1189, 1189,
     1189,    0, 1105, 1128,    0, 1079, 1130, 1130, 1130, 1105,
     1105, 1105, 1105, 1105, 1105,    0,    0, 1079, 1137, 1137,
     1137, 1137, 1137, 1137, 1132, 1132, 1132, 1079, 1216, 1216,
     1216, 1216, 1216, 1216, 1079, 1079, 1079, 1079, 1079, 1079,
     1080, 1127, 1127, 1127, 1127, 1127, 1127,    0,    0,    0,
        0,    0, 1080, 1080, 1080,    0,    0, 1128, 1128, 1128,
     1128, 1128, 1128, 1134, 1134, 1134,    0, 1080, 1142, 1142,
     1142, 1142, 1142, 1142, 1130, 1130, 1130, 1130, 1130, 1130,
     1080,    0,    0,    0,    0,    0, 1135, 1135, 1135, 1179,

        0, 1080, 1132, 1132, 1132, 1132, 1132, 1132,    0, 1177,
        0,    0,    0, 1080, 1179, 1179, 1179, 1179, 1179, 1179,
     1139,    0,    0, 1080, 1177, 1177, 1177, 1177, 1177, 1177,
     1080, 1080, 1080, 1080, 1080, 1080, 1081, 1179,    0,    0,
        0, 1134, 1134, 1134, 1134, 1134, 1134, 2272, 1081, 1081,
     1081,    0, 1177,    0, 1139,    0,    0, 1136,    0,    0,
     1179,    0, 1136, 1081, 1135, 1135, 1135, 1135, 1135, 1135,
        0,    0, 1140, 1179,    0, 1177, 1081, 1139, 1136,    0,
        0, 2822,    0, 1177, 1140, 1140, 1140, 1081, 2272,    0,
     2272, 1136,    0, 1139, 1145,    0,    0,    0,    0, 1081,

     1139, 1139, 1139, 1139, 1139, 1139, 1140,    0,    0, 1081,
        0, 2272,    0, 2272, 1136,    0, 1081, 1081, 1081, 1081,
     1081, 1081, 1082, 2822, 2822,    0,    0, 1198, 1145, 1140,
     1136, 1136,    0,    0, 1082, 1082, 1082, 1136, 1136, 1136,
     1136, 1136, 1136, 1144,    0, 1140, 2822, 2822, 1144, 1082,
        0, 1145, 1140, 1140, 1140, 1140, 1140, 1140, 1141,    0,
        0,    0, 1082,    0, 1144,    0,    0, 1145,    0,    0,
     1141, 1141, 1141, 1082, 1145, 1145, 1145, 1145, 1145, 1145,
        0,    0,    0,    0,    0, 1082, 1218, 1218, 1218, 1218,
     1218, 1218, 1141,    0, 1215, 1082, 1198, 1198, 1198, 1198,

     1198, 1198, 1082, 1082, 1082, 1082, 1082, 1082, 1083, 1215,
     1215, 1215, 1215, 1215, 1215, 1141,    0, 1144,    0,    0,
     1083, 1083, 1083, 1144, 1144, 1144, 1144, 1144, 1144, 1213,
        0, 1141, 2548, 1185, 1178, 1083,    0,    0, 1141, 1141,
     1141, 1141, 1141, 1141,    0, 1180,    0,    0, 1083, 1178,
     1178, 1178, 1178, 1178, 1178,    0,    0,    0,    0, 1083,
     1180, 1180, 1180, 1180, 1180, 1180,    0,    0, 1201,    0,
        0, 1083,    0, 2548,    0, 2548, 1178,    0, 1203,    0,
        0, 1083,    0,    0,    0,    0, 1180, 1203, 1083, 1083,
     1083, 1083, 1083, 1083, 1090,    0, 2548,    0, 2548, 1178,

     2800, 1213, 1213, 1213, 1213, 1213, 1213, 1185, 1178, 1180,
        0,    0, 1146, 1185, 1185, 1185, 1185, 1185, 1185, 1180,
        0, 1090,    0,    0, 1146, 1146, 1146,    0, 1090,    0,
        0,    0,    0,    0, 1090, 1201, 1201, 1201, 1201, 1201,
     1201, 2800,    0, 2800,    0, 1090, 1146,    0,    0,    0,
        0, 1090,    0,    0,    0,    0,    0, 1090, 1203, 1203,
     1203, 1203, 1203, 1203, 2800,    0, 2800, 1090,    0, 1146,
        0,    0, 2824,    0, 1090, 1090, 1090, 1090, 1090, 1090,
     1093,    0,    0,    0,    0, 1146, 1220, 1220, 1220, 1220,
     1220, 1220, 1146, 1146, 1146, 1146, 1146, 1146, 1147,    0,

        0,    0,    0,    0, 1208,    0,    0, 1093,    0, 1205,
     1147, 1147, 1147, 2824, 1093, 2824, 1208,    0, 1208,    0,
     1093, 1205,    0, 1205, 1205, 1205, 1205, 1205, 1205, 1205,
     1206, 1093, 1147,    0,    0,    0, 2824, 1093, 2824, 1206,
        0,    0,    0, 1093,    0, 1206, 1206, 1206, 1206, 1206,
     1206,    0, 2820, 1093,    0, 1147,    0, 2820,    0,    0,
     1093, 1093, 1093, 1093, 1093, 1093, 1094,    0,    0,    0,
        0, 1147, 1227, 1227, 1227, 1227, 1227, 1227, 1147, 1147,
     1147, 1147, 1147, 1147, 1208, 1208, 1208, 1208, 1208, 1208,
     1209,    0,    0, 1094, 1210, 2820,    0,    0,    0, 1209,

     1094,    0, 1210,    0,    0,    0, 1094,    0,    0, 1210,
     1210, 1210, 1210, 1210, 1210, 1219,    0, 1094, 2820,    0,
        0, 1230,    0, 1094, 1211,    0, 2820,    0,    0, 1094,
        0, 1211, 1211, 1211, 1211, 1211, 1211, 1212,    0, 1094,
        0, 1217,    0,    0,    0, 1212, 1094, 1094, 1094, 1094,
     1094, 1094, 1095, 1217,    0, 1217, 1217, 1217, 1217, 1217,
     1217, 1217,    0,    0, 1221,    0,    0, 1231,    0,    0,
     1209, 1209, 1209, 1209, 1209, 1209, 1221,    0, 1221, 1095,
     1230, 1230, 1230, 1230, 1230, 1230, 1095,    0,    0,    0,
        0,    0, 1095,    0,    0, 1219, 1219, 1219, 1219, 1219,

     1219,    0,    0, 1095,    0,    0,    0,    0,    0, 1095,
        0,    0,    0,    0,    0, 1095,    0, 1212, 1212, 1212,
     1212, 1212, 1212,    0,    0, 1095, 1231, 1231, 1231, 1231,
     1231, 1231, 1095, 1095, 1095, 1095, 1095, 1095, 1108,    0,
        0,    0,    0,    0, 1221, 1221, 1221, 1221, 1221, 1221,
     1108, 1108, 1108, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
        0,    0,    0,    0,    0, 1108, 1223, 1223, 1223, 1223,
     1223, 1223, 1223,    0,    0,    0,    0,    0, 1108, 1233,
     1233, 1233, 1233, 1233, 1233,    0, 1235, 1235,    0, 1108,
        0, 1235,    0,    0, 1235, 1235,    0,    0,    0,    0,

        0, 1108, 1235,    0, 1235,    0, 1235, 1235,    0,    0,
        0, 1108, 1237, 1237, 1237, 1237, 1237, 1237, 1108, 1108,
     1108, 1108, 1108, 1108, 1115, 1240, 1240, 1240, 1240, 1240,
     1240, 1115, 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241,
     1241,    0,    0,    0,    0, 1115,    0,    0,    0,    0,
        0, 1115, 1245, 1245, 1245, 1245, 1245, 1245, 1115,    0,
        0,    0,    0,    0, 1115, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242,    0, 1115,    0,    0,    0,    0,
        0, 1115,    0,    0,    0,    0,    0, 1115, 1243, 1243,
     1243, 1243, 1243, 1243, 1243, 1243, 1243, 1115, 1247, 1247,

     1247, 1247, 1247, 1247, 1115, 1115, 1115, 1115, 1115, 1115,
     1116,    0, 1116, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
     1116, 1116,    0, 1116, 1116, 1250, 1250, 1250, 1250, 1250,
     1250, 1116, 1116, 1116, 1116, 1116, 1116, 1244, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1246, 1246, 1246, 1246,
     1246, 1246, 1246, 1246, 1246,    0,    0,    0,    0,    0,
     1116, 1119, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
     1248,    0,    0,    0,    0,    0, 1119, 1119, 1119, 1119,
     1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119,
     1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119,    0,    0,

     1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119,
     1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 1119, 1120,
        0, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120,
     1120,    0,    0, 1120, 1256, 1256, 1256, 1256, 1256, 1256,
     1120, 1120, 1120, 1120, 1120, 1120, 1261, 1261, 1261, 1261,
     1261, 1261, 1263, 1263, 1263, 1263, 1263, 1263, 1270, 1270,
     1270, 1270, 1270, 1270,    0,    0,    0,    0,    0, 1120,
     1125, 1125,    0, 1125, 1125, 1125, 1125, 1125, 1125, 1125,
     1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125,
     1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125,

     1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125,
     1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125,
     1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125,
     1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125,
     1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125,
     1125, 1125, 1125, 1125, 1125, 1125, 1125, 1257, 1257, 1257,
        0,    0,    0, 1258, 1258, 1258,    0,    0,    0, 1259,
     1259, 1259,    0,    0,    0, 1260, 1260, 1260,    0,    0,
        0, 1262, 1262, 1262,    0,    0,    0, 1264, 1264, 1264,
     1271, 1271, 1271, 1271, 1271, 1271, 1272, 1272, 1272, 1272,

     1272, 1272, 1273, 1273, 1273, 1273, 1273, 1273, 1276, 1276,
     1276, 1276, 1276, 1276, 1278, 1278, 1278, 1278, 1278, 1278,
        0,    0,    0, 1297,    0, 1257, 1257, 1257, 1257, 1257,
     1257, 1258, 1258, 1258, 1258, 1258, 1258, 1259, 1259, 1259,
     1259, 1259, 1259, 1260, 1260, 1260, 1260, 1260, 1260, 1262,
     1262, 1262, 1262, 1262, 1262, 1264, 1264, 1264, 1264, 1264,
     1264, 1275, 1279,    0,    0,    0, 1275, 1279,    0, 1293,
        0,    0,    0,    0, 1275, 1279, 1275, 1275, 1275, 1275,
     1275, 1275, 1275, 1279, 1293, 1293, 1293, 1293, 1293, 1293,
     1294, 1294, 1294, 1294, 1294, 1294, 1295, 1295, 1295, 1295,

     1295, 1295, 1296, 1297, 1297, 1297, 1297, 1297, 1297, 1303,
        0, 1296,    0,    0,    0,    0,    0, 1296, 1296, 1296,
     1296, 1296, 1296, 1298, 1298, 1298, 1298, 1298, 1298, 1299,
     1299, 1299, 1299, 1299, 1299, 1301,    0,    0,    0, 1300,
        0,    0, 1279, 1279, 1279, 1279, 1279, 1279, 1300,    0,
     1301, 1301, 1301, 1301, 1301, 1301, 1302, 1302, 1302, 1302,
     1302, 1302, 1304, 1304, 1304, 1304, 1304, 1304, 1308, 1309,
     1309, 1309, 1309, 1309, 1309, 1312, 1312, 1312, 1312, 1312,
     1312,    0,    0, 1308, 1308, 1308, 1308, 1308, 1308, 1303,
     1303, 1303, 1303, 1303, 1303, 1319, 1319, 1319, 1319, 1319,

     1319,    0, 1308, 1321, 1321, 1321, 1321, 1321, 1321,    0,
        0, 1320, 1325, 1325, 1325, 1325, 1325, 1325,    0, 1300,
     1300, 1300, 1300, 1300, 1300, 1308, 1320, 1320, 1320, 1320,
     1320, 1320, 1322, 1322, 1322, 1322, 1322, 1322,    0,    0,
        0, 1308,    0, 1322,    0, 1320, 1323, 1323, 1323, 1323,
     1323, 1323, 1323, 1323, 1323,    0,    0,    0,    0,    0,
     1323, 1324, 1324, 1324, 1324, 1324, 1324,    0, 1320,    0,
        0,    0, 1324,    0, 1326, 1326, 1326, 1326, 1326, 1326,
        0,    0,    0,    0, 1320, 1326, 1327, 1327, 1327, 1327,
     1327, 1327, 1328, 1328, 1328, 1328, 1328, 1328, 1329, 1329,

     1329, 1329, 1329, 1329, 1329, 1329, 1329, 1330, 1330, 1330,
     1330, 1330, 1330, 1331,    0,    0,    0,    0, 1331, 1332,
     1332, 1332, 1332, 1332, 1332,    0,    0,    0, 1331, 1331,
     1331, 1331, 1331, 1331, 1331, 1333, 1333, 1333, 1333, 1333,
     1333, 1334, 1334, 1334, 1334, 1334, 1334, 1331,    0,    0,
        0,    0, 1334,    0,    0,    0, 1331, 1336, 1336, 1336,
     1336, 1336, 1336, 1342, 1342, 1342, 1342, 1342, 1342,    0,
     1331,    0,    0,    0, 1342,    0,    0,    0,    0, 1331,
     1343, 1343, 1343, 1343, 1343, 1343, 1331, 1331, 1335,    0,
     1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,

     1348,    0, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
     1335, 1335, 1335, 1335, 1335, 1348, 1348, 1348, 1348, 1348,
     1348, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373, 1373,
        0,    0,    0,    0,    0, 1373,    0,    0, 1335, 1341,
     1374, 1374, 1374, 1374, 1374, 1374,    0,    0,    0,    0,
        0, 1374, 1341, 1341,    0, 1341, 1341, 1341, 1341, 1341,
     1341,    0,    0,    0,    0,    0, 1341, 1341, 1341, 1341,
     1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341,
     1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341,
        0, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341,

     1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341,
     1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341, 1341,
     1341, 1341, 1341, 1341, 1341, 1341, 1344, 1344,    0, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,

     1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344, 1344,
     1344, 1344, 1344, 1353, 1353,    0, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,

     1365,    0,    0, 2547,    0, 1365,    0, 1366,    0,    0,
        0,    0, 1366,    0,    0, 1365, 1365, 1365, 1365, 1365,
     1365, 1365, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1375,
     1375, 1375, 1375, 1375, 1375, 1367,    0,    0,    0,    0,
     1367, 2547, 1368, 1365,    0,    0, 2547, 1368,    0, 1366,
     1367, 1367, 1367, 1367, 1367, 1367, 1367, 1368, 1368, 1368,
     1368, 1368, 1368, 1368, 2547,    0, 1365,    0,    0, 2547,
        0,    0, 1366, 1367, 1365, 1378, 1378, 1378, 1378, 1378,
     1378, 1366,    0, 1368, 1376, 1376, 1376, 1376, 1376, 1376,
     1376, 1376, 1376,    0,    0,    0, 1367,    0, 1376, 1377,

     1377, 1377, 1377, 1377, 1377,    0, 1368,    0,    0, 1367,
     1377,    0,    0,    0,    0,    0, 1368, 1370, 1370,    0,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,

     1370, 1370, 1370, 1370, 1371, 1371,    0, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
     1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
     1371, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,

     1380, 1380, 1380, 1380, 1380, 1380, 1381, 1381, 1381, 1381,
     1381, 1381, 1381, 1381, 1381, 1382, 1382,    0, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
     1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,

     1382, 1382, 1383, 1383, 1383, 1383, 1383, 1383, 1384, 1384,
     1384, 1384, 1384, 1384, 1385, 1385, 1385, 1385, 1385, 1385,
     1388, 1389, 1392,    0,    0, 1392, 1392, 1392, 1392, 1392,
     1392, 1399, 1399, 1399, 1399, 1399, 1399,    0,    0,    0,
        0,    0, 1399, 1400, 1400, 1400, 1400, 1400, 1400, 1401,
     1401, 1401, 1401, 1401, 1401,    0,    0,    0,    0,    0,
     1401, 1393, 1402, 1402, 1402, 1402, 1402, 1402,    0, 1403,
     1501,    0,    0,    0, 1403,    0,    0,    0, 1388, 1388,
     1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1393, 1389,
     1389, 1389, 1389, 1389, 1389, 1393, 1403, 1501,    0,    0,

        0, 1393,    0, 1403, 1501,    0,    0,    0,    0, 1403,
     1501,    0, 1393,    0,    0,    0,    0,    0, 1393,    0,
     1403, 1501,    0,    0, 1393,    0, 1403, 1501,    0,    0,
        0,    0, 1403, 1501, 1393, 1396, 1407, 1407, 1407, 1407,
     1407, 1407, 1403, 1501,    0,    0,    0, 1407,    0,    0,
     1396, 1396, 1396, 1396, 1396, 1396, 1408, 1408, 1408, 1408,
     1408, 1408, 1396, 1409, 1409, 1409, 1409, 1409, 1409, 1396,
        0,    0,    0,    0,    0, 1396, 1410, 1410, 1410, 1410,
     1410, 1410, 1410, 1410, 1410,    0, 1396,    0,    0,    0,
     1410,    0, 1396,    0,    0,    0,    0,    0, 1396, 1411,

     1411, 1411, 1411, 1411, 1411,    0,    0,    0, 1396, 1405,
     1411, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
     1405,    0, 1405, 1405, 1412, 1412, 1412, 1412, 1412, 1412,
     1405, 1405, 1405, 1405, 1405, 1405, 1413, 1413, 1413, 1413,
     1413, 1413,    0,    0, 1425, 1426,    0, 1413, 1414, 1414,
     1414, 1414, 1414, 1414,    0,    0,    0,    0,    0, 1405,
     1415, 1415, 1415, 1415, 1415, 1415, 1415, 1415, 1415, 1416,
     1416, 1416, 1416, 1416, 1416, 1421,    0, 1421, 1421, 1421,
     1421, 1421, 1421, 1421, 1421, 1421, 1421, 1429,    0, 1421,
     1429, 1429, 1429, 1429, 1429, 1429, 1421, 1421, 1421, 1421,

     1421, 1421, 1425, 1425, 1425, 1425, 1425, 1425, 1425, 1425,
     1425, 1425,    0, 1426, 1426, 1426, 1426, 1426, 1426, 1430,
     1430, 1430, 1430, 1430, 1430, 1421, 1431,    0,    0,    0,
        0, 1431,    0, 1432,    0,    0,    0,    0, 1432,    0,
        0, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1432, 1432,
     1432, 1432, 1432, 1432, 1432,    0, 1438,    0,    0,    0,
        0, 1433,    0,    0,    0,    0, 1433,    0, 1434, 1431,
        0,    0,    0, 1434,    0, 1432, 1433, 1433, 1433, 1433,
     1433, 1433, 1433, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1438,    0, 1431,    0,    0,    0, 1436, 1436, 1432, 1433,

     1431, 1436,    0,    0, 1436, 1436,    0, 1432,    0, 1434,
        0,    0, 1436, 1438, 1436,    0, 1436, 1436,    0,    0,
        0,    0, 1433, 1439, 1439, 1439, 1439, 1439, 1439, 1438,
     1456,    0, 1434,    0,    0, 1433, 1438, 1438, 1438, 1438,
     1438, 1438, 1434, 1443, 1443, 1443, 1443, 1443, 1443, 1450,
     1450, 1450, 1450, 1450, 1450, 1451, 1451, 1451, 1451, 1451,
     1451, 1452, 1452, 1452, 1452, 1452, 1452, 1453, 1453, 1453,
     1453, 1453, 1453, 1454, 1455, 1455, 1455, 1455, 1455, 1455,
     1458,    0,    0,    0, 1456, 1456, 1456, 1456, 1456, 1456,
        0, 1457, 1457, 1457, 1459, 1459, 1459, 1459, 1459, 1459,

        0,    0,    0,    0,    0, 1457,    0, 1454, 1463, 1463,
     1463, 1460, 1461, 1461, 1461, 1461, 1461, 1461, 1462, 1462,
     1462, 1462, 1462, 1462, 1464, 1464, 1464, 1464, 1464, 1464,
     1454,    0,    0,    0, 1458, 1458, 1458, 1458, 1458, 1458,
     1469, 1469, 1469, 1469, 1469, 1469, 1454, 1470, 1470, 1470,
     1470, 1470, 1470, 1454, 1454, 1454, 1454, 1454, 1454, 1457,
     1457, 1457, 1457, 1457, 1457, 1460, 1460, 1460, 1460, 1460,
     1460,    0,    0,    0,    0,    0, 1463, 1463, 1463, 1463,
     1463, 1463, 1466, 1466,    0, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,

     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466,
     1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1466, 1467,
     1467,    0, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467,
     1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467,
     1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467,

     1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467,
     1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467,
     1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467,
     1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467,
     1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467, 1467,
     1467, 1467, 1467, 1467, 1467, 1467, 1468,    0,    0,    0,
     1471, 1468, 1473, 1473, 1473, 1473, 1473, 1473, 1479, 1480,
     1480, 1480, 1480, 1480, 1480,    0,    0, 1468, 1493, 1493,
     1493, 1493, 1493, 1493, 1496, 1496, 1496, 1496, 1496, 1496,
     1468, 1498, 1498, 1498, 1498, 1498, 1498,    0,    0,    0,

     1475,    0,    0,    0,    0, 1475, 1481, 1508, 1508, 1508,
     1508, 1508, 1508, 1468, 1471, 1471, 1471, 1471, 1471, 1471,
        0, 1475, 1479, 1479, 1479, 1479, 1479, 1479,    0, 1468,
     1468,    0,    0,    0, 1475,    0, 1468, 1468, 1468, 1468,
     1468, 1468, 1472, 1492, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1495, 1489, 1472, 1475,    0,    0,
     1489, 1507,    0, 1472, 1472, 1472, 1472, 1472, 1472,    0,
        0,    0,    0, 1475, 1475,    0, 1489,    0,    0,    0,
     1475, 1475, 1475, 1475, 1475, 1475, 1481, 1481, 1481, 1481,
     1481, 1481, 1472,    0,    0,    0,    0, 1492, 1492, 1492,

     1492, 1492, 1492,    0,    0,    0,    0,    0, 1495, 1495,
     1495, 1495, 1495, 1495,    0, 1507, 1507, 1507, 1507, 1507,
     1507,    0, 1472, 1472, 1472, 1472, 1472, 1472, 1478, 1489,
        0,    0,    0,    0,    0, 1489, 1489, 1489, 1489, 1489,
     1489, 1478, 1478,    0, 1478, 1478, 1478, 1478, 1478, 1478,
        0,    0,    0,    0,    0, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,    0,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,

     1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1488, 1488,    0, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,
     1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488, 1488,

     1488, 1488, 1491, 1491, 1491, 1509,    0,    0, 1494, 1494,
     1494,    0,    0,    0,    0,    0, 1491, 1497, 1497, 1497,
        0,    0, 1494, 1499, 1499, 1499, 1510, 1510, 1510, 1510,
     1510, 1510, 1516, 1516, 1516, 1516, 1516, 1516, 1517, 1517,
     1517, 1517, 1517, 1517, 1530,    0,    0, 1530, 1530, 1530,
     1530, 1530, 1530, 1533, 1533, 1533, 1533, 1533, 1533, 1509,
     1509, 1509, 1509, 1509, 1509,    0,    0,    0,    0,    0,
     1491, 1491, 1491, 1491, 1491, 1491, 1494, 1494, 1494, 1494,
     1494, 1494,    0,    0,    0, 1497, 1497, 1497, 1497, 1497,
     1497, 1499, 1499, 1499, 1499, 1499, 1499, 1500, 1500,    0,

     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1504, 1511,    0,    0,    0,    0,
     1511,    0,    0,    0, 2799, 1515, 1535, 1535, 1535, 1535,

     1535, 1535, 1537, 1537, 1537, 1537, 1537, 1537,    0,    0,
        0, 1504, 1511,    0,    0,    0,    0, 1527, 1504, 1511,
        0,    0,    0,    0, 1504, 1511, 1538, 1538, 1538, 1538,
     1538, 1538, 2799,    0,    0, 1504, 1511, 2799,    0, 1526,
        0, 1504, 1511,    0,    0,    0,    0, 1504, 1511, 1515,
     1515, 1515, 1515, 1515, 1515, 2799,    0, 1504, 1511, 1532,
     2799,    0,    0,    0, 1504, 1504, 1504, 1504, 1504, 1504,
     1513,    0, 1513, 1513, 1513, 1513, 1513, 1513, 1513, 1513,
     1513, 1513, 1534, 1513, 1513, 1527, 1527, 1527, 1527, 1527,
     1527, 1513, 1513, 1513, 1513, 1513, 1513, 1526, 1526, 1526,

     1526, 1526, 1526, 1526, 1526, 1526, 1526,    0, 1531, 1531,
     1531,    0,    0, 1532, 1532, 1532, 1532, 1532, 1532,    0,
     1513, 1522, 1531, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522,    0,    0, 1522, 1534, 1534, 1534, 1534,
     1534, 1534, 1522, 1522, 1522, 1522, 1522, 1522, 1536, 1536,
     1536, 1539,    0,    0,    0,    0, 1539, 1570, 1570, 1570,
     1570, 1570, 1570, 1572, 1572, 1572, 1572, 1572, 1572,    0,
        0, 1522, 1539,    0,    0,    0, 1531, 1531, 1531, 1531,
     1531, 1531, 1573, 1573, 1573, 1573, 1573, 1573, 1575, 1575,
     1575, 1575, 1575, 1575, 1576, 1576, 1576, 1576, 1576, 1576,

     1578, 1578, 1578, 1578, 1578, 1578, 1579, 1579, 1579, 1579,
     1579, 1579, 1593,    0,    0,    0, 1536, 1536, 1536, 1536,
     1536, 1536,    0,    0, 1593, 1539, 1593,    0,    0,    0,
        0, 1539, 1539, 1539, 1539, 1539, 1539, 1581, 1581, 1581,
     1581, 1581, 1581, 1582, 1582, 1582, 1582, 1582, 1582, 1583,
     1583, 1583, 1583, 1583, 1583, 1584, 1584, 1584, 1584, 1584,
     1584, 1586, 1586, 1586, 1586, 1586, 1586, 1587, 1587, 1587,
     1587, 1587, 1587, 1588, 1588, 1588, 1588, 1588, 1588, 1590,
     1590, 1590, 1590, 1590, 1590, 1591, 1591, 1591, 1591, 1591,
     1591, 1592, 1593, 1593, 1593, 1593, 1593, 1593, 1594, 1598,

        0,    0,    0, 1592,    0, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1604, 1594, 1594, 1594, 1594, 1594, 1594, 1595,
     1595, 1595, 1595, 1595, 1595, 1596, 1596, 1596, 1596, 1596,
     1596, 1597, 1599, 1599, 1599, 1599, 1599, 1599,    0,    0,
     1597,    0,    0,    0, 1602,    0, 1597, 1597, 1597, 1597,
     1597, 1597, 1600, 1600, 1600, 1600, 1600, 1600, 1601, 1602,
     1602, 1602, 1602, 1602, 1602,    0,    0, 1601, 1603, 1603,
     1603, 1603, 1603, 1603,    0,    0,    0,    0,    0, 1598,
     1598, 1598, 1598, 1598, 1598, 1605, 1605, 1605, 1605, 1605,
     1605,    0, 1604, 1604, 1604, 1604, 1604, 1604, 1606, 1606,

     1606, 1606, 1606, 1606, 1607, 1607, 1607, 1607, 1607, 1607,
     1608, 1609, 1609, 1609, 1609, 1609, 1609,    0,    0,    0,
        0,    0, 1608,    0, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1610, 1610, 1610, 1610, 1610, 1610, 1611, 1601, 1601,
     1601, 1601, 1601, 1601,    0,    0,    0,    0,    0, 1611,
        0, 1611, 1613, 1613, 1613, 1613, 1613, 1613, 1614, 1614,
     1614, 1614, 1614, 1614, 1615, 1615, 1615, 1615, 1615, 1615,
     1616, 1616, 1616, 1616, 1616, 1616, 1619, 1619,    0,    0,
        0, 1619,    0,    0, 1619, 1619, 1621, 1621, 1621, 1621,
     1621, 1621, 1619,    0, 1619,    0, 1619, 1619, 1622, 1622,

     1622, 1622, 1622, 1622, 1622, 1622, 1622, 1623, 1623, 1623,
     1623, 1623, 1623, 1629, 1629, 1629,    0, 1611, 1611, 1611,
     1611, 1611, 1611, 1624, 1624, 1624, 1624, 1624, 1624, 1625,
     1625, 1625, 1625, 1625, 1625, 1626, 1626, 1626, 1626, 1626,
     1626, 1627, 1627, 1627, 1627, 1627, 1627, 1628, 1628, 1628,
     1628, 1628, 1628, 1630, 1630, 1630, 1630, 1630, 1630, 1631,
     1631, 1631, 1631, 1631, 1631, 1632, 1632, 1632, 1632, 1632,
     1632, 1633, 1633, 1633, 1633, 1633, 1633,    0,    0,    0,
        0, 1629, 1629, 1629, 1629, 1629, 1629, 1634, 1634, 1634,
     1634, 1634, 1634, 1635, 1635, 1635, 1635, 1635, 1635, 1636,

     1636, 1636, 1636, 1636, 1636, 1637,    0,    0,    0,    0,
     1637, 1638, 1638, 1638, 1638, 1638, 1638, 1658, 1637,    0,
     1637, 1637, 1637, 1637, 1637, 1637, 1637, 1639, 1639, 1639,
     1639, 1639, 1639, 1640,    0,    0,    0,    0, 1640, 1651,
     1651, 1651, 1651, 1651, 1651, 1655, 1640, 1653, 1653, 1653,
     1653, 1653, 1653,    0, 1640,    0,    0,    0,    0,    0,
     1655, 1655, 1655, 1655, 1655, 1655, 1656, 1656, 1656, 1656,
     1656, 1656, 1657, 1659, 1659, 1659, 1659, 1659, 1659,    0,
        0, 1660,    0,    0, 1657,    0, 1657, 1657, 1657, 1657,
     1657, 1657, 1657, 1660,    0, 1660,    0, 1658, 1658, 1658,

     1658, 1658, 1658, 1664, 1664, 1664, 1664, 1664, 1664,    0,
        0,    0,    0, 1640, 1640, 1640, 1640, 1640, 1640, 1666,
     1666, 1666, 1666, 1666, 1666, 1667, 1667, 1667, 1667, 1667,
     1667, 1671, 1671, 1671, 1671, 1671, 1671, 1672, 1679, 1679,
     1679, 1679, 1679, 1679,    0,    0,    0,    0,    0, 1672,
        0, 1672, 1672, 1672, 1672, 1672, 1672, 1672,    0,    0,
        0, 1660, 1660, 1660, 1660, 1660, 1660, 1669,    0, 1669,
     1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669,    0,
        0, 1669, 1673,    0,    0,    0,    0,    0, 1669, 1669,
     1669, 1669, 1669, 1669, 1673, 1682, 1673, 1673, 1673, 1673,

     1673, 1673, 1673,    0,    0,    0,    0, 1682, 1673, 1682,
     1682, 1682, 1682, 1682, 1682, 1682,    0, 1669, 1675,    0,
     1675, 1675, 1675, 1675, 1675, 1675, 1675, 1675, 1675, 1675,
        0,    0, 1675, 1675, 1675, 1675, 1675, 1675, 1675, 1675,
     1675, 1675, 1675, 1675, 1675, 1683, 1683, 1683, 1683, 1683,
     1683, 1684, 1684, 1684, 1684, 1684, 1684,    0,    0, 1685,
     1685, 1685, 1685, 1685, 1685,    0,    0,    0, 1675, 1676,
     1685, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1676,    0,    0, 1676, 1676, 1676,    0,    0,    0,    0,
     1676, 1676, 1676, 1676, 1676, 1676, 1691, 1691, 1691, 1691,

     1691, 1691, 1692, 1692, 1692, 1692, 1692, 1692,    0,    0,
        0,    0,    0, 1692,    0,    0,    0,    0,    0, 1676,
     1693, 1693, 1693, 1693, 1693, 1693, 1693, 1693, 1693,    0,
        0,    0,    0,    0, 1693, 1694, 1694, 1694, 1694, 1694,
     1694, 1694, 1694, 1694,    0,    0,    0,    0,    0, 1694,
     1695, 1695, 1695, 1695, 1695, 1695, 1696, 1696, 1696, 1696,
     1696, 1696, 1696, 1696, 1696, 1697, 1697, 1697, 1697, 1697,
     1697, 1697, 1697, 1697, 1698,    0,    0,    0,    0, 1698,
     1701, 1701, 1701, 1701, 1701, 1701, 1713,    0,    0, 1698,
     1698, 1698, 1698, 1698, 1698, 1698, 1699, 1699, 1699, 1699,

     1699, 1699, 1700, 1700, 1700, 1700, 1700, 1700,    0,    0,
        0,    0,    0, 1700,    0, 1723, 1713, 1698, 1723, 1723,
     1723, 1723, 1723, 1723, 1725, 1725, 1725, 1725, 1725, 1725,
        0,    0,    0,    0,    0, 1725,    0,    0,    0, 1713,
     1698, 1726, 1726, 1726, 1726, 1726, 1726,    0, 1698,    0,
        0,    0,    0,    0, 1713, 1713, 1713, 1713, 1713, 1713,
        0, 1699, 1699, 1699, 1699, 1699, 1699, 1702, 1702,    0,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,

     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1702, 1702, 1706,    0,    0,    0,    0, 1706,
        0, 1707,    0,    0,    0,    0, 1707,    0,    0, 1706,
     1706, 1706, 1706, 1706, 1706, 1706, 1707, 1707, 1707, 1707,
     1707, 1707, 1707, 1720,    0, 1708,    0,    0,    0,    0,
     1708,    0,    0,    0,    0,    0, 1706,    0,    0, 1707,

     1708, 1708, 1708, 1708, 1708, 1708, 1708,    0,    0, 1716,
        0,    0, 1716, 1716, 1716, 1716, 1716, 1716,    0, 1706,
        0,    0, 1707,    0,    0,    0, 1708,    0, 1706, 1727,
     1727, 1727, 1727, 1727, 1727, 1707,    0,    0,    0, 1716,
     1728, 1728, 1728, 1728, 1728, 1728,    0,    0,    0, 1708,
        0, 1720, 1720, 1720, 1720, 1720, 1720,    0,    0, 1708,
     1709, 1709, 1716, 1709, 1709, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709,

     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1709, 1709, 1709, 1709, 1709, 1712, 1719, 1729,
     1729, 1729, 1729, 1729, 1729, 1730, 1730, 1730, 1730, 1730,
     1730, 1736, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1735,    0, 1712, 1712, 1712, 1712,
     1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712, 1712,

     1712, 1712, 1712, 1712, 1712,    0, 1719, 1719, 1719, 1719,
     1719, 1719, 1719, 1719, 1719, 1719, 1731, 1731, 1731, 1731,
     1731, 1731, 1732, 1732, 1732, 1732, 1732, 1732,    0, 1736,
     1736, 1736, 1736, 1736, 1736, 1740, 1740, 1740, 1740, 1740,
     1740,    0, 1735, 1735, 1735, 1735, 1735, 1735, 1735, 1735,
     1735, 1735, 1739,    0,    0, 1739, 1739, 1739, 1739, 1739,
     1739, 1741, 1741, 1741, 1741, 1741, 1741, 1742, 1742, 1742,
     1742, 1742, 1742, 1743,    0, 1743, 1743, 1743, 1743, 1743,
     1743, 1743, 1743, 1743, 1743,    0,    0, 1743, 1743, 1743,
     1743, 1743, 1743, 1743, 1743, 1743, 1743, 1743, 1743, 1743,

     1744, 1744, 1744, 1744, 1744, 1744, 1745, 1745, 1745, 1745,
     1745, 1745,    0,    0,    0,    0,    0, 1745,    0,    0,
        0,    0,    0, 1743, 1746, 1746, 1746, 1746, 1746, 1746,
     1749,    0, 1749, 1749, 1749, 1749, 1749, 1749, 1749, 1749,
     1749, 1749,    0,    0, 1749, 1753, 1753, 1753, 1753, 1753,
     1753, 1749, 1749, 1749, 1749, 1749, 1749, 1752, 1752, 1752,
     1752, 1752, 1752,    0,    0,    0,    0,    0, 1752, 1754,
     1754, 1754, 1754, 1754, 1754,    0,    0,    0,    0,    0,
     1749, 1751,    0, 1751, 1751, 1751, 1751, 1751, 1751, 1751,
     1751, 1751, 1751,    0,    0, 1751, 1755, 1755, 1755, 1755,

     1755, 1755, 1751, 1751, 1751, 1751, 1751, 1751, 1756, 1756,
     1756, 1756, 1756, 1756, 1757, 1757, 1757, 1757, 1757, 1757,
     1758, 1758, 1758, 1758, 1758, 1758,    0,    0,    0,    0,
        0, 1751, 1759, 1759, 1759, 1759, 1759, 1759, 1763, 1763,
        0,    0,    0, 1763,    0,    0, 1763, 1763, 1767, 1767,
     1767, 1767, 1767, 1767, 1763,    0, 1763,    0, 1763, 1763,
     1769, 1769, 1769, 1769, 1769, 1769, 1770, 1770, 1770, 1770,
     1770, 1770, 1772,    0, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1772, 1772,    0,    0, 1772, 1774, 1774, 1774,
     1774, 1774, 1774, 1772, 1772, 1772, 1772, 1772, 1772, 1775,

     1775, 1775, 1775, 1775, 1775, 1776, 1776, 1776, 1776, 1776,
     1776, 1777, 1777, 1777, 1777, 1777, 1777, 1778, 1793, 1806,
        0,    0, 1772, 1779,    0,    0,    0,    0,    0, 1778,
        0, 1778,    0,    0,    0, 1779,    0, 1779, 1785, 1785,
     1785, 1785, 1785, 1785, 1788,    0,    0,    0, 1793, 1779,
     1804, 1804, 1804, 1804, 1804, 1804, 1788,    0, 1788, 1805,
     1805, 1805, 1805, 1805, 1805,    0,    0,    0, 1802,    0,
        0, 1793,    0, 1806, 1806, 1806, 1806, 1806, 1806, 1812,
     1812, 1812, 1812, 1812, 1812,    0, 1793, 1793, 1793, 1793,
     1793, 1793,    0,    0,    0,    0,    0, 1778, 1778, 1778,

     1778, 1778, 1778, 1779, 1779, 1779, 1779, 1779, 1779, 1781,
        0, 1781, 1781, 1781, 1781, 1781, 1781, 1781, 1781, 1781,
     1781, 1813,    0, 1781, 1788, 1788, 1788, 1788, 1788, 1788,
     1781, 1781, 1781, 1781, 1781, 1781, 1802, 1802, 1802, 1802,
     1802, 1802,    0, 1796,    0,    0, 1796, 1796, 1796, 1796,
     1796, 1796, 1816, 1816, 1816, 1816, 1816, 1816,    0, 1781,
     1803, 1803, 1803, 1803, 1803, 1803,    0, 1814, 1814, 1814,
        0,    0,    0, 1796,    0, 1813, 1813, 1813, 1813, 1813,
     1813, 1814, 1817, 1817, 1817,    0,    0,    0,    0, 1781,
     1781, 1781, 1781, 1781, 1781, 1782, 1796, 1782, 1782, 1782,

     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1821,    0, 1782,
     1822, 1822, 1822, 1822, 1822, 1822, 1782, 1782, 1782, 1782,
     1782, 1782,    0,    0,    0, 1803, 1803, 1803, 1803, 1803,
     1803,    0,    0,    0,    0, 1814, 1814, 1814, 1814, 1814,
     1814,    0,    0,    0,    0, 1782,    0,    0,    0,    0,
     1817, 1817, 1817, 1817, 1817, 1817,    0,    0,    0,    0,
        0, 1821, 1821, 1821, 1821, 1821, 1821, 1826, 1826, 1826,
     1826, 1826, 1826,    0,    0, 1782, 1782, 1789, 1789,    0,
     1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789,
     1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789,

     1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789,
     1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789,
     1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789,
     1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789,
     1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789,
     1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789,
     1789, 1789, 1789, 1789, 1792, 1827, 1827, 1827, 1827, 1827,
     1827, 1828, 1828, 1828, 1828, 1828, 1828,    0,    0, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,

     1792, 1825,    0, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1799,    0, 1799, 1799, 1799, 1799, 1799, 1799,
     1799, 1799, 1799, 1799,    0,    0, 1799, 1799, 1799, 1799,
     1799, 1799, 1799, 1799, 1799, 1799, 1799, 1799, 1799, 1829,
     1829, 1829, 1829, 1829, 1829, 1825, 1825, 1825, 1825, 1825,
     1825, 1830, 1830, 1830, 1830, 1830, 1830, 1815, 1815, 1815,
        0,    0, 1799, 1818, 1818, 1818,    0,    0,    0, 1819,
        0, 1815,    0,    0, 1819, 1831, 1831, 1831, 1831, 1831,
     1831, 1832, 1832, 1832, 1832, 1832, 1832, 1838,    0,    0,

     1819,    0, 1799, 1799, 1799, 1799, 1799, 1799, 1800,    0,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800,    0, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1815, 1815, 1815, 1815, 1815,
     1815, 1818, 1818, 1818, 1818, 1818, 1818, 1841, 1841, 1841,
     1841, 1841, 1841, 1819,    0,    0,    0,    0, 1800, 1819,
     1819, 1819, 1819, 1819, 1819, 1838, 1838, 1838, 1838, 1838,
     1838, 1843, 1843, 1843, 1843, 1843, 1843,    0, 1800, 1800,
     1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1820, 1852,
     1852, 1852, 1852, 1852, 1852, 1853, 1853, 1853, 1853, 1853,

     1853, 1820, 1820,    0, 1820, 1820, 1820, 1820, 1820, 1820,
        0,    0,    0,    0,    0, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,    0,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1820, 1820, 1820, 1820, 1820, 1823, 1823,    0, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,

     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1835, 1854, 1854, 1854, 1854, 1854, 1854,    0,
        0, 1839, 1839, 1839, 1839, 1839, 1839, 1855, 1855, 1855,
     1855, 1855, 1855, 1856, 1856, 1856, 1856, 1856, 1856, 1857,
     1857, 1857, 1857, 1857, 1857, 1858, 1858, 1858, 1858, 1858,

     1858,    0,    0, 1842, 1891, 1891, 1891, 1891, 1891, 1891,
        0,    0,    0,    0,    0, 1851,    0,    0,    0,    0,
     1835, 1835, 1835, 1835, 1835, 1835, 1835, 1835, 1835, 1835,
     1835, 1835, 1835, 1835, 1835, 1835, 1839, 1839, 1839, 1839,
     1839, 1839, 1840,    0, 1840, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1840,    0,    0, 1840, 1842, 1842, 1842,
     1842, 1842, 1842, 1840, 1840, 1840, 1840, 1840, 1840, 1851,
     1851, 1851, 1851, 1851, 1851, 1892, 1892, 1892, 1892, 1892,
     1892, 1893, 1893, 1893, 1893, 1893, 1893,    0,    0,    0,
        0,    0, 1840, 1894, 1894, 1894, 1894, 1894, 1894, 1895,

     1895, 1895, 1895, 1895, 1895, 1896, 1896, 1896, 1896, 1896,
     1896, 1897, 1897, 1897, 1897, 1897, 1897,    0,    0,    0,
        0,    0, 1840, 1840, 1840, 1840, 1840, 1840, 1846,    0,
     1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846, 1846,
        0,    0, 1846, 1898, 1898, 1898, 1898, 1898, 1898, 1846,
     1846, 1846, 1846, 1846, 1846, 1899, 1899, 1899, 1899, 1899,
     1899, 1900, 1900, 1900, 1900, 1900, 1900, 1901, 1901, 1901,
     1901, 1901, 1901,    0,    0,    0,    0,    0, 1846, 1848,
        0, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1848,    0,    0, 1848, 1902, 1902, 1902, 1902, 1902, 1902,

     1848, 1848, 1848, 1848, 1848, 1848, 1903, 1903, 1903, 1903,
     1903, 1903, 1904, 1904, 1904, 1904, 1904, 1904, 1905, 1905,
     1905, 1905, 1905, 1905, 1915,    0,    0,    0,    0, 1848,
     1906, 1906, 1906, 1906, 1906, 1906, 1907, 1907, 1907, 1907,
     1907, 1907, 1908, 1908, 1908, 1908, 1908, 1908, 1909, 1909,
     1909, 1909, 1909, 1909, 1910, 1910, 1910, 1910, 1910, 1910,
     1911, 1911, 1911, 1911, 1911, 1911, 1912, 1912, 1912, 1912,
     1912, 1912, 1913, 1914, 1914, 1914, 1914, 1914, 1914, 1916,
     1916, 1916, 1916, 1916, 1916, 1926,    0, 1913, 1913, 1913,
     1913, 1913, 1913, 1917, 1917, 1917, 1917, 1917, 1917,    0,

        0,    0,    0,    0, 1915, 1915, 1915, 1915, 1915, 1915,
     1918, 1918, 1918, 1918, 1918, 1918, 1920, 1920, 1920, 1920,
     1920, 1920, 1921, 1921, 1921, 1921, 1921, 1921, 1923, 1924,
     1924, 1924, 1924, 1924, 1924,    0,    0, 1925,    0,    0,
        0,    0,    0, 1923, 1923, 1923, 1923, 1923, 1923, 1925,
        0, 1925, 1925, 1925, 1925, 1925, 1925, 1925, 1927, 1927,
     1927, 1927, 1927, 1927, 1928, 1926, 1926, 1926, 1926, 1926,
     1926, 1929,    0,    0,    0,    0, 1928,    0, 1928,    0,
        0,    0,    0, 1929,    0, 1929, 1929, 1929, 1929, 1929,
     1929, 1929, 1930, 1930, 1930, 1930, 1930, 1930, 1931, 1931,

     1931, 1931, 1931, 1931, 1932, 1933, 1933, 1933, 1933, 1933,
     1933,    0,    0,    0,    0,    0, 1932,    0, 1932, 1934,
     1934, 1934, 1934, 1934, 1934, 1935, 1935, 1935, 1935, 1935,
     1935, 1936, 1936, 1936, 1936, 1936, 1936, 1937, 1937, 1937,
     1937, 1937, 1937,    0, 1928, 1928, 1928, 1928, 1928, 1928,
     1938, 1938, 1938, 1938, 1938, 1938, 1940, 1940,    0,    0,
        0, 1940,    0,    0, 1940, 1940, 1943, 1943, 1943, 1943,
     1943, 1943, 1940,    0, 1940,    0, 1940, 1940, 1946, 1946,
     1946, 1946, 1946, 1946, 1932, 1932, 1932, 1932, 1932, 1932,
     1947, 1947, 1947, 1947, 1947, 1947, 1948, 1948, 1948, 1948,

     1948, 1948, 1949, 1949, 1949, 1949, 1949, 1949, 1951, 1951,
     1951, 1951, 1951, 1951, 1952, 1952, 1952, 1952, 1952, 1952,
     1953, 1953, 1953, 1953, 1953, 1953, 1954, 1954, 1954, 1954,
     1954, 1954, 1955, 1955, 1955, 1955, 1955, 1955, 1956, 1956,
     1956, 1956, 1956, 1956, 1958, 1958, 1958, 1958, 1958, 1958,
     1961, 1961, 1961, 1961, 1961, 1961, 1962, 1962, 1962, 1962,
     1962, 1962, 1963, 1963, 1963, 1963, 1963, 1963, 1964, 1964,
     1964, 1964, 1964, 1964, 1966, 1966, 1966, 1966, 1966, 1966,
     1967, 1967, 1967, 1967, 1967, 1967, 1968, 1968, 1968, 1968,
     1968, 1968, 1969, 1969, 1969, 1969, 1969, 1969, 1970, 1970,

     1970, 1970, 1970, 1970, 1971, 1971, 1971, 1971, 1971, 1971,
     1974,    0,    0, 1992,    0, 1974, 1975, 1975, 1975, 1975,
     1975, 1975, 1992, 1974,    0, 1974, 1974, 1974, 1974, 1974,
     1974, 1976, 1976, 1976, 1976, 1976, 1976, 1977,    0, 1986,
        0,    0, 1977,    0,    0,    0,    0,    0, 1987,    0,
     1977, 1986, 1988, 1986, 1986, 1986, 1986, 1986, 1986, 1986,
     1987, 1988, 1987, 1989, 1993,    0,    0, 1988, 1988, 1988,
     1988, 1988, 1988,    0,    0,    0,    0,    0, 1989, 1989,
     1989, 1989, 1989, 1989, 1990, 1990, 1990, 1990, 1990, 1990,
     1991,    0,    0, 1992, 1992, 1992, 1992, 1992, 1992,    0,

        0,    0, 1991,    0, 1991, 1991, 1991, 1991, 1991, 1991,
     1991, 1994, 1994, 1994, 1994, 1994, 1994, 1977, 1977, 1977,
     1977, 1977, 1977, 1995,    0,    0,    0,    0, 1987, 1987,
     1987, 1987, 1987, 1987, 1998, 1995,    0, 1995, 1998, 1998,
     1998, 1998, 1998, 1998, 1993, 1993, 1993, 1993, 1993, 1993,
     1999, 1999, 1999, 1999, 1999, 1999, 2004, 2005, 2005, 2005,
     2005, 2005, 2005,    0,    0, 2006,    0,    0,    0,    0,
        0, 2004, 2004, 2004, 2004, 2004, 2004, 2006,    0, 2006,
     2006, 2006, 2006, 2006, 2006, 2006, 2007, 2007, 2007, 2007,
     2007, 2007,    0,    0,    0,    0,    0, 2007, 2008,    0,

        0,    0,    0, 1995, 1995, 1995, 1995, 1995, 1995,    0,
     2008, 2012, 2008, 2008, 2008, 2008, 2008, 2008, 2008,    0,
        0,    0,    0,    0, 2008,    0, 2012, 2012, 2012, 2012,
     2012, 2012, 2013, 2013, 2013, 2013, 2013, 2013, 2014,    0,
     2022, 2022, 2022, 2022, 2022, 2022,    0, 2015,    0,    0,
     2014, 2022, 2014, 2014, 2014, 2014, 2014, 2014, 2014, 2015,
        0, 2015, 2015, 2015, 2015, 2015, 2015, 2015, 2017,    0,
     2017, 2017, 2017, 2017, 2017, 2017, 2017, 2017, 2017, 2017,
     2017,    0, 2017, 2017, 2017, 2017, 2017, 2017, 2017, 2017,
     2017, 2017, 2017, 2017, 2017, 2018, 2020, 2020, 2020, 2020,

     2020, 2020, 2020, 2020, 2020,    0,    0, 2018,    0, 2018,
     2018, 2018, 2018, 2018, 2018, 2018,    0,    0, 2017, 2019,
     2019, 2019, 2019, 2019, 2019, 2019, 2019, 2019,    0, 2021,
        0,    0,    0, 2019, 2021, 2050, 2050, 2050, 2050, 2050,
     2050,    0,    0,    0, 2021, 2021, 2021, 2021, 2021, 2021,
     2021, 2028, 2028, 2028, 2028, 2028, 2028,    0,    0,    0,
        0,    0, 2028, 2051, 2051, 2051, 2051, 2051, 2051,    0,
        0,    0, 2021, 2057, 2057, 2057, 2057, 2057, 2057,    0,
        0,    0,    0,    0, 2057, 2059, 2059, 2059, 2059, 2059,
     2059,    0,    0,    0,    0, 2021, 2061, 2061, 2061, 2061,

     2061, 2061,    0, 2021, 2027, 2068, 2068, 2068, 2068, 2068,
     2068, 2069, 2069, 2069, 2069, 2069, 2069, 2027, 2027,    0,
     2027, 2027, 2027, 2027, 2027, 2027,    0,    0,    0,    0,
        0, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027,
     2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027,
     2027, 2027, 2027, 2027, 2027,    0, 2027, 2027, 2027, 2027,
     2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027,
     2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027,
     2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027, 2027,
     2027, 2029, 2029,    0, 2029, 2029, 2029, 2029, 2029, 2029,

     2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029,
     2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029,
     2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029,
     2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029,
     2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029,
     2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029,
     2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029,
     2029, 2029, 2029, 2029, 2029, 2029, 2029, 2029, 2034, 2034,
        0, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,

     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034, 2034,
     2034, 2034, 2034, 2034, 2034, 2036, 2036,    0, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,

     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036, 2036,
     2036, 2036, 2044,    0,    0,    0,    0, 2044,    0, 2045,
        0,    0,    0,    0, 2045,    0,    0, 2044, 2044, 2044,
     2044, 2044, 2044, 2044, 2045, 2045, 2045, 2045, 2045, 2045,
     2045, 2076,    0, 2046,    0,    0,    0,    0, 2046,    0,
        0,    0,    0,    0, 2044,    0,    0, 2045, 2046, 2046,

     2046, 2046, 2046, 2046, 2046, 2070, 2070, 2070, 2070, 2070,
     2070, 2085,    0,    0, 2072, 2072,    0, 2044,    0, 2072,
     2045,    0, 2072, 2072, 2046,    0, 2044,    0,    0,    0,
     2072,    0, 2072, 2045, 2072, 2072, 2077, 2077, 2077, 2077,
     2077, 2077,    0, 2088,    0,    0,    0, 2046,    0,    0,
     2076, 2076, 2076, 2076, 2076, 2076, 2093, 2046, 2048,    0,
     2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
        0,    0, 2048, 2048, 2048, 2048, 2048, 2048, 2048, 2048,
     2048, 2048, 2048, 2048, 2048, 2086, 2086, 2086, 2086, 2086,
     2086, 2085, 2085, 2085, 2085, 2085, 2085, 2088, 2088, 2088,

     2088, 2088, 2088,    0,    0,    0,    0,    0, 2048, 2049,
        0, 2049, 2049, 2049, 2049, 2049, 2049, 2049, 2049, 2049,
     2049,    0,    0, 2049, 2049, 2049, 2049, 2049, 2049, 2049,
     2049, 2049, 2049, 2049, 2049, 2049, 2093, 2093, 2093, 2093,
     2093, 2093, 2094, 2094, 2094, 2094, 2094, 2094, 2103, 2118,
     2118, 2118, 2118, 2118, 2118,    0,    0,    0,    0, 2049,
     2060,    0, 2060, 2060, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060,    0,    0, 2060, 2060, 2060, 2060, 2060, 2060,
     2060, 2060, 2060, 2060, 2060, 2060, 2060, 2100, 2100, 2100,
     2109, 2119, 2119, 2119, 2119, 2119, 2119,    0,    0,    0,

        0, 2100, 2103, 2103, 2103, 2103, 2103, 2103,    0,    0,
     2060, 2065,    0, 2065, 2065, 2065, 2065, 2065, 2065, 2065,
     2065, 2065, 2065,    0,    0, 2065, 2065, 2065, 2065, 2065,
     2065, 2065, 2065, 2065, 2065, 2065, 2065, 2065, 2124, 2124,
     2124, 2124, 2124, 2124, 2109, 2109, 2109, 2109, 2109, 2109,
        0,    0,    0,    0,    0, 2100, 2100, 2100, 2100, 2100,
     2100, 2065, 2066,    0, 2066, 2066, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066,    0,    0, 2066, 2066, 2066, 2066,
     2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2066, 2087,
        0,    0,    0,    0,    0, 2095,    0,    0,    0,    0,

        0, 2087,    0, 2087,    0,    0,    0, 2095,    0, 2095,
        0,    0, 2066, 2067,    0, 2067, 2067, 2067, 2067, 2067,
     2067, 2067, 2067, 2067, 2067,    0,    0, 2067, 2067, 2067,
     2067, 2067, 2067, 2067, 2067, 2067, 2067, 2067, 2067, 2067,
     2089, 2101, 2101, 2101,    0,    0, 2096, 2123,    0,    0,
        0,    0, 2089,    0, 2089,    0,    0,    0, 2096,    0,
     2096,    0,    0, 2067,    0,    0, 2089,    0,    0, 2087,
     2087, 2087, 2087, 2087, 2087, 2095, 2095, 2095, 2095, 2095,
     2095, 2099, 2126, 2126, 2126, 2126, 2126, 2126,    0,    0,
        0,    0,    0, 2099, 2102, 2099,    0,    0,    0, 2102,

        0, 2123, 2123, 2123, 2123, 2123, 2123,    0,    0, 2101,
     2101, 2101, 2101, 2101, 2101, 2102,    0,    0,    0,    0,
     2089, 2089, 2089, 2089, 2089, 2089, 2096, 2096, 2096, 2096,
     2096, 2096, 2098,    0, 2098, 2098, 2098, 2098, 2098, 2098,
     2098, 2098, 2098, 2098, 2098,    0, 2098, 2133, 2133, 2133,
     2133, 2133, 2133, 2098, 2098, 2098, 2098, 2098, 2098,    0,
        0, 2099, 2099, 2099, 2099, 2099, 2099,    0, 2102,    0,
        0,    0,    0,    0, 2102, 2102, 2102, 2102, 2102, 2102,
        0,    0, 2098, 2134, 2134, 2134, 2134, 2134, 2134, 2135,
     2135, 2135, 2135, 2135, 2135, 2168,    0,    0,    0, 2168,

     2168, 2168, 2168, 2168, 2168, 2179, 2179, 2179, 2179, 2179,
     2179,    0, 2098, 2098, 2098, 2098, 2098, 2098, 2108, 2172,
        0,    0,    0, 2172, 2172, 2172, 2172, 2172, 2172,    0,
        0, 2108, 2108,    0, 2108, 2108, 2108, 2108, 2108, 2108,
        0,    0,    0,    0,    0, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,    0,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,
     2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108, 2108,

     2108, 2108, 2108, 2108, 2108, 2111, 2111,    0, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111, 2111,
     2111, 2111, 2112, 2112,    0, 2112, 2112, 2112, 2112, 2112,

     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112,
     2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2112, 2114,
     2114,    0, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,

     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114, 2114,
     2114, 2114, 2114, 2114, 2114, 2114, 2116, 2170, 2116, 2116,
     2116, 2116, 2116, 2116, 2116, 2116, 2116, 2116,    0,    0,
     2116, 2182, 2182, 2182, 2182, 2182, 2182, 2116, 2116, 2116,
     2116, 2116, 2116,    0,    0, 2178,    0,    0, 2174, 2178,

     2178, 2178, 2178, 2178, 2178, 2184,    0,    0,    0,    0,
     2181,    0,    0,    0, 2185,    0, 2116, 2184,    0, 2184,
     2184, 2184, 2184, 2184, 2184, 2184, 2185,    0, 2185, 2185,
     2185, 2185, 2185, 2185, 2185,    0, 2170, 2170, 2170, 2170,
     2170, 2170,    0,    0,    0,    0, 2116, 2116, 2116, 2116,
     2116, 2116, 2117,    0, 2117, 2117, 2117, 2117, 2117, 2117,
     2117, 2117, 2117, 2117,    0,    0, 2117, 2174, 2174, 2174,
     2174, 2174, 2174, 2117, 2117, 2117, 2117, 2117, 2117, 2181,
     2181, 2181, 2181, 2181, 2181, 2186,    0,    0,    0,    0,
        0, 2187, 2188,    0,    0,    0,    0, 2186, 2189, 2186,

     2193, 2188, 2117, 2187,    0, 2187,    0, 2188, 2188, 2188,
     2188, 2188, 2188, 2189, 2189, 2189, 2189, 2189, 2189, 2190,
     2190, 2190, 2190, 2190, 2190,    0,    0,    0,    0,    0,
     2192,    0, 2117, 2117, 2117, 2117, 2117, 2117, 2125, 2192,
     2125, 2125, 2125, 2125, 2125, 2125, 2125, 2125, 2125, 2125,
        0,    0, 2125, 2194, 2194, 2194, 2194, 2194, 2194, 2125,
     2125, 2125, 2125, 2125, 2125, 2186, 2186, 2186, 2186, 2186,
     2186, 2187, 2187, 2187, 2187, 2187, 2187, 2191,    0,    0,
     2193, 2193, 2193, 2193, 2193, 2193, 2195, 2196, 2125, 2191,
        0, 2191, 2191, 2191, 2191, 2191, 2191, 2191, 2195,    0,

     2195,    0, 2196, 2196, 2196, 2196, 2196, 2196,    0,    0,
     2192, 2192, 2192, 2192, 2192, 2192, 2201,    0, 2125, 2125,
     2125, 2125, 2125, 2125, 2130,    0, 2130, 2130, 2130, 2130,
     2130, 2130, 2130, 2130, 2130, 2130,    0,    0, 2130, 2197,
     2197, 2197, 2197, 2197, 2197, 2130, 2130, 2130, 2130, 2130,
     2130, 2200, 2200, 2200, 2200, 2200, 2200,    0,    0,    0,
        0, 2198,    0,    0,    0,    0, 2195, 2195, 2195, 2195,
     2195, 2195, 2199, 2198, 2130, 2198, 2198, 2198, 2198, 2198,
     2198, 2198,    0,    0, 2199,    0, 2199, 2199, 2199, 2199,
     2199, 2199, 2199,    0,    0,    0, 2201, 2201, 2201, 2201,

     2201, 2201,    0,    0, 2130, 2130, 2130, 2130, 2130, 2130,
     2131,    0, 2131, 2131, 2131, 2131, 2131, 2131, 2131, 2131,
     2131, 2131,    0,    0, 2131, 2202, 2202, 2202, 2202, 2202,
     2202, 2131, 2131, 2131, 2131, 2131, 2131, 2205, 2205, 2205,
     2205, 2205, 2205, 2203,    0,    0,    0,    0,    0, 2204,
        0,    0,    0,    0,    0, 2203,    0, 2203,    0,    0,
     2131, 2204,    0, 2204, 2211, 2211,    0,    0,    0, 2211,
        0,    0, 2211, 2211, 2213, 2213, 2213, 2213, 2213, 2213,
     2211,    0, 2211,    0, 2211, 2211,    0,    0,    0,    0,
     2131, 2131, 2131, 2131, 2131, 2131, 2132,    0, 2132, 2132,

     2132, 2132, 2132, 2132, 2132, 2132, 2132, 2132,    0,    0,
     2132, 2214, 2214, 2214, 2214, 2214, 2214, 2132, 2132, 2132,
     2132, 2132, 2132, 2203, 2203, 2203, 2203, 2203, 2203, 2204,
     2204, 2204, 2204, 2204, 2204, 2215, 2215, 2215, 2215, 2215,
     2215,    0,    0,    0,    0,    0, 2132, 2216, 2216, 2216,
     2216, 2216, 2216, 2217, 2217, 2217, 2217, 2217, 2217, 2218,
     2218, 2218, 2218, 2218, 2218, 2219, 2219, 2219, 2219, 2219,
     2219, 2233,    0,    0,    0,    0, 2132, 2132, 2132, 2132,
     2132, 2132, 2220, 2220, 2220, 2220, 2220, 2220, 2221, 2221,
     2221, 2221, 2221, 2221, 2222, 2222, 2222, 2222, 2222, 2222,

     2230, 2231, 2231, 2231, 2231, 2231, 2231,    0,    0, 2232,
        0,    0,    0,    0,    0, 2230, 2230, 2230, 2230, 2230,
     2230, 2232,    0, 2232, 2232, 2232, 2232, 2232, 2232, 2232,
     2234, 2234, 2234, 2234, 2234, 2234, 2235, 2239, 2239, 2239,
     2239, 2239, 2239,    0,    0, 2237,    0,    0, 2235,    0,
     2235, 2233, 2233, 2233, 2233, 2233, 2233, 2237, 2238, 2237,
     2237, 2237, 2237, 2237, 2237, 2237,    0, 2238, 2240,    0,
        0,    0, 2243, 2238, 2238, 2238, 2238, 2238, 2238, 2242,
     2240, 2243, 2240, 2240, 2240, 2240, 2240, 2240, 2240, 2245,
        0, 2242,    0, 2242, 2244, 2244, 2244, 2244, 2244, 2244,

        0, 2245,    0, 2245, 2248, 2248, 2248, 2248, 2248, 2248,
     2249, 2249, 2249, 2249, 2249, 2249, 2235, 2235, 2235, 2235,
     2235, 2235, 2250, 2250, 2250, 2250, 2250, 2250,    0,    0,
        0,    0,    0, 2250, 2251, 2251, 2251, 2251, 2251, 2251,
        0,    0,    0,    0,    0, 2251, 2252, 2252, 2252, 2252,
     2252, 2252, 2243, 2243, 2243, 2243, 2243, 2243,    0, 2242,
     2242, 2242, 2242, 2242, 2242, 2254,    0,    0,    0, 2245,
     2245, 2245, 2245, 2245, 2245,    0,    0,    0,    0,    0,
     2254, 2254, 2254, 2254, 2254, 2254, 2255, 2255, 2255, 2255,
     2255, 2255, 2256, 2258, 2258, 2258, 2258, 2258, 2258,    0,

        0,    0,    0,    0, 2256,    0, 2256, 2256, 2256, 2256,
     2256, 2256, 2256, 2259, 2259, 2259, 2259, 2259, 2259, 2261,
     2261, 2261, 2261, 2261, 2261,    0,    0,    0,    0,    0,
     2261, 2262,    0, 2262, 2262, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2265, 2262, 2262, 2262, 2262, 2262,
     2262, 2262, 2262, 2262, 2262, 2262, 2262, 2262,    0, 2265,
     2265, 2265, 2265, 2265, 2265, 2266, 2266, 2266, 2266, 2266,
     2266, 2267,    0, 2278, 2278, 2278, 2278, 2278, 2278,    0,
        0, 2262,    0, 2267, 2278, 2267, 2267, 2267, 2267, 2267,
     2267, 2267, 2269, 2269,    0, 2269, 2269, 2269, 2269, 2269,

     2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269,
     2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269,
     2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269,
     2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269,
     2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269,
     2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269,
     2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269,
     2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2269, 2280,
     2280, 2280, 2280, 2280, 2280, 2283,    0, 2283, 2283, 2283,
     2283, 2283, 2283, 2283, 2283, 2283, 2283,    0,    0, 2283,

     2289, 2289, 2289, 2289, 2289, 2289, 2283, 2283, 2283, 2283,
     2283, 2283, 2287, 2287, 2287, 2287, 2287, 2287, 2311, 2307,
        0,    0,    0, 2287,    0, 2292, 2292, 2292, 2292, 2292,
     2292, 2308, 2313,    0,    0, 2283, 2292, 2296, 2296, 2296,
     2296, 2296, 2296,    0, 2313, 2322, 2313,    0, 2296, 2298,
     2298, 2298, 2298, 2298, 2298, 2299, 2299, 2299, 2299, 2299,
     2299, 2305, 2305, 2305, 2305, 2305, 2305, 2306, 2306, 2306,
     2306, 2306, 2306, 2307, 2307, 2307, 2307, 2307, 2307, 2309,
     2309, 2309, 2309, 2309, 2309, 2308, 2308, 2308, 2308, 2308,
     2308, 2312, 2312, 2312, 2312, 2312, 2312, 2318, 2311, 2311,

     2311, 2311, 2311, 2311, 2315, 2315, 2315, 2315, 2315, 2315,
        0,    0, 2313, 2313, 2313, 2313, 2313, 2313, 2316, 2316,
     2316, 2316, 2316, 2316,    0, 2322, 2322, 2322, 2322, 2322,
     2322, 2323, 2323, 2323, 2323, 2323, 2323, 2330, 2331, 2331,
     2331, 2331, 2331, 2331, 2337, 2338, 2338, 2338, 2338, 2338,
     2338, 2318, 2318, 2318, 2318, 2318, 2318, 2320, 2342, 2320,
     2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320, 2320,
     2346, 2320, 2324,    0,    0,    0,    0,    0, 2320, 2320,
     2320, 2320, 2320, 2320, 2324,    0, 2324,    0,    0,    0,
        0, 2330, 2330, 2330, 2330, 2330, 2330,    0, 2337, 2337,

     2337, 2337, 2337, 2337,    0,    0,    0, 2320,    0,    0,
        0,    0, 2342, 2342, 2342, 2342, 2342, 2342, 2347, 2347,
     2347, 2347, 2347, 2347, 2346, 2346, 2346, 2346, 2346, 2346,
     2348, 2348, 2348, 2348, 2348, 2348,    0, 2320, 2320, 2320,
     2320, 2320, 2320, 2378, 2378, 2378, 2378, 2378, 2378,    0,
        0,    0, 2324, 2324, 2324, 2324, 2324, 2324, 2326, 2326,
        0, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,

     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326, 2326,
     2326, 2326, 2326, 2326, 2326, 2332,    0, 2332, 2332, 2332,
     2332, 2332, 2332, 2332, 2332, 2332, 2332, 2381, 2387, 2332,
     2380, 2380, 2380, 2380, 2380, 2380, 2332, 2332, 2332, 2332,
     2332, 2332, 2381, 2381, 2381, 2381, 2381, 2381, 2382, 2382,
     2382, 2382, 2382, 2382, 2383, 2390,    0,    0,    0,    0,
     2384,    0,    0,    0,    0, 2332, 2383,    0, 2383, 2383,

     2383, 2383, 2383, 2383, 2383, 2384, 2384, 2384, 2384, 2384,
     2384, 2385, 2385, 2385, 2385, 2385, 2385, 2386, 2388, 2388,
     2388, 2388, 2388, 2388,    0,    0,    0,    0,    0, 2386,
        0, 2386, 2386, 2386, 2386, 2386, 2386, 2386, 2387, 2387,
     2387, 2387, 2387, 2387, 2389, 2391, 2391, 2391, 2391, 2391,
     2391,    0, 2400,    0,    0,    0, 2389,    0, 2389, 2392,
     2394, 2400,    0,    0,    0, 2390, 2390, 2390, 2390, 2390,
     2390, 2392, 2394, 2392, 2394, 2394, 2394, 2394, 2394, 2394,
     2394, 2395, 2396, 2396, 2396, 2396, 2396, 2396,    0,    0,
     2395, 2397,    0,    0,    0,    0, 2395, 2395, 2395, 2395,

     2395, 2395, 2399, 2397,    0, 2397, 2397, 2397, 2397, 2397,
     2397, 2397,    0,    0, 2399,    0, 2399, 2401, 2401, 2401,
     2401, 2401, 2401,    0, 2389, 2389, 2389, 2389, 2389, 2389,
        0,    0, 2400, 2400, 2400, 2400, 2400, 2400, 2402, 2392,
     2392, 2392, 2392, 2392, 2392,    0,    0,    0,    0,    0,
     2402,    0, 2402, 2403, 2403, 2403, 2403, 2403, 2403, 2404,
     2404, 2404, 2404, 2404, 2404, 2406, 2406, 2406, 2406, 2406,
     2406,    0,    0,    0,    0,    0, 2405,    0,    0,    0,
        0,    0, 2399, 2399, 2399, 2399, 2399, 2399, 2405,    0,
     2405, 2405, 2405, 2405, 2405, 2405, 2405, 2407, 2407, 2407,

     2407, 2407, 2407, 2408, 2408, 2408, 2408, 2408, 2408,    0,
        0,    0, 2409,    0,    0,    0,    0,    0, 2402, 2402,
     2402, 2402, 2402, 2402, 2409,    0, 2409, 2410, 2410, 2410,
     2410, 2410, 2410, 2415, 2415, 2415, 2415, 2415, 2415, 2416,
     2416, 2416, 2416, 2416, 2416, 2418, 2418, 2418, 2418, 2418,
     2418, 2419, 2419, 2419, 2419, 2419, 2419, 2422, 2422, 2422,
     2422, 2422, 2422, 2423, 2423, 2423, 2423, 2423, 2423, 2424,
     2424, 2424, 2424, 2424, 2424, 2425, 2425, 2425, 2425, 2425,
     2425, 2432,    0, 2426, 2427, 2427, 2427, 2427, 2427, 2427,
        0,    0, 2409, 2409, 2409, 2409, 2409, 2409, 2426, 2426,

     2426, 2426, 2426, 2426, 2428, 2428, 2428, 2428, 2428, 2428,
     2429, 2430, 2430, 2430, 2430, 2430, 2430,    0,    0, 2429,
        0,    0,    0,    0,    0, 2429, 2429, 2429, 2429, 2429,
     2429, 2433, 2433, 2433, 2433, 2433, 2433, 2434, 2434, 2434,
     2434, 2434, 2434, 2435, 2436, 2436, 2436, 2436, 2436, 2436,
        0,    0, 2435, 2439, 2439, 2439, 2439, 2439, 2439,    0,
        0, 2432, 2432, 2432, 2432, 2432, 2432, 2440, 2440, 2440,
     2440, 2440, 2440, 2441, 2441, 2441, 2441, 2441, 2441, 2442,
     2442, 2442, 2442, 2442, 2442,    0,    0,    0,    0,    0,
     2442, 2444, 2444, 2444, 2444, 2444, 2444, 2445, 2445, 2445,

     2445, 2445, 2445, 2446, 2446, 2446, 2446, 2446, 2446, 2447,
     2447, 2447, 2447, 2447, 2447,    0,    0,    0,    0,    0,
     2447,    0,    0, 2435, 2435, 2435, 2435, 2435, 2435, 2443,
        0, 2443, 2443, 2443, 2443, 2443, 2443, 2443, 2443, 2443,
     2443,    0,    0, 2443, 2443, 2443, 2443, 2443, 2443, 2443,
     2443, 2443, 2443, 2443, 2443, 2443, 2448, 2448, 2448, 2448,
     2448, 2448, 2449, 2449, 2449, 2449, 2449, 2449, 2450,    0,
     2823,    0,    0,    0, 2451,    0,    0,    0,    0, 2443,
     2452,    0,    0, 2450, 2450, 2450, 2450, 2450, 2450, 2451,
     2451, 2451, 2451, 2451, 2451, 2452, 2452, 2452, 2452, 2452,

     2452, 2460, 2460, 2460, 2460, 2460, 2460,    0, 2823,    0,
     2450, 2450, 2451, 2823,    0,    0,    0, 2451,    0,    0,
     2464, 2452,    0, 2452, 2462, 2462, 2462, 2462, 2462, 2462,
        0, 2823,    0, 2450, 2450, 2451, 2823,    0,    0,    0,
     2451,    0,    0,    0, 2452,    0, 2452, 2454,    0, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454, 2454,    0,
        0, 2454, 2463, 2463, 2463, 2463, 2463, 2463, 2454, 2454,
     2454, 2454, 2454, 2454, 2464, 2464, 2464, 2464, 2464, 2464,
     2466, 2466, 2466, 2466, 2466, 2466, 2467, 2467, 2467, 2467,
     2467, 2467,    0,    0,    0,    0,    0, 2454, 2456,    0,

     2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456, 2456,
     2469,    0, 2456, 2468, 2468, 2468, 2468, 2468, 2468, 2456,
     2456, 2456, 2456, 2456, 2456, 2470, 2470, 2470, 2470, 2470,
     2470, 2471, 2471, 2471, 2471, 2471, 2471, 2487, 2487, 2487,
     2487, 2487, 2487,    0,    0,    0,    0,    0, 2456, 2465,
        0, 2465, 2465, 2465, 2465, 2465, 2465, 2465, 2465, 2465,
     2465,    0,    0, 2465, 2469, 2469, 2469, 2469, 2469, 2469,
     2465, 2465, 2465, 2465, 2465, 2465, 2488, 2488, 2488, 2488,
     2488, 2488, 2489, 2489, 2489, 2489, 2489, 2489, 2490, 2490,
     2490, 2490, 2490, 2490, 2492,    0,    0,    0,    0, 2465,

     2491, 2491, 2491, 2491, 2491, 2491,    0,    0,    0, 2492,
     2492, 2492, 2492, 2492, 2492, 2493, 2493, 2493, 2493, 2493,
     2493, 2495, 2495, 2495, 2495, 2495, 2495,    0,    0, 2465,
     2465, 2465, 2465, 2465, 2465, 2472, 2498, 2472, 2472, 2472,
     2472, 2472, 2472, 2472, 2472, 2472, 2472,    0,    0, 2472,
     2494,    0,    0,    0,    0,    0, 2472, 2472, 2472, 2472,
     2472, 2472, 2494,    0, 2494, 2494, 2494, 2494, 2494, 2494,
     2494, 2496, 2496, 2496, 2496, 2496, 2496, 2497, 2497, 2497,
     2497, 2497, 2497,    0,    0, 2472, 2474,    0, 2474, 2474,
     2474, 2474, 2474, 2474, 2474, 2474, 2474, 2474,    0,    0,

     2474, 2499, 2499, 2499, 2499, 2499, 2499, 2474, 2474, 2474,
     2474, 2474, 2474, 2500,    0,    0, 2498, 2498, 2498, 2498,
     2498, 2498, 2509,    0,    0, 2500,    0, 2500, 2501, 2501,
     2501, 2501, 2501, 2501, 2503,    0, 2474, 2502, 2502, 2502,
     2502, 2502, 2502, 2504, 2504, 2504, 2504, 2504, 2504, 2503,
     2503, 2503, 2503, 2503, 2503, 2505, 2505, 2505, 2505, 2505,
     2505, 2506, 2507, 2507, 2507, 2507, 2507, 2507,    0,    0,
     2506,    0,    0,    0,    0,    0, 2506, 2506, 2506, 2506,
     2506, 2506, 2510, 2510, 2510, 2510, 2510, 2510,    0,    0,
     2512,    0,    0, 2500, 2500, 2500, 2500, 2500, 2500, 2512,

        0,    0, 2509, 2509, 2509, 2509, 2509, 2509, 2511, 2511,
     2511, 2511, 2511, 2511, 2513, 2513, 2513, 2513, 2513, 2513,
     2515, 2515, 2515, 2515, 2515, 2515, 2516, 2516, 2516, 2516,
     2516, 2516, 2517, 2517, 2517, 2517, 2517, 2517, 2518, 2518,
     2518, 2518, 2518, 2518, 2519, 2519, 2519, 2519, 2519, 2519,
     2520, 2520, 2520, 2520, 2520, 2520, 2528, 2528, 2528, 2528,
     2528, 2528, 2529, 2529, 2529, 2529, 2529, 2529,    0,    0,
     2512, 2512, 2512, 2512, 2512, 2512, 2530, 2530, 2530, 2530,
     2530, 2530, 2531, 2531, 2531, 2531, 2531, 2531, 2532, 2532,
     2532, 2532, 2532, 2532, 2534, 2535, 2535, 2535, 2535, 2535,

     2535,    0,    0, 2537,    0,    0, 2534,    0, 2534, 2534,
     2534, 2534, 2534, 2534, 2534, 2537,    0, 2537, 2538, 2538,
     2538, 2538, 2538, 2538, 2539, 2539, 2539, 2539, 2539, 2539,
     2550, 2550, 2550, 2550, 2550, 2550, 2551, 2551, 2551, 2551,
     2551, 2551, 2557, 2557, 2557, 2557, 2557, 2557, 2565, 2565,
     2565, 2565, 2565, 2565, 2566, 2566, 2566, 2566, 2566, 2566,
     2567, 2567, 2567, 2567, 2567, 2567, 2568, 2568, 2568, 2568,
     2568, 2568, 2570, 2570, 2570, 2570, 2570, 2570,    0,    0,
        0,    0,    0, 2537, 2537, 2537, 2537, 2537, 2537, 2541,
        0, 2541, 2541, 2541, 2541, 2541, 2541, 2541, 2541, 2541,

     2541,    0,    0, 2541, 2541, 2541, 2541, 2541, 2541, 2541,
     2541, 2541, 2541, 2541, 2541, 2541, 2569, 2571, 2571, 2571,
     2571, 2571, 2571,    0,    0,    0,    0,    0, 2569,    0,
     2569, 2569, 2569, 2569, 2569, 2569, 2569,    0,    0, 2541,
     2545, 2545,    0, 2545, 2545, 2545, 2545, 2545, 2545, 2545,
     2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545,
     2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545,
     2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545,
     2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545,
     2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545,

     2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545,
     2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545, 2545,
     2545, 2545, 2545, 2545, 2545, 2545, 2545, 2553,    0, 2553,
     2553, 2553, 2553, 2553, 2553, 2553, 2553, 2553, 2553,    0,
        0, 2553, 2572, 2572, 2572, 2572, 2572, 2572, 2553, 2553,
     2553, 2553, 2553, 2553, 2573, 2573, 2573, 2573, 2573, 2573,
     2574, 2575, 2575, 2575, 2575, 2575, 2575,    0,    0,    0,
        0,    0, 2574,    0, 2574,    0,    0, 2553, 2576, 2576,
     2576, 2576, 2576, 2576, 2577, 2577, 2577, 2577, 2577, 2577,
     2580, 2580, 2580, 2580, 2580, 2580,    0,    0,    0,    0,

        0, 2579, 2599,    0,    0,    0,    0, 2553, 2553, 2553,
     2553, 2553, 2553, 2579, 2582, 2579, 2579, 2579, 2579, 2579,
     2579, 2579,    0,    0,    0,    0, 2582,    0, 2582, 2583,
     2583, 2583, 2583, 2583, 2583,    0,    0,    0,    0,    0,
     2574, 2574, 2574, 2574, 2574, 2574, 2584, 2584, 2584, 2584,
     2584, 2584, 2585, 2585, 2585, 2585, 2585, 2585, 2586, 2586,
     2586, 2586, 2586, 2586, 2590, 2590, 2590, 2590, 2590, 2590,
     2592, 2592, 2592, 2592, 2592, 2592, 2596, 2596, 2596, 2596,
     2596, 2596, 2599, 2599, 2599, 2599, 2599, 2599, 2594,    0,
        0,    0,    0,    0, 2582, 2582, 2582, 2582, 2582, 2582,

     2594, 2595, 2594, 2594, 2594, 2594, 2594, 2594, 2594,    0,
     2597,    0,    0,    0,    0,    0, 2595, 2595, 2595, 2595,
     2595, 2595, 2597, 2598, 2597, 2597, 2597, 2597, 2597, 2597,
     2597,    0, 2601,    0,    0, 2598,    0, 2598, 2600, 2600,
     2600, 2600, 2600, 2600, 2601, 2606, 2601, 2605, 2605, 2605,
     2605, 2605, 2605, 2612, 2612, 2612, 2612, 2612, 2612,    0,
     2606, 2606, 2606, 2606, 2606, 2606, 2613, 2613, 2613, 2613,
     2613, 2613,    0,    0,    0,    0,    0, 2619, 2620, 2620,
     2620, 2620, 2620, 2620,    0,    0,    0, 2606, 2606, 2619,
        0, 2619, 2619, 2619, 2619, 2619, 2619, 2619,    0,    0,

        0,    0,    0, 2598, 2598, 2598, 2598, 2598, 2598,    0,
     2606, 2606, 2601, 2601, 2601, 2601, 2601, 2601, 2604,    0,
     2604, 2604, 2604, 2604, 2604, 2604, 2604, 2604, 2604, 2604,
        0, 2607, 2604,    0,    0,    0,    0, 2608,    0, 2604,
     2604, 2604, 2604, 2604, 2604,    0, 2607, 2607, 2607, 2607,
     2607, 2607, 2608, 2608, 2608, 2608, 2608, 2608, 2621, 2621,
     2621, 2621, 2621, 2621,    0, 2622,    0,    0, 2604, 2607,
        0,    0,    0,    0, 2607,    0,    0, 2622, 2608, 2622,
     2608, 2623, 2623, 2623, 2623, 2623, 2623,    0, 2629,    0,
        0,    0, 2607,    0, 2630,    0,    0, 2607, 2625,    0,

     2629, 2608, 2629, 2608, 2624, 2624, 2624, 2624, 2624, 2624,
     2625, 2626, 2625, 2625, 2625, 2625, 2625, 2625, 2625, 2627,
     2627, 2627, 2627, 2627, 2627,    0, 2626, 2626, 2626, 2626,
     2626, 2626, 2631, 2631, 2631, 2631, 2631, 2631,    0, 2628,
        0,    0,    0,    0,    0, 2622, 2622, 2622, 2622, 2622,
     2622, 2628, 2632, 2628, 2628, 2628, 2628, 2628, 2628, 2628,
        0,    0,    0,    0, 2632, 2647, 2632,    0, 2629, 2629,
     2629, 2629, 2629, 2629, 2630, 2630, 2630, 2630, 2630, 2630,
     2634, 2634, 2634, 2634, 2634, 2634, 2636, 2636, 2636, 2636,
     2636, 2636, 2642, 2643, 2643, 2643, 2643, 2643, 2643,    0,

        0, 2644,    0,    0,    0,    0,    0, 2642, 2642, 2642,
     2642, 2642, 2642, 2644,    0, 2644, 2644, 2644, 2644, 2644,
     2644, 2644, 2645, 2645, 2645, 2645, 2645, 2645,    0,    0,
        0,    0, 2632, 2632, 2632, 2632, 2632, 2632, 2646, 2646,
     2646, 2646, 2646, 2646,    0, 2647, 2647, 2647, 2647, 2647,
     2647, 2648, 2648, 2648, 2648, 2648, 2648, 2649, 2650, 2650,
     2650, 2650, 2650, 2650,    0,    0,    0,    0,    0, 2649,
     2653, 2649, 2651, 2651, 2651, 2651, 2651, 2651, 2652, 2652,
     2652, 2652, 2652, 2652, 2654, 2653, 2653, 2653, 2653, 2653,
     2653, 2655, 2656, 2656, 2656, 2656, 2656, 2656,    0, 2654,

     2654, 2654, 2654, 2654, 2654,    0, 2655, 2655, 2655, 2655,
     2655, 2655, 2653, 2653, 2662, 2662, 2662, 2662, 2662, 2662,
     2666,    0, 2654,    0,    0,    0,    0, 2654,    0,    0,
        0,    0, 2655,    0, 2655, 2653, 2653, 2649, 2649, 2649,
     2649, 2649, 2649, 2661,    0, 2654,    0,    0,    0,    0,
     2654,    0, 2663,    0,    0, 2655,    0, 2655, 2661, 2661,
     2661, 2661, 2661, 2661, 2663, 2664, 2663, 2663, 2663, 2663,
     2663, 2663, 2663, 2676,    0,    0,    0, 2664,    0, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2667, 2667, 2667, 2667,
     2667, 2667,    0,    0, 2668, 2671,    0,    0,    0,    0,

     2666, 2666, 2666, 2666, 2666, 2666, 2668, 2669, 2668,    0,
     2671, 2671, 2671, 2671, 2671, 2671, 2673,    0,    0, 2669,
        0, 2669, 2672, 2672, 2672, 2672, 2672, 2672, 2673,    0,
     2673, 2673, 2673, 2673, 2673, 2673, 2673, 2674, 2674, 2674,
     2674, 2674, 2674, 2675, 2675, 2675, 2675, 2675, 2675,    0,
        0,    0,    0, 2676, 2676, 2676, 2676, 2676, 2676, 2677,
     2677, 2677, 2677, 2677, 2677,    0,    0,    0, 2678,    0,
        0,    0,    0,    0, 2668, 2668, 2668, 2668, 2668, 2668,
     2678,    0, 2678,    0,    0,    0,    0, 2669, 2669, 2669,
     2669, 2669, 2669, 2679, 2679, 2679, 2679, 2679, 2679, 2680,

     2680, 2680, 2680, 2680, 2680, 2681, 2681, 2681, 2681, 2681,
     2681, 2682, 2682, 2682, 2682, 2682, 2682, 2686, 2686, 2686,
     2686, 2686, 2686, 2687, 2687, 2687, 2687, 2687, 2687, 2688,
     2688, 2688, 2688, 2688, 2688, 2689, 2689, 2689, 2689, 2689,
     2689, 2690, 2690, 2690, 2690, 2690, 2690,    0, 2678, 2678,
     2678, 2678, 2678, 2678, 2691, 2691, 2691, 2691, 2691, 2691,
     2692, 2692, 2692, 2692, 2692, 2692, 2693, 2693, 2693, 2693,
     2693, 2693, 2694, 2694, 2694, 2694, 2694, 2694, 2695,    0,
        0,    0,    0,    0, 2696,    0,    0,    0,    0,    0,
     2697,    0,    0, 2695, 2695, 2695, 2695, 2695, 2695, 2696,

     2696, 2696, 2696, 2696, 2696, 2697, 2697, 2697, 2697, 2697,
     2697, 2698, 2698, 2698, 2698, 2698, 2698,    0, 2707,    0,
     2695, 2695, 2696,    0,    0,    0,    0, 2696,    0,    0,
     2707, 2697, 2707, 2697, 2702, 2702, 2702, 2702, 2702, 2702,
        0,    0,    0, 2695, 2695, 2696,    0,    0,    0,    0,
     2696, 2704,    0,    0, 2697,    0, 2697, 2703, 2703, 2703,
     2703, 2703, 2703, 2704,    0, 2704, 2704, 2704, 2704, 2704,
     2704, 2704, 2705, 2705, 2705, 2705, 2705, 2705, 2706, 2706,
     2706, 2706, 2706, 2706, 2708, 2708, 2708, 2708, 2708, 2708,
     2709, 2709, 2709, 2709, 2709, 2709,    0,    0, 2707, 2707,

     2707, 2707, 2707, 2707, 2710, 2710, 2710, 2710, 2710, 2710,
     2711, 2711, 2711, 2711, 2711, 2711, 2712, 2712, 2712, 2712,
     2712, 2712, 2713, 2713, 2713, 2713, 2713, 2713, 2714, 2714,
     2714, 2714, 2714, 2714, 2715, 2715, 2715, 2715, 2715, 2715,
     2716, 2716, 2716, 2716, 2716, 2716, 2717, 2717, 2717, 2717,
     2717, 2717, 2721, 2721, 2721, 2721, 2721, 2721, 2722, 2722,
     2722, 2722, 2722, 2722, 2723, 2723, 2723, 2723, 2723, 2723,
     2725, 2725, 2725, 2725, 2725, 2725, 2726, 2726, 2726, 2726,
     2726, 2726, 2727, 2727, 2727, 2727, 2727, 2727, 2728, 2728,
     2728, 2728, 2728, 2728, 2730, 2730, 2730, 2730, 2730, 2730,

     2731, 2731, 2731, 2731, 2731, 2731, 2732,    0,    0,    0,
        0,    0, 2733,    0,    0,    0,    0,    0, 2734,    0,
        0, 2732, 2732, 2732, 2732, 2732, 2732, 2733, 2733, 2733,
     2733, 2733, 2733, 2734, 2734, 2734, 2734, 2734, 2734, 2735,
     2735, 2735, 2735, 2735, 2735,    0,    0,    0, 2732, 2732,
     2733,    0,    0,    0,    0, 2733,    0,    0,    0, 2734,
        0, 2734, 2746, 2746, 2746, 2746, 2746, 2746,    0,    0,
        0, 2732, 2732, 2733,    0,    0,    0,    0, 2733,    0,
        0,    0, 2734,    0, 2734, 2747, 2747, 2747, 2747, 2747,
     2747, 2748, 2748, 2748, 2748, 2748, 2748, 2749, 2749, 2749,

     2749, 2749, 2749, 2750, 2750, 2750, 2750, 2750, 2750, 2751,
     2751, 2751, 2751, 2751, 2751, 2752, 2752, 2752, 2752, 2752,
     2752, 2753, 2753, 2753, 2753, 2753, 2753, 2754, 2754, 2754,
     2754, 2754, 2754, 2755, 2755, 2755, 2755, 2755, 2755, 2756,
     2756, 2756, 2756, 2756, 2756, 2757, 2757, 2757, 2757, 2757,
     2757, 2758, 2758, 2758, 2758, 2758, 2758, 2759, 2759, 2759,
     2759, 2759, 2759, 2762, 2762, 2762, 2762, 2762, 2762, 2764,
     2764, 2764, 2764, 2764, 2764, 2766, 2766, 2766, 2766, 2766,
     2766, 2767,    0,    0,    0,    0,    0, 2768,    0,    0,
        0,    0,    0, 2769,    0,    0, 2767, 2767, 2767, 2767,

     2767, 2767, 2768, 2768, 2768, 2768, 2768, 2768, 2769, 2769,
     2769, 2769, 2769, 2769, 2770, 2770, 2770, 2770, 2770, 2770,
        0,    0,    0, 2767, 2767, 2768,    0,    0,    0,    0,
     2768,    0,    0,    0, 2769,    0, 2769, 2785, 2785, 2785,
     2785, 2785, 2785,    0,    0,    0, 2767, 2767, 2768,    0,
        0,    0,    0, 2768,    0,    0,    0, 2769,    0, 2769,
     2786, 2786, 2786, 2786, 2786, 2786, 2787, 2787, 2787, 2787,
     2787, 2787, 2789, 2789, 2789, 2789, 2789, 2789, 2797, 2797,
        0, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797,
     2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797,

     2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797,
     2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797,
     2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797,
     2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797,
     2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797,
     2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797, 2797,
     2797, 2797, 2797, 2797, 2797, 2801, 2801,    0, 2801, 2801,
     2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801,
     2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801,
     2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801,

     2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801,
     2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801,
     2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801,
     2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801,
     2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801, 2801,
     2801, 2801, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894,
     2894, 2894, 2895, 2895, 2895, 2895, 2895, 2895, 2895, 2895,
     2895, 2895, 2896, 2896, 2896, 2896, 2896, 2896, 2896, 2896,
     2896, 2896, 2897, 2897, 2897, 2897, 2897, 2897, 2897, 2897,
     2897, 2897, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,

     2898, 2898, 2899, 2899, 2899, 2899, 2899, 2899, 2899, 2899,
     2899, 2899, 2900, 2900, 2900, 2900, 2900, 2900, 2900, 2900,
     2900, 2900, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,
     2901, 2901, 2902, 2902, 2902, 2902, 2902, 2902, 2902, 2902,
     2902, 2902, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,
     2903, 2903, 2904, 2904, 2904, 2904, 2904, 2904, 2904, 2904,
     2904, 2904, 2905, 2905, 2905, 2905, 2905, 2905, 2905, 2905,
     2905, 2905, 2906, 2906, 2906, 2906, 2906, 2906, 2906, 2906,
     2906, 2906, 2907, 2907, 2907, 2907, 2907, 2907, 2907, 2907,
     2907, 2907, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908,

     2908, 2908, 2909, 2909, 2909, 2909, 2909, 2909, 2909, 2909,
     2909, 2909, 2910,    0,    0,    0,    0, 2910,    0,    0,
        0, 2910, 2911, 2911,    0, 2911, 2911, 2911, 2911,    0,
        0, 2911, 2912, 2912,    0, 2912, 2912, 2912, 2912, 2912,
     2912, 2912, 2913, 2913,    0, 2913, 2913, 2913, 2913, 2913,
     2913, 2913, 2914,    0,    0,    0,    0, 2914,    0,    0,
        0, 2914, 2915, 2915, 2915, 2915, 2915, 2915, 2915,    0,
        0, 2915, 2916,    0,    0,    0,    0, 2916, 2917, 2917,
        0, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2918, 2918,
        0, 2918, 2918, 2918, 2918,    0, 2918, 2918, 2919, 2919,

        0, 2919, 2919, 2919, 2919, 2919, 2919, 2919, 2920, 2920,
        0, 2920, 2920, 2920, 2920, 2920, 2920, 2920, 2921, 2921,
        0, 2921, 2921, 2921, 2921, 2921, 2921, 2921, 2922,    0,
        0,    0,    0, 2922,    0,    0,    0, 2922, 2923,    0,
        0,    0,    0, 2923, 2924, 2924, 2924, 2924, 2924, 2924,
     2924,    0, 2924, 2924, 2925, 2925,    0, 2925, 2925, 2925,
     2925, 2925, 2925, 2925, 2926, 2926,    0, 2926, 2926, 2926,
     2926, 2926, 2926, 2926, 2927, 2927,    0, 2927, 2927, 2927,
     2927, 2927, 2927, 2927, 2928, 2928,    0, 2928, 2928, 2928,
     2928, 2928, 2928, 2928, 2929, 2929,    0, 2929, 2929, 2929,

     2929, 2929, 2929, 2929, 2930, 2930,    0, 2930, 2930, 2930,
     2930, 2930, 2930, 2930, 2931, 2931,    0, 2931, 2931, 2931,
     2931, 2931, 2931, 2931, 2932, 2932,    0, 2932, 2932, 2932,
     2932, 2932, 2932, 2932, 2933,    0,    0,    0,    0, 2933,
     2934,    0,    0,    0,    0, 2934,    0,    0,    0, 2934,
     2935, 2935,    0, 2935, 2935, 2935, 2935, 2935, 2935, 2935,
     2936, 2936,    0, 2936, 2936, 2936, 2936, 2936, 2936, 2936,
     2937, 2937,    0, 2937, 2937, 2937, 2937, 2937, 2937, 2937,
     2938,    0,    0,    0,    0, 2938, 2939, 2939,    0, 2939,
     2939, 2939, 2939, 2939, 2939, 2939, 2940, 2940,    0, 2940,

     2940, 2940, 2940, 2940, 2940, 2940, 2941, 2941,    0, 2941,
     2941, 2941, 2941, 2941, 2941, 2941, 2942, 2942,    0, 2942,
     2942, 2942, 2942, 2942, 2942, 2942, 2943,    0,    0,    0,
     2943, 2943, 2943,    0,    0, 2943, 2944, 2944,    0, 2944,
     2944, 2944, 2944, 2944, 2944, 2944, 2945, 2945,    0, 2945,
     2945, 2945, 2945, 2945, 2945, 2945, 2946, 2946,    0, 2946,
     2946, 2946, 2946, 2946, 2946, 2946, 2947, 2947,    0, 2947,
     2947, 2947, 2947, 2947, 2947, 2947, 2948, 2948,    0, 2948,
     2948, 2948, 2948, 2948, 2948, 2948, 2949, 2949,    0, 2949,
     2949, 2949, 2949, 2949, 2949, 2949, 2950,    0,    0,    0,

        0, 2950, 2950,    0,    0, 2950, 2951,    0,    0,    0,
     2951, 2951, 2951,    0,    0, 2951, 2952, 2952,    0, 2952,
     2952, 2952, 2952, 2952, 2952, 2952, 2953, 2953,    0, 2953,
     2953, 2953, 2953, 2953, 2953, 2953, 2954, 2954,    0, 2954,
     2954, 2954, 2954, 2954, 2954, 2954, 2955, 2955,    0, 2955,
     2955, 2955, 2955, 2955, 2955, 2955, 2956, 2956,    0, 2956,
     2956, 2956, 2956, 2956, 2956, 2956, 2957, 2957,    0, 2957,
     2957, 2957, 2957, 2957, 2957, 2957, 2958, 2958,    0, 2958,
     2958, 2958, 2958, 2958, 2958, 2958, 2959, 2959,    0, 2959,
     2959, 2959, 2959, 2959, 2959, 2959, 2960, 2960,    0, 2960,

     2960, 2960, 2960, 2960, 2960, 2960, 2961, 2961,    0, 2961,
     2961, 2961, 2961, 2961, 2961, 2961, 2962,    0,    0,    0,
     2962, 2962, 2962,    0,    0, 2962, 2963,    0,    0,    0,
     2963, 2963, 2963, 2964, 2964,    0, 2964, 2964, 2964, 2964,
     2964, 2964, 2964, 2965, 2965,    0, 2965, 2965, 2965, 2965,
     2965, 2965, 2965, 2966, 2966,    0, 2966, 2966, 2966, 2966,
     2966, 2966, 2966, 2967, 2967,    0, 2967, 2967, 2967, 2967,
     2967, 2967, 2967, 2968, 2968,    0, 2968, 2968, 2968, 2968,
     2968, 2968, 2968, 2969, 2969,    0, 2969, 2969, 2969, 2969,
     2969, 2969, 2969, 2970, 2970,    0, 2970, 2970, 2970, 2970,

     2970, 2970, 2970, 2971, 2971,    0, 2971, 2971, 2971, 2971,
     2971, 2971, 2971, 2972, 2972,    0, 2972, 2972, 2972, 2972,
     2972, 2972, 2972, 2973,    0,    0,    0, 2973, 2973, 2973,
        0,    0, 2973, 2974,    0,    0,    0, 2974, 2974, 2974,
     2975, 2975,    0, 2975, 2975, 2975, 2975, 2975, 2975, 2975,
     2976, 2976,    0, 2976, 2976, 2976, 2976, 2976, 2976, 2976,
     2977, 2977,    0, 2977, 2977, 2977, 2977, 2977, 2977, 2977,
     2978, 2978,    0, 2978, 2978, 2978, 2978, 2978, 2978, 2978,
     2979, 2979,    0, 2979, 2979, 2979, 2979, 2979, 2979, 2979,
     2980, 2980,    0, 2980, 2980, 2980, 2980, 2980, 2980, 2980,

     2981, 2981,    0, 2981, 2981, 2981, 2981, 2981, 2981, 2981,
     2982, 2982,    0, 2982, 2982, 2982, 2982, 2982, 2982, 2982,
     2983, 2983,    0, 2983, 2983, 2983, 2983, 2983, 2983, 2983,
     2984, 2984,    0, 2984, 2984, 2984, 2984, 2984, 2984, 2984,
     2985, 2985,    0, 2985, 2985, 2985, 2985, 2985, 2985, 2985,
     2986, 2986,    0, 2986, 2986, 2986, 2986, 2986, 2986, 2986,
     2987, 2987,    0, 2987, 2987, 2987, 2987, 2987, 2987, 2987,
     2988, 2988,    0, 2988, 2988, 2988, 2988, 2988, 2988, 2988,
     2989,    0,    0,    0, 2989, 2989, 2989,    0,    0, 2989,
     2990,    0,    0,    0, 2990,    0, 2990, 2991, 2991,    0,

     2991, 2991, 2991, 2991, 2991, 2991, 2991, 2992, 2992,    0,
     2992, 2992, 2992, 2992, 2992, 2992, 2992, 2993, 2993,    0,
     2993, 2993, 2993, 2993, 2993, 2993, 2993, 2994, 2994,    0,
     2994, 2994, 2994, 2994, 2994, 2994, 2994, 2995, 2995,    0,
     2995, 2995, 2995, 2995, 2995, 2995, 2995, 2996, 2996,    0,
     2996, 2996, 2996, 2996, 2996, 2996, 2996, 2997, 2997,    0,
     2997, 2997, 2997, 2997, 2997, 2997, 2997, 2998, 2998,    0,
     2998, 2998, 2998, 2998, 2998, 2998, 2998, 2999, 2999,    0,
     2999, 2999, 2999, 2999, 2999, 2999, 2999, 3000, 3000,    0,
     3000, 3000, 3000, 3000, 3000, 3000, 3000, 3001, 3001,    0,

     3001, 3001, 3001, 3001, 3001, 3001, 3001, 3002, 3002,    0,
     3002, 3002, 3002, 3002, 3002, 3002, 3002, 3003, 3003,    0,
     3003, 3003, 3003, 3003, 3003, 3003, 3003, 3004, 3004,    0,
     3004, 3004, 3004, 3004, 3004, 3004, 3004, 3005, 3005,    0,
     3005, 3005, 3005, 3005, 3005, 3005, 3005, 3006,    0,    0,
        0, 3006, 3006, 3006,    0,    0, 3006, 3007,    0,    0,
        0, 3007,    0, 3007, 3008, 3008,    0, 3008, 3008, 3008,
     3008, 3008, 3008, 3008, 3009, 3009,    0, 3009, 3009, 3009,
     3009, 3009, 3009, 3009, 3010, 3010,    0, 3010, 3010, 3010,
     3010, 3010, 3010, 3010, 3011, 3011,    0, 3011, 3011, 3011,

     3011, 3011, 3011, 3011, 3012, 3012,    0, 3012, 3012, 3012,
     3012, 3012, 3012, 3012, 3013, 3013,    0, 3013, 3013, 3013,
     3013, 3013, 3013, 3013, 3014, 3014,    0, 3014, 3014, 3014,
     3014, 3014, 3014, 3014, 3015, 3015,    0, 3015, 3015, 3015,
     3015, 3015, 3015, 3015, 3016, 3016,    0, 3016, 3016, 3016,
     3016, 3016, 3016, 3016, 3017, 3017,    0, 3017, 3017, 3017,
     3017, 3017, 3017, 3017, 3018, 3018,    0, 3018, 3018, 3018,
     3018, 3018, 3018, 3018, 3019, 3019,    0, 3019, 3019, 3019,
     3019, 3019, 3019, 3019, 3020, 3020,    0, 3020, 3020, 3020,
     3020, 3020, 3020, 3020, 3021, 3021,    0, 3021, 3021, 3021,

     3021, 3021, 3021, 3021, 3022, 3022,    0, 3022, 3022, 3022,
     3022, 3022, 3022, 3022, 3023, 3023,    0, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3024, 3024,    0, 3024, 3024, 3024,
     3024, 3024, 3024, 3024, 3025, 3025,    0, 3025, 3025, 3025,
     3025, 3025, 3025, 3025, 3026, 3026,    0, 3026, 3026, 3026,
     3026, 3026, 3026, 3026, 3027,    0,    0,    0, 3027,    0,
     3027, 3028,    0,    0,    0, 3028, 3028, 3028,    0,    0,
     3028, 3029,    0,    0,    0, 3029, 3029, 3029, 3030, 3030,
        0, 3030, 3030, 3030, 3030, 3030, 3030, 3030, 3031, 3031,
        0, 3031, 3031, 3031, 3031, 3031, 3031, 3031, 3032, 3032,

        0, 3032, 3032, 3032, 3032, 3032, 3032, 3032, 3033, 3033,
        0, 3033, 3033, 3033, 3033, 3033, 3033, 3033, 3034, 3034,
        0, 3034, 3034, 3034, 3034, 3034, 3034, 3034, 3035, 3035,
        0, 3035, 3035, 3035, 3035, 3035, 3035, 3035, 3036, 3036,
        0, 3036, 3036, 3036, 3036, 3036, 3036, 3036, 3037, 3037,
        0, 3037, 3037, 3037, 3037, 3037, 3037, 3037, 3038, 3038,
        0, 3038, 3038, 3038, 3038, 3038, 3038, 3038, 3039, 3039,
        0, 3039, 3039, 3039, 3039, 3039, 3039, 3039, 3040, 3040,
        0, 3040, 3040, 3040, 3040, 3040, 3040, 3040, 3041, 3041,
        0, 3041, 3041, 3041, 3041, 3041, 3041, 3041, 3042, 3042,

        0, 3042, 3042, 3042, 3042, 3042, 3042, 3042, 3043, 3043,
        0, 3043, 3043, 3043, 3043, 3043, 3043, 3043, 3044, 3044,
        0, 3044, 3044, 3044, 3044, 3044, 3044, 3044, 3045, 3045,
        0, 3045, 3045, 3045, 3045, 3045, 3045, 3045, 3046, 3046,
        0, 3046, 3046, 3046, 3046, 3046, 3046, 3046, 3047, 3047,
        0, 3047, 3047, 3047, 3047, 3047, 3047, 3047, 3048, 3048,
        0, 3048, 3048, 3048, 3048, 3048, 3048, 3048, 3049,    0,
        0,    0, 3049,    0, 3049, 3050,    0,    0,    0, 3050,
     3050, 3050,    0,    0, 3050, 3051,    0,    0,    0, 3051,
     3051, 3051, 3052, 3052,    0, 3052, 3052, 3052, 3052, 3052,

     3052, 3052, 3053, 3053,    0, 3053, 3053, 3053, 3053, 3053,
     3053, 3053, 3054, 3054,    0, 3054, 3054, 3054, 3054, 3054,
     3054, 3054, 3055, 3055,    0, 3055, 3055, 3055, 3055, 3055,
     3055, 3055, 3056, 3056,    0, 3056, 3056, 3056, 3056, 3056,
     3056, 3056, 3057, 3057,    0, 3057, 3057, 3057, 3057, 3057,
     3057, 3057, 3058, 3058,    0, 3058, 3058, 3058, 3058, 3058,
     3058, 3058, 3059, 3059,    0, 3059, 3059, 3059, 3059, 3059,
     3059, 3059, 3060,    0,    0,    0, 3060, 3060, 3060, 3061,
     3061,    0, 3061, 3061, 3061, 3061, 3061, 3061, 3061, 3062,
     3062,    0, 3062, 3062, 3062, 3062, 3062, 3062, 3062, 3063,

     3063,    0, 3063, 3063, 3063, 3063, 3063, 3063, 3063, 3064,
     3064,    0, 3064, 3064, 3064, 3064, 3064, 3064, 3064, 3065,
     3065,    0, 3065, 3065, 3065, 3065, 3065, 3065, 3065, 3066,
     3066,    0, 3066, 3066, 3066, 3066, 3066, 3066, 3066, 3067,
     3067,    0, 3067, 3067, 3067, 3067, 3067, 3067, 3067, 3068,
     3068,    0, 3068, 3068, 3068, 3068, 3068, 3068, 3068, 3069,
        0,    0,    0, 3069, 3069, 3069, 3070, 3070,    0, 3070,
     3070, 3070, 3070, 3070, 3070, 3070, 3071, 3071,    0, 3071,
     3071, 3071, 3071, 3071, 3071, 3071, 3072, 3072,    0, 3072,
     3072, 3072, 3072, 3072, 3072, 3072, 3073, 3073,    0, 3073,

     3073, 3073, 3073, 3073, 3073, 3073, 3074, 3074,    0, 3074,
     3074, 3074, 3074, 3074, 3074, 3074, 3075, 3075,    0, 3075,
     3075, 3075, 3075, 3075, 3075, 3075, 3076, 3076,    0, 3076,
     3076, 3076, 3076, 3076, 3076, 3076, 3077, 3077,    0, 3077,
     3077, 3077, 3077, 3077, 3077, 3077, 3078, 3078,    0, 3078,
     3078, 3078, 3078, 3078, 3078, 3078, 3079, 3079,    0, 3079,
     3079, 3079, 3079, 3079, 3079, 3079, 3080, 3080,    0, 3080,
     3080, 3080, 3080, 3080, 3080, 3080, 3081, 3081,    0, 3081,
     3081, 3081, 3081, 3081, 3081, 3081, 3082, 3082,    0, 3082,
     3082, 3082, 3082, 3082, 3082, 3082, 3083, 3083,    0, 3083,

     3083, 3083, 3083, 3083, 3083, 3083, 3084, 3084,    0, 3084,
     3084, 3084, 3084, 3084, 3084, 3084, 3085, 3085,    0, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3086, 3086,    0, 3086,
     3086, 3086, 3086, 3086, 3086, 3086, 3087, 3087,    0, 3087,
     3087, 3087, 3087, 3087, 3087, 3087, 3088, 3088,    0, 3088,
     3088, 3088, 3088, 3088, 3088, 3088, 3089, 3089,    0, 3089,
     3089, 3089, 3089, 3089, 3089, 3089, 3090, 3090,    0, 3090,
     3090, 3090, 3090, 3090, 3090, 3090, 3091,    0,    0,    0,
        0, 3091, 3092, 3092,    0, 3092, 3092, 3092, 3092, 3092,
     3092, 3092, 3093,    0,    0,    0, 3093,    0, 3093, 3094,

        0,    0,    0, 3094,    0, 3094, 3095, 3095, 3095,    0,
     3095, 3095, 3095, 3095, 3095, 3095, 3096, 3096,    0, 3096,
     3096, 3096, 3096, 3096, 3096, 3096, 3097, 3097,    0, 3097,
     3097, 3097, 3097, 3097, 3097, 3097, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,

     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893, 2893,
     2893, 2893, 2893, 2893
    } ;

static yy_state_type yy_state_buf[YY_BUF_SIZE + 2], *yy_state_ptr;
static char *yy_full_match;
static int yy_lp;
static int yy_looking_for_trail_begin = 0;
static int yy_full_lp;
static int *yy_full_state;
#define YY_TRAILING_MASK 0x2000
#define YY_TRAILING_HEAD_MASK 0x4000
#define REJECT \
{ \
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */ \
yy_cp = yy_full_match; /* restore poss. backed-over text */ \
yy_lp = yy_full_lp; /* restore orig. accepting pos. */ \
yy_state_ptr = yy_full_state; /* restore orig. state */ \
yy_current_state = *yy_state_ptr; /* restore curr. state */ \
++yy_lp; \
goto find_rule; \
}
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "modified_Tokenizer.lex"
#define INITIAL 0
#line 2 "modified_Tokenizer.lex"
#include "lex.h"
#include "festival.h"
#line 95 "modified_Tokenizer.lex"
//DELIMITER ({WHITESPACE}|[\n]|{PUNC}|{WORD_DELIM})
#define TOKEN 1

#define SW_TOKEN 2

#define NUMRANGE_tag 3

#define MARKED_UP_TEXT 4

#define SCAN_NORD 5

#define SCAN_NUM 6

#define SCAN_NFRAC 7

#define SCAN_NFLOAT 8

#define SCAN_NTEL 9

#define SCAN_NTIME 10

#define SCAN_NET 11

#define SCAN_NDATE 12

#define SCAN_NYEAR 13

#define SCAN_NZIP 14

#define SCAN_NPRCT 15

#define SCAN_NRATIO 16

#define SCAN_NDIG 17

#define SCAN_NLITERAL 18

#define SCAN_NMONEY 19

#define SCAN_LCMONEY 20

#define INTO_SAYAS_MODE 21

#define OTHER_TAG 22

#line 7546 "lex.yy.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp = NULL, *yy_bp = NULL;
	register int yy_act;

#line 124 "modified_Tokenizer.lex"


printf("Begin State: %d\n", Begin_State);
BEGIN(Begin_State);

#line 7703 "lex.yy.c"

	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
		yy_state_ptr = yy_state_buf;
		*yy_state_ptr++ = yy_current_state;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 2894 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			*yy_state_ptr++ = yy_current_state;
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 25937 );

yy_find_action:
		yy_current_state = *--yy_state_ptr;
		yy_lp = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( yy_lp && yy_lp < yy_accept[yy_current_state + 1] )
				{
				yy_act = yy_acclist[yy_lp];
				if ( yy_act & YY_TRAILING_HEAD_MASK ||
				     yy_looking_for_trail_begin )
					{
					if ( yy_act == yy_looking_for_trail_begin )
						{
						yy_looking_for_trail_begin = 0;
						yy_act &= ~YY_TRAILING_HEAD_MASK;
						break;
						}
					}
				else if ( yy_act & YY_TRAILING_MASK )
					{
					yy_looking_for_trail_begin = yy_act & ~YY_TRAILING_MASK;
					yy_looking_for_trail_begin |= YY_TRAILING_HEAD_MASK;
					}
				else
					{
					yy_full_match = yy_cp;
					yy_full_state = yy_state_ptr;
					yy_full_lp = yy_lp;
					break;
					}
				++yy_lp;
				goto find_rule;
				}
			--yy_cp;
			yy_current_state = *--yy_state_ptr;
			yy_lp = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */


case 1:
YY_RULE_SETUP
#line 131 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NYEAR>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 132 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NUM1>")); printf("*** yytext1 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 133 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NUM1>")); printf("*** yytext1 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 134 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NUM>")); printf("*** yytext2 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 135 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NUM>")); printf("*** yytext2 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 136 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NUM>")); printf("*** yytext2 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 137 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NUM>")); printf("*** yytext2 =  %s\n", yytext); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 138 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 139 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 140 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 141 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 142 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 143 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 144 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NFRAC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 145 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NFRAC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 146 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 147 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 148 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 149 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NPRCT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 150 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NPRCT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 152 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 153 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 154 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 155 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 156 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 157 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 158 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 159 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 160 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 161 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 163 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 164 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 165 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 166 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 167 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 168 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 170 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 171 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 172 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 173 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 174 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 175 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 176 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 177 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 178 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 179 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 181 "modified_Tokenizer.lex"
tokenList.append(EST_String("<URL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 182 "modified_Tokenizer.lex"
tokenList.append(EST_String("<EMAIL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 183 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NET>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 185 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NRATIO>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 186 "modified_Tokenizer.lex"
tokenList.append(EST_String("<NRATIO>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 188 "modified_Tokenizer.lex"
tokenList.append(EST_String("<ALPHANUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 189 "modified_Tokenizer.lex"
tokenList.append(EST_String("<ALPHANUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 191 "modified_Tokenizer.lex"
{
if(Inside_Engine_ID == 1) 
{
	printf("%s", yytext);
	while( ( c = yyinput() ) != '>' )
	{
		printf("%c", c);
	}
	printf("%c", c);
	Inside_Engine_ID = 0;
	BEGIN(TOKEN);
}
else  tokenList.append(EST_String("<PUNC>"));tokenList.append(EST_String(yytext));BEGIN(TOKEN);
}
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 205 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 206 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 207 "modified_Tokenizer.lex"
tokenList.append(EST_String("<PUNC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 208 "modified_Tokenizer.lex"
tokenList.append(EST_String("<DELIMITER>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 209 "modified_Tokenizer.lex"
yyless(0);BEGIN(MARKED_UP_TEXT);
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 210 "modified_Tokenizer.lex"
yyless(0);BEGIN(SW_TOKEN);
	YY_BREAK



case 61:
YY_RULE_SETUP
#line 215 "modified_Tokenizer.lex"
tokenList.append(EST_String(yytext));BEGIN(TOKEN);
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 216 "modified_Tokenizer.lex"
tokenList.append(EST_String(yytext));BEGIN(TOKEN);
	YY_BREAK


/*
<NUMRANGE_tag>
{
{SP_YEAR}|{SP_IYEAR}/{DELIMITER} {
				fprintf(fout,"<NYEAR> %s </NYEAR>", yytext);
				inside_NUMRANGE = 1;
				BEGIN(NUMRANGE_tag);
				}
{NUM1}/{DELIMITER} {
			if(inside_NUMRANGE == 0)
			{
				fprintf(fout,"<NUM> %s </NUM>", yytext);BEGIN(NUMRANGE_tag);
			}
			else 
			{
				fprintf(fout,"<NYEAR> %s </NYEAR></NRANGE>", yytext);
				inside_NUMRANGE = 0;
				BEGIN(TOKEN);
			}
		}	
{NUM2}/{DELIMITER} fprintf(fout,"<NUM> %s </NUM>", yytext);BEGIN(NUMRANGE_tag);
{NUM3}/{DELIMITER} fprintf(fout,"<NFLOAT> %s </NFLOAT>", yytext);BEGIN(NUMRANGE_tag);
{INUM1}/{DELIMITER} {
			if(inside_NUMRANGE == 0)
			{
				fprintf(fout,"<NUM> %s </NUM>", yytext);BEGIN(NUMRANGE_tag);
			}
			else 
			{
				fprintf(fout,"<NYEAR> %s </NYEAR></NRANGE>", yytext);
				inside_NUMRANGE = 0;
				BEGIN(TOKEN);
			}
		}	
{INUM2}/{DELIMITER} fprintf(fout,"<NUM> %s </NUM>", yytext);BEGIN(NUMRANGE_tag);
{INUM3}/{DELIMITER} fprintf(fout,"<NFLOAT> %s </NFLOAT>", yytext);BEGIN(NUMRANGE_tag);
{WHITESPACE}*"-"{WHITESPACE}* fprintf(fout, "%s", yytext);BEGIN(NUMRANGE_tag);
{DELIMITER} inside_NUMRANGE=0;fprintf(fout, " </NRANGE>%s", yytext);BEGIN(TOKEN);
}

*/



case 63:
YY_RULE_SETUP
#line 265 "modified_Tokenizer.lex"
BEGIN(SCAN_NUM);
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 266 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 267 "modified_Tokenizer.lex"
BEGIN(SCAN_NORD);
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 268 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 269 "modified_Tokenizer.lex"
BEGIN(SCAN_NTEL);
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 270 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 271 "modified_Tokenizer.lex"
BEGIN(SCAN_NDATE);
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 272 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 273 "modified_Tokenizer.lex"
BEGIN(SCAN_NYEAR);
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 274 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 275 "modified_Tokenizer.lex"
BEGIN(SCAN_NTIME);
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 276 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 277 "modified_Tokenizer.lex"
BEGIN(SCAN_NFRAC);
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 278 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 279 "modified_Tokenizer.lex"
BEGIN(SCAN_NFLOAT);
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 280 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 281 "modified_Tokenizer.lex"
BEGIN(SCAN_NZIP);
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 282 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 283 "modified_Tokenizer.lex"
BEGIN(SCAN_NPRCT);
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 284 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 285 "modified_Tokenizer.lex"
BEGIN(SCAN_NMONEY);
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 286 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 287 "modified_Tokenizer.lex"
BEGIN(SCAN_LCMONEY);
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 288 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 289 "modified_Tokenizer.lex"
BEGIN(SCAN_NLITERAL);
	YY_BREAK
case 88:
YY_RULE_SETUP
#line 290 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 291 "modified_Tokenizer.lex"
yyless(0);BEGIN(INTO_SAYAS_MODE);
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 292 "modified_Tokenizer.lex"
BEGIN(TOKEN);
	YY_BREAK
case 91:
YY_RULE_SETUP
#line 293 "modified_Tokenizer.lex"
printf("%s", yytext);Inside_Engine_ID = 1;BEGIN(TOKEN);
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 294 "modified_Tokenizer.lex"
yyless(0);BEGIN(OTHER_TAG);
	YY_BREAK



case 93:
YY_RULE_SETUP
#line 299 "modified_Tokenizer.lex"
printf("%s",yytext);BEGIN(TOKEN);
	YY_BREAK



case 94:
YY_RULE_SETUP
#line 305 "modified_Tokenizer.lex"
BEGIN(SCAN_NUM);
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 306 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 101;
    }
  else
    {
      tokenList.append(EST_String("<NUM1>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 317 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 101;
    }
  else
    {
      tokenList.append(EST_String("<NUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 328 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 102;
    }
  else
    {
      tokenList.append(EST_String("<NUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 339 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 201;
    }
  else
    {
      tokenList.append(EST_String("<NUM1>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 350 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 201;
    }
  else
    {
      tokenList.append(EST_String("<NUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 361 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 202;
    }
  else
    {
      tokenList.append(EST_String("<NUM>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 372 "modified_Tokenizer.lex"
return 0;
	YY_BREAK



case 102:
YY_RULE_SETUP
#line 378 "modified_Tokenizer.lex"
BEGIN(SCAN_NORD);
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 379 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 101;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 390 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 101;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 401 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 102;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 412 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 201;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 107:
YY_RULE_SETUP
#line 423 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 201;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 108:
YY_RULE_SETUP
#line 434 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 202;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 109:
YY_RULE_SETUP
#line 445 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 104;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 456 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 204;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 467 "modified_Tokenizer.lex"
{
  if(Begin_State != TOKEN)
    {
      if(yyleng != String_Length) return 0;
      else return 105;
    }
  else
    {
      tokenList.append(EST_String("<NORD>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
    }
}
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 478 "modified_Tokenizer.lex"
return 0;
	YY_BREAK



case 113:
YY_RULE_SETUP
#line 483 "modified_Tokenizer.lex"
BEGIN(SCAN_NTEL);
	YY_BREAK
case 114:
YY_RULE_SETUP
#line 484 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 495 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 506 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 105;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 517 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 106;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 118:
YY_RULE_SETUP
#line 528 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 119:
YY_RULE_SETUP
#line 539 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 104;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 120:
YY_RULE_SETUP
#line 550 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 121:
YY_RULE_SETUP
#line 561 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 202;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 122:
YY_RULE_SETUP
#line 572 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 205;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 123:
YY_RULE_SETUP
#line 583 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 206;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 124:
YY_RULE_SETUP
#line 594 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 125:
YY_RULE_SETUP
#line 605 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
        if(yyleng != String_Length) return 0;
       else return 204;
     }
   else 
     {
       tokenList.append(EST_String("<NTEL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 126:
YY_RULE_SETUP
#line 616 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 127:
YY_RULE_SETUP
#line 621 "modified_Tokenizer.lex"
BEGIN(SCAN_NTEL);
	YY_BREAK
case 128:
YY_RULE_SETUP
#line 622 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 129:
YY_RULE_SETUP
#line 633 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 130:
YY_RULE_SETUP
#line 644 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 131:
YY_RULE_SETUP
#line 655 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 104;

     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 132:
YY_RULE_SETUP
#line 667 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 105;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 133:
YY_RULE_SETUP
#line 678 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 134:
YY_RULE_SETUP
#line 689 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 202;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 135:
YY_RULE_SETUP
#line 700 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 136:
YY_RULE_SETUP
#line 711 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 204;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 137:
YY_RULE_SETUP
#line 722 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 205;
     }
   else 
     {
       tokenList.append(EST_String("<NTIME>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 138:
YY_RULE_SETUP
#line 733 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 139:
YY_RULE_SETUP
#line 739 "modified_Tokenizer.lex"
BEGIN(SCAN_NDATE);
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 740 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 751 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 142:
YY_RULE_SETUP
#line 762 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 143:
YY_RULE_SETUP
#line 773 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 104;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 144:
YY_RULE_SETUP
#line 784 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 105;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 145:
YY_RULE_SETUP
#line 795 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 106;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 146:
YY_RULE_SETUP
#line 806 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 107;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 147:
YY_RULE_SETUP
#line 817 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 148:
YY_RULE_SETUP
#line 828 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 202;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 149:
YY_RULE_SETUP
#line 839 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 150:
YY_RULE_SETUP
#line 850 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 204;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 151:
YY_RULE_SETUP
#line 861 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 205;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 152:
YY_RULE_SETUP
#line 872 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 206;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 153:
YY_RULE_SETUP
#line 883 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 207;
     }
   else 
     {
       tokenList.append(EST_String("<NDATE>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
 }
	YY_BREAK
case 154:
YY_RULE_SETUP
#line 894 "modified_Tokenizer.lex"
yyless(0);return 1;
	YY_BREAK



case 155:
YY_RULE_SETUP
#line 900 "modified_Tokenizer.lex"
BEGIN(SCAN_NYEAR);
	YY_BREAK
case 156:
YY_RULE_SETUP
#line 901 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NYEAR>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 157:
YY_RULE_SETUP
#line 912 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NYEAR>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 158:
YY_RULE_SETUP
#line 923 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 159:
YY_RULE_SETUP
#line 928 "modified_Tokenizer.lex"
BEGIN(SCAN_NMONEY);
	YY_BREAK
case 160:
YY_RULE_SETUP
#line 929 "modified_Tokenizer.lex"
yyless(0);return -1;
	YY_BREAK



case 161:
YY_RULE_SETUP
#line 934 "modified_Tokenizer.lex"
BEGIN(SCAN_LCMONEY);
	YY_BREAK
case 162:
YY_RULE_SETUP
#line 935 "modified_Tokenizer.lex"
yyless(0);return -1;
	YY_BREAK



case 163:
YY_RULE_SETUP
#line 940 "modified_Tokenizer.lex"
BEGIN(SCAN_NFRAC);
	YY_BREAK
case 164:
YY_RULE_SETUP
#line 941 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NFRAC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 165:
YY_RULE_SETUP
#line 952 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NFRAC>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 166:
YY_RULE_SETUP
#line 963 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 167:
YY_RULE_SETUP
#line 968 "modified_Tokenizer.lex"
BEGIN(SCAN_NFLOAT);
	YY_BREAK
case 168:
YY_RULE_SETUP
#line 969 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 169:
YY_RULE_SETUP
#line 980 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 170:
YY_RULE_SETUP
#line 991 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 103;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 171:
YY_RULE_SETUP
#line 1002 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 172:
YY_RULE_SETUP
#line 1013 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 202;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 173:
YY_RULE_SETUP
#line 1024 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 203;
     }
   else 
     {
       tokenList.append(EST_String("<NFLOAT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 174:
YY_RULE_SETUP
#line 1035 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 175:
YY_RULE_SETUP
#line 1041 "modified_Tokenizer.lex"
BEGIN(SCAN_NZIP);
	YY_BREAK
case 176:
YY_RULE_SETUP
#line 1042 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NZIP>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 177:
YY_RULE_SETUP
#line 1053 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NZIP>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 178:
YY_RULE_SETUP
#line 1064 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 179:
YY_RULE_SETUP
#line 1070 "modified_Tokenizer.lex"
printf("%s", yytext);
	YY_BREAK
case 180:
YY_RULE_SETUP
#line 1071 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NPRCT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 181:
YY_RULE_SETUP
#line 1082 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NPRCT>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 182:
YY_RULE_SETUP
#line 1093 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 183:
YY_RULE_SETUP
#line 1100 "modified_Tokenizer.lex"
printf("%s", yytext);
	YY_BREAK
case 184:
YY_RULE_SETUP
#line 1101 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NRATIO>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 185:
YY_RULE_SETUP
#line 1112 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NRATIO>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 186:
YY_RULE_SETUP
#line 1123 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 187:
YY_RULE_SETUP
#line 1128 "modified_Tokenizer.lex"
BEGIN(SCAN_NET);
	YY_BREAK
case 188:
YY_RULE_SETUP
#line 1129 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<URL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 189:
YY_RULE_SETUP
#line 1140 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 102;
     }
   else 
     {
       tokenList.append(EST_String("<EMAIL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 190:
YY_RULE_SETUP
#line 1151 "modified_Tokenizer.lex"
yyless(0);return 0;
	YY_BREAK



case 191:
YY_RULE_SETUP
#line 1156 "modified_Tokenizer.lex"
BEGIN(SCAN_NLITERAL);
	YY_BREAK
case 192:
YY_RULE_SETUP
#line 1157 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 101;
     }
   else 
     {
       tokenList.append(EST_String("<NLITERAL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 193:
YY_RULE_SETUP
#line 1168 "modified_Tokenizer.lex"
{
   if(Begin_State != TOKEN)
     {
       if(yyleng != String_Length) return 0;
       else return 201;
     }
   else 
     {
       tokenList.append(EST_String("<NLITERAL>")); tokenList.append(EST_String(yytext)); BEGIN(TOKEN);
     }
}
	YY_BREAK
case 194:
YY_RULE_SETUP
#line 1179 "modified_Tokenizer.lex"
printf(" <NLITERAL>:%s ", yytext);
	YY_BREAK



case 195:
YY_RULE_SETUP
#line 1184 "modified_Tokenizer.lex"

	YY_BREAK
case 196:
YY_RULE_SETUP
#line 1185 "modified_Tokenizer.lex"
{
				if(strcmp(yytext,"literal") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NLITERAL);
				}
				else if(strcmp(yytext,"date") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NDATE);
				}
				else if(strcmp(yytext,"time") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NTIME);
				}
				else if(strcmp(yytext,"phone") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NTEL);
				}
				else if(strcmp(yytext,"net") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NET);
				}
				else if(strcmp(yytext,"postal") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(TOKEN);
				}
				else if(strcmp(yytext,"currency") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NMONEY);
				}
				else if(strcmp(yytext,"fraction") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NFRAC);
				}
				else if(strcmp(yytext,"ordinal") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NORD);
				}
				else if(strcmp(yytext,"cardinal") == 0)
				{
					while(yyinput() != '>'); 
					BEGIN(SCAN_NUM);
				}
		 }
	YY_BREAK
case 197:
YY_RULE_SETUP
#line 1237 "modified_Tokenizer.lex"

	YY_BREAK
case 198:
YY_RULE_SETUP
#line 1238 "modified_Tokenizer.lex"
{
					if(strcmp(yytext,"DMY") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"MDY") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"YMD") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"YM") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"MY") == 0)
					{
					  while(yyinput() != '>');
					   BEGIN(SCAN_NDATE);
					}
					else if(strcmp(yytext,"MD") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NDATE);

					}
					else if(strcmp(yytext,"HM") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NTIME);
					}
					else if(strcmp(yytext,"HMS") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NTIME);
					}
					else if(strcmp(yytext,"EMAIL") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NTIME);
					}
					else if(strcmp(yytext,"URL") == 0)
					{
					  while(yyinput() != '>');
					  BEGIN(SCAN_NTIME);
					}
			 }
	YY_BREAK

case 199:
YY_RULE_SETUP
#line 1292 "modified_Tokenizer.lex"
ECHO;
	YY_BREAK
#line 9732 "lex.yy.c"
			case YY_STATE_EOF(INITIAL):
			case YY_STATE_EOF(TOKEN):
			case YY_STATE_EOF(SW_TOKEN):
			case YY_STATE_EOF(NUMRANGE_tag):
			case YY_STATE_EOF(MARKED_UP_TEXT):
			case YY_STATE_EOF(SCAN_NORD):
			case YY_STATE_EOF(SCAN_NUM):
			case YY_STATE_EOF(SCAN_NFRAC):
			case YY_STATE_EOF(SCAN_NFLOAT):
			case YY_STATE_EOF(SCAN_NTEL):
			case YY_STATE_EOF(SCAN_NTIME):
			case YY_STATE_EOF(SCAN_NET):
			case YY_STATE_EOF(SCAN_NDATE):
			case YY_STATE_EOF(SCAN_NYEAR):
			case YY_STATE_EOF(SCAN_NZIP):
			case YY_STATE_EOF(SCAN_NPRCT):
			case YY_STATE_EOF(SCAN_NRATIO):
			case YY_STATE_EOF(SCAN_NDIG):
			case YY_STATE_EOF(SCAN_NLITERAL):
			case YY_STATE_EOF(SCAN_NMONEY):
			case YY_STATE_EOF(SCAN_LCMONEY):
			case YY_STATE_EOF(INTO_SAYAS_MODE):
			case YY_STATE_EOF(OTHER_TAG):
				yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );

		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;
	yy_state_ptr = yy_state_buf;
	*yy_state_ptr++ = yy_current_state;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 2894 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		*yy_state_ptr++ = yy_current_state;
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;

	register YY_CHAR yy_c = 1;
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 2894 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 2893);
	if ( ! yy_is_jam )
		*yy_state_ptr++ = yy_current_state;

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_current_buffer->yy_n_chars =
			yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}
#endif	/* ifndef YY_NO_UNPUT */


#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						return EOF;

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;


	return c;
	}


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}



#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


	{
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
	b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
	b->yy_is_interactive = 0;
#else
	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	}


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
	{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
	{
	int len;
	for ( len = 0; yy_str[len]; ++len )
		;

	return yy_scan_bytes( yy_str, len );
	}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
	{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_flex_alloc( n );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif
#line 1292 "modified_Tokenizer.lex"


/*

int main(int argc, char *argv[])
{
  YY_BUFFER_STATE string_buffer;
  char *str;
	if(argc != 3 )
		exit(0);
	else
	{
	  yyin = fopen(argv[1],"r");
		fout = fopen(argv[2],"w");
		Init_Data_Structures();
	}

	yylex(TOKEN,-1);
	str = (char *)malloc(30*sizeof(char));
	strcpy(str,"54.29");
	string_buffer = yy_scan_string(str);
	printf("Float: %d\n",yylex(SCAN_NFLOAT, strlen(str)));
	yy_delete_buffer(string_buffer);
	string_buffer = yy_scan_string(str);
	printf("Time: %d\n",yylex(SCAN_NTIME, strlen(str)));
	yy_delete_buffer(string_buffer);
	string_buffer = yy_scan_string(str);
	printf("Date: %d\n",yylex(SCAN_NDATE, strlen(str)));
	yy_delete_buffer(string_buffer);
	string_buffer = yy_scan_string(str);
	printf("Year: %d\n",yylex(SCAN_NYEAR, strlen(str)));
	yy_delete_buffer(string_buffer);
	return 1;
}

*/

